/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/



#ifndef H_KINOSEARCH_ANALYSIS_STEMMER
#define H_KINOSEARCH_ANALYSIS_STEMMER 1


#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned char sb_symbol;
struct sb_stemmer;

typedef struct sb_stemmer*
(*kino_Stemmer_sb_stemmer_new_t)(const char *algorithm, const char *encoding);
typedef void
(*kino_Stemmer_sb_stemmer_delete_t)(struct sb_stemmer *snowstemmer);
typedef sb_symbol*
(*kino_Stemmer_sb_stemmer_stem_t)(struct sb_stemmer *snowstemmer, 
    const sb_symbol *text, int len);
typedef int
(*kino_Stemmer_sb_stemmer_length_t)(struct sb_stemmer *snowstemmer);
extern kino_Stemmer_sb_stemmer_new_t    kino_Stemmer_sb_stemmer_new;
extern kino_Stemmer_sb_stemmer_delete_t kino_Stemmer_sb_stemmer_delete;
extern kino_Stemmer_sb_stemmer_stem_t   kino_Stemmer_sb_stemmer_stem;
extern kino_Stemmer_sb_stemmer_length_t kino_Stemmer_sb_stemmer_length;
#ifdef KINO_USE_SHORT_NAMES
  #define Stemmer_sb_stemmer_new_t    kino_Stemmer_sb_stemmer_new_t
  #define Stemmer_sb_stemmer_delete_t kino_Stemmer_sb_stemmer_delete_t
  #define Stemmer_sb_stemmer_stem_t   kino_Stemmer_sb_stemmer_stem_t
  #define Stemmer_sb_stemmer_length_t kino_Stemmer_sb_stemmer_length_t
  #define Stemmer_sb_stemmer_new      kino_Stemmer_sb_stemmer_new
  #define Stemmer_sb_stemmer_delete   kino_Stemmer_sb_stemmer_delete
  #define Stemmer_sb_stemmer_stem     kino_Stemmer_sb_stemmer_stem
  #define Stemmer_sb_stemmer_length   kino_Stemmer_sb_stemmer_length
#endif


#include "charmony.h"
#include "boil.h"
#include "KinoSearch/Analysis/Analyzer.h"

#ifdef C_KINO_STEMMER
struct kino_Stemmer {
    kino_VTable* vtable;
    kino_ref_t ref;
    void* snowstemmer;
    kino_CharBuf* language;
};

#endif /* C_KINO_STEMMER */



kino_Stemmer*
kino_Stemmer_new(const kino_CharBuf* language);

kino_Stemmer*
kino_Stemmer_init(kino_Stemmer* self, const kino_CharBuf* language);

void
kino_Stemmer_load_snowball();

void
kino_Stemmer_destroy(kino_Stemmer* self);

chy_bool_t
kino_Stemmer_equals(kino_Stemmer* self, kino_Obj* other);

kino_Hash*
kino_Stemmer_dump(kino_Stemmer* self);

kino_Stemmer*
kino_Stemmer_load(kino_Stemmer* self, kino_Obj* dump);

kino_Inversion*
kino_Stemmer_transform(kino_Stemmer* self, kino_Inversion* inversion);


extern cfish_Callback kino_Stemmer_destroy_CALLBACK;
extern cfish_Callback kino_Stemmer_equals_CALLBACK;
extern cfish_Callback kino_Stemmer_dump_CALLBACK;
extern cfish_Callback kino_Stemmer_load_CALLBACK;
extern cfish_Callback kino_Stemmer_transform_CALLBACK;


typedef void
(*kino_Stemmer_destroy_t)(kino_Stemmer* self);

typedef chy_bool_t
(*kino_Stemmer_equals_t)(kino_Stemmer* self, kino_Obj* other);

typedef kino_Hash*
(*kino_Stemmer_dump_t)(kino_Stemmer* self);

typedef kino_Stemmer*
(*kino_Stemmer_load_t)(kino_Stemmer* self, kino_Obj* dump);

typedef kino_Inversion*
(*kino_Stemmer_transform_t)(kino_Stemmer* self, kino_Inversion* inversion);

extern size_t Kino_Stemmer_Make_OFFSET;
static CHY_INLINE kino_Obj*
Kino_Stemmer_Make(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Make_OFFSET;
    const kino_Obj_make_t method = *((kino_Obj_make_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Kino_Stemmer_Get_RefCount(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Get_RefCount_OFFSET;
    const kino_Obj_get_refcount_t method = *((kino_Obj_get_refcount_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_Inc_RefCount_OFFSET;
static CHY_INLINE kino_Obj*
Kino_Stemmer_Inc_RefCount(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Inc_RefCount_OFFSET;
    const kino_Obj_inc_refcount_t method = *((kino_Obj_inc_refcount_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Kino_Stemmer_Dec_RefCount(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Dec_RefCount_OFFSET;
    const kino_Obj_dec_refcount_t method = *((kino_Obj_dec_refcount_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_To_Host_OFFSET;
static CHY_INLINE void*
Kino_Stemmer_To_Host(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_To_Host_OFFSET;
    const kino_Obj_to_host_t method = *((kino_Obj_to_host_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_Clone_OFFSET;
static CHY_INLINE kino_Obj*
Kino_Stemmer_Clone(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Clone_OFFSET;
    const kino_Obj_clone_t method = *((kino_Obj_clone_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_Destroy_OFFSET;
static CHY_INLINE void
Kino_Stemmer_Destroy(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Destroy_OFFSET;
    const kino_Stemmer_destroy_t method = *((kino_Stemmer_destroy_t*)method_address);
    method((kino_Stemmer*)self);
}

extern size_t Kino_Stemmer_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Kino_Stemmer_Equals(const kino_Stemmer *self, kino_Obj* other)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Equals_OFFSET;
    const kino_Stemmer_equals_t method = *((kino_Stemmer_equals_t*)method_address);
    return method((kino_Stemmer*)self, other);
}

extern size_t Kino_Stemmer_Compare_To_OFFSET;
static CHY_INLINE int32_t
Kino_Stemmer_Compare_To(const kino_Stemmer *self, kino_Obj* other)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Compare_To_OFFSET;
    const kino_Obj_compare_to_t method = *((kino_Obj_compare_to_t*)method_address);
    return method((kino_Obj*)self, other);
}

extern size_t Kino_Stemmer_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Kino_Stemmer_Hash_Sum(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Hash_Sum_OFFSET;
    const kino_Obj_hash_sum_t method = *((kino_Obj_hash_sum_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_Get_VTable_OFFSET;
static CHY_INLINE kino_VTable*
Kino_Stemmer_Get_VTable(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Get_VTable_OFFSET;
    const kino_Obj_get_vtable_t method = *((kino_Obj_get_vtable_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_Get_Class_Name_OFFSET;
static CHY_INLINE kino_CharBuf*
Kino_Stemmer_Get_Class_Name(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Get_Class_Name_OFFSET;
    const kino_Obj_get_class_name_t method = *((kino_Obj_get_class_name_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Kino_Stemmer_Is_A(const kino_Stemmer *self, kino_VTable* ancestor)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Is_A_OFFSET;
    const kino_Obj_is_a_t method = *((kino_Obj_is_a_t*)method_address);
    return method((kino_Obj*)self, ancestor);
}

extern size_t Kino_Stemmer_To_String_OFFSET;
static CHY_INLINE kino_CharBuf*
Kino_Stemmer_To_String(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_To_String_OFFSET;
    const kino_Obj_to_string_t method = *((kino_Obj_to_string_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_To_I64_OFFSET;
static CHY_INLINE int64_t
Kino_Stemmer_To_I64(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_To_I64_OFFSET;
    const kino_Obj_to_i64_t method = *((kino_Obj_to_i64_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_To_F64_OFFSET;
static CHY_INLINE double
Kino_Stemmer_To_F64(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_To_F64_OFFSET;
    const kino_Obj_to_f64_t method = *((kino_Obj_to_f64_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Stemmer_Serialize_OFFSET;
static CHY_INLINE void
Kino_Stemmer_Serialize(const kino_Stemmer *self, kino_OutStream* outstream)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Serialize_OFFSET;
    const kino_Obj_serialize_t method = *((kino_Obj_serialize_t*)method_address);
    method((kino_Obj*)self, outstream);
}

extern size_t Kino_Stemmer_Deserialize_OFFSET;
static CHY_INLINE kino_Obj*
Kino_Stemmer_Deserialize(const kino_Stemmer *self, kino_InStream* instream)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Deserialize_OFFSET;
    const kino_Obj_deserialize_t method = *((kino_Obj_deserialize_t*)method_address);
    return method((kino_Obj*)self, instream);
}

extern size_t Kino_Stemmer_Dump_OFFSET;
static CHY_INLINE kino_Hash*
Kino_Stemmer_Dump(const kino_Stemmer *self)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Dump_OFFSET;
    const kino_Stemmer_dump_t method = *((kino_Stemmer_dump_t*)method_address);
    return method((kino_Stemmer*)self);
}

extern size_t Kino_Stemmer_Load_OFFSET;
static CHY_INLINE kino_Stemmer*
Kino_Stemmer_Load(const kino_Stemmer *self, kino_Obj* dump)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Load_OFFSET;
    const kino_Stemmer_load_t method = *((kino_Stemmer_load_t*)method_address);
    return method((kino_Stemmer*)self, dump);
}

extern size_t Kino_Stemmer_Mimic_OFFSET;
static CHY_INLINE void
Kino_Stemmer_Mimic(const kino_Stemmer *self, kino_Obj* other)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Mimic_OFFSET;
    const kino_Obj_mimic_t method = *((kino_Obj_mimic_t*)method_address);
    method((kino_Obj*)self, other);
}

extern size_t Kino_Stemmer_Transform_OFFSET;
static CHY_INLINE kino_Inversion*
Kino_Stemmer_Transform(const kino_Stemmer *self, kino_Inversion* inversion)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Transform_OFFSET;
    const kino_Stemmer_transform_t method = *((kino_Stemmer_transform_t*)method_address);
    return method((kino_Stemmer*)self, inversion);
}

extern size_t Kino_Stemmer_Transform_Text_OFFSET;
static CHY_INLINE kino_Inversion*
Kino_Stemmer_Transform_Text(const kino_Stemmer *self, kino_CharBuf* text)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Transform_Text_OFFSET;
    const kino_Analyzer_transform_text_t method = *((kino_Analyzer_transform_text_t*)method_address);
    return method((kino_Analyzer*)self, text);
}

extern size_t Kino_Stemmer_Split_OFFSET;
static CHY_INLINE kino_VArray*
Kino_Stemmer_Split(const kino_Stemmer *self, kino_CharBuf* text)
{
    char *const method_address = *(char**)self + Kino_Stemmer_Split_OFFSET;
    const kino_Analyzer_split_t method = *((kino_Analyzer_split_t*)method_address);
    return method((kino_Analyzer*)self, text);
}

typedef struct KINO_STEMMER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[24];
} KINO_STEMMER_VT;
extern struct KINO_STEMMER_VT KINO_STEMMER_vt;
#define KINO_STEMMER ((cfish_VTable*)&KINO_STEMMER_vt)

#ifdef KINO_USE_SHORT_NAMES
  #define Stemmer kino_Stemmer 
  #define STEMMER KINO_STEMMER
  #define Stemmer_new kino_Stemmer_new
  #define Stemmer_init kino_Stemmer_init
  #define Stemmer_load_snowball kino_Stemmer_load_snowball
  #define Stemmer_destroy_t kino_Stemmer_destroy_t
  #define Stemmer_destroy kino_Stemmer_destroy
  #define Stemmer_equals_t kino_Stemmer_equals_t
  #define Stemmer_equals kino_Stemmer_equals
  #define Stemmer_dump_t kino_Stemmer_dump_t
  #define Stemmer_dump kino_Stemmer_dump
  #define Stemmer_load_t kino_Stemmer_load_t
  #define Stemmer_load kino_Stemmer_load
  #define Stemmer_transform_t kino_Stemmer_transform_t
  #define Stemmer_transform kino_Stemmer_transform
  #define Stemmer_Make Kino_Stemmer_Make
  #define Stemmer_Get_RefCount Kino_Stemmer_Get_RefCount
  #define Stemmer_Inc_RefCount Kino_Stemmer_Inc_RefCount
  #define Stemmer_Dec_RefCount Kino_Stemmer_Dec_RefCount
  #define Stemmer_To_Host Kino_Stemmer_To_Host
  #define Stemmer_Clone Kino_Stemmer_Clone
  #define Stemmer_Destroy Kino_Stemmer_Destroy
  #define Stemmer_Equals Kino_Stemmer_Equals
  #define Stemmer_Compare_To Kino_Stemmer_Compare_To
  #define Stemmer_Hash_Sum Kino_Stemmer_Hash_Sum
  #define Stemmer_Get_VTable Kino_Stemmer_Get_VTable
  #define Stemmer_Get_Class_Name Kino_Stemmer_Get_Class_Name
  #define Stemmer_Is_A Kino_Stemmer_Is_A
  #define Stemmer_To_String Kino_Stemmer_To_String
  #define Stemmer_To_I64 Kino_Stemmer_To_I64
  #define Stemmer_To_F64 Kino_Stemmer_To_F64
  #define Stemmer_Serialize Kino_Stemmer_Serialize
  #define Stemmer_Deserialize Kino_Stemmer_Deserialize
  #define Stemmer_Dump Kino_Stemmer_Dump
  #define Stemmer_Load Kino_Stemmer_Load
  #define Stemmer_Mimic Kino_Stemmer_Mimic
  #define Stemmer_Transform Kino_Stemmer_Transform
  #define Stemmer_Transform_Text Kino_Stemmer_Transform_Text
  #define Stemmer_Split Kino_Stemmer_Split
#endif /* KINO_USE_SHORT_NAMES */




#ifdef __cplusplus
}
#endif

#endif /* H_KINOSEARCH_ANALYSIS_STEMMER */


/* Copyright 2005-2011 Marvin Humphrey
 *
 * This program is free software; you can redistribute it and/or modify
 * under the same terms as Perl itself.
 */


