/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/



#ifndef H_KINOSEARCH_INDEX_INDEXER
#define H_KINOSEARCH_INDEX_INDEXER 1


#ifdef __cplusplus
extern "C" {
#endif


#include "charmony.h"
#include "boil.h"
#include "KinoSearch/Object/Obj.h"

#ifdef C_KINO_INDEXER
struct kino_Indexer {
    kino_VTable* vtable;
    kino_ref_t ref;
    kino_Schema* schema;
    kino_Folder* folder;
    kino_Segment* segment;
    kino_IndexManager* manager;
    kino_PolyReader* polyreader;
    kino_Snapshot* snapshot;
    kino_SegWriter* seg_writer;
    kino_DeletionsWriter* del_writer;
    kino_FilePurger* file_purger;
    kino_Lock* write_lock;
    kino_Lock* merge_lock;
    kino_Doc* stock_doc;
    kino_CharBuf* snapfile;
    chy_bool_t truncate;
    chy_bool_t optimize;
    chy_bool_t needs_commit;
    chy_bool_t prepared;
};

#endif /* C_KINO_INDEXER */

extern int32_t kino_Indexer_TRUNCATE;
extern int32_t kino_Indexer_CREATE;


kino_Indexer*
kino_Indexer_new(kino_Schema* schema, kino_Obj* index, kino_IndexManager* manager, int32_t flags);

kino_Indexer*
kino_Indexer_init(kino_Indexer* self, kino_Schema* schema, kino_Obj* index, kino_IndexManager* manager, int32_t flags);

void
kino_Indexer_destroy(kino_Indexer* self);

void
kino_Indexer_add_doc(kino_Indexer* self, kino_Doc* doc, float boost);

void
kino_Indexer_add_index(kino_Indexer* self, kino_Obj* index);

void
kino_Indexer_delete_by_term(kino_Indexer* self, kino_CharBuf* field, kino_Obj* term);

void
kino_Indexer_delete_by_query(kino_Indexer* self, kino_Query* query);

void
kino_Indexer_optimize(kino_Indexer* self);

void
kino_Indexer_commit(kino_Indexer* self);

void
kino_Indexer_prepare_commit(kino_Indexer* self);

kino_SegWriter*
kino_Indexer_get_seg_writer(kino_Indexer* self);

kino_Doc*
kino_Indexer_get_stock_doc(kino_Indexer* self);


extern cfish_Callback kino_Indexer_destroy_CALLBACK;
extern cfish_Callback kino_Indexer_add_doc_CALLBACK;
extern cfish_Callback kino_Indexer_add_index_CALLBACK;
extern cfish_Callback kino_Indexer_delete_by_term_CALLBACK;
extern cfish_Callback kino_Indexer_delete_by_query_CALLBACK;
extern cfish_Callback kino_Indexer_optimize_CALLBACK;
extern cfish_Callback kino_Indexer_commit_CALLBACK;
extern cfish_Callback kino_Indexer_prepare_commit_CALLBACK;
extern cfish_Callback kino_Indexer_get_seg_writer_CALLBACK;


typedef void
(*kino_Indexer_destroy_t)(kino_Indexer* self);

typedef void
(*kino_Indexer_add_doc_t)(kino_Indexer* self, kino_Doc* doc, float boost);

typedef void
(*kino_Indexer_add_index_t)(kino_Indexer* self, kino_Obj* index);

typedef void
(*kino_Indexer_delete_by_term_t)(kino_Indexer* self, kino_CharBuf* field, kino_Obj* term);

typedef void
(*kino_Indexer_delete_by_query_t)(kino_Indexer* self, kino_Query* query);

typedef void
(*kino_Indexer_optimize_t)(kino_Indexer* self);

typedef void
(*kino_Indexer_commit_t)(kino_Indexer* self);

typedef void
(*kino_Indexer_prepare_commit_t)(kino_Indexer* self);

typedef kino_SegWriter*
(*kino_Indexer_get_seg_writer_t)(kino_Indexer* self);

typedef kino_Doc*
(*kino_Indexer_get_stock_doc_t)(kino_Indexer* self);

extern size_t Kino_Indexer_Make_OFFSET;
static CHY_INLINE kino_Obj*
Kino_Indexer_Make(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Make_OFFSET;
    const kino_Obj_make_t method = *((kino_Obj_make_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Kino_Indexer_Get_RefCount(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Get_RefCount_OFFSET;
    const kino_Obj_get_refcount_t method = *((kino_Obj_get_refcount_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_Inc_RefCount_OFFSET;
static CHY_INLINE kino_Obj*
Kino_Indexer_Inc_RefCount(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Inc_RefCount_OFFSET;
    const kino_Obj_inc_refcount_t method = *((kino_Obj_inc_refcount_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Kino_Indexer_Dec_RefCount(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Dec_RefCount_OFFSET;
    const kino_Obj_dec_refcount_t method = *((kino_Obj_dec_refcount_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_To_Host_OFFSET;
static CHY_INLINE void*
Kino_Indexer_To_Host(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_To_Host_OFFSET;
    const kino_Obj_to_host_t method = *((kino_Obj_to_host_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_Clone_OFFSET;
static CHY_INLINE kino_Obj*
Kino_Indexer_Clone(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Clone_OFFSET;
    const kino_Obj_clone_t method = *((kino_Obj_clone_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_Destroy_OFFSET;
static CHY_INLINE void
Kino_Indexer_Destroy(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Destroy_OFFSET;
    const kino_Indexer_destroy_t method = *((kino_Indexer_destroy_t*)method_address);
    method((kino_Indexer*)self);
}

extern size_t Kino_Indexer_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Kino_Indexer_Equals(const kino_Indexer *self, kino_Obj* other)
{
    char *const method_address = *(char**)self + Kino_Indexer_Equals_OFFSET;
    const kino_Obj_equals_t method = *((kino_Obj_equals_t*)method_address);
    return method((kino_Obj*)self, other);
}

extern size_t Kino_Indexer_Compare_To_OFFSET;
static CHY_INLINE int32_t
Kino_Indexer_Compare_To(const kino_Indexer *self, kino_Obj* other)
{
    char *const method_address = *(char**)self + Kino_Indexer_Compare_To_OFFSET;
    const kino_Obj_compare_to_t method = *((kino_Obj_compare_to_t*)method_address);
    return method((kino_Obj*)self, other);
}

extern size_t Kino_Indexer_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Kino_Indexer_Hash_Sum(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Hash_Sum_OFFSET;
    const kino_Obj_hash_sum_t method = *((kino_Obj_hash_sum_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_Get_VTable_OFFSET;
static CHY_INLINE kino_VTable*
Kino_Indexer_Get_VTable(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Get_VTable_OFFSET;
    const kino_Obj_get_vtable_t method = *((kino_Obj_get_vtable_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_Get_Class_Name_OFFSET;
static CHY_INLINE kino_CharBuf*
Kino_Indexer_Get_Class_Name(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Get_Class_Name_OFFSET;
    const kino_Obj_get_class_name_t method = *((kino_Obj_get_class_name_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Kino_Indexer_Is_A(const kino_Indexer *self, kino_VTable* ancestor)
{
    char *const method_address = *(char**)self + Kino_Indexer_Is_A_OFFSET;
    const kino_Obj_is_a_t method = *((kino_Obj_is_a_t*)method_address);
    return method((kino_Obj*)self, ancestor);
}

extern size_t Kino_Indexer_To_String_OFFSET;
static CHY_INLINE kino_CharBuf*
Kino_Indexer_To_String(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_To_String_OFFSET;
    const kino_Obj_to_string_t method = *((kino_Obj_to_string_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_To_I64_OFFSET;
static CHY_INLINE int64_t
Kino_Indexer_To_I64(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_To_I64_OFFSET;
    const kino_Obj_to_i64_t method = *((kino_Obj_to_i64_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_To_F64_OFFSET;
static CHY_INLINE double
Kino_Indexer_To_F64(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_To_F64_OFFSET;
    const kino_Obj_to_f64_t method = *((kino_Obj_to_f64_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_Serialize_OFFSET;
static CHY_INLINE void
Kino_Indexer_Serialize(const kino_Indexer *self, kino_OutStream* outstream)
{
    char *const method_address = *(char**)self + Kino_Indexer_Serialize_OFFSET;
    const kino_Obj_serialize_t method = *((kino_Obj_serialize_t*)method_address);
    method((kino_Obj*)self, outstream);
}

extern size_t Kino_Indexer_Deserialize_OFFSET;
static CHY_INLINE kino_Obj*
Kino_Indexer_Deserialize(const kino_Indexer *self, kino_InStream* instream)
{
    char *const method_address = *(char**)self + Kino_Indexer_Deserialize_OFFSET;
    const kino_Obj_deserialize_t method = *((kino_Obj_deserialize_t*)method_address);
    return method((kino_Obj*)self, instream);
}

extern size_t Kino_Indexer_Dump_OFFSET;
static CHY_INLINE kino_Obj*
Kino_Indexer_Dump(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Dump_OFFSET;
    const kino_Obj_dump_t method = *((kino_Obj_dump_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_Indexer_Load_OFFSET;
static CHY_INLINE kino_Obj*
Kino_Indexer_Load(const kino_Indexer *self, kino_Obj* dump)
{
    char *const method_address = *(char**)self + Kino_Indexer_Load_OFFSET;
    const kino_Obj_load_t method = *((kino_Obj_load_t*)method_address);
    return method((kino_Obj*)self, dump);
}

extern size_t Kino_Indexer_Mimic_OFFSET;
static CHY_INLINE void
Kino_Indexer_Mimic(const kino_Indexer *self, kino_Obj* other)
{
    char *const method_address = *(char**)self + Kino_Indexer_Mimic_OFFSET;
    const kino_Obj_mimic_t method = *((kino_Obj_mimic_t*)method_address);
    method((kino_Obj*)self, other);
}

extern size_t Kino_Indexer_Add_Doc_OFFSET;
static CHY_INLINE void
Kino_Indexer_Add_Doc(const kino_Indexer *self, kino_Doc* doc, float boost)
{
    char *const method_address = *(char**)self + Kino_Indexer_Add_Doc_OFFSET;
    const kino_Indexer_add_doc_t method = *((kino_Indexer_add_doc_t*)method_address);
    method((kino_Indexer*)self, doc, boost);
}

extern size_t Kino_Indexer_Add_Index_OFFSET;
static CHY_INLINE void
Kino_Indexer_Add_Index(const kino_Indexer *self, kino_Obj* index)
{
    char *const method_address = *(char**)self + Kino_Indexer_Add_Index_OFFSET;
    const kino_Indexer_add_index_t method = *((kino_Indexer_add_index_t*)method_address);
    method((kino_Indexer*)self, index);
}

extern size_t Kino_Indexer_Delete_By_Term_OFFSET;
static CHY_INLINE void
Kino_Indexer_Delete_By_Term(const kino_Indexer *self, kino_CharBuf* field, kino_Obj* term)
{
    char *const method_address = *(char**)self + Kino_Indexer_Delete_By_Term_OFFSET;
    const kino_Indexer_delete_by_term_t method = *((kino_Indexer_delete_by_term_t*)method_address);
    method((kino_Indexer*)self, field, term);
}

extern size_t Kino_Indexer_Delete_By_Query_OFFSET;
static CHY_INLINE void
Kino_Indexer_Delete_By_Query(const kino_Indexer *self, kino_Query* query)
{
    char *const method_address = *(char**)self + Kino_Indexer_Delete_By_Query_OFFSET;
    const kino_Indexer_delete_by_query_t method = *((kino_Indexer_delete_by_query_t*)method_address);
    method((kino_Indexer*)self, query);
}

extern size_t Kino_Indexer_Optimize_OFFSET;
static CHY_INLINE void
Kino_Indexer_Optimize(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Optimize_OFFSET;
    const kino_Indexer_optimize_t method = *((kino_Indexer_optimize_t*)method_address);
    method((kino_Indexer*)self);
}

extern size_t Kino_Indexer_Commit_OFFSET;
static CHY_INLINE void
Kino_Indexer_Commit(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Commit_OFFSET;
    const kino_Indexer_commit_t method = *((kino_Indexer_commit_t*)method_address);
    method((kino_Indexer*)self);
}

extern size_t Kino_Indexer_Prepare_Commit_OFFSET;
static CHY_INLINE void
Kino_Indexer_Prepare_Commit(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Prepare_Commit_OFFSET;
    const kino_Indexer_prepare_commit_t method = *((kino_Indexer_prepare_commit_t*)method_address);
    method((kino_Indexer*)self);
}

extern size_t Kino_Indexer_Get_Seg_Writer_OFFSET;
static CHY_INLINE kino_SegWriter*
Kino_Indexer_Get_Seg_Writer(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Get_Seg_Writer_OFFSET;
    const kino_Indexer_get_seg_writer_t method = *((kino_Indexer_get_seg_writer_t*)method_address);
    return method((kino_Indexer*)self);
}

extern size_t Kino_Indexer_Get_Stock_Doc_OFFSET;
static CHY_INLINE kino_Doc*
Kino_Indexer_Get_Stock_Doc(const kino_Indexer *self)
{
    char *const method_address = *(char**)self + Kino_Indexer_Get_Stock_Doc_OFFSET;
    const kino_Indexer_get_stock_doc_t method = *((kino_Indexer_get_stock_doc_t*)method_address);
    return method((kino_Indexer*)self);
}

typedef struct KINO_INDEXER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[30];
} KINO_INDEXER_VT;
extern struct KINO_INDEXER_VT KINO_INDEXER_vt;
#define KINO_INDEXER ((cfish_VTable*)&KINO_INDEXER_vt)

#ifdef KINO_USE_SHORT_NAMES
  #define Indexer kino_Indexer 
  #define INDEXER KINO_INDEXER
  #define Indexer_new kino_Indexer_new
  #define Indexer_init kino_Indexer_init
  #define Indexer_TRUNCATE kino_Indexer_TRUNCATE
  #define Indexer_CREATE kino_Indexer_CREATE
  #define Indexer_destroy_t kino_Indexer_destroy_t
  #define Indexer_destroy kino_Indexer_destroy
  #define Indexer_add_doc_t kino_Indexer_add_doc_t
  #define Indexer_add_doc kino_Indexer_add_doc
  #define Indexer_add_index_t kino_Indexer_add_index_t
  #define Indexer_add_index kino_Indexer_add_index
  #define Indexer_delete_by_term_t kino_Indexer_delete_by_term_t
  #define Indexer_delete_by_term kino_Indexer_delete_by_term
  #define Indexer_delete_by_query_t kino_Indexer_delete_by_query_t
  #define Indexer_delete_by_query kino_Indexer_delete_by_query
  #define Indexer_optimize_t kino_Indexer_optimize_t
  #define Indexer_optimize kino_Indexer_optimize
  #define Indexer_commit_t kino_Indexer_commit_t
  #define Indexer_commit kino_Indexer_commit
  #define Indexer_prepare_commit_t kino_Indexer_prepare_commit_t
  #define Indexer_prepare_commit kino_Indexer_prepare_commit
  #define Indexer_get_seg_writer_t kino_Indexer_get_seg_writer_t
  #define Indexer_get_seg_writer kino_Indexer_get_seg_writer
  #define Indexer_get_stock_doc_t kino_Indexer_get_stock_doc_t
  #define Indexer_get_stock_doc kino_Indexer_get_stock_doc
  #define Indexer_Make Kino_Indexer_Make
  #define Indexer_Get_RefCount Kino_Indexer_Get_RefCount
  #define Indexer_Inc_RefCount Kino_Indexer_Inc_RefCount
  #define Indexer_Dec_RefCount Kino_Indexer_Dec_RefCount
  #define Indexer_To_Host Kino_Indexer_To_Host
  #define Indexer_Clone Kino_Indexer_Clone
  #define Indexer_Destroy Kino_Indexer_Destroy
  #define Indexer_Equals Kino_Indexer_Equals
  #define Indexer_Compare_To Kino_Indexer_Compare_To
  #define Indexer_Hash_Sum Kino_Indexer_Hash_Sum
  #define Indexer_Get_VTable Kino_Indexer_Get_VTable
  #define Indexer_Get_Class_Name Kino_Indexer_Get_Class_Name
  #define Indexer_Is_A Kino_Indexer_Is_A
  #define Indexer_To_String Kino_Indexer_To_String
  #define Indexer_To_I64 Kino_Indexer_To_I64
  #define Indexer_To_F64 Kino_Indexer_To_F64
  #define Indexer_Serialize Kino_Indexer_Serialize
  #define Indexer_Deserialize Kino_Indexer_Deserialize
  #define Indexer_Dump Kino_Indexer_Dump
  #define Indexer_Load Kino_Indexer_Load
  #define Indexer_Mimic Kino_Indexer_Mimic
  #define Indexer_Add_Doc Kino_Indexer_Add_Doc
  #define Indexer_Add_Index Kino_Indexer_Add_Index
  #define Indexer_Delete_By_Term Kino_Indexer_Delete_By_Term
  #define Indexer_Delete_By_Query Kino_Indexer_Delete_By_Query
  #define Indexer_Optimize Kino_Indexer_Optimize
  #define Indexer_Commit Kino_Indexer_Commit
  #define Indexer_Prepare_Commit Kino_Indexer_Prepare_Commit
  #define Indexer_Get_Seg_Writer Kino_Indexer_Get_Seg_Writer
  #define Indexer_Get_Stock_Doc Kino_Indexer_Get_Stock_Doc
#endif /* KINO_USE_SHORT_NAMES */




#ifdef __cplusplus
}
#endif

#endif /* H_KINOSEARCH_INDEX_INDEXER */


/* Copyright 2005-2011 Marvin Humphrey
 *
 * This program is free software; you can redistribute it and/or modify
 * under the same terms as Perl itself.
 */


