/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/



#ifndef H_KINOSEARCH_INDEX_POSTINGPOOL
#define H_KINOSEARCH_INDEX_POSTINGPOOL 1


#ifdef __cplusplus
extern "C" {
#endif


#include "charmony.h"
#include "boil.h"
#include "KinoSearch/Util/SortExternal.h"

#ifdef C_KINO_POSTINGPOOL
struct kino_PostingPool {
    kino_VTable* vtable;
    kino_ref_t ref;
    uint8_t* cache;
    uint32_t cache_cap;
    uint32_t cache_max;
    uint32_t cache_tick;
    uint8_t* scratch;
    uint32_t scratch_cap;
    kino_VArray* runs;
    uint32_t num_slices;
    uint8_t** slice_starts;
    uint32_t* slice_sizes;
    uint32_t mem_thresh;
    size_t width;
    chy_bool_t flipped;
    kino_Schema* schema;
    kino_Snapshot* snapshot;
    kino_Segment* segment;
    kino_PolyReader* polyreader;
    kino_CharBuf* field;
    kino_LexiconWriter* lex_writer;
    kino_Lexicon* lexicon;
    kino_PostingList* plist;
    kino_MemoryPool* mem_pool;
    kino_I32Array* doc_map;
    int32_t field_num;
    int32_t doc_base;
    int32_t last_doc_id;
    uint32_t post_count;
    kino_OutStream* lex_temp_out;
    kino_OutStream* post_temp_out;
    kino_OutStream* skip_out;
    kino_InStream* lex_temp_in;
    kino_InStream* post_temp_in;
    kino_FieldType* type;
    kino_Posting* posting;
    kino_SkipStepper* skip_stepper;
    int64_t lex_start;
    int64_t post_start;
    int64_t lex_end;
    int64_t post_end;
};

#endif /* C_KINO_POSTINGPOOL */



kino_PostingPool*
kino_PostPool_new(kino_Schema* schema, kino_Snapshot* snapshot, kino_Segment* segment, kino_PolyReader* polyreader, const kino_CharBuf* field, kino_LexiconWriter* lex_writer, kino_MemoryPool* mem_pool, kino_OutStream* lex_temp_out, kino_OutStream* post_temp_out, kino_OutStream* skip_out);

kino_PostingPool*
kino_PostPool_init(kino_PostingPool* self, kino_Schema* schema, kino_Snapshot* snapshot, kino_Segment* segment, kino_PolyReader* polyreader, const kino_CharBuf* field, kino_LexiconWriter* lex_writer, kino_MemoryPool* mem_pool, kino_OutStream* lex_temp_out, kino_OutStream* post_temp_out, kino_OutStream* skip_out);

void
kino_PostPool_destroy(kino_PostingPool* self);

int
kino_PostPool_compare(kino_PostingPool* self, void* va, void* vb);

void
kino_PostPool_flush(kino_PostingPool* self);

void
kino_PostPool_flip(kino_PostingPool* self);

uint32_t
kino_PostPool_refill(kino_PostingPool* self);

void
kino_PostPool_add_inversion(kino_PostingPool* self, kino_Inversion* inversion, int32_t doc_id, float doc_boost, float length_norm);

void
kino_PostPool_shrink(kino_PostingPool* self);

kino_MemoryPool*
kino_PostPool_get_mem_pool(kino_PostingPool* self);

void
kino_PostPool_add_segment(kino_PostingPool* self, kino_SegReader* reader, kino_I32Array* doc_map, int32_t doc_base);

void
kino_PostPool_finish(kino_PostingPool* self);


extern cfish_Callback kino_PostPool_destroy_CALLBACK;


typedef void
(*kino_PostPool_destroy_t)(kino_PostingPool* self);

typedef int
(*kino_PostPool_compare_t)(kino_PostingPool* self, void* va, void* vb);

typedef void
(*kino_PostPool_flush_t)(kino_PostingPool* self);

typedef void
(*kino_PostPool_flip_t)(kino_PostingPool* self);

typedef uint32_t
(*kino_PostPool_refill_t)(kino_PostingPool* self);

typedef void
(*kino_PostPool_add_inversion_t)(kino_PostingPool* self, kino_Inversion* inversion, int32_t doc_id, float doc_boost, float length_norm);

typedef void
(*kino_PostPool_shrink_t)(kino_PostingPool* self);

typedef kino_MemoryPool*
(*kino_PostPool_get_mem_pool_t)(kino_PostingPool* self);

typedef void
(*kino_PostPool_add_segment_t)(kino_PostingPool* self, kino_SegReader* reader, kino_I32Array* doc_map, int32_t doc_base);

typedef void
(*kino_PostPool_finish_t)(kino_PostingPool* self);

extern size_t Kino_PostPool_Make_OFFSET;
static CHY_INLINE kino_Obj*
Kino_PostPool_Make(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Make_OFFSET;
    const kino_Obj_make_t method = *((kino_Obj_make_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Kino_PostPool_Get_RefCount(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Get_RefCount_OFFSET;
    const kino_Obj_get_refcount_t method = *((kino_Obj_get_refcount_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_Inc_RefCount_OFFSET;
static CHY_INLINE kino_Obj*
Kino_PostPool_Inc_RefCount(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Inc_RefCount_OFFSET;
    const kino_Obj_inc_refcount_t method = *((kino_Obj_inc_refcount_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Kino_PostPool_Dec_RefCount(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Dec_RefCount_OFFSET;
    const kino_Obj_dec_refcount_t method = *((kino_Obj_dec_refcount_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_To_Host_OFFSET;
static CHY_INLINE void*
Kino_PostPool_To_Host(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_To_Host_OFFSET;
    const kino_Obj_to_host_t method = *((kino_Obj_to_host_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_Clone_OFFSET;
static CHY_INLINE kino_Obj*
Kino_PostPool_Clone(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Clone_OFFSET;
    const kino_Obj_clone_t method = *((kino_Obj_clone_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_Destroy_OFFSET;
static CHY_INLINE void
Kino_PostPool_Destroy(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Destroy_OFFSET;
    const kino_PostPool_destroy_t method = *((kino_PostPool_destroy_t*)method_address);
    method((kino_PostingPool*)self);
}

extern size_t Kino_PostPool_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Kino_PostPool_Equals(const kino_PostingPool *self, kino_Obj* other)
{
    char *const method_address = *(char**)self + Kino_PostPool_Equals_OFFSET;
    const kino_Obj_equals_t method = *((kino_Obj_equals_t*)method_address);
    return method((kino_Obj*)self, other);
}

extern size_t Kino_PostPool_Compare_To_OFFSET;
static CHY_INLINE int32_t
Kino_PostPool_Compare_To(const kino_PostingPool *self, kino_Obj* other)
{
    char *const method_address = *(char**)self + Kino_PostPool_Compare_To_OFFSET;
    const kino_Obj_compare_to_t method = *((kino_Obj_compare_to_t*)method_address);
    return method((kino_Obj*)self, other);
}

extern size_t Kino_PostPool_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Kino_PostPool_Hash_Sum(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Hash_Sum_OFFSET;
    const kino_Obj_hash_sum_t method = *((kino_Obj_hash_sum_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_Get_VTable_OFFSET;
static CHY_INLINE kino_VTable*
Kino_PostPool_Get_VTable(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Get_VTable_OFFSET;
    const kino_Obj_get_vtable_t method = *((kino_Obj_get_vtable_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_Get_Class_Name_OFFSET;
static CHY_INLINE kino_CharBuf*
Kino_PostPool_Get_Class_Name(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Get_Class_Name_OFFSET;
    const kino_Obj_get_class_name_t method = *((kino_Obj_get_class_name_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Kino_PostPool_Is_A(const kino_PostingPool *self, kino_VTable* ancestor)
{
    char *const method_address = *(char**)self + Kino_PostPool_Is_A_OFFSET;
    const kino_Obj_is_a_t method = *((kino_Obj_is_a_t*)method_address);
    return method((kino_Obj*)self, ancestor);
}

extern size_t Kino_PostPool_To_String_OFFSET;
static CHY_INLINE kino_CharBuf*
Kino_PostPool_To_String(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_To_String_OFFSET;
    const kino_Obj_to_string_t method = *((kino_Obj_to_string_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_To_I64_OFFSET;
static CHY_INLINE int64_t
Kino_PostPool_To_I64(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_To_I64_OFFSET;
    const kino_Obj_to_i64_t method = *((kino_Obj_to_i64_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_To_F64_OFFSET;
static CHY_INLINE double
Kino_PostPool_To_F64(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_To_F64_OFFSET;
    const kino_Obj_to_f64_t method = *((kino_Obj_to_f64_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_Serialize_OFFSET;
static CHY_INLINE void
Kino_PostPool_Serialize(const kino_PostingPool *self, kino_OutStream* outstream)
{
    char *const method_address = *(char**)self + Kino_PostPool_Serialize_OFFSET;
    const kino_Obj_serialize_t method = *((kino_Obj_serialize_t*)method_address);
    method((kino_Obj*)self, outstream);
}

extern size_t Kino_PostPool_Deserialize_OFFSET;
static CHY_INLINE kino_Obj*
Kino_PostPool_Deserialize(const kino_PostingPool *self, kino_InStream* instream)
{
    char *const method_address = *(char**)self + Kino_PostPool_Deserialize_OFFSET;
    const kino_Obj_deserialize_t method = *((kino_Obj_deserialize_t*)method_address);
    return method((kino_Obj*)self, instream);
}

extern size_t Kino_PostPool_Dump_OFFSET;
static CHY_INLINE kino_Obj*
Kino_PostPool_Dump(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Dump_OFFSET;
    const kino_Obj_dump_t method = *((kino_Obj_dump_t*)method_address);
    return method((kino_Obj*)self);
}

extern size_t Kino_PostPool_Load_OFFSET;
static CHY_INLINE kino_Obj*
Kino_PostPool_Load(const kino_PostingPool *self, kino_Obj* dump)
{
    char *const method_address = *(char**)self + Kino_PostPool_Load_OFFSET;
    const kino_Obj_load_t method = *((kino_Obj_load_t*)method_address);
    return method((kino_Obj*)self, dump);
}

extern size_t Kino_PostPool_Mimic_OFFSET;
static CHY_INLINE void
Kino_PostPool_Mimic(const kino_PostingPool *self, kino_Obj* other)
{
    char *const method_address = *(char**)self + Kino_PostPool_Mimic_OFFSET;
    const kino_Obj_mimic_t method = *((kino_Obj_mimic_t*)method_address);
    method((kino_Obj*)self, other);
}

extern size_t Kino_PostPool_Compare_OFFSET;
static CHY_INLINE int
Kino_PostPool_Compare(const kino_PostingPool *self, void* va, void* vb)
{
    char *const method_address = *(char**)self + Kino_PostPool_Compare_OFFSET;
    const kino_PostPool_compare_t method = *((kino_PostPool_compare_t*)method_address);
    return method((kino_PostingPool*)self, va, vb);
}

extern size_t Kino_PostPool_Flush_OFFSET;
static CHY_INLINE void
Kino_PostPool_Flush(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Flush_OFFSET;
    const kino_PostPool_flush_t method = *((kino_PostPool_flush_t*)method_address);
    method((kino_PostingPool*)self);
}

extern size_t Kino_PostPool_Feed_OFFSET;
static CHY_INLINE void
Kino_PostPool_Feed(const kino_PostingPool *self, void* data)
{
    char *const method_address = *(char**)self + Kino_PostPool_Feed_OFFSET;
    const kino_SortEx_feed_t method = *((kino_SortEx_feed_t*)method_address);
    method((kino_SortExternal*)self, data);
}

extern size_t Kino_PostPool_Flip_OFFSET;
static CHY_INLINE void
Kino_PostPool_Flip(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Flip_OFFSET;
    const kino_PostPool_flip_t method = *((kino_PostPool_flip_t*)method_address);
    method((kino_PostingPool*)self);
}

extern size_t Kino_PostPool_Fetch_OFFSET;
static CHY_INLINE void*
Kino_PostPool_Fetch(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Fetch_OFFSET;
    const kino_SortEx_fetch_t method = *((kino_SortEx_fetch_t*)method_address);
    return method((kino_SortExternal*)self);
}

extern size_t Kino_PostPool_Peek_OFFSET;
static CHY_INLINE void*
Kino_PostPool_Peek(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Peek_OFFSET;
    const kino_SortEx_peek_t method = *((kino_SortEx_peek_t*)method_address);
    return method((kino_SortExternal*)self);
}

extern size_t Kino_PostPool_Add_Run_OFFSET;
static CHY_INLINE void
Kino_PostPool_Add_Run(const kino_PostingPool *self, kino_SortExternal* run)
{
    char *const method_address = *(char**)self + Kino_PostPool_Add_Run_OFFSET;
    const kino_SortEx_add_run_t method = *((kino_SortEx_add_run_t*)method_address);
    method((kino_SortExternal*)self, run);
}

extern size_t Kino_PostPool_Refill_OFFSET;
static CHY_INLINE uint32_t
Kino_PostPool_Refill(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Refill_OFFSET;
    const kino_PostPool_refill_t method = *((kino_PostPool_refill_t*)method_address);
    return method((kino_PostingPool*)self);
}

extern size_t Kino_PostPool_Sort_Cache_OFFSET;
static CHY_INLINE void
Kino_PostPool_Sort_Cache(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Sort_Cache_OFFSET;
    const kino_SortEx_sort_cache_t method = *((kino_SortEx_sort_cache_t*)method_address);
    method((kino_SortExternal*)self);
}

extern size_t Kino_PostPool_Clear_Cache_OFFSET;
static CHY_INLINE void
Kino_PostPool_Clear_Cache(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Clear_Cache_OFFSET;
    const kino_SortEx_clear_cache_t method = *((kino_SortEx_clear_cache_t*)method_address);
    method((kino_SortExternal*)self);
}

extern size_t Kino_PostPool_Cache_Count_OFFSET;
static CHY_INLINE uint32_t
Kino_PostPool_Cache_Count(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Cache_Count_OFFSET;
    const kino_SortEx_cache_count_t method = *((kino_SortEx_cache_count_t*)method_address);
    return method((kino_SortExternal*)self);
}

extern size_t Kino_PostPool_Grow_Cache_OFFSET;
static CHY_INLINE void
Kino_PostPool_Grow_Cache(const kino_PostingPool *self, uint32_t new_cache_cap)
{
    char *const method_address = *(char**)self + Kino_PostPool_Grow_Cache_OFFSET;
    const kino_SortEx_grow_cache_t method = *((kino_SortEx_grow_cache_t*)method_address);
    method((kino_SortExternal*)self, new_cache_cap);
}

extern size_t Kino_PostPool_Set_Mem_Thresh_OFFSET;
static CHY_INLINE void
Kino_PostPool_Set_Mem_Thresh(const kino_PostingPool *self, uint32_t mem_thresh)
{
    char *const method_address = *(char**)self + Kino_PostPool_Set_Mem_Thresh_OFFSET;
    const kino_SortEx_set_mem_thresh_t method = *((kino_SortEx_set_mem_thresh_t*)method_address);
    method((kino_SortExternal*)self, mem_thresh);
}

extern size_t Kino_PostPool_Add_Inversion_OFFSET;
static CHY_INLINE void
Kino_PostPool_Add_Inversion(const kino_PostingPool *self, kino_Inversion* inversion, int32_t doc_id, float doc_boost, float length_norm)
{
    char *const method_address = *(char**)self + Kino_PostPool_Add_Inversion_OFFSET;
    const kino_PostPool_add_inversion_t method = *((kino_PostPool_add_inversion_t*)method_address);
    method((kino_PostingPool*)self, inversion, doc_id, doc_boost, length_norm);
}

extern size_t Kino_PostPool_Shrink_OFFSET;
static CHY_INLINE void
Kino_PostPool_Shrink(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Shrink_OFFSET;
    const kino_PostPool_shrink_t method = *((kino_PostPool_shrink_t*)method_address);
    method((kino_PostingPool*)self);
}

extern size_t Kino_PostPool_Get_Mem_Pool_OFFSET;
static CHY_INLINE kino_MemoryPool*
Kino_PostPool_Get_Mem_Pool(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Get_Mem_Pool_OFFSET;
    const kino_PostPool_get_mem_pool_t method = *((kino_PostPool_get_mem_pool_t*)method_address);
    return method((kino_PostingPool*)self);
}

extern size_t Kino_PostPool_Add_Segment_OFFSET;
static CHY_INLINE void
Kino_PostPool_Add_Segment(const kino_PostingPool *self, kino_SegReader* reader, kino_I32Array* doc_map, int32_t doc_base)
{
    char *const method_address = *(char**)self + Kino_PostPool_Add_Segment_OFFSET;
    const kino_PostPool_add_segment_t method = *((kino_PostPool_add_segment_t*)method_address);
    method((kino_PostingPool*)self, reader, doc_map, doc_base);
}

extern size_t Kino_PostPool_Finish_OFFSET;
static CHY_INLINE void
Kino_PostPool_Finish(const kino_PostingPool *self)
{
    char *const method_address = *(char**)self + Kino_PostPool_Finish_OFFSET;
    const kino_PostPool_finish_t method = *((kino_PostPool_finish_t*)method_address);
    method((kino_PostingPool*)self);
}

typedef struct KINO_POSTINGPOOL_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[39];
} KINO_POSTINGPOOL_VT;
extern struct KINO_POSTINGPOOL_VT KINO_POSTINGPOOL_vt;
#define KINO_POSTINGPOOL ((cfish_VTable*)&KINO_POSTINGPOOL_vt)

#ifdef KINO_USE_SHORT_NAMES
  #define PostingPool kino_PostingPool 
  #define POSTINGPOOL KINO_POSTINGPOOL
  #define PostPool_new kino_PostPool_new
  #define PostPool_init kino_PostPool_init
  #define PostPool_destroy_t kino_PostPool_destroy_t
  #define PostPool_destroy kino_PostPool_destroy
  #define PostPool_compare_t kino_PostPool_compare_t
  #define PostPool_compare kino_PostPool_compare
  #define PostPool_flush_t kino_PostPool_flush_t
  #define PostPool_flush kino_PostPool_flush
  #define PostPool_flip_t kino_PostPool_flip_t
  #define PostPool_flip kino_PostPool_flip
  #define PostPool_refill_t kino_PostPool_refill_t
  #define PostPool_refill kino_PostPool_refill
  #define PostPool_add_inversion_t kino_PostPool_add_inversion_t
  #define PostPool_add_inversion kino_PostPool_add_inversion
  #define PostPool_shrink_t kino_PostPool_shrink_t
  #define PostPool_shrink kino_PostPool_shrink
  #define PostPool_get_mem_pool_t kino_PostPool_get_mem_pool_t
  #define PostPool_get_mem_pool kino_PostPool_get_mem_pool
  #define PostPool_add_segment_t kino_PostPool_add_segment_t
  #define PostPool_add_segment kino_PostPool_add_segment
  #define PostPool_finish_t kino_PostPool_finish_t
  #define PostPool_finish kino_PostPool_finish
  #define PostPool_Make Kino_PostPool_Make
  #define PostPool_Get_RefCount Kino_PostPool_Get_RefCount
  #define PostPool_Inc_RefCount Kino_PostPool_Inc_RefCount
  #define PostPool_Dec_RefCount Kino_PostPool_Dec_RefCount
  #define PostPool_To_Host Kino_PostPool_To_Host
  #define PostPool_Clone Kino_PostPool_Clone
  #define PostPool_Destroy Kino_PostPool_Destroy
  #define PostPool_Equals Kino_PostPool_Equals
  #define PostPool_Compare_To Kino_PostPool_Compare_To
  #define PostPool_Hash_Sum Kino_PostPool_Hash_Sum
  #define PostPool_Get_VTable Kino_PostPool_Get_VTable
  #define PostPool_Get_Class_Name Kino_PostPool_Get_Class_Name
  #define PostPool_Is_A Kino_PostPool_Is_A
  #define PostPool_To_String Kino_PostPool_To_String
  #define PostPool_To_I64 Kino_PostPool_To_I64
  #define PostPool_To_F64 Kino_PostPool_To_F64
  #define PostPool_Serialize Kino_PostPool_Serialize
  #define PostPool_Deserialize Kino_PostPool_Deserialize
  #define PostPool_Dump Kino_PostPool_Dump
  #define PostPool_Load Kino_PostPool_Load
  #define PostPool_Mimic Kino_PostPool_Mimic
  #define PostPool_Compare Kino_PostPool_Compare
  #define PostPool_Flush Kino_PostPool_Flush
  #define PostPool_Feed Kino_PostPool_Feed
  #define PostPool_Flip Kino_PostPool_Flip
  #define PostPool_Fetch Kino_PostPool_Fetch
  #define PostPool_Peek Kino_PostPool_Peek
  #define PostPool_Add_Run Kino_PostPool_Add_Run
  #define PostPool_Refill Kino_PostPool_Refill
  #define PostPool_Sort_Cache Kino_PostPool_Sort_Cache
  #define PostPool_Clear_Cache Kino_PostPool_Clear_Cache
  #define PostPool_Cache_Count Kino_PostPool_Cache_Count
  #define PostPool_Grow_Cache Kino_PostPool_Grow_Cache
  #define PostPool_Set_Mem_Thresh Kino_PostPool_Set_Mem_Thresh
  #define PostPool_Add_Inversion Kino_PostPool_Add_Inversion
  #define PostPool_Shrink Kino_PostPool_Shrink
  #define PostPool_Get_Mem_Pool Kino_PostPool_Get_Mem_Pool
  #define PostPool_Add_Segment Kino_PostPool_Add_Segment
  #define PostPool_Finish Kino_PostPool_Finish
#endif /* KINO_USE_SHORT_NAMES */




#ifdef __cplusplus
}
#endif

#endif /* H_KINOSEARCH_INDEX_POSTINGPOOL */


/* Copyright 2005-2011 Marvin Humphrey
 *
 * This program is free software; you can redistribute it and/or modify
 * under the same terms as Perl itself.
 */


