#include "XSBind.h"
#include "boil.h"
#include "kino_boot.h"

#include "KinoSearch/Object/Host.h"
#include "KinoSearch/Util/Memory.h"
#include "KinoSearch/Util/StringHelper.h"

#include "Charmonizer/Test.h"
#include "Charmonizer/Test/AllTests.h"

#include "KinoSearch/Test/TestQueryParserLogic.h"
#include "KinoSearch/Test/Util/TestMemoryPool.h"
#include "KinoSearch/Test/Analysis/TestStemmer.h"
#include "KinoSearch/Test/Store/TestFileHandle.h"
#include "KinoSearch/Util/StringHelper.h"
#include "KinoSearch/Test/Analysis/TestAnalyzer.h"
#include "KinoSearch/Test/Search/TestPhraseQuery.h"
#include "KinoSearch/Test/Search/TestNoMatchQuery.h"
#include "KinoSearch/Util/Memory.h"
#include "KinoSearch/Test/Analysis/TestCaseFolder.h"
#include "KinoSearch/Test/Util/TestJson.h"
#include "KinoSearch/Object/Host.h"
#include "KinoSearch/Test/Plan/TestFieldType.h"
#include "KinoSearch/Test/Search/TestSeriesMatcher.h"
#include "KinoSearch/Test/Search/TestReqOptQuery.h"
#include "KinoSearch/Object/Obj.h"
#include "KinoSearch/Highlight/Highlighter.h"
#include "KinoSearch/Index/TermInfo.h"
#include "KinoSearch/Index/Inverter.h"
#include "KinoSearch/Index/DocVector.h"
#include "KinoSearch/Index/Inverter.h"
#include "KinoSearch/Store/Lock.h"
#include "KinoSearch/Store/Lock.h"
#include "KinoSearch/Store/SharedLock.h"
#include "KinoSearch/Search/QueryParser.h"
#include "KinoSearch/Index/IndexManager.h"
#include "KinoSearch/Search/QueryParser.h"
#include "KinoSearch/Search/TopDocs.h"
#include "KinoSearch/Analysis/Token.h"
#include "KinoSearch/Test/Object/TestByteBuf.h"
#include "KinoSearch/Index/Snapshot.h"
#include "KinoSearch/Search/SortRule.h"
#include "KinoSearch/Test/Object/TestCharBuf.h"
#include "KinoSearch/Highlight/HeatMap.h"
#include "KinoSearch/Object/LockFreeRegistry.h"
#include "KinoSearch/Util/Json.h"
#include "KinoSearch/Util/MemoryPool.h"
#include "KinoSearch/Index/SortCache.h"
#include "KinoSearch/Index/SortCache/TextSortCache.h"
#include "KinoSearch/Index/SortCache/NumericSortCache.h"
#include "KinoSearch/Index/SortCache/NumericSortCache.h"
#include "KinoSearch/Index/SortCache/NumericSortCache.h"
#include "KinoSearch/Index/SortCache/NumericSortCache.h"
#include "KinoSearch/Index/SortCache/NumericSortCache.h"
#include "KinoSearch/Object/Num.h"
#include "KinoSearch/Object/Num.h"
#include "KinoSearch/Object/Num.h"
#include "KinoSearch/Object/Num.h"
#include "KinoSearch/Object/Num.h"
#include "KinoSearch/Object/Num.h"
#include "KinoSearch/Object/Num.h"
#include "KinoSearch/Store/LockFactory.h"
#include "KinoSearch/Object/VTable.h"
#include "KinoSearch/Store/FileHandle.h"
#include "KinoSearch/Test/Store/MockFileHandle.h"
#include "KinoSearch/Store/FSFileHandle.h"
#include "KinoSearch/Store/RAMFileHandle.h"
#include "KinoSearch/Search/SortSpec.h"
#include "KinoSearch/Object/Err.h"
#include "KinoSearch/Store/Lock.h"
#include "KinoSearch/Search/QueryParser.h"
#include "KinoSearch/Analysis/Inversion.h"
#include "KinoSearch/Index/DataWriter.h"
#include "KinoSearch/Index/HighlightWriter.h"
#include "KinoSearch/Index/LexiconWriter.h"
#include "KinoSearch/Index/DeletionsWriter.h"
#include "KinoSearch/Index/DeletionsWriter.h"
#include "KinoSearch/Index/PostingListWriter.h"
#include "KinoSearch/Index/DocWriter.h"
#include "KinoSearch/Index/SortWriter.h"
#include "KinoSearch/Index/Posting.h"
#include "KinoSearch/Index/Posting/RawPosting.h"
#include "KinoSearch/Index/Posting/MatchPosting.h"
#include "KinoSearch/Index/SegWriter.h"
#include "KinoSearch/Object/Hash.h"
#include "KinoSearch/Index/BackgroundMerger.h"
#include "KinoSearch/Store/RAMFile.h"
#include "KinoSearch/Object/BitVector.h"
#include "KinoSearch/Index/BitVecDelDocs.h"
#include "KinoSearch/Util/Stepper.h"
#include "KinoSearch/Index/SkipStepper.h"
#include "KinoSearch/Index/Posting.h"
#include "KinoSearch/Index/Posting/MatchPosting.h"
#include "KinoSearch/Index/Posting/ScorePosting.h"
#include "KinoSearch/Index/Posting/RichPosting.h"
#include "KinoSearch/Index/Posting/RawPosting.h"
#include "KinoSearch/Index/TermStepper.h"
#include "KinoSearch/Plan/TextType.h"
#include "KinoSearch/Index/Posting/MatchPosting.h"
#include "KinoSearch/Plan/Architecture.h"
#include "KinoSearch/Test/Plan/TestArchitecture.h"
#include "KinoSearch/Plan/FieldType.h"
#include "KinoSearch/Test/Plan/TestFieldType.h"
#include "KinoSearch/Plan/TextType.h"
#include "KinoSearch/Plan/StringType.h"
#include "KinoSearch/Plan/FullTextType.h"
#include "KinoSearch/Plan/NumericType.h"
#include "KinoSearch/Plan/NumericType.h"
#include "KinoSearch/Plan/NumericType.h"
#include "KinoSearch/Plan/NumericType.h"
#include "KinoSearch/Plan/NumericType.h"
#include "KinoSearch/Plan/NumericType.h"
#include "KinoSearch/Plan/NumericType.h"
#include "KinoSearch/Plan/BlobType.h"
#include "KinoSearch/Search/Span.h"
#include "KinoSearch/Store/Folder.h"
#include "KinoSearch/Store/FSFolder.h"
#include "KinoSearch/Store/RAMFolder.h"
#include "KinoSearch/Store/CompoundFileReader.h"
#include "KinoSearch/Util/PriorityQueue.h"
#include "KinoSearch/Test/Util/TestPriorityQueue.h"
#include "KinoSearch/Index/PolyLexicon.h"
#include "KinoSearch/Search/HitQueue.h"
#include "KinoSearch/Search/Matcher.h"
#include "KinoSearch/Search/BitVecMatcher.h"
#include "KinoSearch/Search/PhraseScorer.h"
#include "KinoSearch/Search/TermScorer.h"
#include "KinoSearch/Index/Posting/MatchPosting.h"
#include "KinoSearch/Index/Posting/ScorePosting.h"
#include "KinoSearch/Index/Posting/RichPosting.h"
#include "KinoSearch/Search/SeriesMatcher.h"
#include "KinoSearch/Index/PostingList.h"
#include "KinoSearch/Index/SegPostingList.h"
#include "KinoSearch/Index/RawPostingList.h"
#include "KSx/Search/FilterScorer.h"
#include "KSx/Search/ProximityScorer.h"
#include "KinoSearch/Search/NoMatchScorer.h"
#include "KSx/Search/MockMatcher.h"
#include "KinoSearch/Search/PolyMatcher.h"
#include "KinoSearch/Search/ORMatcher.h"
#include "KinoSearch/Search/ORMatcher.h"
#include "KinoSearch/Search/ANDScorer.h"
#include "KinoSearch/Search/NOTScorer.h"
#include "KinoSearch/Search/RequiredOptionalScorer.h"
#include "KinoSearch/Search/RangeScorer.h"
#include "KinoSearch/Search/MatchAllScorer.h"
#include "KinoSearch/Test/TestQueryParser.h"
#include "KinoSearch/Object/Hash.h"
#include "KinoSearch/Index/ZombieKeyedHash.h"
#include "KinoSearch/Search/Hits.h"
#include "KinoSearch/Object/VArray.h"
#include "KinoSearch/Search/Query.h"
#include "KinoSearch/Search/NoMatchQuery.h"
#include "KinoSearch/Search/MatchAllQuery.h"
#include "KinoSearch/Search/PhraseQuery.h"
#include "KinoSearch/Search/PolyQuery.h"
#include "KinoSearch/Search/ANDQuery.h"
#include "KinoSearch/Search/RequiredOptionalQuery.h"
#include "KinoSearch/Search/NOTQuery.h"
#include "KinoSearch/Search/ORQuery.h"
#include "KinoSearch/Search/TermQuery.h"
#include "KSx/Search/ProximityQuery.h"
#include "KinoSearch/Search/LeafQuery.h"
#include "KinoSearch/Search/Compiler.h"
#include "KinoSearch/Search/PhraseQuery.h"
#include "KSx/Search/ProximityQuery.h"
#include "KinoSearch/Search/PolyQuery.h"
#include "KinoSearch/Search/RequiredOptionalQuery.h"
#include "KinoSearch/Search/ANDQuery.h"
#include "KinoSearch/Search/NOTQuery.h"
#include "KinoSearch/Search/ORQuery.h"
#include "KinoSearch/Search/MatchAllQuery.h"
#include "KinoSearch/Search/NoMatchQuery.h"
#include "KinoSearch/Search/TermQuery.h"
#include "KinoSearch/Search/RangeQuery.h"
#include "KinoSearch/Search/RangeQuery.h"
#include "KinoSearch/Object/ByteBuf.h"
#include "KinoSearch/Object/ByteBuf.h"
#include "KinoSearch/Store/DirHandle.h"
#include "KinoSearch/Store/CompoundFileReader.h"
#include "KinoSearch/Store/FSDirHandle.h"
#include "KinoSearch/Store/RAMDirHandle.h"
#include "KinoSearch/Index/Indexer.h"
#include "KinoSearch/Search/Searcher.h"
#include "KinoSearch/Search/PolySearcher.h"
#include "KinoSearch/Search/IndexSearcher.h"
#include "KinoSearch/Index/Similarity.h"
#include "KinoSearch/Analysis/Analyzer.h"
#include "KinoSearch/Test/Analysis/TestAnalyzer.h"
#include "KinoSearch/Analysis/PolyAnalyzer.h"
#include "KinoSearch/Analysis/Stopalizer.h"
#include "KinoSearch/Analysis/CaseFolder.h"
#include "KinoSearch/Analysis/Tokenizer.h"
#include "KinoSearch/Analysis/Stemmer.h"
#include "KinoSearch/Index/TermVector.h"
#include "KinoSearch/Store/InStream.h"
#include "KinoSearch/Object/CharBuf.h"
#include "KinoSearch/Test/Object/TestLockFreeRegistry.h"
#include "KinoSearch/Object/CharBuf.h"
#include "KinoSearch/Object/CharBuf.h"
#include "KinoSearch/Index/DataReader.h"
#include "KinoSearch/Index/PostingListReader.h"
#include "KinoSearch/Index/PostingListReader.h"
#include "KinoSearch/Index/LexiconReader.h"
#include "KinoSearch/Index/LexiconReader.h"
#include "KinoSearch/Index/LexiconReader.h"
#include "KinoSearch/Index/HighlightReader.h"
#include "KinoSearch/Index/HighlightReader.h"
#include "KinoSearch/Index/HighlightReader.h"
#include "KinoSearch/Index/DocReader.h"
#include "KinoSearch/Index/DocReader.h"
#include "KinoSearch/Index/DocReader.h"
#include "KinoSearch/Index/IndexReader.h"
#include "KinoSearch/Index/SegReader.h"
#include "KinoSearch/Index/PolyReader.h"
#include "KinoSearch/Index/SortReader.h"
#include "KinoSearch/Index/SortReader.h"
#include "KinoSearch/Index/DeletionsReader.h"
#include "KinoSearch/Index/DeletionsReader.h"
#include "KinoSearch/Index/DeletionsReader.h"
#include "KinoSearch/Search/Collector.h"
#include "KinoSearch/Search/Collector/SortCollector.h"
#include "KinoSearch/Search/Collector.h"
#include "KinoSearch/Search/Collector.h"
#include "KinoSearch/Plan/Schema.h"
#include "KinoSearch/Test/TestSchema.h"
#include "KinoSearch/Document/Doc.h"
#include "KinoSearch/Document/HitDoc.h"
#include "KinoSearch/Util/SortExternal.h"
#include "KinoSearch/Test/Util/BBSortEx.h"
#include "KinoSearch/Index/PostingPool.h"
#include "KinoSearch/Index/SortFieldWriter.h"
#include "KinoSearch/Test.h"
#include "KinoSearch/Search/MatchDoc.h"
#include "KinoSearch/Index/Segment.h"
#include "KinoSearch/Index/Lexicon.h"
#include "KinoSearch/Index/SegLexicon.h"
#include "KinoSearch/Index/PolyLexicon.h"
#include "KinoSearch/Index/LexIndex.h"
#include "KinoSearch/Index/RawLexicon.h"
#include "KinoSearch/Index/FilePurger.h"
#include "KinoSearch/Store/OutStream.h"
#include "KinoSearch/Object/I32Array.h"
#include "KinoSearch/Store/FileWindow.h"
#include "KinoSearch/Store/CompoundFileWriter.h"
#include "KinoSearch/Test/Store/TestRAMDirHandle.h"
#include "KinoSearch/Test/Store/TestFSFolder.h"
#include "KinoSearch/Test/Object/TestObj.h"
#include "KinoSearch/Test/Store/TestCompoundFileWriter.h"
#include "KinoSearch/Test/Index/TestSegWriter.h"
#include "KinoSearch/Test/Store/TestFolder.h"
#include "KinoSearch/Test/Store/TestIOChunks.h"
#include "KinoSearch/Test/Index/TestIndexManager.h"
#include "KinoSearch/Test/TestQueryParserSyntax.h"
#include "KinoSearch/Test/Object/TestBitVector.h"
#include "KinoSearch/Test/Store/TestInStream.h"
#include "KinoSearch/Test/Search/TestLeafQuery.h"
#include "KinoSearch/Test/Plan/TestNumericType.h"
#include "KinoSearch/Docs/FileLocking.h"
#include "KinoSearch/Test/Plan/TestBlobType.h"
#include "KinoSearch/Test/Util/TestIndexFileNames.h"
#include "KinoSearch/Test/Store/TestIOPrimitives.h"
#include "KinoSearch/Docs/DevGuide.h"
#include "KinoSearch/Util/Debug.h"
#include "KinoSearch/Test/Index/TestDocWriter.h"
#include "KinoSearch/Test/Search/TestPolyQuery.h"
#include "KinoSearch/Test/Store/TestFSDirHandle.h"
#include "KinoSearch/Test/Object/TestI32Array.h"
#include "KinoSearch/Test/Plan/TestFullTextType.h"
#include "KinoSearch/Test/Object/TestHash.h"
#include "KinoSearch/Test/Search/TestRangeQuery.h"
#include "KinoSearch/Test/TestUtils.h"
#include "KinoSearch/Test/Util/TestAtomic.h"
#include "KinoSearch/Test/Store/TestCompoundFileReader.h"
#include "KinoSearch/Test/Search/TestMatchAllQuery.h"
#include "KinoSearch/Test/Store/TestRAMFolder.h"
#include "KinoSearch/Test/Util/TestNumberUtils.h"
#include "KinoSearch/Util/Atomic.h"
#include "KinoSearch/Test/Search/TestPolyQuery.h"
#include "KinoSearch/Test/Index/TestHighlightWriter.h"
#include "KinoSearch/Test/Analysis/TestStopalizer.h"
#include "KinoSearch/Test/Util/TestMemory.h"
#include "KinoSearch/Test/Store/TestFSFileHandle.h"
#include "KinoSearch/Test/Store/TestRAMFileHandle.h"
#include "KinoSearch/Test/Analysis/TestPolyAnalyzer.h"
#include "KinoSearch/Test/Search/TestNOTQuery.h"
#include "KinoSearch/Test/Util/TestPriorityQueue.h"
#include "KinoSearch/Util/Freezer.h"
#include "KinoSearch/Test/Search/TestPolyQuery.h"
#include "KinoSearch/Test/Index/TestSnapshot.h"
#include "KinoSearch/Test/Store/TestFolderCommon.h"
#include "KinoSearch/Test/Util/TestStringHelper.h"
#include "KinoSearch/Util/NumberUtils.h"
#include "KinoSearch/Test/Object/TestLockFreeRegistry.h"
#include "KinoSearch/Util/SortUtils.h"
#include "KinoSearch/Test/Index/TestSegment.h"
#include "KinoSearch/Test/Analysis/TestTokenizer.h"
#include "KinoSearch/Util/ProcessID.h"
#include "KinoSearch/Test/Object/TestNum.h"
#include "KinoSearch/Test/Object/TestVArray.h"
#include "KinoSearch/Util/IndexFileNames.h"
#include "KinoSearch/Test/Search/TestTermQuery.h"
#include "KinoSearch/Test/Index/TestPolyReader.h"
#include "KinoSearch/Test/Index/TestPostingListWriter.h"
#include "KinoSearch/Test.h"
#include "KinoSearch/Util/Sleep.h"

XS(XS_KinoSearch_Object_Obj_new);
XS(XS_KinoSearch_Object_Obj_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Obj* self;
        kino_Obj* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Object::Obj::new_PARAMS",
            NULL);

        self = (kino_Obj*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Obj_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Highlight_Highlighter_new);
XS(XS_KinoSearch_Highlight_Highlighter_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Highlighter* self;
        kino_Searcher* searcher;
        kino_Obj* query;
        const kino_CharBuf* field;
        uint32_t excerpt_length;
        kino_Highlighter* retval;
        SV* searcher_sv = NULL;
        SV* query_sv = NULL;
        SV* field_sv = NULL;
        SV* excerpt_length_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Highlight::Highlighter::new_PARAMS",
            &searcher_sv, "searcher", 8,
            &query_sv, "query", 5,
            &field_sv, "field", 5,
            &excerpt_length_sv, "excerpt_length", 14,
            NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'");
        }
        searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);
        if ( !query_sv || !XSBind_sv_defined(query_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'query'");
        }
        query = (kino_Obj*)XSBind_sv_to_cfish_obj(query_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if (excerpt_length_sv && XSBind_sv_defined(excerpt_length_sv)) {
            excerpt_length = (uint32_t)SvUV( excerpt_length_sv );
        }
        else {
            excerpt_length = 200;
        }
        self = (kino_Highlighter*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Highlighter_init(self, searcher, query, field, excerpt_length);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_TermInfo_new);
XS(XS_KinoSearch_Index_TermInfo_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_TermInfo* self;
        int32_t doc_freq;
        kino_TermInfo* retval;
        SV* doc_freq_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::TermInfo::new_PARAMS",
            &doc_freq_sv, "doc_freq", 8,
            NULL);

        if (doc_freq_sv && XSBind_sv_defined(doc_freq_sv)) {
            doc_freq = (int32_t)SvIV( doc_freq_sv );
        }
        else {
            doc_freq = 0;
        }
        self = (kino_TermInfo*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_TInfo_init(self, doc_freq);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_Inverter_new);
XS(XS_KinoSearch_Index_Inverter_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Inverter* self;
        kino_Schema* schema;
        kino_Segment* segment;
        kino_Inverter* retval;
        SV* schema_sv = NULL;
        SV* segment_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Inverter::new_PARAMS",
            &schema_sv, "schema", 6,
            &segment_sv, "segment", 7,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !segment_sv || !XSBind_sv_defined(segment_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segment'");
        }
        segment = (kino_Segment*)XSBind_sv_to_cfish_obj(segment_sv, KINO_SEGMENT, NULL);
        self = (kino_Inverter*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Inverter_init(self, schema, segment);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DocVector_new);
XS(XS_KinoSearch_Index_DocVector_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DocVector* self;
        kino_DocVector* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DocVector::new_PARAMS",
            NULL);

        self = (kino_DocVector*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DocVec_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_Lock_new);
XS(XS_KinoSearch_Store_Lock_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Lock* self;
        kino_Folder* folder;
        const kino_CharBuf* name;
        const kino_CharBuf* host;
        int32_t timeout;
        int32_t interval;
        kino_Lock* retval;
        SV* folder_sv = NULL;
        SV* name_sv = NULL;
        SV* host_sv = NULL;
        SV* timeout_sv = NULL;
        SV* interval_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::Lock::new_PARAMS",
            &folder_sv, "folder", 6,
            &name_sv, "name", 4,
            &host_sv, "host", 4,
            &timeout_sv, "timeout", 7,
            &interval_sv, "interval", 8,
            NULL);

        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !name_sv || !XSBind_sv_defined(name_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'name'");
        }
        name = (kino_CharBuf*)XSBind_sv_to_cfish_obj(name_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if ( !host_sv || !XSBind_sv_defined(host_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'host'");
        }
        host = (kino_CharBuf*)XSBind_sv_to_cfish_obj(host_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if (timeout_sv && XSBind_sv_defined(timeout_sv)) {
            timeout = (int32_t)SvIV( timeout_sv );
        }
        else {
            timeout = 0;
        }
        if (interval_sv && XSBind_sv_defined(interval_sv)) {
            interval = (int32_t)SvIV( interval_sv );
        }
        else {
            interval = 100;
        }
        self = (kino_Lock*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Lock_init(self, folder, name, host, timeout, interval);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_LockFileLock_new);
XS(XS_KinoSearch_Store_LockFileLock_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_LockFileLock* self;
        kino_Folder* folder;
        const kino_CharBuf* name;
        const kino_CharBuf* host;
        int32_t timeout;
        int32_t interval;
        kino_LockFileLock* retval;
        SV* folder_sv = NULL;
        SV* name_sv = NULL;
        SV* host_sv = NULL;
        SV* timeout_sv = NULL;
        SV* interval_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::LockFileLock::new_PARAMS",
            &folder_sv, "folder", 6,
            &name_sv, "name", 4,
            &host_sv, "host", 4,
            &timeout_sv, "timeout", 7,
            &interval_sv, "interval", 8,
            NULL);

        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !name_sv || !XSBind_sv_defined(name_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'name'");
        }
        name = (kino_CharBuf*)XSBind_sv_to_cfish_obj(name_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if ( !host_sv || !XSBind_sv_defined(host_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'host'");
        }
        host = (kino_CharBuf*)XSBind_sv_to_cfish_obj(host_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if (timeout_sv && XSBind_sv_defined(timeout_sv)) {
            timeout = (int32_t)SvIV( timeout_sv );
        }
        else {
            timeout = 0;
        }
        if (interval_sv && XSBind_sv_defined(interval_sv)) {
            interval = (int32_t)SvIV( interval_sv );
        }
        else {
            interval = 100;
        }
        self = (kino_LockFileLock*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_LFLock_init(self, folder, name, host, timeout, interval);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_SharedLock_new);
XS(XS_KinoSearch_Store_SharedLock_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SharedLock* self;
        kino_Folder* folder;
        const kino_CharBuf* name;
        const kino_CharBuf* host;
        int32_t timeout;
        int32_t interval;
        kino_SharedLock* retval;
        SV* folder_sv = NULL;
        SV* name_sv = NULL;
        SV* host_sv = NULL;
        SV* timeout_sv = NULL;
        SV* interval_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::SharedLock::new_PARAMS",
            &folder_sv, "folder", 6,
            &name_sv, "name", 4,
            &host_sv, "host", 4,
            &timeout_sv, "timeout", 7,
            &interval_sv, "interval", 8,
            NULL);

        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !name_sv || !XSBind_sv_defined(name_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'name'");
        }
        name = (kino_CharBuf*)XSBind_sv_to_cfish_obj(name_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if ( !host_sv || !XSBind_sv_defined(host_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'host'");
        }
        host = (kino_CharBuf*)XSBind_sv_to_cfish_obj(host_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if (timeout_sv && XSBind_sv_defined(timeout_sv)) {
            timeout = (int32_t)SvIV( timeout_sv );
        }
        else {
            timeout = 0;
        }
        if (interval_sv && XSBind_sv_defined(interval_sv)) {
            interval = (int32_t)SvIV( interval_sv );
        }
        else {
            interval = 100;
        }
        self = (kino_SharedLock*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_ShLock_init(self, folder, name, host, timeout, interval);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_QueryParser_new);
XS(XS_KinoSearch_Search_QueryParser_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_QueryParser* self;
        kino_Schema* schema;
        kino_Analyzer* analyzer;
        const kino_CharBuf* default_boolop;
        kino_VArray* fields;
        kino_QueryParser* retval;
        SV* schema_sv = NULL;
        SV* analyzer_sv = NULL;
        SV* default_boolop_sv = NULL;
        SV* fields_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::QueryParser::new_PARAMS",
            &schema_sv, "schema", 6,
            &analyzer_sv, "analyzer", 8,
            &default_boolop_sv, "default_boolop", 14,
            &fields_sv, "fields", 6,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if (analyzer_sv && XSBind_sv_defined(analyzer_sv)) {
            analyzer = (kino_Analyzer*)XSBind_sv_to_cfish_obj(analyzer_sv, KINO_ANALYZER, NULL);
        }
        else {
            analyzer = NULL;
        }
        if (default_boolop_sv && XSBind_sv_defined(default_boolop_sv)) {
            default_boolop = (kino_CharBuf*)XSBind_sv_to_cfish_obj(default_boolop_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            default_boolop = NULL;
        }
        if (fields_sv && XSBind_sv_defined(fields_sv)) {
            fields = (kino_VArray*)XSBind_sv_to_cfish_obj(fields_sv, KINO_VARRAY, NULL);
        }
        else {
            fields = NULL;
        }
        self = (kino_QueryParser*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_QParser_init(self, schema, analyzer, default_boolop, fields);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_IndexManager_new);
XS(XS_KinoSearch_Index_IndexManager_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_IndexManager* self;
        const kino_CharBuf* host;
        kino_LockFactory* lock_factory;
        kino_IndexManager* retval;
        SV* host_sv = NULL;
        SV* lock_factory_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::IndexManager::new_PARAMS",
            &host_sv, "host", 4,
            &lock_factory_sv, "lock_factory", 12,
            NULL);

        if (host_sv && XSBind_sv_defined(host_sv)) {
            host = (kino_CharBuf*)XSBind_sv_to_cfish_obj(host_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            host = NULL;
        }
        if (lock_factory_sv && XSBind_sv_defined(lock_factory_sv)) {
            lock_factory = (kino_LockFactory*)XSBind_sv_to_cfish_obj(lock_factory_sv, KINO_LOCKFACTORY, NULL);
        }
        else {
            lock_factory = NULL;
        }
        self = (kino_IndexManager*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_IxManager_init(self, host, lock_factory);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_TopDocs_new);
XS(XS_KinoSearch_Search_TopDocs_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_TopDocs* self;
        kino_VArray* match_docs;
        uint32_t total_hits;
        kino_TopDocs* retval;
        SV* match_docs_sv = NULL;
        SV* total_hits_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::TopDocs::new_PARAMS",
            &match_docs_sv, "match_docs", 10,
            &total_hits_sv, "total_hits", 10,
            NULL);

        if ( !match_docs_sv || !XSBind_sv_defined(match_docs_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'match_docs'");
        }
        match_docs = (kino_VArray*)XSBind_sv_to_cfish_obj(match_docs_sv, KINO_VARRAY, NULL);
        if ( !total_hits_sv || !XSBind_sv_defined(total_hits_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'total_hits'");
        }
        total_hits = (uint32_t)SvUV( total_hits_sv );
        self = (kino_TopDocs*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_TopDocs_init(self, match_docs, total_hits);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_Snapshot_new);
XS(XS_KinoSearch_Index_Snapshot_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Snapshot* self;
        kino_Snapshot* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Snapshot::new_PARAMS",
            NULL);

        self = (kino_Snapshot*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Snapshot_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_SortRule__new);
XS(XS_KinoSearch_Search_SortRule__new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SortRule* self;
        int32_t type;
        const kino_CharBuf* field;
        chy_bool_t reverse;
        kino_SortRule* retval;
        SV* type_sv = NULL;
        SV* field_sv = NULL;
        SV* reverse_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::SortRule::_new_PARAMS",
            &type_sv, "type", 4,
            &field_sv, "field", 5,
            &reverse_sv, "reverse", 7,
            NULL);

        if (type_sv && XSBind_sv_defined(type_sv)) {
            type = (int32_t)SvIV( type_sv );
        }
        else {
            type = 0;
        }
        if (field_sv && XSBind_sv_defined(field_sv)) {
            field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            field = NULL;
        }
        if (reverse_sv && XSBind_sv_defined(reverse_sv)) {
            reverse = SvTRUE( reverse_sv ) ? 1 : 0;
        }
        else {
            reverse = false;
        }
        self = (kino_SortRule*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_SortRule_init(self, type, field, reverse);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Highlight_HeatMap_new);
XS(XS_KinoSearch_Highlight_HeatMap_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_HeatMap* self;
        kino_VArray* spans;
        uint32_t window;
        kino_HeatMap* retval;
        SV* spans_sv = NULL;
        SV* window_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Highlight::HeatMap::new_PARAMS",
            &spans_sv, "spans", 5,
            &window_sv, "window", 6,
            NULL);

        if ( !spans_sv || !XSBind_sv_defined(spans_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'spans'");
        }
        spans = (kino_VArray*)XSBind_sv_to_cfish_obj(spans_sv, KINO_VARRAY, NULL);
        if (window_sv && XSBind_sv_defined(window_sv)) {
            window = (uint32_t)SvUV( window_sv );
        }
        else {
            window = 133;
        }
        self = (kino_HeatMap*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_HeatMap_init(self, spans, window);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Object_LockFreeRegistry_new);
XS(XS_KinoSearch_Object_LockFreeRegistry_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_LockFreeRegistry* self;
        size_t capacity;
        kino_LockFreeRegistry* retval;
        SV* capacity_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Object::LockFreeRegistry::new_PARAMS",
            &capacity_sv, "capacity", 8,
            NULL);

        if ( !capacity_sv || !XSBind_sv_defined(capacity_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'capacity'");
        }
        capacity = (size_t)SvIV( capacity_sv );
        self = (kino_LockFreeRegistry*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_LFReg_init(self, capacity);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Util_MemoryPool_new);
XS(XS_KinoSearch_Util_MemoryPool_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_MemoryPool* self;
        uint32_t arena_size;
        kino_MemoryPool* retval;
        SV* arena_size_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Util::MemoryPool::new_PARAMS",
            &arena_size_sv, "arena_size", 10,
            NULL);

        if ( !arena_size_sv || !XSBind_sv_defined(arena_size_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'arena_size'");
        }
        arena_size = (uint32_t)SvUV( arena_size_sv );
        self = (kino_MemoryPool*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_MemPool_init(self, arena_size);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_SortCache_new);
XS(XS_KinoSearch_Index_SortCache_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SortCache* self;
        const kino_CharBuf* field;
        kino_FieldType* type;
        void* ords;
        int32_t cardinality;
        int32_t doc_max;
        int32_t null_ord;
        int32_t ord_width;
        kino_SortCache* retval;
        SV* field_sv = NULL;
        SV* type_sv = NULL;
        SV* ords_sv = NULL;
        SV* cardinality_sv = NULL;
        SV* doc_max_sv = NULL;
        SV* null_ord_sv = NULL;
        SV* ord_width_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SortCache::new_PARAMS",
            &field_sv, "field", 5,
            &type_sv, "type", 4,
            &ords_sv, "ords", 4,
            &cardinality_sv, "cardinality", 11,
            &doc_max_sv, "doc_max", 7,
            &null_ord_sv, "null_ord", 8,
            &ord_width_sv, "ord_width", 9,
            NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if ( !type_sv || !XSBind_sv_defined(type_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'type'");
        }
        type = (kino_FieldType*)XSBind_sv_to_cfish_obj(type_sv, KINO_FIELDTYPE, NULL);
        if ( !ords_sv || !XSBind_sv_defined(ords_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'ords'");
        }
        if (SvROK(ords_sv)) {
            ords = SvRV(ords_sv);
        }
        else {
            ords = NULL; /* avoid uninitialized compiler warning */
            CFISH_THROW(CFISH_ERR, "ords is not a reference");
        }

        if ( !cardinality_sv || !XSBind_sv_defined(cardinality_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'cardinality'");
        }
        cardinality = (int32_t)SvIV( cardinality_sv );
        if ( !doc_max_sv || !XSBind_sv_defined(doc_max_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'doc_max'");
        }
        doc_max = (int32_t)SvIV( doc_max_sv );
        if (null_ord_sv && XSBind_sv_defined(null_ord_sv)) {
            null_ord = (int32_t)SvIV( null_ord_sv );
        }
        else {
            null_ord = -1;
        }
        if ( !ord_width_sv || !XSBind_sv_defined(ord_width_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'ord_width'");
        }
        ord_width = (int32_t)SvIV( ord_width_sv );
        self = (kino_SortCache*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_SortCache_init(self, field, type, ords, cardinality, doc_max, null_ord, ord_width);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_LockFactory_new);
XS(XS_KinoSearch_Store_LockFactory_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_LockFactory* self;
        kino_Folder* folder;
        const kino_CharBuf* host;
        kino_LockFactory* retval;
        SV* folder_sv = NULL;
        SV* host_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::LockFactory::new_PARAMS",
            &folder_sv, "folder", 6,
            &host_sv, "host", 4,
            NULL);

        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !host_sv || !XSBind_sv_defined(host_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'host'");
        }
        host = (kino_CharBuf*)XSBind_sv_to_cfish_obj(host_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        self = (kino_LockFactory*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_LockFact_init(self, folder, host);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_FileHandle__open);
XS(XS_KinoSearch_Store_FileHandle__open)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_FileHandle* self;
        const kino_CharBuf* path;
        uint32_t flags;
        kino_FileHandle* retval;
        SV* path_sv = NULL;
        SV* flags_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::FileHandle::_open_PARAMS",
            &path_sv, "path", 4,
            &flags_sv, "flags", 5,
            NULL);

        if (path_sv && XSBind_sv_defined(path_sv)) {
            path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(path_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            path = NULL;
        }
        if ( !flags_sv || !XSBind_sv_defined(flags_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'flags'");
        }
        flags = (uint32_t)SvUV( flags_sv );
        self = (kino_FileHandle*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_FH_do_open(self, path, flags);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_FSFileHandle__open);
XS(XS_KinoSearch_Store_FSFileHandle__open)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_FSFileHandle* self;
        const kino_CharBuf* path;
        uint32_t flags;
        kino_FSFileHandle* retval;
        SV* path_sv = NULL;
        SV* flags_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::FSFileHandle::_open_PARAMS",
            &path_sv, "path", 4,
            &flags_sv, "flags", 5,
            NULL);

        if (path_sv && XSBind_sv_defined(path_sv)) {
            path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(path_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            path = NULL;
        }
        if ( !flags_sv || !XSBind_sv_defined(flags_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'flags'");
        }
        flags = (uint32_t)SvUV( flags_sv );
        self = (kino_FSFileHandle*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_FSFH_do_open(self, path, flags);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_RAMFileHandle__open);
XS(XS_KinoSearch_Store_RAMFileHandle__open)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_RAMFileHandle* self;
        const kino_CharBuf* path;
        uint32_t flags;
        kino_RAMFile* file;
        kino_RAMFileHandle* retval;
        SV* path_sv = NULL;
        SV* flags_sv = NULL;
        SV* file_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::RAMFileHandle::_open_PARAMS",
            &path_sv, "path", 4,
            &flags_sv, "flags", 5,
            &file_sv, "file", 4,
            NULL);

        if (path_sv && XSBind_sv_defined(path_sv)) {
            path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(path_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            path = NULL;
        }
        if ( !flags_sv || !XSBind_sv_defined(flags_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'flags'");
        }
        flags = (uint32_t)SvUV( flags_sv );
        if (file_sv && XSBind_sv_defined(file_sv)) {
            file = (kino_RAMFile*)XSBind_sv_to_cfish_obj(file_sv, KINO_RAMFILE, NULL);
        }
        else {
            file = NULL;
        }
        self = (kino_RAMFileHandle*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_RAMFH_do_open(self, path, flags, file);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_SortSpec_new);
XS(XS_KinoSearch_Search_SortSpec_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SortSpec* self;
        kino_VArray* rules;
        kino_SortSpec* retval;
        SV* rules_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::SortSpec::new_PARAMS",
            &rules_sv, "rules", 5,
            NULL);

        if ( !rules_sv || !XSBind_sv_defined(rules_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'rules'");
        }
        rules = (kino_VArray*)XSBind_sv_to_cfish_obj(rules_sv, KINO_VARRAY, NULL);
        self = (kino_SortSpec*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_SortSpec_init(self, rules);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Object_Err__new);
XS(XS_KinoSearch_Object_Err__new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Err* self;
        kino_CharBuf* mess;
        kino_Err* retval;
        SV* mess_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Object::Err::_new_PARAMS",
            &mess_sv, "mess", 4,
            NULL);

        if ( !mess_sv || !XSBind_sv_defined(mess_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'mess'");
        }
        mess = (kino_CharBuf*)XSBind_sv_to_cfish_obj(mess_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        self = (kino_Err*)XSBind_new_blank_obj( ST(0) );
        if (mess) { KINO_INCREF(mess); }
        retval = kino_Err_init(self, mess);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DataWriter_new);
XS(XS_KinoSearch_Index_DataWriter_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DataWriter* self;
        kino_Schema* schema;
        kino_Snapshot* snapshot;
        kino_Segment* segment;
        kino_PolyReader* polyreader;
        kino_DataWriter* retval;
        SV* schema_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segment_sv = NULL;
        SV* polyreader_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DataWriter::new_PARAMS",
            &schema_sv, "schema", 6,
            &snapshot_sv, "snapshot", 8,
            &segment_sv, "segment", 7,
            &polyreader_sv, "polyreader", 10,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segment_sv || !XSBind_sv_defined(segment_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segment'");
        }
        segment = (kino_Segment*)XSBind_sv_to_cfish_obj(segment_sv, KINO_SEGMENT, NULL);
        if ( !polyreader_sv || !XSBind_sv_defined(polyreader_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'polyreader'");
        }
        polyreader = (kino_PolyReader*)XSBind_sv_to_cfish_obj(polyreader_sv, KINO_POLYREADER, NULL);
        self = (kino_DataWriter*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DataWriter_init(self, schema, snapshot, segment, polyreader);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_HighlightWriter_new);
XS(XS_KinoSearch_Index_HighlightWriter_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_HighlightWriter* self;
        kino_Schema* schema;
        kino_Snapshot* snapshot;
        kino_Segment* segment;
        kino_PolyReader* polyreader;
        kino_HighlightWriter* retval;
        SV* schema_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segment_sv = NULL;
        SV* polyreader_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::HighlightWriter::new_PARAMS",
            &schema_sv, "schema", 6,
            &snapshot_sv, "snapshot", 8,
            &segment_sv, "segment", 7,
            &polyreader_sv, "polyreader", 10,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segment_sv || !XSBind_sv_defined(segment_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segment'");
        }
        segment = (kino_Segment*)XSBind_sv_to_cfish_obj(segment_sv, KINO_SEGMENT, NULL);
        if ( !polyreader_sv || !XSBind_sv_defined(polyreader_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'polyreader'");
        }
        polyreader = (kino_PolyReader*)XSBind_sv_to_cfish_obj(polyreader_sv, KINO_POLYREADER, NULL);
        self = (kino_HighlightWriter*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_HLWriter_init(self, schema, snapshot, segment, polyreader);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_LexiconWriter_new);
XS(XS_KinoSearch_Index_LexiconWriter_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_LexiconWriter* self;
        kino_Schema* schema;
        kino_Snapshot* snapshot;
        kino_Segment* segment;
        kino_PolyReader* polyreader;
        kino_LexiconWriter* retval;
        SV* schema_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segment_sv = NULL;
        SV* polyreader_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::LexiconWriter::new_PARAMS",
            &schema_sv, "schema", 6,
            &snapshot_sv, "snapshot", 8,
            &segment_sv, "segment", 7,
            &polyreader_sv, "polyreader", 10,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segment_sv || !XSBind_sv_defined(segment_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segment'");
        }
        segment = (kino_Segment*)XSBind_sv_to_cfish_obj(segment_sv, KINO_SEGMENT, NULL);
        if ( !polyreader_sv || !XSBind_sv_defined(polyreader_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'polyreader'");
        }
        polyreader = (kino_PolyReader*)XSBind_sv_to_cfish_obj(polyreader_sv, KINO_POLYREADER, NULL);
        self = (kino_LexiconWriter*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_LexWriter_init(self, schema, snapshot, segment, polyreader);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DefaultDeletionsWriter_new);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DefaultDeletionsWriter* self;
        kino_Schema* schema;
        kino_Snapshot* snapshot;
        kino_Segment* segment;
        kino_PolyReader* polyreader;
        kino_DefaultDeletionsWriter* retval;
        SV* schema_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segment_sv = NULL;
        SV* polyreader_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultDeletionsWriter::new_PARAMS",
            &schema_sv, "schema", 6,
            &snapshot_sv, "snapshot", 8,
            &segment_sv, "segment", 7,
            &polyreader_sv, "polyreader", 10,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segment_sv || !XSBind_sv_defined(segment_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segment'");
        }
        segment = (kino_Segment*)XSBind_sv_to_cfish_obj(segment_sv, KINO_SEGMENT, NULL);
        if ( !polyreader_sv || !XSBind_sv_defined(polyreader_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'polyreader'");
        }
        polyreader = (kino_PolyReader*)XSBind_sv_to_cfish_obj(polyreader_sv, KINO_POLYREADER, NULL);
        self = (kino_DefaultDeletionsWriter*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DefDelWriter_init(self, schema, snapshot, segment, polyreader);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_PostingListWriter_new);
XS(XS_KinoSearch_Index_PostingListWriter_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PostingListWriter* self;
        kino_Schema* schema;
        kino_Snapshot* snapshot;
        kino_Segment* segment;
        kino_PolyReader* polyreader;
        kino_LexiconWriter* lex_writer;
        kino_PostingListWriter* retval;
        SV* schema_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segment_sv = NULL;
        SV* polyreader_sv = NULL;
        SV* lex_writer_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PostingListWriter::new_PARAMS",
            &schema_sv, "schema", 6,
            &snapshot_sv, "snapshot", 8,
            &segment_sv, "segment", 7,
            &polyreader_sv, "polyreader", 10,
            &lex_writer_sv, "lex_writer", 10,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segment_sv || !XSBind_sv_defined(segment_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segment'");
        }
        segment = (kino_Segment*)XSBind_sv_to_cfish_obj(segment_sv, KINO_SEGMENT, NULL);
        if ( !polyreader_sv || !XSBind_sv_defined(polyreader_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'polyreader'");
        }
        polyreader = (kino_PolyReader*)XSBind_sv_to_cfish_obj(polyreader_sv, KINO_POLYREADER, NULL);
        if ( !lex_writer_sv || !XSBind_sv_defined(lex_writer_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'lex_writer'");
        }
        lex_writer = (kino_LexiconWriter*)XSBind_sv_to_cfish_obj(lex_writer_sv, KINO_LEXICONWRITER, NULL);
        self = (kino_PostingListWriter*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PListWriter_init(self, schema, snapshot, segment, polyreader, lex_writer);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DocWriter_new);
XS(XS_KinoSearch_Index_DocWriter_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DocWriter* self;
        kino_Schema* schema;
        kino_Snapshot* snapshot;
        kino_Segment* segment;
        kino_PolyReader* polyreader;
        kino_DocWriter* retval;
        SV* schema_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segment_sv = NULL;
        SV* polyreader_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DocWriter::new_PARAMS",
            &schema_sv, "schema", 6,
            &snapshot_sv, "snapshot", 8,
            &segment_sv, "segment", 7,
            &polyreader_sv, "polyreader", 10,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segment_sv || !XSBind_sv_defined(segment_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segment'");
        }
        segment = (kino_Segment*)XSBind_sv_to_cfish_obj(segment_sv, KINO_SEGMENT, NULL);
        if ( !polyreader_sv || !XSBind_sv_defined(polyreader_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'polyreader'");
        }
        polyreader = (kino_PolyReader*)XSBind_sv_to_cfish_obj(polyreader_sv, KINO_POLYREADER, NULL);
        self = (kino_DocWriter*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DocWriter_init(self, schema, snapshot, segment, polyreader);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_SortWriter_new);
XS(XS_KinoSearch_Index_SortWriter_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SortWriter* self;
        kino_Schema* schema;
        kino_Snapshot* snapshot;
        kino_Segment* segment;
        kino_PolyReader* polyreader;
        kino_SortWriter* retval;
        SV* schema_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segment_sv = NULL;
        SV* polyreader_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SortWriter::new_PARAMS",
            &schema_sv, "schema", 6,
            &snapshot_sv, "snapshot", 8,
            &segment_sv, "segment", 7,
            &polyreader_sv, "polyreader", 10,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segment_sv || !XSBind_sv_defined(segment_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segment'");
        }
        segment = (kino_Segment*)XSBind_sv_to_cfish_obj(segment_sv, KINO_SEGMENT, NULL);
        if ( !polyreader_sv || !XSBind_sv_defined(polyreader_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'polyreader'");
        }
        polyreader = (kino_PolyReader*)XSBind_sv_to_cfish_obj(polyreader_sv, KINO_POLYREADER, NULL);
        self = (kino_SortWriter*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_SortWriter_init(self, schema, snapshot, segment, polyreader);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_SegWriter_new);
XS(XS_KinoSearch_Index_SegWriter_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SegWriter* self;
        kino_Schema* schema;
        kino_Snapshot* snapshot;
        kino_Segment* segment;
        kino_PolyReader* polyreader;
        kino_SegWriter* retval;
        SV* schema_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segment_sv = NULL;
        SV* polyreader_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegWriter::new_PARAMS",
            &schema_sv, "schema", 6,
            &snapshot_sv, "snapshot", 8,
            &segment_sv, "segment", 7,
            &polyreader_sv, "polyreader", 10,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segment_sv || !XSBind_sv_defined(segment_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segment'");
        }
        segment = (kino_Segment*)XSBind_sv_to_cfish_obj(segment_sv, KINO_SEGMENT, NULL);
        if ( !polyreader_sv || !XSBind_sv_defined(polyreader_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'polyreader'");
        }
        polyreader = (kino_PolyReader*)XSBind_sv_to_cfish_obj(polyreader_sv, KINO_POLYREADER, NULL);
        self = (kino_SegWriter*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_SegWriter_init(self, schema, snapshot, segment, polyreader);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_BackgroundMerger_new);
XS(XS_KinoSearch_Index_BackgroundMerger_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_BackgroundMerger* self;
        kino_Obj* index;
        kino_IndexManager* manager;
        kino_BackgroundMerger* retval;
        SV* index_sv = NULL;
        SV* manager_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::BackgroundMerger::new_PARAMS",
            &index_sv, "index", 5,
            &manager_sv, "manager", 7,
            NULL);

        if ( !index_sv || !XSBind_sv_defined(index_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'index'");
        }
        index = (kino_Obj*)XSBind_sv_to_cfish_obj(index_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        if (manager_sv && XSBind_sv_defined(manager_sv)) {
            manager = (kino_IndexManager*)XSBind_sv_to_cfish_obj(manager_sv, KINO_INDEXMANAGER, NULL);
        }
        else {
            manager = NULL;
        }
        self = (kino_BackgroundMerger*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_BGMerger_init(self, index, manager);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_RAMFile_new);
XS(XS_KinoSearch_Store_RAMFile_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_RAMFile* self;
        kino_ByteBuf* contents;
        chy_bool_t read_only;
        kino_RAMFile* retval;
        SV* contents_sv = NULL;
        SV* read_only_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::RAMFile::new_PARAMS",
            &contents_sv, "contents", 8,
            &read_only_sv, "read_only", 9,
            NULL);

        if (contents_sv && XSBind_sv_defined(contents_sv)) {
            contents = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(contents_sv, KINO_BYTEBUF, NULL);
        }
        else {
            contents = NULL;
        }
        if (read_only_sv && XSBind_sv_defined(read_only_sv)) {
            read_only = SvTRUE( read_only_sv ) ? 1 : 0;
        }
        else {
            read_only = false;
        }
        self = (kino_RAMFile*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_RAMFile_init(self, contents, read_only);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Object_BitVector_new);
XS(XS_KinoSearch_Object_BitVector_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_BitVector* self;
        uint32_t capacity;
        kino_BitVector* retval;
        SV* capacity_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Object::BitVector::new_PARAMS",
            &capacity_sv, "capacity", 8,
            NULL);

        if (capacity_sv && XSBind_sv_defined(capacity_sv)) {
            capacity = (uint32_t)SvUV( capacity_sv );
        }
        else {
            capacity = 0;
        }
        self = (kino_BitVector*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_BitVec_init(self, capacity);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_Posting_MatchPosting_new);
XS(XS_KinoSearch_Index_Posting_MatchPosting_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_MatchPosting* self;
        kino_Similarity* similarity;
        kino_MatchPosting* retval;
        SV* similarity_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Posting::MatchPosting::new_PARAMS",
            &similarity_sv, "similarity", 10,
            NULL);

        if ( !similarity_sv || !XSBind_sv_defined(similarity_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'similarity'");
        }
        similarity = (kino_Similarity*)XSBind_sv_to_cfish_obj(similarity_sv, KINO_SIMILARITY, NULL);
        self = (kino_MatchPosting*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_MatchPost_init(self, similarity);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_Posting_ScorePosting_new);
XS(XS_KinoSearch_Index_Posting_ScorePosting_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_ScorePosting* self;
        kino_Similarity* similarity;
        kino_ScorePosting* retval;
        SV* similarity_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Posting::ScorePosting::new_PARAMS",
            &similarity_sv, "similarity", 10,
            NULL);

        if ( !similarity_sv || !XSBind_sv_defined(similarity_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'similarity'");
        }
        similarity = (kino_Similarity*)XSBind_sv_to_cfish_obj(similarity_sv, KINO_SIMILARITY, NULL);
        self = (kino_ScorePosting*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_ScorePost_init(self, similarity);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_Posting_RichPosting_new);
XS(XS_KinoSearch_Index_Posting_RichPosting_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_RichPosting* self;
        kino_Similarity* similarity;
        kino_RichPosting* retval;
        SV* similarity_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Posting::RichPosting::new_PARAMS",
            &similarity_sv, "similarity", 10,
            NULL);

        if ( !similarity_sv || !XSBind_sv_defined(similarity_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'similarity'");
        }
        similarity = (kino_Similarity*)XSBind_sv_to_cfish_obj(similarity_sv, KINO_SIMILARITY, NULL);
        self = (kino_RichPosting*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_RichPost_init(self, similarity);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Plan_Architecture_new);
XS(XS_KinoSearch_Plan_Architecture_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Architecture* self;
        kino_Architecture* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::Architecture::new_PARAMS",
            NULL);

        self = (kino_Architecture*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Arch_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Plan_FieldType_new);
XS(XS_KinoSearch_Plan_FieldType_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_FieldType* self;
        float boost;
        chy_bool_t indexed;
        chy_bool_t stored;
        chy_bool_t sortable;
        kino_FieldType* retval;
        SV* boost_sv = NULL;
        SV* indexed_sv = NULL;
        SV* stored_sv = NULL;
        SV* sortable_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::FieldType::new_PARAMS",
            &boost_sv, "boost", 5,
            &indexed_sv, "indexed", 7,
            &stored_sv, "stored", 6,
            &sortable_sv, "sortable", 8,
            NULL);

        if (boost_sv && XSBind_sv_defined(boost_sv)) {
            boost = (float)SvNV( boost_sv );
        }
        else {
            boost = 1.0;
        }
        if (indexed_sv && XSBind_sv_defined(indexed_sv)) {
            indexed = SvTRUE( indexed_sv ) ? 1 : 0;
        }
        else {
            indexed = false;
        }
        if (stored_sv && XSBind_sv_defined(stored_sv)) {
            stored = SvTRUE( stored_sv ) ? 1 : 0;
        }
        else {
            stored = false;
        }
        if (sortable_sv && XSBind_sv_defined(sortable_sv)) {
            sortable = SvTRUE( sortable_sv ) ? 1 : 0;
        }
        else {
            sortable = false;
        }
        self = (kino_FieldType*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_FType_init2(self, boost, indexed, stored, sortable);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Plan_StringType_new);
XS(XS_KinoSearch_Plan_StringType_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_StringType* self;
        float boost;
        chy_bool_t indexed;
        chy_bool_t stored;
        chy_bool_t sortable;
        kino_StringType* retval;
        SV* boost_sv = NULL;
        SV* indexed_sv = NULL;
        SV* stored_sv = NULL;
        SV* sortable_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::StringType::new_PARAMS",
            &boost_sv, "boost", 5,
            &indexed_sv, "indexed", 7,
            &stored_sv, "stored", 6,
            &sortable_sv, "sortable", 8,
            NULL);

        if (boost_sv && XSBind_sv_defined(boost_sv)) {
            boost = (float)SvNV( boost_sv );
        }
        else {
            boost = 1.0;
        }
        if (indexed_sv && XSBind_sv_defined(indexed_sv)) {
            indexed = SvTRUE( indexed_sv ) ? 1 : 0;
        }
        else {
            indexed = true;
        }
        if (stored_sv && XSBind_sv_defined(stored_sv)) {
            stored = SvTRUE( stored_sv ) ? 1 : 0;
        }
        else {
            stored = true;
        }
        if (sortable_sv && XSBind_sv_defined(sortable_sv)) {
            sortable = SvTRUE( sortable_sv ) ? 1 : 0;
        }
        else {
            sortable = false;
        }
        self = (kino_StringType*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_StringType_init2(self, boost, indexed, stored, sortable);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Plan_FullTextType_new);
XS(XS_KinoSearch_Plan_FullTextType_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_FullTextType* self;
        kino_Analyzer* analyzer;
        float boost;
        chy_bool_t indexed;
        chy_bool_t stored;
        chy_bool_t sortable;
        chy_bool_t highlightable;
        kino_FullTextType* retval;
        SV* analyzer_sv = NULL;
        SV* boost_sv = NULL;
        SV* indexed_sv = NULL;
        SV* stored_sv = NULL;
        SV* sortable_sv = NULL;
        SV* highlightable_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::FullTextType::new_PARAMS",
            &analyzer_sv, "analyzer", 8,
            &boost_sv, "boost", 5,
            &indexed_sv, "indexed", 7,
            &stored_sv, "stored", 6,
            &sortable_sv, "sortable", 8,
            &highlightable_sv, "highlightable", 13,
            NULL);

        if ( !analyzer_sv || !XSBind_sv_defined(analyzer_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'analyzer'");
        }
        analyzer = (kino_Analyzer*)XSBind_sv_to_cfish_obj(analyzer_sv, KINO_ANALYZER, NULL);
        if (boost_sv && XSBind_sv_defined(boost_sv)) {
            boost = (float)SvNV( boost_sv );
        }
        else {
            boost = 1.0;
        }
        if (indexed_sv && XSBind_sv_defined(indexed_sv)) {
            indexed = SvTRUE( indexed_sv ) ? 1 : 0;
        }
        else {
            indexed = true;
        }
        if (stored_sv && XSBind_sv_defined(stored_sv)) {
            stored = SvTRUE( stored_sv ) ? 1 : 0;
        }
        else {
            stored = true;
        }
        if (sortable_sv && XSBind_sv_defined(sortable_sv)) {
            sortable = SvTRUE( sortable_sv ) ? 1 : 0;
        }
        else {
            sortable = false;
        }
        if (highlightable_sv && XSBind_sv_defined(highlightable_sv)) {
            highlightable = SvTRUE( highlightable_sv ) ? 1 : 0;
        }
        else {
            highlightable = false;
        }
        self = (kino_FullTextType*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_FullTextType_init2(self, analyzer, boost, indexed, stored, sortable, highlightable);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Plan_Float32Type_new);
XS(XS_KinoSearch_Plan_Float32Type_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Float32Type* self;
        float boost;
        chy_bool_t indexed;
        chy_bool_t stored;
        chy_bool_t sortable;
        kino_Float32Type* retval;
        SV* boost_sv = NULL;
        SV* indexed_sv = NULL;
        SV* stored_sv = NULL;
        SV* sortable_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::Float32Type::new_PARAMS",
            &boost_sv, "boost", 5,
            &indexed_sv, "indexed", 7,
            &stored_sv, "stored", 6,
            &sortable_sv, "sortable", 8,
            NULL);

        if (boost_sv && XSBind_sv_defined(boost_sv)) {
            boost = (float)SvNV( boost_sv );
        }
        else {
            boost = 1.0;
        }
        if (indexed_sv && XSBind_sv_defined(indexed_sv)) {
            indexed = SvTRUE( indexed_sv ) ? 1 : 0;
        }
        else {
            indexed = true;
        }
        if (stored_sv && XSBind_sv_defined(stored_sv)) {
            stored = SvTRUE( stored_sv ) ? 1 : 0;
        }
        else {
            stored = true;
        }
        if (sortable_sv && XSBind_sv_defined(sortable_sv)) {
            sortable = SvTRUE( sortable_sv ) ? 1 : 0;
        }
        else {
            sortable = false;
        }
        self = (kino_Float32Type*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Float32Type_init2(self, boost, indexed, stored, sortable);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Plan_Float64Type_new);
XS(XS_KinoSearch_Plan_Float64Type_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Float64Type* self;
        float boost;
        chy_bool_t indexed;
        chy_bool_t stored;
        chy_bool_t sortable;
        kino_Float64Type* retval;
        SV* boost_sv = NULL;
        SV* indexed_sv = NULL;
        SV* stored_sv = NULL;
        SV* sortable_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::Float64Type::new_PARAMS",
            &boost_sv, "boost", 5,
            &indexed_sv, "indexed", 7,
            &stored_sv, "stored", 6,
            &sortable_sv, "sortable", 8,
            NULL);

        if (boost_sv && XSBind_sv_defined(boost_sv)) {
            boost = (float)SvNV( boost_sv );
        }
        else {
            boost = 1.0;
        }
        if (indexed_sv && XSBind_sv_defined(indexed_sv)) {
            indexed = SvTRUE( indexed_sv ) ? 1 : 0;
        }
        else {
            indexed = true;
        }
        if (stored_sv && XSBind_sv_defined(stored_sv)) {
            stored = SvTRUE( stored_sv ) ? 1 : 0;
        }
        else {
            stored = true;
        }
        if (sortable_sv && XSBind_sv_defined(sortable_sv)) {
            sortable = SvTRUE( sortable_sv ) ? 1 : 0;
        }
        else {
            sortable = true;
        }
        self = (kino_Float64Type*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Float64Type_init2(self, boost, indexed, stored, sortable);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Plan_Int64Type_new);
XS(XS_KinoSearch_Plan_Int64Type_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Int64Type* self;
        float boost;
        chy_bool_t indexed;
        chy_bool_t stored;
        chy_bool_t sortable;
        kino_Int64Type* retval;
        SV* boost_sv = NULL;
        SV* indexed_sv = NULL;
        SV* stored_sv = NULL;
        SV* sortable_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::Int64Type::new_PARAMS",
            &boost_sv, "boost", 5,
            &indexed_sv, "indexed", 7,
            &stored_sv, "stored", 6,
            &sortable_sv, "sortable", 8,
            NULL);

        if (boost_sv && XSBind_sv_defined(boost_sv)) {
            boost = (float)SvNV( boost_sv );
        }
        else {
            boost = 1.0;
        }
        if (indexed_sv && XSBind_sv_defined(indexed_sv)) {
            indexed = SvTRUE( indexed_sv ) ? 1 : 0;
        }
        else {
            indexed = true;
        }
        if (stored_sv && XSBind_sv_defined(stored_sv)) {
            stored = SvTRUE( stored_sv ) ? 1 : 0;
        }
        else {
            stored = true;
        }
        if (sortable_sv && XSBind_sv_defined(sortable_sv)) {
            sortable = SvTRUE( sortable_sv ) ? 1 : 0;
        }
        else {
            sortable = false;
        }
        self = (kino_Int64Type*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Int64Type_init2(self, boost, indexed, stored, sortable);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Plan_Int32Type_new);
XS(XS_KinoSearch_Plan_Int32Type_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Int32Type* self;
        float boost;
        chy_bool_t indexed;
        chy_bool_t stored;
        chy_bool_t sortable;
        kino_Int32Type* retval;
        SV* boost_sv = NULL;
        SV* indexed_sv = NULL;
        SV* stored_sv = NULL;
        SV* sortable_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::Int32Type::new_PARAMS",
            &boost_sv, "boost", 5,
            &indexed_sv, "indexed", 7,
            &stored_sv, "stored", 6,
            &sortable_sv, "sortable", 8,
            NULL);

        if (boost_sv && XSBind_sv_defined(boost_sv)) {
            boost = (float)SvNV( boost_sv );
        }
        else {
            boost = 1.0;
        }
        if (indexed_sv && XSBind_sv_defined(indexed_sv)) {
            indexed = SvTRUE( indexed_sv ) ? 1 : 0;
        }
        else {
            indexed = true;
        }
        if (stored_sv && XSBind_sv_defined(stored_sv)) {
            stored = SvTRUE( stored_sv ) ? 1 : 0;
        }
        else {
            stored = true;
        }
        if (sortable_sv && XSBind_sv_defined(sortable_sv)) {
            sortable = SvTRUE( sortable_sv ) ? 1 : 0;
        }
        else {
            sortable = false;
        }
        self = (kino_Int32Type*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Int32Type_init2(self, boost, indexed, stored, sortable);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Plan_BlobType_new);
XS(XS_KinoSearch_Plan_BlobType_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_BlobType* self;
        chy_bool_t stored;
        kino_BlobType* retval;
        SV* stored_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::BlobType::new_PARAMS",
            &stored_sv, "stored", 6,
            NULL);

        if ( !stored_sv || !XSBind_sv_defined(stored_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'stored'");
        }
        stored = SvTRUE( stored_sv ) ? 1 : 0;
        self = (kino_BlobType*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_BlobType_init(self, stored);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_Span_new);
XS(XS_KinoSearch_Search_Span_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Span* self;
        int32_t offset;
        int32_t length;
        float weight;
        kino_Span* retval;
        SV* offset_sv = NULL;
        SV* length_sv = NULL;
        SV* weight_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Span::new_PARAMS",
            &offset_sv, "offset", 6,
            &length_sv, "length", 6,
            &weight_sv, "weight", 6,
            NULL);

        if ( !offset_sv || !XSBind_sv_defined(offset_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'offset'");
        }
        offset = (int32_t)SvIV( offset_sv );
        if ( !length_sv || !XSBind_sv_defined(length_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'length'");
        }
        length = (int32_t)SvIV( length_sv );
        if (weight_sv && XSBind_sv_defined(weight_sv)) {
            weight = (float)SvNV( weight_sv );
        }
        else {
            weight = 0.0;
        }
        self = (kino_Span*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Span_init(self, offset, length, weight);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_Folder_new);
XS(XS_KinoSearch_Store_Folder_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Folder* self;
        const kino_CharBuf* path;
        kino_Folder* retval;
        SV* path_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::Folder::new_PARAMS",
            &path_sv, "path", 4,
            NULL);

        if ( !path_sv || !XSBind_sv_defined(path_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'path'");
        }
        path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(path_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        self = (kino_Folder*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Folder_init(self, path);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_FSFolder_new);
XS(XS_KinoSearch_Store_FSFolder_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_FSFolder* self;
        const kino_CharBuf* path;
        kino_FSFolder* retval;
        SV* path_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::FSFolder::new_PARAMS",
            &path_sv, "path", 4,
            NULL);

        if ( !path_sv || !XSBind_sv_defined(path_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'path'");
        }
        path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(path_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        self = (kino_FSFolder*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_FSFolder_init(self, path);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_RAMFolder_new);
XS(XS_KinoSearch_Store_RAMFolder_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_RAMFolder* self;
        const kino_CharBuf* path;
        kino_RAMFolder* retval;
        SV* path_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::RAMFolder::new_PARAMS",
            &path_sv, "path", 4,
            NULL);

        if (path_sv && XSBind_sv_defined(path_sv)) {
            path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(path_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            path = NULL;
        }
        self = (kino_RAMFolder*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_RAMFolder_init(self, path);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Util_PriorityQueue_new);
XS(XS_KinoSearch_Util_PriorityQueue_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PriorityQueue* self;
        uint32_t max_size;
        kino_PriorityQueue* retval;
        SV* max_size_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Util::PriorityQueue::new_PARAMS",
            &max_size_sv, "max_size", 8,
            NULL);

        if ( !max_size_sv || !XSBind_sv_defined(max_size_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'max_size'");
        }
        max_size = (uint32_t)SvUV( max_size_sv );
        self = (kino_PriorityQueue*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PriQ_init(self, max_size);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_HitQueue_new);
XS(XS_KinoSearch_Search_HitQueue_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_HitQueue* self;
        kino_Schema* schema;
        kino_SortSpec* sort_spec;
        uint32_t wanted;
        kino_HitQueue* retval;
        SV* schema_sv = NULL;
        SV* sort_spec_sv = NULL;
        SV* wanted_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::HitQueue::new_PARAMS",
            &schema_sv, "schema", 6,
            &sort_spec_sv, "sort_spec", 9,
            &wanted_sv, "wanted", 6,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if (sort_spec_sv && XSBind_sv_defined(sort_spec_sv)) {
            sort_spec = (kino_SortSpec*)XSBind_sv_to_cfish_obj(sort_spec_sv, KINO_SORTSPEC, NULL);
        }
        else {
            sort_spec = NULL;
        }
        if ( !wanted_sv || !XSBind_sv_defined(wanted_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'wanted'");
        }
        wanted = (uint32_t)SvUV( wanted_sv );
        self = (kino_HitQueue*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_HitQ_init(self, schema, sort_spec, wanted);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_Matcher_new);
XS(XS_KinoSearch_Search_Matcher_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Matcher* self;
        kino_Matcher* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Matcher::new_PARAMS",
            NULL);

        self = (kino_Matcher*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Matcher_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_BitVecMatcher_new);
XS(XS_KinoSearch_Search_BitVecMatcher_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_BitVecMatcher* self;
        kino_BitVector* bit_vector;
        kino_BitVecMatcher* retval;
        SV* bit_vector_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::BitVecMatcher::new_PARAMS",
            &bit_vector_sv, "bit_vector", 10,
            NULL);

        if ( !bit_vector_sv || !XSBind_sv_defined(bit_vector_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'bit_vector'");
        }
        bit_vector = (kino_BitVector*)XSBind_sv_to_cfish_obj(bit_vector_sv, KINO_BITVECTOR, NULL);
        self = (kino_BitVecMatcher*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_BitVecMatcher_init(self, bit_vector);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_PostingList_new);
XS(XS_KinoSearch_Index_PostingList_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PostingList* self;
        kino_PostingList* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PostingList::new_PARAMS",
            NULL);

        self = (kino_PostingList*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PList_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_SegPostingList_new);
XS(XS_KinoSearch_Index_SegPostingList_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SegPostingList* self;
        kino_PostingListReader* plist_reader;
        const kino_CharBuf* field;
        kino_SegPostingList* retval;
        SV* plist_reader_sv = NULL;
        SV* field_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegPostingList::new_PARAMS",
            &plist_reader_sv, "plist_reader", 12,
            &field_sv, "field", 5,
            NULL);

        if ( !plist_reader_sv || !XSBind_sv_defined(plist_reader_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'plist_reader'");
        }
        plist_reader = (kino_PostingListReader*)XSBind_sv_to_cfish_obj(plist_reader_sv, KINO_POSTINGLISTREADER, NULL);
        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        self = (kino_SegPostingList*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_SegPList_init(self, plist_reader, field);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KSx_Search_FilterScorer_new);
XS(XS_KSx_Search_FilterScorer_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_FilterScorer* self;
        kino_BitVector* bits;
        int32_t doc_max;
        kino_FilterScorer* retval;
        SV* bits_sv = NULL;
        SV* doc_max_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KSx::Search::FilterScorer::new_PARAMS",
            &bits_sv, "bits", 4,
            &doc_max_sv, "doc_max", 7,
            NULL);

        if ( !bits_sv || !XSBind_sv_defined(bits_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'bits'");
        }
        bits = (kino_BitVector*)XSBind_sv_to_cfish_obj(bits_sv, KINO_BITVECTOR, NULL);
        if ( !doc_max_sv || !XSBind_sv_defined(doc_max_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'doc_max'");
        }
        doc_max = (int32_t)SvIV( doc_max_sv );
        self = (kino_FilterScorer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_FilterScorer_init(self, bits, doc_max);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KSx_Search_MockMatcher__new);
XS(XS_KSx_Search_MockMatcher__new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_MockMatcher* self;
        kino_I32Array* doc_ids;
        kino_ByteBuf* scores;
        kino_MockMatcher* retval;
        SV* doc_ids_sv = NULL;
        SV* scores_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KSx::Search::MockMatcher::_new_PARAMS",
            &doc_ids_sv, "doc_ids", 7,
            &scores_sv, "scores", 6,
            NULL);

        if ( !doc_ids_sv || !XSBind_sv_defined(doc_ids_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'doc_ids'");
        }
        doc_ids = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_ids_sv, KINO_I32ARRAY, NULL);
        if (scores_sv && XSBind_sv_defined(scores_sv)) {
            scores = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(scores_sv, KINO_BYTEBUF, NULL);
        }
        else {
            scores = NULL;
        }
        self = (kino_MockMatcher*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_MockMatcher_init(self, doc_ids, scores);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_ORScorer_new);
XS(XS_KinoSearch_Search_ORScorer_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_ORScorer* self;
        kino_VArray* children;
        kino_Similarity* similarity;
        kino_ORScorer* retval;
        SV* children_sv = NULL;
        SV* similarity_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::ORScorer::new_PARAMS",
            &children_sv, "children", 8,
            &similarity_sv, "similarity", 10,
            NULL);

        if ( !children_sv || !XSBind_sv_defined(children_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'children'");
        }
        children = (kino_VArray*)XSBind_sv_to_cfish_obj(children_sv, KINO_VARRAY, NULL);
        if ( !similarity_sv || !XSBind_sv_defined(similarity_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'similarity'");
        }
        similarity = (kino_Similarity*)XSBind_sv_to_cfish_obj(similarity_sv, KINO_SIMILARITY, NULL);
        self = (kino_ORScorer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_ORScorer_init(self, children, similarity);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_ANDScorer_new);
XS(XS_KinoSearch_Search_ANDScorer_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_ANDScorer* self;
        kino_VArray* children;
        kino_Similarity* similarity;
        kino_ANDScorer* retval;
        SV* children_sv = NULL;
        SV* similarity_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::ANDScorer::new_PARAMS",
            &children_sv, "children", 8,
            &similarity_sv, "similarity", 10,
            NULL);

        if ( !children_sv || !XSBind_sv_defined(children_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'children'");
        }
        children = (kino_VArray*)XSBind_sv_to_cfish_obj(children_sv, KINO_VARRAY, NULL);
        if ( !similarity_sv || !XSBind_sv_defined(similarity_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'similarity'");
        }
        similarity = (kino_Similarity*)XSBind_sv_to_cfish_obj(similarity_sv, KINO_SIMILARITY, NULL);
        self = (kino_ANDScorer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_ANDScorer_init(self, children, similarity);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_NOTScorer_new);
XS(XS_KinoSearch_Search_NOTScorer_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_NOTScorer* self;
        kino_Matcher* negated_matcher;
        int32_t doc_max;
        kino_NOTScorer* retval;
        SV* negated_matcher_sv = NULL;
        SV* doc_max_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::NOTScorer::new_PARAMS",
            &negated_matcher_sv, "negated_matcher", 15,
            &doc_max_sv, "doc_max", 7,
            NULL);

        if ( !negated_matcher_sv || !XSBind_sv_defined(negated_matcher_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'negated_matcher'");
        }
        negated_matcher = (kino_Matcher*)XSBind_sv_to_cfish_obj(negated_matcher_sv, KINO_MATCHER, NULL);
        if ( !doc_max_sv || !XSBind_sv_defined(doc_max_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'doc_max'");
        }
        doc_max = (int32_t)SvIV( doc_max_sv );
        self = (kino_NOTScorer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_NOTScorer_init(self, negated_matcher, doc_max);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_RequiredOptionalScorer_new);
XS(XS_KinoSearch_Search_RequiredOptionalScorer_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_RequiredOptionalScorer* self;
        kino_Similarity* similarity;
        kino_Matcher* required_matcher;
        kino_Matcher* optional_matcher;
        kino_RequiredOptionalScorer* retval;
        SV* similarity_sv = NULL;
        SV* required_matcher_sv = NULL;
        SV* optional_matcher_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::RequiredOptionalScorer::new_PARAMS",
            &similarity_sv, "similarity", 10,
            &required_matcher_sv, "required_matcher", 16,
            &optional_matcher_sv, "optional_matcher", 16,
            NULL);

        if ( !similarity_sv || !XSBind_sv_defined(similarity_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'similarity'");
        }
        similarity = (kino_Similarity*)XSBind_sv_to_cfish_obj(similarity_sv, KINO_SIMILARITY, NULL);
        if ( !required_matcher_sv || !XSBind_sv_defined(required_matcher_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'required_matcher'");
        }
        required_matcher = (kino_Matcher*)XSBind_sv_to_cfish_obj(required_matcher_sv, KINO_MATCHER, NULL);
        if ( !optional_matcher_sv || !XSBind_sv_defined(optional_matcher_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'optional_matcher'");
        }
        optional_matcher = (kino_Matcher*)XSBind_sv_to_cfish_obj(optional_matcher_sv, KINO_MATCHER, NULL);
        self = (kino_RequiredOptionalScorer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_ReqOptScorer_init(self, similarity, required_matcher, optional_matcher);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Object_Hash_new);
XS(XS_KinoSearch_Object_Hash_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Hash* self;
        uint32_t capacity;
        kino_Hash* retval;
        SV* capacity_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Object::Hash::new_PARAMS",
            &capacity_sv, "capacity", 8,
            NULL);

        if (capacity_sv && XSBind_sv_defined(capacity_sv)) {
            capacity = (uint32_t)SvUV( capacity_sv );
        }
        else {
            capacity = 0;
        }
        self = (kino_Hash*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Hash_init(self, capacity);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_Hits_new);
XS(XS_KinoSearch_Search_Hits_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Hits* self;
        kino_Searcher* searcher;
        kino_TopDocs* top_docs;
        uint32_t offset;
        kino_Hits* retval;
        SV* searcher_sv = NULL;
        SV* top_docs_sv = NULL;
        SV* offset_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Hits::new_PARAMS",
            &searcher_sv, "searcher", 8,
            &top_docs_sv, "top_docs", 8,
            &offset_sv, "offset", 6,
            NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'");
        }
        searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);
        if ( !top_docs_sv || !XSBind_sv_defined(top_docs_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'top_docs'");
        }
        top_docs = (kino_TopDocs*)XSBind_sv_to_cfish_obj(top_docs_sv, KINO_TOPDOCS, NULL);
        if (offset_sv && XSBind_sv_defined(offset_sv)) {
            offset = (uint32_t)SvUV( offset_sv );
        }
        else {
            offset = 0;
        }
        self = (kino_Hits*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Hits_init(self, searcher, top_docs, offset);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Object_VArray_new);
XS(XS_KinoSearch_Object_VArray_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_VArray* self;
        uint32_t capacity;
        kino_VArray* retval;
        SV* capacity_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Object::VArray::new_PARAMS",
            &capacity_sv, "capacity", 8,
            NULL);

        if ( !capacity_sv || !XSBind_sv_defined(capacity_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'capacity'");
        }
        capacity = (uint32_t)SvUV( capacity_sv );
        self = (kino_VArray*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_VA_init(self, capacity);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_Query_new);
XS(XS_KinoSearch_Search_Query_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Query* self;
        float boost;
        kino_Query* retval;
        SV* boost_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Query::new_PARAMS",
            &boost_sv, "boost", 5,
            NULL);

        if (boost_sv && XSBind_sv_defined(boost_sv)) {
            boost = (float)SvNV( boost_sv );
        }
        else {
            boost = 1.0;
        }
        self = (kino_Query*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Query_init(self, boost);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_NoMatchQuery_new);
XS(XS_KinoSearch_Search_NoMatchQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_NoMatchQuery* self;
        kino_NoMatchQuery* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::NoMatchQuery::new_PARAMS",
            NULL);

        self = (kino_NoMatchQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_NoMatchQuery_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_MatchAllQuery_new);
XS(XS_KinoSearch_Search_MatchAllQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_MatchAllQuery* self;
        kino_MatchAllQuery* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::MatchAllQuery::new_PARAMS",
            NULL);

        self = (kino_MatchAllQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_MatchAllQuery_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_PhraseQuery_new);
XS(XS_KinoSearch_Search_PhraseQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PhraseQuery* self;
        const kino_CharBuf* field;
        kino_VArray* terms;
        kino_PhraseQuery* retval;
        SV* field_sv = NULL;
        SV* terms_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PhraseQuery::new_PARAMS",
            &field_sv, "field", 5,
            &terms_sv, "terms", 5,
            NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if ( !terms_sv || !XSBind_sv_defined(terms_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'terms'");
        }
        terms = (kino_VArray*)XSBind_sv_to_cfish_obj(terms_sv, KINO_VARRAY, NULL);
        self = (kino_PhraseQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PhraseQuery_init(self, field, terms);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_PolyQuery_new);
XS(XS_KinoSearch_Search_PolyQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PolyQuery* self;
        kino_VArray* children;
        kino_PolyQuery* retval;
        SV* children_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PolyQuery::new_PARAMS",
            &children_sv, "children", 8,
            NULL);

        if (children_sv && XSBind_sv_defined(children_sv)) {
            children = (kino_VArray*)XSBind_sv_to_cfish_obj(children_sv, KINO_VARRAY, NULL);
        }
        else {
            children = NULL;
        }
        self = (kino_PolyQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PolyQuery_init(self, children);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_ANDQuery_new);
XS(XS_KinoSearch_Search_ANDQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_ANDQuery* self;
        kino_VArray* children;
        kino_ANDQuery* retval;
        SV* children_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::ANDQuery::new_PARAMS",
            &children_sv, "children", 8,
            NULL);

        if (children_sv && XSBind_sv_defined(children_sv)) {
            children = (kino_VArray*)XSBind_sv_to_cfish_obj(children_sv, KINO_VARRAY, NULL);
        }
        else {
            children = NULL;
        }
        self = (kino_ANDQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_ANDQuery_init(self, children);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_RequiredOptionalQuery_new);
XS(XS_KinoSearch_Search_RequiredOptionalQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_RequiredOptionalQuery* self;
        kino_Query* required_query;
        kino_Query* optional_query;
        kino_RequiredOptionalQuery* retval;
        SV* required_query_sv = NULL;
        SV* optional_query_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::RequiredOptionalQuery::new_PARAMS",
            &required_query_sv, "required_query", 14,
            &optional_query_sv, "optional_query", 14,
            NULL);

        if ( !required_query_sv || !XSBind_sv_defined(required_query_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'required_query'");
        }
        required_query = (kino_Query*)XSBind_sv_to_cfish_obj(required_query_sv, KINO_QUERY, NULL);
        if ( !optional_query_sv || !XSBind_sv_defined(optional_query_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'optional_query'");
        }
        optional_query = (kino_Query*)XSBind_sv_to_cfish_obj(optional_query_sv, KINO_QUERY, NULL);
        self = (kino_RequiredOptionalQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_ReqOptQuery_init(self, required_query, optional_query);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_NOTQuery_new);
XS(XS_KinoSearch_Search_NOTQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_NOTQuery* self;
        kino_Query* negated_query;
        kino_NOTQuery* retval;
        SV* negated_query_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::NOTQuery::new_PARAMS",
            &negated_query_sv, "negated_query", 13,
            NULL);

        if ( !negated_query_sv || !XSBind_sv_defined(negated_query_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'negated_query'");
        }
        negated_query = (kino_Query*)XSBind_sv_to_cfish_obj(negated_query_sv, KINO_QUERY, NULL);
        self = (kino_NOTQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_NOTQuery_init(self, negated_query);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_ORQuery_new);
XS(XS_KinoSearch_Search_ORQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_ORQuery* self;
        kino_VArray* children;
        kino_ORQuery* retval;
        SV* children_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::ORQuery::new_PARAMS",
            &children_sv, "children", 8,
            NULL);

        if (children_sv && XSBind_sv_defined(children_sv)) {
            children = (kino_VArray*)XSBind_sv_to_cfish_obj(children_sv, KINO_VARRAY, NULL);
        }
        else {
            children = NULL;
        }
        self = (kino_ORQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_ORQuery_init(self, children);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_TermQuery_new);
XS(XS_KinoSearch_Search_TermQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_TermQuery* self;
        const kino_CharBuf* field;
        const kino_Obj* term;
        kino_TermQuery* retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::TermQuery::new_PARAMS",
            &field_sv, "field", 5,
            &term_sv, "term", 4,
            NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'term'");
        }
        term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        self = (kino_TermQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_TermQuery_init(self, field, term);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KSx_Search_ProximityQuery_new);
XS(XS_KSx_Search_ProximityQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_ProximityQuery* self;
        const kino_CharBuf* field;
        kino_VArray* terms;
        uint32_t within;
        kino_ProximityQuery* retval;
        SV* field_sv = NULL;
        SV* terms_sv = NULL;
        SV* within_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KSx::Search::ProximityQuery::new_PARAMS",
            &field_sv, "field", 5,
            &terms_sv, "terms", 5,
            &within_sv, "within", 6,
            NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if ( !terms_sv || !XSBind_sv_defined(terms_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'terms'");
        }
        terms = (kino_VArray*)XSBind_sv_to_cfish_obj(terms_sv, KINO_VARRAY, NULL);
        if ( !within_sv || !XSBind_sv_defined(within_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'within'");
        }
        within = (uint32_t)SvUV( within_sv );
        self = (kino_ProximityQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_ProximityQuery_init(self, field, terms, within);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_LeafQuery_new);
XS(XS_KinoSearch_Search_LeafQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_LeafQuery* self;
        const kino_CharBuf* field;
        const kino_CharBuf* text;
        kino_LeafQuery* retval;
        SV* field_sv = NULL;
        SV* text_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::LeafQuery::new_PARAMS",
            &field_sv, "field", 5,
            &text_sv, "text", 4,
            NULL);

        if (field_sv && XSBind_sv_defined(field_sv)) {
            field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            field = NULL;
        }
        if ( !text_sv || !XSBind_sv_defined(text_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'text'");
        }
        text = (kino_CharBuf*)XSBind_sv_to_cfish_obj(text_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        self = (kino_LeafQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_LeafQuery_init(self, field, text);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_Compiler_do_new);
XS(XS_KinoSearch_Search_Compiler_do_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Compiler* self;
        kino_Query* parent;
        kino_Searcher* searcher;
        kino_Similarity* similarity;
        float boost;
        kino_Compiler* retval;
        SV* parent_sv = NULL;
        SV* searcher_sv = NULL;
        SV* similarity_sv = NULL;
        SV* boost_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Compiler::do_new_PARAMS",
            &parent_sv, "parent", 6,
            &searcher_sv, "searcher", 8,
            &similarity_sv, "similarity", 10,
            &boost_sv, "boost", 5,
            NULL);

        if ( !parent_sv || !XSBind_sv_defined(parent_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'parent'");
        }
        parent = (kino_Query*)XSBind_sv_to_cfish_obj(parent_sv, KINO_QUERY, NULL);
        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'");
        }
        searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);
        if (similarity_sv && XSBind_sv_defined(similarity_sv)) {
            similarity = (kino_Similarity*)XSBind_sv_to_cfish_obj(similarity_sv, KINO_SIMILARITY, NULL);
        }
        else {
            similarity = NULL;
        }
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'boost'");
        }
        boost = (float)SvNV( boost_sv );
        self = (kino_Compiler*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Compiler_init(self, parent, searcher, similarity, boost);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_PhraseCompiler_do_new);
XS(XS_KinoSearch_Search_PhraseCompiler_do_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PhraseCompiler* self;
        kino_PhraseQuery* parent;
        kino_Searcher* searcher;
        float boost;
        kino_PhraseCompiler* retval;
        SV* parent_sv = NULL;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PhraseCompiler::do_new_PARAMS",
            &parent_sv, "parent", 6,
            &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
            NULL);

        if ( !parent_sv || !XSBind_sv_defined(parent_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'parent'");
        }
        parent = (kino_PhraseQuery*)XSBind_sv_to_cfish_obj(parent_sv, KINO_PHRASEQUERY, NULL);
        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'");
        }
        searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'boost'");
        }
        boost = (float)SvNV( boost_sv );
        self = (kino_PhraseCompiler*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PhraseCompiler_init(self, parent, searcher, boost);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KSx_Search_ProximityCompiler_do_new);
XS(XS_KSx_Search_ProximityCompiler_do_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_ProximityCompiler* self;
        kino_ProximityQuery* parent;
        kino_Searcher* searcher;
        float boost;
        uint32_t within;
        kino_ProximityCompiler* retval;
        SV* parent_sv = NULL;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        SV* within_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KSx::Search::ProximityCompiler::do_new_PARAMS",
            &parent_sv, "parent", 6,
            &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
            &within_sv, "within", 6,
            NULL);

        if ( !parent_sv || !XSBind_sv_defined(parent_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'parent'");
        }
        parent = (kino_ProximityQuery*)XSBind_sv_to_cfish_obj(parent_sv, KINO_PROXIMITYQUERY, NULL);
        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'");
        }
        searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'boost'");
        }
        boost = (float)SvNV( boost_sv );
        if ( !within_sv || !XSBind_sv_defined(within_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'within'");
        }
        within = (uint32_t)SvUV( within_sv );
        self = (kino_ProximityCompiler*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_ProximityCompiler_init(self, parent, searcher, boost, within);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_TermCompiler_do_new);
XS(XS_KinoSearch_Search_TermCompiler_do_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_TermCompiler* self;
        kino_Query* parent;
        kino_Searcher* searcher;
        float boost;
        kino_TermCompiler* retval;
        SV* parent_sv = NULL;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::TermCompiler::do_new_PARAMS",
            &parent_sv, "parent", 6,
            &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
            NULL);

        if ( !parent_sv || !XSBind_sv_defined(parent_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'parent'");
        }
        parent = (kino_Query*)XSBind_sv_to_cfish_obj(parent_sv, KINO_QUERY, NULL);
        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'");
        }
        searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'boost'");
        }
        boost = (float)SvNV( boost_sv );
        self = (kino_TermCompiler*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_TermCompiler_init(self, parent, searcher, boost);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_RangeQuery_new);
XS(XS_KinoSearch_Search_RangeQuery_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_RangeQuery* self;
        const kino_CharBuf* field;
        kino_Obj* lower_term;
        kino_Obj* upper_term;
        chy_bool_t include_lower;
        chy_bool_t include_upper;
        kino_RangeQuery* retval;
        SV* field_sv = NULL;
        SV* lower_term_sv = NULL;
        SV* upper_term_sv = NULL;
        SV* include_lower_sv = NULL;
        SV* include_upper_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::RangeQuery::new_PARAMS",
            &field_sv, "field", 5,
            &lower_term_sv, "lower_term", 10,
            &upper_term_sv, "upper_term", 10,
            &include_lower_sv, "include_lower", 13,
            &include_upper_sv, "include_upper", 13,
            NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if (lower_term_sv && XSBind_sv_defined(lower_term_sv)) {
            lower_term = (kino_Obj*)XSBind_sv_to_cfish_obj(lower_term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        }
        else {
            lower_term = NULL;
        }
        if (upper_term_sv && XSBind_sv_defined(upper_term_sv)) {
            upper_term = (kino_Obj*)XSBind_sv_to_cfish_obj(upper_term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        }
        else {
            upper_term = NULL;
        }
        if (include_lower_sv && XSBind_sv_defined(include_lower_sv)) {
            include_lower = SvTRUE( include_lower_sv ) ? 1 : 0;
        }
        else {
            include_lower = true;
        }
        if (include_upper_sv && XSBind_sv_defined(include_upper_sv)) {
            include_upper = SvTRUE( include_upper_sv ) ? 1 : 0;
        }
        else {
            include_upper = true;
        }
        self = (kino_RangeQuery*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_RangeQuery_init(self, field, lower_term, upper_term, include_lower, include_upper);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_Indexer__new);
XS(XS_KinoSearch_Index_Indexer__new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Indexer* self;
        kino_Schema* schema;
        kino_Obj* index;
        kino_IndexManager* manager;
        int32_t flags;
        kino_Indexer* retval;
        SV* schema_sv = NULL;
        SV* index_sv = NULL;
        SV* manager_sv = NULL;
        SV* flags_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Indexer::_new_PARAMS",
            &schema_sv, "schema", 6,
            &index_sv, "index", 5,
            &manager_sv, "manager", 7,
            &flags_sv, "flags", 5,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if ( !index_sv || !XSBind_sv_defined(index_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'index'");
        }
        index = (kino_Obj*)XSBind_sv_to_cfish_obj(index_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        if (manager_sv && XSBind_sv_defined(manager_sv)) {
            manager = (kino_IndexManager*)XSBind_sv_to_cfish_obj(manager_sv, KINO_INDEXMANAGER, NULL);
        }
        else {
            manager = NULL;
        }
        if (flags_sv && XSBind_sv_defined(flags_sv)) {
            flags = (int32_t)SvIV( flags_sv );
        }
        else {
            flags = 0;
        }
        self = (kino_Indexer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Indexer_init(self, schema, index, manager, flags);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_Searcher_new);
XS(XS_KinoSearch_Search_Searcher_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Searcher* self;
        kino_Schema* schema;
        kino_Searcher* retval;
        SV* schema_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Searcher::new_PARAMS",
            &schema_sv, "schema", 6,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        self = (kino_Searcher*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Searcher_init(self, schema);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_PolySearcher_new);
XS(XS_KinoSearch_Search_PolySearcher_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PolySearcher* self;
        kino_Schema* schema;
        kino_VArray* searchers;
        kino_PolySearcher* retval;
        SV* schema_sv = NULL;
        SV* searchers_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PolySearcher::new_PARAMS",
            &schema_sv, "schema", 6,
            &searchers_sv, "searchers", 9,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !searchers_sv || !XSBind_sv_defined(searchers_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'searchers'");
        }
        searchers = (kino_VArray*)XSBind_sv_to_cfish_obj(searchers_sv, KINO_VARRAY, NULL);
        self = (kino_PolySearcher*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PolySearcher_init(self, schema, searchers);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_IndexSearcher_new);
XS(XS_KinoSearch_Search_IndexSearcher_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_IndexSearcher* self;
        kino_Obj* index;
        kino_IndexSearcher* retval;
        SV* index_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::IndexSearcher::new_PARAMS",
            &index_sv, "index", 5,
            NULL);

        if ( !index_sv || !XSBind_sv_defined(index_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'index'");
        }
        index = (kino_Obj*)XSBind_sv_to_cfish_obj(index_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        self = (kino_IndexSearcher*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_IxSearcher_init(self, index);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_Similarity_new);
XS(XS_KinoSearch_Index_Similarity_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Similarity* self;
        kino_Similarity* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Similarity::new_PARAMS",
            NULL);

        self = (kino_Similarity*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Sim_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Analysis_Analyzer_new);
XS(XS_KinoSearch_Analysis_Analyzer_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Analyzer* self;
        kino_Analyzer* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Analysis::Analyzer::new_PARAMS",
            NULL);

        self = (kino_Analyzer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Analyzer_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Analysis_PolyAnalyzer_new);
XS(XS_KinoSearch_Analysis_PolyAnalyzer_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PolyAnalyzer* self;
        const kino_CharBuf* language;
        kino_VArray* analyzers;
        kino_PolyAnalyzer* retval;
        SV* language_sv = NULL;
        SV* analyzers_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Analysis::PolyAnalyzer::new_PARAMS",
            &language_sv, "language", 8,
            &analyzers_sv, "analyzers", 9,
            NULL);

        if (language_sv && XSBind_sv_defined(language_sv)) {
            language = (kino_CharBuf*)XSBind_sv_to_cfish_obj(language_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            language = NULL;
        }
        if (analyzers_sv && XSBind_sv_defined(analyzers_sv)) {
            analyzers = (kino_VArray*)XSBind_sv_to_cfish_obj(analyzers_sv, KINO_VARRAY, NULL);
        }
        else {
            analyzers = NULL;
        }
        self = (kino_PolyAnalyzer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PolyAnalyzer_init(self, language, analyzers);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Analysis_Stopalizer_new);
XS(XS_KinoSearch_Analysis_Stopalizer_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Stopalizer* self;
        const kino_CharBuf* language;
        kino_Hash* stoplist;
        kino_Stopalizer* retval;
        SV* language_sv = NULL;
        SV* stoplist_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Analysis::Stopalizer::new_PARAMS",
            &language_sv, "language", 8,
            &stoplist_sv, "stoplist", 8,
            NULL);

        if (language_sv && XSBind_sv_defined(language_sv)) {
            language = (kino_CharBuf*)XSBind_sv_to_cfish_obj(language_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            language = NULL;
        }
        if (stoplist_sv && XSBind_sv_defined(stoplist_sv)) {
            stoplist = (kino_Hash*)XSBind_sv_to_cfish_obj(stoplist_sv, KINO_HASH, NULL);
        }
        else {
            stoplist = NULL;
        }
        self = (kino_Stopalizer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Stopalizer_init(self, language, stoplist);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Analysis_CaseFolder_new);
XS(XS_KinoSearch_Analysis_CaseFolder_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_CaseFolder* self;
        kino_CaseFolder* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Analysis::CaseFolder::new_PARAMS",
            NULL);

        self = (kino_CaseFolder*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_CaseFolder_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Analysis_Tokenizer__new);
XS(XS_KinoSearch_Analysis_Tokenizer__new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Tokenizer* self;
        const kino_CharBuf* pattern;
        kino_Tokenizer* retval;
        SV* pattern_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Analysis::Tokenizer::_new_PARAMS",
            &pattern_sv, "pattern", 7,
            NULL);

        if (pattern_sv && XSBind_sv_defined(pattern_sv)) {
            pattern = (kino_CharBuf*)XSBind_sv_to_cfish_obj(pattern_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else {
            pattern = NULL;
        }
        self = (kino_Tokenizer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Tokenizer_init(self, pattern);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Analysis_Stemmer_new);
XS(XS_KinoSearch_Analysis_Stemmer_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Stemmer* self;
        const kino_CharBuf* language;
        kino_Stemmer* retval;
        SV* language_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Analysis::Stemmer::new_PARAMS",
            &language_sv, "language", 8,
            NULL);

        if ( !language_sv || !XSBind_sv_defined(language_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'language'");
        }
        language = (kino_CharBuf*)XSBind_sv_to_cfish_obj(language_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        self = (kino_Stemmer*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Stemmer_init(self, language);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_TermVector_new);
XS(XS_KinoSearch_Index_TermVector_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_TermVector* self;
        const kino_CharBuf* field;
        const kino_CharBuf* text;
        kino_I32Array* positions;
        kino_I32Array* start_offsets;
        kino_I32Array* end_offsets;
        kino_TermVector* retval;
        SV* field_sv = NULL;
        SV* text_sv = NULL;
        SV* positions_sv = NULL;
        SV* start_offsets_sv = NULL;
        SV* end_offsets_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::TermVector::new_PARAMS",
            &field_sv, "field", 5,
            &text_sv, "text", 4,
            &positions_sv, "positions", 9,
            &start_offsets_sv, "start_offsets", 13,
            &end_offsets_sv, "end_offsets", 11,
            NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if ( !text_sv || !XSBind_sv_defined(text_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'text'");
        }
        text = (kino_CharBuf*)XSBind_sv_to_cfish_obj(text_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if ( !positions_sv || !XSBind_sv_defined(positions_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'positions'");
        }
        positions = (kino_I32Array*)XSBind_sv_to_cfish_obj(positions_sv, KINO_I32ARRAY, NULL);
        if ( !start_offsets_sv || !XSBind_sv_defined(start_offsets_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'start_offsets'");
        }
        start_offsets = (kino_I32Array*)XSBind_sv_to_cfish_obj(start_offsets_sv, KINO_I32ARRAY, NULL);
        if ( !end_offsets_sv || !XSBind_sv_defined(end_offsets_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'end_offsets'");
        }
        end_offsets = (kino_I32Array*)XSBind_sv_to_cfish_obj(end_offsets_sv, KINO_I32ARRAY, NULL);
        self = (kino_TermVector*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_TV_init(self, field, text, positions, start_offsets, end_offsets);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_InStream_open);
XS(XS_KinoSearch_Store_InStream_open)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_InStream* self;
        kino_Obj* file;
        kino_InStream* retval;
        SV* file_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::InStream::open_PARAMS",
            &file_sv, "file", 4,
            NULL);

        if ( !file_sv || !XSBind_sv_defined(file_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'file'");
        }
        file = (kino_Obj*)XSBind_sv_to_cfish_obj(file_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        self = (kino_InStream*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_InStream_do_open(self, file);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DataReader_new);
XS(XS_KinoSearch_Index_DataReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DataReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_DataReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DataReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if (folder_sv && XSBind_sv_defined(folder_sv)) {
            folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        }
        else {
            folder = NULL;
        }
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (segments_sv && XSBind_sv_defined(segments_sv)) {
            segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        }
        else {
            segments = NULL;
        }
        if (seg_tick_sv && XSBind_sv_defined(seg_tick_sv)) {
            seg_tick = (int32_t)SvIV( seg_tick_sv );
        }
        else {
            seg_tick = -1;
        }
        self = (kino_DataReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DataReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_PostingListReader_new);
XS(XS_KinoSearch_Index_PostingListReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PostingListReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_PostingListReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PostingListReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if (folder_sv && XSBind_sv_defined(folder_sv)) {
            folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        }
        else {
            folder = NULL;
        }
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (segments_sv && XSBind_sv_defined(segments_sv)) {
            segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        }
        else {
            segments = NULL;
        }
        if (seg_tick_sv && XSBind_sv_defined(seg_tick_sv)) {
            seg_tick = (int32_t)SvIV( seg_tick_sv );
        }
        else {
            seg_tick = -1;
        }
        self = (kino_PostingListReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PListReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DefaultPostingListReader_new);
XS(XS_KinoSearch_Index_DefaultPostingListReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DefaultPostingListReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_LexiconReader* lex_reader;
        kino_DefaultPostingListReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        SV* lex_reader_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultPostingListReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            &lex_reader_sv, "lex_reader", 10,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segments_sv || !XSBind_sv_defined(segments_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segments'");
        }
        segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        if ( !seg_tick_sv || !XSBind_sv_defined(seg_tick_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'seg_tick'");
        }
        seg_tick = (int32_t)SvIV( seg_tick_sv );
        if ( !lex_reader_sv || !XSBind_sv_defined(lex_reader_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'lex_reader'");
        }
        lex_reader = (kino_LexiconReader*)XSBind_sv_to_cfish_obj(lex_reader_sv, KINO_LEXICONREADER, NULL);
        self = (kino_DefaultPostingListReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DefPListReader_init(self, schema, folder, snapshot, segments, seg_tick, lex_reader);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_LexiconReader_new);
XS(XS_KinoSearch_Index_LexiconReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_LexiconReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_LexiconReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::LexiconReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if (folder_sv && XSBind_sv_defined(folder_sv)) {
            folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        }
        else {
            folder = NULL;
        }
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (segments_sv && XSBind_sv_defined(segments_sv)) {
            segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        }
        else {
            segments = NULL;
        }
        if (seg_tick_sv && XSBind_sv_defined(seg_tick_sv)) {
            seg_tick = (int32_t)SvIV( seg_tick_sv );
        }
        else {
            seg_tick = -1;
        }
        self = (kino_LexiconReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_LexReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DefaultLexiconReader_new);
XS(XS_KinoSearch_Index_DefaultLexiconReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DefaultLexiconReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_DefaultLexiconReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultLexiconReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segments_sv || !XSBind_sv_defined(segments_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segments'");
        }
        segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        if ( !seg_tick_sv || !XSBind_sv_defined(seg_tick_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'seg_tick'");
        }
        seg_tick = (int32_t)SvIV( seg_tick_sv );
        self = (kino_DefaultLexiconReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DefLexReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_HighlightReader_new);
XS(XS_KinoSearch_Index_HighlightReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_HighlightReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_HighlightReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::HighlightReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if (folder_sv && XSBind_sv_defined(folder_sv)) {
            folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        }
        else {
            folder = NULL;
        }
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (segments_sv && XSBind_sv_defined(segments_sv)) {
            segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        }
        else {
            segments = NULL;
        }
        if (seg_tick_sv && XSBind_sv_defined(seg_tick_sv)) {
            seg_tick = (int32_t)SvIV( seg_tick_sv );
        }
        else {
            seg_tick = -1;
        }
        self = (kino_HighlightReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_HLReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DefaultHighlightReader_new);
XS(XS_KinoSearch_Index_DefaultHighlightReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DefaultHighlightReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_DefaultHighlightReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultHighlightReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segments_sv || !XSBind_sv_defined(segments_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segments'");
        }
        segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        if ( !seg_tick_sv || !XSBind_sv_defined(seg_tick_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'seg_tick'");
        }
        seg_tick = (int32_t)SvIV( seg_tick_sv );
        self = (kino_DefaultHighlightReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DefHLReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DocReader_new);
XS(XS_KinoSearch_Index_DocReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DocReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_DocReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DocReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if (folder_sv && XSBind_sv_defined(folder_sv)) {
            folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        }
        else {
            folder = NULL;
        }
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (segments_sv && XSBind_sv_defined(segments_sv)) {
            segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        }
        else {
            segments = NULL;
        }
        if (seg_tick_sv && XSBind_sv_defined(seg_tick_sv)) {
            seg_tick = (int32_t)SvIV( seg_tick_sv );
        }
        else {
            seg_tick = -1;
        }
        self = (kino_DocReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DocReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DefaultDocReader_new);
XS(XS_KinoSearch_Index_DefaultDocReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DefaultDocReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_DefaultDocReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultDocReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segments_sv || !XSBind_sv_defined(segments_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segments'");
        }
        segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        if ( !seg_tick_sv || !XSBind_sv_defined(seg_tick_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'seg_tick'");
        }
        seg_tick = (int32_t)SvIV( seg_tick_sv );
        self = (kino_DefaultDocReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DefDocReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_IndexReader_open);
XS(XS_KinoSearch_Index_IndexReader_open)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_IndexReader* self;
        kino_Obj* index;
        kino_Snapshot* snapshot;
        kino_IndexManager* manager;
        kino_IndexReader* retval;
        SV* index_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* manager_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::IndexReader::open_PARAMS",
            &index_sv, "index", 5,
            &snapshot_sv, "snapshot", 8,
            &manager_sv, "manager", 7,
            NULL);

        if ( !index_sv || !XSBind_sv_defined(index_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'index'");
        }
        index = (kino_Obj*)XSBind_sv_to_cfish_obj(index_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (manager_sv && XSBind_sv_defined(manager_sv)) {
            manager = (kino_IndexManager*)XSBind_sv_to_cfish_obj(manager_sv, KINO_INDEXMANAGER, NULL);
        }
        else {
            manager = NULL;
        }
        self = (kino_IndexReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_IxReader_do_open(self, index, snapshot, manager);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_SegReader_new);
XS(XS_KinoSearch_Index_SegReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SegReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_SegReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if ( !segments_sv || !XSBind_sv_defined(segments_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segments'");
        }
        segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        if ( !seg_tick_sv || !XSBind_sv_defined(seg_tick_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'seg_tick'");
        }
        seg_tick = (int32_t)SvIV( seg_tick_sv );
        self = (kino_SegReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_SegReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_PolyReader_new);
XS(XS_KinoSearch_Index_PolyReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PolyReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_IndexManager* manager;
        kino_VArray* sub_readers;
        kino_PolyReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* manager_sv = NULL;
        SV* sub_readers_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PolyReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &manager_sv, "manager", 7,
            &sub_readers_sv, "sub_readers", 11,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (manager_sv && XSBind_sv_defined(manager_sv)) {
            manager = (kino_IndexManager*)XSBind_sv_to_cfish_obj(manager_sv, KINO_INDEXMANAGER, NULL);
        }
        else {
            manager = NULL;
        }
        if (sub_readers_sv && XSBind_sv_defined(sub_readers_sv)) {
            sub_readers = (kino_VArray*)XSBind_sv_to_cfish_obj(sub_readers_sv, KINO_VARRAY, NULL);
        }
        else {
            sub_readers = NULL;
        }
        self = (kino_PolyReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PolyReader_init(self, schema, folder, snapshot, manager, sub_readers);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_PolyReader_open);
XS(XS_KinoSearch_Index_PolyReader_open)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PolyReader* self;
        kino_Obj* index;
        kino_Snapshot* snapshot;
        kino_IndexManager* manager;
        kino_PolyReader* retval;
        SV* index_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* manager_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PolyReader::open_PARAMS",
            &index_sv, "index", 5,
            &snapshot_sv, "snapshot", 8,
            &manager_sv, "manager", 7,
            NULL);

        if ( !index_sv || !XSBind_sv_defined(index_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'index'");
        }
        index = (kino_Obj*)XSBind_sv_to_cfish_obj(index_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (manager_sv && XSBind_sv_defined(manager_sv)) {
            manager = (kino_IndexManager*)XSBind_sv_to_cfish_obj(manager_sv, KINO_INDEXMANAGER, NULL);
        }
        else {
            manager = NULL;
        }
        self = (kino_PolyReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PolyReader_do_open(self, index, snapshot, manager);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_SortReader_new);
XS(XS_KinoSearch_Index_SortReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SortReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_SortReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SortReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if (folder_sv && XSBind_sv_defined(folder_sv)) {
            folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        }
        else {
            folder = NULL;
        }
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (segments_sv && XSBind_sv_defined(segments_sv)) {
            segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        }
        else {
            segments = NULL;
        }
        if (seg_tick_sv && XSBind_sv_defined(seg_tick_sv)) {
            seg_tick = (int32_t)SvIV( seg_tick_sv );
        }
        else {
            seg_tick = -1;
        }
        self = (kino_SortReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_SortReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DefaultSortReader_new);
XS(XS_KinoSearch_Index_DefaultSortReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DefaultSortReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_DefaultSortReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultSortReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segments_sv || !XSBind_sv_defined(segments_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segments'");
        }
        segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        if ( !seg_tick_sv || !XSBind_sv_defined(seg_tick_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'seg_tick'");
        }
        seg_tick = (int32_t)SvIV( seg_tick_sv );
        self = (kino_DefaultSortReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DefSortReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DeletionsReader_new);
XS(XS_KinoSearch_Index_DeletionsReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DeletionsReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_DeletionsReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DeletionsReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if (folder_sv && XSBind_sv_defined(folder_sv)) {
            folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        }
        else {
            folder = NULL;
        }
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (segments_sv && XSBind_sv_defined(segments_sv)) {
            segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        }
        else {
            segments = NULL;
        }
        if (seg_tick_sv && XSBind_sv_defined(seg_tick_sv)) {
            seg_tick = (int32_t)SvIV( seg_tick_sv );
        }
        else {
            seg_tick = -1;
        }
        self = (kino_DeletionsReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DelReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_DefaultDeletionsReader_new);
XS(XS_KinoSearch_Index_DefaultDeletionsReader_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_DefaultDeletionsReader* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_VArray* segments;
        int32_t seg_tick;
        kino_DefaultDeletionsReader* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* segments_sv = NULL;
        SV* seg_tick_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultDeletionsReader::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &segments_sv, "segments", 8,
            &seg_tick_sv, "seg_tick", 8,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !snapshot_sv || !XSBind_sv_defined(snapshot_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'snapshot'");
        }
        snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        if ( !segments_sv || !XSBind_sv_defined(segments_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segments'");
        }
        segments = (kino_VArray*)XSBind_sv_to_cfish_obj(segments_sv, KINO_VARRAY, NULL);
        if ( !seg_tick_sv || !XSBind_sv_defined(seg_tick_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'seg_tick'");
        }
        seg_tick = (int32_t)SvIV( seg_tick_sv );
        self = (kino_DefaultDeletionsReader*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_DefDelReader_init(self, schema, folder, snapshot, segments, seg_tick);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_Collector_new);
XS(XS_KinoSearch_Search_Collector_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Collector* self;
        kino_Collector* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Collector::new_PARAMS",
            NULL);

        self = (kino_Collector*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Coll_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_Collector_SortCollector_new);
XS(XS_KinoSearch_Search_Collector_SortCollector_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SortCollector* self;
        kino_Schema* schema;
        kino_SortSpec* sort_spec;
        uint32_t wanted;
        kino_SortCollector* retval;
        SV* schema_sv = NULL;
        SV* sort_spec_sv = NULL;
        SV* wanted_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Collector::SortCollector::new_PARAMS",
            &schema_sv, "schema", 6,
            &sort_spec_sv, "sort_spec", 9,
            &wanted_sv, "wanted", 6,
            NULL);

        if (schema_sv && XSBind_sv_defined(schema_sv)) {
            schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        }
        else {
            schema = NULL;
        }
        if (sort_spec_sv && XSBind_sv_defined(sort_spec_sv)) {
            sort_spec = (kino_SortSpec*)XSBind_sv_to_cfish_obj(sort_spec_sv, KINO_SORTSPEC, NULL);
        }
        else {
            sort_spec = NULL;
        }
        if ( !wanted_sv || !XSBind_sv_defined(wanted_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'wanted'");
        }
        wanted = (uint32_t)SvUV( wanted_sv );
        self = (kino_SortCollector*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_SortColl_init(self, schema, sort_spec, wanted);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_Collector_BitCollector_new);
XS(XS_KinoSearch_Search_Collector_BitCollector_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_BitCollector* self;
        kino_BitVector* bit_vector;
        kino_BitCollector* retval;
        SV* bit_vector_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Collector::BitCollector::new_PARAMS",
            &bit_vector_sv, "bit_vector", 10,
            NULL);

        if ( !bit_vector_sv || !XSBind_sv_defined(bit_vector_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'bit_vector'");
        }
        bit_vector = (kino_BitVector*)XSBind_sv_to_cfish_obj(bit_vector_sv, KINO_BITVECTOR, NULL);
        self = (kino_BitCollector*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_BitColl_init(self, bit_vector);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_Collector_OffsetCollector_new);
XS(XS_KinoSearch_Search_Collector_OffsetCollector_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_OffsetCollector* self;
        kino_Collector* collector;
        int32_t offset;
        kino_OffsetCollector* retval;
        SV* collector_sv = NULL;
        SV* offset_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Collector::OffsetCollector::new_PARAMS",
            &collector_sv, "collector", 9,
            &offset_sv, "offset", 6,
            NULL);

        if ( !collector_sv || !XSBind_sv_defined(collector_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'collector'");
        }
        collector = (kino_Collector*)XSBind_sv_to_cfish_obj(collector_sv, KINO_COLLECTOR, NULL);
        if ( !offset_sv || !XSBind_sv_defined(offset_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'offset'");
        }
        offset = (int32_t)SvIV( offset_sv );
        self = (kino_OffsetCollector*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_OffsetColl_init(self, collector, offset);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Plan_Schema_new);
XS(XS_KinoSearch_Plan_Schema_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Schema* self;
        kino_Schema* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::Schema::new_PARAMS",
            NULL);

        self = (kino_Schema*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Schema_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Test_TestSchema_new);
XS(XS_KinoSearch_Test_TestSchema_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_TestSchema* self;
        kino_TestSchema* retval;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Test::TestSchema::new_PARAMS",
            NULL);

        self = (kino_TestSchema*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_TestSchema_init(self);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Document_Doc_new);
XS(XS_KinoSearch_Document_Doc_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Doc* self;
        void* fields;
        int32_t doc_id;
        kino_Doc* retval;
        SV* fields_sv = NULL;
        SV* doc_id_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Document::Doc::new_PARAMS",
            &fields_sv, "fields", 6,
            &doc_id_sv, "doc_id", 6,
            NULL);

        if (fields_sv && XSBind_sv_defined(fields_sv)) {
            if (SvROK(fields_sv)) {
            fields = SvRV(fields_sv);
        }
        else {
            fields = NULL; /* avoid uninitialized compiler warning */
            CFISH_THROW(CFISH_ERR, "fields is not a reference");
        }

        }
        else {
            fields = NULL;
        }
        if (doc_id_sv && XSBind_sv_defined(doc_id_sv)) {
            doc_id = (int32_t)SvIV( doc_id_sv );
        }
        else {
            doc_id = 0;
        }
        self = (kino_Doc*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Doc_init(self, fields, doc_id);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Document_HitDoc_new);
XS(XS_KinoSearch_Document_HitDoc_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_HitDoc* self;
        void* fields;
        int32_t doc_id;
        float score;
        kino_HitDoc* retval;
        SV* fields_sv = NULL;
        SV* doc_id_sv = NULL;
        SV* score_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Document::HitDoc::new_PARAMS",
            &fields_sv, "fields", 6,
            &doc_id_sv, "doc_id", 6,
            &score_sv, "score", 5,
            NULL);

        if (fields_sv && XSBind_sv_defined(fields_sv)) {
            if (SvROK(fields_sv)) {
            fields = SvRV(fields_sv);
        }
        else {
            fields = NULL; /* avoid uninitialized compiler warning */
            CFISH_THROW(CFISH_ERR, "fields is not a reference");
        }

        }
        else {
            fields = NULL;
        }
        if (doc_id_sv && XSBind_sv_defined(doc_id_sv)) {
            doc_id = (int32_t)SvIV( doc_id_sv );
        }
        else {
            doc_id = 0;
        }
        if (score_sv && XSBind_sv_defined(score_sv)) {
            score = (float)SvNV( score_sv );
        }
        else {
            score = 0.0;
        }
        self = (kino_HitDoc*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_HitDoc_init(self, fields, doc_id, score);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Test_Util_BBSortEx_new);
XS(XS_KinoSearch_Test_Util_BBSortEx_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_BBSortEx* self;
        uint32_t mem_thresh;
        kino_VArray* external;
        kino_BBSortEx* retval;
        SV* mem_thresh_sv = NULL;
        SV* external_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Test::Util::BBSortEx::new_PARAMS",
            &mem_thresh_sv, "mem_thresh", 10,
            &external_sv, "external", 8,
            NULL);

        if (mem_thresh_sv && XSBind_sv_defined(mem_thresh_sv)) {
            mem_thresh = (uint32_t)SvUV( mem_thresh_sv );
        }
        else {
            mem_thresh = 0x1000000;
        }
        if (external_sv && XSBind_sv_defined(external_sv)) {
            external = (kino_VArray*)XSBind_sv_to_cfish_obj(external_sv, KINO_VARRAY, NULL);
        }
        else {
            external = NULL;
        }
        self = (kino_BBSortEx*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_BBSortEx_init(self, mem_thresh, external);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Search_MatchDoc_new);
XS(XS_KinoSearch_Search_MatchDoc_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_MatchDoc* self;
        int32_t doc_id;
        float score;
        kino_VArray* values;
        kino_MatchDoc* retval;
        SV* doc_id_sv = NULL;
        SV* score_sv = NULL;
        SV* values_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::MatchDoc::new_PARAMS",
            &doc_id_sv, "doc_id", 6,
            &score_sv, "score", 5,
            &values_sv, "values", 6,
            NULL);

        if ( !doc_id_sv || !XSBind_sv_defined(doc_id_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'doc_id'");
        }
        doc_id = (int32_t)SvIV( doc_id_sv );
        if ( !score_sv || !XSBind_sv_defined(score_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'score'");
        }
        score = (float)SvNV( score_sv );
        if (values_sv && XSBind_sv_defined(values_sv)) {
            values = (kino_VArray*)XSBind_sv_to_cfish_obj(values_sv, KINO_VARRAY, NULL);
        }
        else {
            values = NULL;
        }
        self = (kino_MatchDoc*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_MatchDoc_init(self, doc_id, score, values);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_Segment_new);
XS(XS_KinoSearch_Index_Segment_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Segment* self;
        int64_t number;
        kino_Segment* retval;
        SV* number_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Segment::new_PARAMS",
            &number_sv, "number", 6,
            NULL);

        if ( !number_sv || !XSBind_sv_defined(number_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'number'");
        }
        number = (int64_t)SvNV( number_sv );
        self = (kino_Segment*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Seg_init(self, number);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_Lexicon_new);
XS(XS_KinoSearch_Index_Lexicon_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_Lexicon* self;
        const kino_CharBuf* field;
        kino_Lexicon* retval;
        SV* field_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Lexicon::new_PARAMS",
            &field_sv, "field", 5,
            NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        self = (kino_Lexicon*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_Lex_init(self, field);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_SegLexicon_new);
XS(XS_KinoSearch_Index_SegLexicon_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_SegLexicon* self;
        kino_Schema* schema;
        kino_Folder* folder;
        kino_Segment* segment;
        const kino_CharBuf* field;
        kino_SegLexicon* retval;
        SV* schema_sv = NULL;
        SV* folder_sv = NULL;
        SV* segment_sv = NULL;
        SV* field_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegLexicon::new_PARAMS",
            &schema_sv, "schema", 6,
            &folder_sv, "folder", 6,
            &segment_sv, "segment", 7,
            &field_sv, "field", 5,
            NULL);

        if ( !schema_sv || !XSBind_sv_defined(schema_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'schema'");
        }
        schema = (kino_Schema*)XSBind_sv_to_cfish_obj(schema_sv, KINO_SCHEMA, NULL);
        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if ( !segment_sv || !XSBind_sv_defined(segment_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'segment'");
        }
        segment = (kino_Segment*)XSBind_sv_to_cfish_obj(segment_sv, KINO_SEGMENT, NULL);
        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        self = (kino_SegLexicon*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_SegLex_init(self, schema, folder, segment, field);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_PolyLexicon_new);
XS(XS_KinoSearch_Index_PolyLexicon_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_PolyLexicon* self;
        const kino_CharBuf* field;
        kino_VArray* sub_readers;
        kino_PolyLexicon* retval;
        SV* field_sv = NULL;
        SV* sub_readers_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PolyLexicon::new_PARAMS",
            &field_sv, "field", 5,
            &sub_readers_sv, "sub_readers", 11,
            NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'field'");
        }
        field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));
        if ( !sub_readers_sv || !XSBind_sv_defined(sub_readers_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'sub_readers'");
        }
        sub_readers = (kino_VArray*)XSBind_sv_to_cfish_obj(sub_readers_sv, KINO_VARRAY, NULL);
        self = (kino_PolyLexicon*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_PolyLex_init(self, field, sub_readers);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Index_FilePurger_new);
XS(XS_KinoSearch_Index_FilePurger_new)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_FilePurger* self;
        kino_Folder* folder;
        kino_Snapshot* snapshot;
        kino_IndexManager* manager;
        kino_FilePurger* retval;
        SV* folder_sv = NULL;
        SV* snapshot_sv = NULL;
        SV* manager_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::FilePurger::new_PARAMS",
            &folder_sv, "folder", 6,
            &snapshot_sv, "snapshot", 8,
            &manager_sv, "manager", 7,
            NULL);

        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'folder'");
        }
        folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);
        if (snapshot_sv && XSBind_sv_defined(snapshot_sv)) {
            snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(snapshot_sv, KINO_SNAPSHOT, NULL);
        }
        else {
            snapshot = NULL;
        }
        if (manager_sv && XSBind_sv_defined(manager_sv)) {
            manager = (kino_IndexManager*)XSBind_sv_to_cfish_obj(manager_sv, KINO_INDEXMANAGER, NULL);
        }
        else {
            manager = NULL;
        }
        self = (kino_FilePurger*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_FilePurger_init(self, folder, snapshot, manager);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Store_OutStream_open);
XS(XS_KinoSearch_Store_OutStream_open)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(class_name, ...)",  GvNAME(CvGV(cv))); }
    SP -= items;
    {
        kino_OutStream* self;
        kino_Obj* file;
        kino_OutStream* retval;
        SV* file_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::OutStream::open_PARAMS",
            &file_sv, "file", 4,
            NULL);

        if ( !file_sv || !XSBind_sv_defined(file_sv) ) {
           CFISH_THROW(CFISH_ERR, "Missing required param 'file'");
        }
        file = (kino_Obj*)XSBind_sv_to_cfish_obj(file_sv, KINO_OBJ, alloca(cfish_ZCB_size()));
        self = (kino_OutStream*)XSBind_new_blank_obj( ST(0) );
        
        retval = kino_OutStream_do_open(self, file);
        if (retval) {
            ST(0) = (SV*)Cfish_Obj_To_Host((cfish_Obj*)retval);
            Cfish_Obj_Dec_RefCount((cfish_Obj*)retval);
        }
        else {
            ST(0) = newSV(0);
        }
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}


XS(XS_KinoSearch_Object_Obj_get_refcount);
XS(XS_KinoSearch_Object_Obj_get_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        uint32_t retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        retval = kino_Obj_get_refcount(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VTable_get_refcount);
XS(XS_KinoSearch_Object_VTable_get_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VTable* self;
        uint32_t retval;
        self = (kino_VTable*)XSBind_sv_to_cfish_obj(ST(0), KINO_VTABLE, NULL);

        /* Execute */
        retval = kino_VTable_get_refcount(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_HashTombStone_get_refcount);
XS(XS_KinoSearch_Object_Hash_HashTombStone_get_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HashTombStone* self;
        uint32_t retval;
        self = (kino_HashTombStone*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASHTOMBSTONE, NULL);

        /* Execute */
        retval = kino_HashTombStone_get_refcount(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_RawPosting_get_refcount);
XS(XS_KinoSearch_Index_RawPosting_get_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RawPosting* self;
        uint32_t retval;
        self = (kino_RawPosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAWPOSTING, NULL);

        /* Execute */
        retval = kino_RawPost_get_refcount(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_inc_refcount);
XS(XS_KinoSearch_Object_Obj_inc_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        kino_Obj* retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        retval = kino_Obj_inc_refcount(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VTable_inc_refcount);
XS(XS_KinoSearch_Object_VTable_inc_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VTable* self;
        kino_Obj* retval;
        self = (kino_VTable*)XSBind_sv_to_cfish_obj(ST(0), KINO_VTABLE, NULL);

        /* Execute */
        retval = kino_VTable_inc_refcount(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_HashTombStone_inc_refcount);
XS(XS_KinoSearch_Object_Hash_HashTombStone_inc_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HashTombStone* self;
        kino_HashTombStone* retval;
        self = (kino_HashTombStone*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASHTOMBSTONE, NULL);

        /* Execute */
        retval = kino_HashTombStone_inc_refcount(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_RawPosting_inc_refcount);
XS(XS_KinoSearch_Index_RawPosting_inc_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RawPosting* self;
        kino_RawPosting* retval;
        self = (kino_RawPosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAWPOSTING, NULL);

        /* Execute */
        retval = kino_RawPost_inc_refcount(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_dec_refcount);
XS(XS_KinoSearch_Object_Obj_dec_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        uint32_t retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        retval = kino_Obj_dec_refcount(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VTable_dec_refcount);
XS(XS_KinoSearch_Object_VTable_dec_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VTable* self;
        uint32_t retval;
        self = (kino_VTable*)XSBind_sv_to_cfish_obj(ST(0), KINO_VTABLE, NULL);

        /* Execute */
        retval = kino_VTable_dec_refcount(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_HashTombStone_dec_refcount);
XS(XS_KinoSearch_Object_Hash_HashTombStone_dec_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HashTombStone* self;
        uint32_t retval;
        self = (kino_HashTombStone*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASHTOMBSTONE, NULL);

        /* Execute */
        retval = kino_HashTombStone_dec_refcount(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_RawPosting_dec_refcount);
XS(XS_KinoSearch_Index_RawPosting_dec_refcount)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RawPosting* self;
        uint32_t retval;
        self = (kino_RawPosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAWPOSTING, NULL);

        /* Execute */
        retval = kino_RawPost_dec_refcount(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_clone);
XS(XS_KinoSearch_Object_Obj_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        kino_Obj* retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        retval = kino_Obj_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_clone);
XS(XS_KinoSearch_Index_TermInfo_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        kino_TermInfo* retval;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);

        /* Execute */
        retval = kino_TInfo_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float32_clone);
XS(XS_KinoSearch_Object_Float32_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float32* self;
        kino_Float32* retval;
        self = (kino_Float32*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT32, NULL);

        /* Execute */
        retval = kino_Float32_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float64_clone);
XS(XS_KinoSearch_Object_Float64_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float64* self;
        kino_Float64* retval;
        self = (kino_Float64*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT64, NULL);

        /* Execute */
        retval = kino_Float64_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer32_clone);
XS(XS_KinoSearch_Object_Integer32_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer32* self;
        kino_Integer32* retval;
        self = (kino_Integer32*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER32, NULL);

        /* Execute */
        retval = kino_Int32_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer64_clone);
XS(XS_KinoSearch_Object_Integer64_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer64* self;
        kino_Integer64* retval;
        self = (kino_Integer64*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER64, NULL);

        /* Execute */
        retval = kino_Int64_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VTable_clone);
XS(XS_KinoSearch_Object_VTable_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VTable* self;
        kino_VTable* retval;
        self = (kino_VTable*)XSBind_sv_to_cfish_obj(ST(0), KINO_VTABLE, NULL);

        /* Execute */
        retval = kino_VTable_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_clone);
XS(XS_KinoSearch_Object_BitVector_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        kino_BitVector* retval;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);

        /* Execute */
        retval = kino_BitVec_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_clone);
XS(XS_KinoSearch_Object_VArray_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        kino_VArray* retval;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);

        /* Execute */
        retval = kino_VA_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ByteBuf_clone);
XS(XS_KinoSearch_Object_ByteBuf_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ByteBuf* self;
        kino_ByteBuf* retval;
        self = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_BYTEBUF, NULL);

        /* Execute */
        retval = kino_BB_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_clone);
XS(XS_KinoSearch_Store_InStream_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        kino_InStream* retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf_clone);
XS(XS_KinoSearch_Object_CharBuf_clone)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        kino_CharBuf* retval;
        self = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);

        /* Execute */
        retval = kino_CB_clone(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_destroy);
XS(XS_KinoSearch_Object_Obj_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        kino_Obj_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_destroy);
XS(XS_KinoSearch_Highlight_Highlighter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);

        /* Execute */
        kino_Highlighter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_destroy);
XS(XS_KinoSearch_Index_Inverter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        kino_Inverter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocVector_destroy);
XS(XS_KinoSearch_Index_DocVector_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DocVector* self;
        self = (kino_DocVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCVECTOR, NULL);

        /* Execute */
        kino_DocVec_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_InverterEntry_destroy);
XS(XS_KinoSearch_Index_Inverter_InverterEntry_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InverterEntry* self;
        self = (kino_InverterEntry*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTERENTRY, NULL);

        /* Execute */
        kino_InvEntry_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Lock_destroy);
XS(XS_KinoSearch_Store_Lock_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lock* self;
        self = (kino_Lock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCK, NULL);

        /* Execute */
        kino_Lock_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_LockFileLock_destroy);
XS(XS_KinoSearch_Store_LockFileLock_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LockFileLock* self;
        self = (kino_LockFileLock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFILELOCK, NULL);

        /* Execute */
        kino_LFLock_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_destroy);
XS(XS_KinoSearch_Search_QueryParser_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);

        /* Execute */
        kino_QParser_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_destroy);
XS(XS_KinoSearch_Index_IndexManager_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        kino_IxManager_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_QueryParser_ParserToken_destroy);
XS(XS_KinoSearch_QueryParser_ParserToken_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ParserToken* self;
        self = (kino_ParserToken*)XSBind_sv_to_cfish_obj(ST(0), KINO_PARSERTOKEN, NULL);

        /* Execute */
        kino_ParserToken_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TopDocs_destroy);
XS(XS_KinoSearch_Search_TopDocs_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TopDocs* self;
        self = (kino_TopDocs*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOPDOCS, NULL);

        /* Execute */
        kino_TopDocs_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Token_destroy);
XS(XS_KinoSearch_Analysis_Token_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Token* self;
        self = (kino_Token*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKEN, NULL);

        /* Execute */
        kino_Token_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot_destroy);
XS(XS_KinoSearch_Index_Snapshot_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);

        /* Execute */
        kino_Snapshot_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SortRule_destroy);
XS(XS_KinoSearch_Search_SortRule_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortRule* self;
        self = (kino_SortRule*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTRULE, NULL);

        /* Execute */
        kino_SortRule_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_HeatMap_destroy);
XS(XS_KinoSearch_Highlight_HeatMap_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HeatMap* self;
        self = (kino_HeatMap*)XSBind_sv_to_cfish_obj(ST(0), KINO_HEATMAP, NULL);

        /* Execute */
        kino_HeatMap_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_LockFreeRegistry_destroy);
XS(XS_KinoSearch_Object_LockFreeRegistry_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LockFreeRegistry* self;
        self = (kino_LockFreeRegistry*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFREEREGISTRY, NULL);

        /* Execute */
        kino_LFReg_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_MemoryPool_destroy);
XS(XS_KinoSearch_Util_MemoryPool_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MemoryPool* self;
        self = (kino_MemoryPool*)XSBind_sv_to_cfish_obj(ST(0), KINO_MEMORYPOOL, NULL);

        /* Execute */
        kino_MemPool_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortCache_destroy);
XS(XS_KinoSearch_Index_SortCache_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortCache* self;
        self = (kino_SortCache*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTCACHE, NULL);

        /* Execute */
        kino_SortCache_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortCache_TextSortCache_destroy);
XS(XS_KinoSearch_Index_SortCache_TextSortCache_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TextSortCache* self;
        self = (kino_TextSortCache*)XSBind_sv_to_cfish_obj(ST(0), KINO_TEXTSORTCACHE, NULL);

        /* Execute */
        kino_TextSortCache_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortCache_NumericSortCache_destroy);
XS(XS_KinoSearch_Index_SortCache_NumericSortCache_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NumericSortCache* self;
        self = (kino_NumericSortCache*)XSBind_sv_to_cfish_obj(ST(0), KINO_NUMERICSORTCACHE, NULL);

        /* Execute */
        kino_NumSortCache_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_LockFactory_destroy);
XS(XS_KinoSearch_Store_LockFactory_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LockFactory* self;
        self = (kino_LockFactory*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFACTORY, NULL);

        /* Execute */
        kino_LockFact_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VTable_destroy);
XS(XS_KinoSearch_Object_VTable_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VTable* self;
        self = (kino_VTable*)XSBind_sv_to_cfish_obj(ST(0), KINO_VTABLE, NULL);

        /* Execute */
        kino_VTable_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_FileHandle_destroy);
XS(XS_KinoSearch_Store_FileHandle_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FileHandle* self;
        self = (kino_FileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_FILEHANDLE, NULL);

        /* Execute */
        kino_FH_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_RAMFileHandle_destroy);
XS(XS_KinoSearch_Store_RAMFileHandle_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RAMFileHandle* self;
        self = (kino_RAMFileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAMFILEHANDLE, NULL);

        /* Execute */
        kino_RAMFH_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SortSpec_destroy);
XS(XS_KinoSearch_Search_SortSpec_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortSpec* self;
        self = (kino_SortSpec*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTSPEC, NULL);

        /* Execute */
        kino_SortSpec_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Err_destroy);
XS(XS_KinoSearch_Object_Err_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Err* self;
        self = (kino_Err*)XSBind_sv_to_cfish_obj(ST(0), KINO_ERR, NULL);

        /* Execute */
        kino_Err_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_QueryParser_ParserClause_destroy);
XS(XS_KinoSearch_QueryParser_ParserClause_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ParserClause* self;
        self = (kino_ParserClause*)XSBind_sv_to_cfish_obj(ST(0), KINO_PARSERCLAUSE, NULL);

        /* Execute */
        kino_ParserClause_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Inversion_destroy);
XS(XS_KinoSearch_Analysis_Inversion_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inversion* self;
        self = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERSION, NULL);

        /* Execute */
        kino_Inversion_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_destroy);
XS(XS_KinoSearch_Index_DataWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);

        /* Execute */
        kino_DataWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_HighlightWriter_destroy);
XS(XS_KinoSearch_Index_HighlightWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HighlightWriter* self;
        self = (kino_HighlightWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTWRITER, NULL);

        /* Execute */
        kino_HLWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexiconWriter_destroy);
XS(XS_KinoSearch_Index_LexiconWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LexiconWriter* self;
        self = (kino_LexiconWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICONWRITER, NULL);

        /* Execute */
        kino_LexWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_destroy);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);

        /* Execute */
        kino_DefDelWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingListWriter_destroy);
XS(XS_KinoSearch_Index_PostingListWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingListWriter* self;
        self = (kino_PostingListWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLISTWRITER, NULL);

        /* Execute */
        kino_PListWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocWriter_destroy);
XS(XS_KinoSearch_Index_DocWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DocWriter* self;
        self = (kino_DocWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCWRITER, NULL);

        /* Execute */
        kino_DocWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortWriter_destroy);
XS(XS_KinoSearch_Index_SortWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortWriter* self;
        self = (kino_SortWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTWRITER, NULL);

        /* Execute */
        kino_SortWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_RawPostingWriter_destroy);
XS(XS_KinoSearch_Index_Posting_RawPostingWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RawPostingWriter* self;
        self = (kino_RawPostingWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAWPOSTINGWRITER, NULL);

        /* Execute */
        kino_RawPostWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_MatchPostingWriter_destroy);
XS(XS_KinoSearch_Index_Posting_MatchPostingWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchPostingWriter* self;
        self = (kino_MatchPostingWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHPOSTINGWRITER, NULL);

        /* Execute */
        kino_MatchPostWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegWriter_destroy);
XS(XS_KinoSearch_Index_SegWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegWriter* self;
        self = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGWRITER, NULL);

        /* Execute */
        kino_SegWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_BackgroundMerger_destroy);
XS(XS_KinoSearch_Index_BackgroundMerger_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BackgroundMerger* self;
        self = (kino_BackgroundMerger*)XSBind_sv_to_cfish_obj(ST(0), KINO_BACKGROUNDMERGER, NULL);

        /* Execute */
        kino_BGMerger_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_RAMFile_destroy);
XS(XS_KinoSearch_Store_RAMFile_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RAMFile* self;
        self = (kino_RAMFile*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAMFILE, NULL);

        /* Execute */
        kino_RAMFile_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_destroy);
XS(XS_KinoSearch_Object_BitVector_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);

        /* Execute */
        kino_BitVec_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_BitVecDelDocs_destroy);
XS(XS_KinoSearch_Index_BitVecDelDocs_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVecDelDocs* self;
        self = (kino_BitVecDelDocs*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECDELDOCS, NULL);

        /* Execute */
        kino_BitVecDelDocs_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_MatchPosting_destroy);
XS(XS_KinoSearch_Index_Posting_MatchPosting_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchPosting* self;
        self = (kino_MatchPosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHPOSTING, NULL);

        /* Execute */
        kino_MatchPost_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_ScorePosting_destroy);
XS(XS_KinoSearch_Index_Posting_ScorePosting_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ScorePosting* self;
        self = (kino_ScorePosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCOREPOSTING, NULL);

        /* Execute */
        kino_ScorePost_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_RichPosting_destroy);
XS(XS_KinoSearch_Index_Posting_RichPosting_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RichPosting* self;
        self = (kino_RichPosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_RICHPOSTING, NULL);

        /* Execute */
        kino_RichPost_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_RawPosting_destroy);
XS(XS_KinoSearch_Index_RawPosting_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RawPosting* self;
        self = (kino_RawPosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAWPOSTING, NULL);

        /* Execute */
        kino_RawPost_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermStepper_destroy);
XS(XS_KinoSearch_Index_TermStepper_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermStepper* self;
        self = (kino_TermStepper*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMSTEPPER, NULL);

        /* Execute */
        kino_TermStepper_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FullTextType_destroy);
XS(XS_KinoSearch_Plan_FullTextType_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FullTextType* self;
        self = (kino_FullTextType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FULLTEXTTYPE, NULL);

        /* Execute */
        kino_FullTextType_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_destroy);
XS(XS_KinoSearch_Store_Folder_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);

        /* Execute */
        kino_Folder_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_CompoundFileReader_destroy);
XS(XS_KinoSearch_Store_CompoundFileReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CompoundFileReader* self;
        self = (kino_CompoundFileReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPOUNDFILEREADER, NULL);

        /* Execute */
        kino_CFReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_PriorityQueue_destroy);
XS(XS_KinoSearch_Util_PriorityQueue_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PriorityQueue* self;
        self = (kino_PriorityQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_PRIORITYQUEUE, NULL);

        /* Execute */
        kino_PriQ_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_HitQueue_destroy);
XS(XS_KinoSearch_Search_HitQueue_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HitQueue* self;
        self = (kino_HitQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITQUEUE, NULL);

        /* Execute */
        kino_HitQ_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_BitVecMatcher_destroy);
XS(XS_KinoSearch_Search_BitVecMatcher_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVecMatcher* self;
        self = (kino_BitVecMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECMATCHER, NULL);

        /* Execute */
        kino_BitVecMatcher_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseScorer_destroy);
XS(XS_KinoSearch_Search_PhraseScorer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseScorer* self;
        self = (kino_PhraseScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASESCORER, NULL);

        /* Execute */
        kino_PhraseScorer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermScorer_destroy);
XS(XS_KinoSearch_Search_TermScorer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermScorer* self;
        self = (kino_TermScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMSCORER, NULL);

        /* Execute */
        kino_TermScorer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_ScorePostingScorer_destroy);
XS(XS_KinoSearch_Index_Posting_ScorePostingScorer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ScorePostingScorer* self;
        self = (kino_ScorePostingScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCOREPOSTINGSCORER, NULL);

        /* Execute */
        kino_ScorePostScorer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SeriesMatcher_destroy);
XS(XS_KinoSearch_Search_SeriesMatcher_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SeriesMatcher* self;
        self = (kino_SeriesMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SERIESMATCHER, NULL);

        /* Execute */
        kino_SeriesMatcher_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegPostingList_destroy);
XS(XS_KinoSearch_Index_SegPostingList_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegPostingList* self;
        self = (kino_SegPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGPOSTINGLIST, NULL);

        /* Execute */
        kino_SegPList_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_RawPostingList_destroy);
XS(XS_KinoSearch_Index_RawPostingList_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RawPostingList* self;
        self = (kino_RawPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAWPOSTINGLIST, NULL);

        /* Execute */
        kino_RawPList_destroy(self);
    }
    PUTBACK;
}

XS(XS_KSx_Search_FilterScorer_destroy);
XS(XS_KSx_Search_FilterScorer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FilterScorer* self;
        self = (kino_FilterScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_FILTERSCORER, NULL);

        /* Execute */
        kino_FilterScorer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityScorer_destroy);
XS(XS_KSx_Search_ProximityScorer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityScorer* self;
        self = (kino_ProximityScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYSCORER, NULL);

        /* Execute */
        kino_ProximityScorer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KSx_Search_MockMatcher_destroy);
XS(XS_KSx_Search_MockMatcher_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MockMatcher* self;
        self = (kino_MockMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_MOCKMATCHER, NULL);

        /* Execute */
        kino_MockMatcher_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyMatcher_destroy);
XS(XS_KinoSearch_Search_PolyMatcher_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyMatcher* self;
        self = (kino_PolyMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYMATCHER, NULL);

        /* Execute */
        kino_PolyMatcher_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORMatcher_destroy);
XS(XS_KinoSearch_Search_ORMatcher_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORMatcher* self;
        self = (kino_ORMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORMATCHER, NULL);

        /* Execute */
        kino_ORMatcher_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORScorer_destroy);
XS(XS_KinoSearch_Search_ORScorer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORScorer* self;
        self = (kino_ORScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORSCORER, NULL);

        /* Execute */
        kino_ORScorer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ANDScorer_destroy);
XS(XS_KinoSearch_Search_ANDScorer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ANDScorer* self;
        self = (kino_ANDScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANDSCORER, NULL);

        /* Execute */
        kino_ANDScorer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTScorer_destroy);
XS(XS_KinoSearch_Search_NOTScorer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NOTScorer* self;
        self = (kino_NOTScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTSCORER, NULL);

        /* Execute */
        kino_NOTScorer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalScorer_destroy);
XS(XS_KinoSearch_Search_RequiredOptionalScorer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalScorer* self;
        self = (kino_RequiredOptionalScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALSCORER, NULL);

        /* Execute */
        kino_ReqOptScorer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeScorer_destroy);
XS(XS_KinoSearch_Search_RangeScorer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeScorer* self;
        self = (kino_RangeScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGESCORER, NULL);

        /* Execute */
        kino_RangeScorer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_TestQueryParser_destroy);
XS(XS_KinoSearch_Test_TestQueryParser_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TestQueryParser* self;
        self = (kino_TestQueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_TESTQUERYPARSER, NULL);

        /* Execute */
        kino_TestQP_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_destroy);
XS(XS_KinoSearch_Object_Hash_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);

        /* Execute */
        kino_Hash_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortFieldWriter_ZombieKeyedHash_destroy);
XS(XS_KinoSearch_Index_SortFieldWriter_ZombieKeyedHash_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ZombieKeyedHash* self;
        self = (kino_ZombieKeyedHash*)XSBind_sv_to_cfish_obj(ST(0), KINO_ZOMBIEKEYEDHASH, NULL);

        /* Execute */
        kino_ZKHash_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Hits_destroy);
XS(XS_KinoSearch_Search_Hits_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hits* self;
        self = (kino_Hits*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITS, NULL);

        /* Execute */
        kino_Hits_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_destroy);
XS(XS_KinoSearch_Object_VArray_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);

        /* Execute */
        kino_VA_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseQuery_destroy);
XS(XS_KinoSearch_Search_PhraseQuery_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseQuery* self;
        self = (kino_PhraseQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASEQUERY, NULL);

        /* Execute */
        kino_PhraseQuery_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyQuery_destroy);
XS(XS_KinoSearch_Search_PolyQuery_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyQuery* self;
        self = (kino_PolyQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYQUERY, NULL);

        /* Execute */
        kino_PolyQuery_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermQuery_destroy);
XS(XS_KinoSearch_Search_TermQuery_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermQuery* self;
        self = (kino_TermQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMQUERY, NULL);

        /* Execute */
        kino_TermQuery_destroy(self);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityQuery_destroy);
XS(XS_KSx_Search_ProximityQuery_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityQuery* self;
        self = (kino_ProximityQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYQUERY, NULL);

        /* Execute */
        kino_ProximityQuery_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_LeafQuery_destroy);
XS(XS_KinoSearch_Search_LeafQuery_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LeafQuery* self;
        self = (kino_LeafQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEAFQUERY, NULL);

        /* Execute */
        kino_LeafQuery_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_destroy);
XS(XS_KinoSearch_Search_Compiler_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);

        /* Execute */
        kino_Compiler_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyCompiler_destroy);
XS(XS_KinoSearch_Search_PolyCompiler_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyCompiler* self;
        self = (kino_PolyCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYCOMPILER, NULL);

        /* Execute */
        kino_PolyCompiler_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeQuery_destroy);
XS(XS_KinoSearch_Search_RangeQuery_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeQuery* self;
        self = (kino_RangeQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGEQUERY, NULL);

        /* Execute */
        kino_RangeQuery_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ByteBuf_destroy);
XS(XS_KinoSearch_Object_ByteBuf_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ByteBuf* self;
        self = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_BYTEBUF, NULL);

        /* Execute */
        kino_BB_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ViewByteBuf_destroy);
XS(XS_KinoSearch_Object_ViewByteBuf_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ViewByteBuf* self;
        self = (kino_ViewByteBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_VIEWBYTEBUF, NULL);

        /* Execute */
        kino_ViewBB_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_DirHandle_destroy);
XS(XS_KinoSearch_Store_DirHandle_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DirHandle* self;
        self = (kino_DirHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_DIRHANDLE, NULL);

        /* Execute */
        kino_DH_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_FSDirHandle_destroy);
XS(XS_KinoSearch_Store_FSDirHandle_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FSDirHandle* self;
        self = (kino_FSDirHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_FSDIRHANDLE, NULL);

        /* Execute */
        kino_FSDH_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Indexer_destroy);
XS(XS_KinoSearch_Index_Indexer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Indexer* self;
        self = (kino_Indexer*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXER, NULL);

        /* Execute */
        kino_Indexer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_destroy);
XS(XS_KinoSearch_Search_Searcher_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);

        /* Execute */
        kino_Searcher_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolySearcher_destroy);
XS(XS_KinoSearch_Search_PolySearcher_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolySearcher* self;
        self = (kino_PolySearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYSEARCHER, NULL);

        /* Execute */
        kino_PolySearcher_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_IndexSearcher_destroy);
XS(XS_KinoSearch_Search_IndexSearcher_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexSearcher* self;
        self = (kino_IndexSearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXSEARCHER, NULL);

        /* Execute */
        kino_IxSearcher_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_destroy);
XS(XS_KinoSearch_Index_Similarity_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);

        /* Execute */
        kino_Sim_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_PolyAnalyzer_destroy);
XS(XS_KinoSearch_Analysis_PolyAnalyzer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyAnalyzer* self;
        self = (kino_PolyAnalyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYANALYZER, NULL);

        /* Execute */
        kino_PolyAnalyzer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Stopalizer_destroy);
XS(XS_KinoSearch_Analysis_Stopalizer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stopalizer* self;
        self = (kino_Stopalizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_STOPALIZER, NULL);

        /* Execute */
        kino_Stopalizer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_CaseFolder_destroy);
XS(XS_KinoSearch_Analysis_CaseFolder_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CaseFolder* self;
        self = (kino_CaseFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_CASEFOLDER, NULL);

        /* Execute */
        kino_CaseFolder_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Tokenizer_destroy);
XS(XS_KinoSearch_Analysis_Tokenizer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Tokenizer* self;
        self = (kino_Tokenizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKENIZER, NULL);

        /* Execute */
        kino_Tokenizer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Stemmer_destroy);
XS(XS_KinoSearch_Analysis_Stemmer_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stemmer* self;
        self = (kino_Stemmer*)XSBind_sv_to_cfish_obj(ST(0), KINO_STEMMER, NULL);

        /* Execute */
        kino_Stemmer_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermVector_destroy);
XS(XS_KinoSearch_Index_TermVector_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermVector* self;
        self = (kino_TermVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMVECTOR, NULL);

        /* Execute */
        kino_TV_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_destroy);
XS(XS_KinoSearch_Store_InStream_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        kino_InStream_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf_destroy);
XS(XS_KinoSearch_Object_CharBuf_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        self = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);

        /* Execute */
        kino_CB_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ViewCharBuf_destroy);
XS(XS_KinoSearch_Object_ViewCharBuf_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ViewCharBuf* self;
        self = (kino_ViewCharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_VIEWCHARBUF, NULL);

        /* Execute */
        kino_ViewCB_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ZombieCharBuf_destroy);
XS(XS_KinoSearch_Object_ZombieCharBuf_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ZombieCharBuf* self;
        self = (kino_ZombieCharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_ZOMBIECHARBUF, NULL);

        /* Execute */
        kino_ZCB_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataReader_destroy);
XS(XS_KinoSearch_Index_DataReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataReader* self;
        self = (kino_DataReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAREADER, NULL);

        /* Execute */
        kino_DataReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultPostingListReader_destroy);
XS(XS_KinoSearch_Index_DefaultPostingListReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultPostingListReader* self;
        self = (kino_DefaultPostingListReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTPOSTINGLISTREADER, NULL);

        /* Execute */
        kino_DefPListReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyLexiconReader_destroy);
XS(XS_KinoSearch_Index_PolyLexiconReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyLexiconReader* self;
        self = (kino_PolyLexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYLEXICONREADER, NULL);

        /* Execute */
        kino_PolyLexReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultLexiconReader_destroy);
XS(XS_KinoSearch_Index_DefaultLexiconReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultLexiconReader* self;
        self = (kino_DefaultLexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTLEXICONREADER, NULL);

        /* Execute */
        kino_DefLexReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyHighlightReader_destroy);
XS(XS_KinoSearch_Index_PolyHighlightReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyHighlightReader* self;
        self = (kino_PolyHighlightReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYHIGHLIGHTREADER, NULL);

        /* Execute */
        kino_PolyHLReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultHighlightReader_destroy);
XS(XS_KinoSearch_Index_DefaultHighlightReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultHighlightReader* self;
        self = (kino_DefaultHighlightReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTHIGHLIGHTREADER, NULL);

        /* Execute */
        kino_DefHLReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDocReader_destroy);
XS(XS_KinoSearch_Index_DefaultDocReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDocReader* self;
        self = (kino_DefaultDocReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDOCREADER, NULL);

        /* Execute */
        kino_DefDocReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyDocReader_destroy);
XS(XS_KinoSearch_Index_PolyDocReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyDocReader* self;
        self = (kino_PolyDocReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYDOCREADER, NULL);

        /* Execute */
        kino_PolyDocReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexReader_destroy);
XS(XS_KinoSearch_Index_IndexReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexReader* self;
        self = (kino_IndexReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXREADER, NULL);

        /* Execute */
        kino_IxReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegReader_destroy);
XS(XS_KinoSearch_Index_SegReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegReader* self;
        self = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGREADER, NULL);

        /* Execute */
        kino_SegReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyReader_destroy);
XS(XS_KinoSearch_Index_PolyReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyReader* self;
        self = (kino_PolyReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYREADER, NULL);

        /* Execute */
        kino_PolyReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultSortReader_destroy);
XS(XS_KinoSearch_Index_DefaultSortReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultSortReader* self;
        self = (kino_DefaultSortReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTSORTREADER, NULL);

        /* Execute */
        kino_DefSortReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyDeletionsReader_destroy);
XS(XS_KinoSearch_Index_PolyDeletionsReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyDeletionsReader* self;
        self = (kino_PolyDeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYDELETIONSREADER, NULL);

        /* Execute */
        kino_PolyDelReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsReader_destroy);
XS(XS_KinoSearch_Index_DefaultDeletionsReader_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsReader* self;
        self = (kino_DefaultDeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSREADER, NULL);

        /* Execute */
        kino_DefDelReader_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_destroy);
XS(XS_KinoSearch_Search_Collector_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Collector* self;
        self = (kino_Collector*)XSBind_sv_to_cfish_obj(ST(0), KINO_COLLECTOR, NULL);

        /* Execute */
        kino_Coll_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_SortCollector_destroy);
XS(XS_KinoSearch_Search_Collector_SortCollector_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortCollector* self;
        self = (kino_SortCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTCOLLECTOR, NULL);

        /* Execute */
        kino_SortColl_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_BitCollector_destroy);
XS(XS_KinoSearch_Search_Collector_BitCollector_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitCollector* self;
        self = (kino_BitCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITCOLLECTOR, NULL);

        /* Execute */
        kino_BitColl_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_OffsetCollector_destroy);
XS(XS_KinoSearch_Search_Collector_OffsetCollector_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_OffsetCollector* self;
        self = (kino_OffsetCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_OFFSETCOLLECTOR, NULL);

        /* Execute */
        kino_OffsetColl_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_destroy);
XS(XS_KinoSearch_Plan_Schema_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);

        /* Execute */
        kino_Schema_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_Doc_destroy);
XS(XS_KinoSearch_Document_Doc_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Doc* self;
        self = (kino_Doc*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOC, NULL);

        /* Execute */
        kino_Doc_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_SortExternal_destroy);
XS(XS_KinoSearch_Util_SortExternal_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortExternal* self;
        self = (kino_SortExternal*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTEXTERNAL, NULL);

        /* Execute */
        kino_SortEx_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_Util_BBSortEx_destroy);
XS(XS_KinoSearch_Test_Util_BBSortEx_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BBSortEx* self;
        self = (kino_BBSortEx*)XSBind_sv_to_cfish_obj(ST(0), KINO_BBSORTEX, NULL);

        /* Execute */
        kino_BBSortEx_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingPool_destroy);
XS(XS_KinoSearch_Index_PostingPool_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingPool* self;
        self = (kino_PostingPool*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGPOOL, NULL);

        /* Execute */
        kino_PostPool_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortFieldWriter_destroy);
XS(XS_KinoSearch_Index_SortFieldWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortFieldWriter* self;
        self = (kino_SortFieldWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTFIELDWRITER, NULL);

        /* Execute */
        kino_SortFieldWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchDoc_destroy);
XS(XS_KinoSearch_Search_MatchDoc_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchDoc* self;
        self = (kino_MatchDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHDOC, NULL);

        /* Execute */
        kino_MatchDoc_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_destroy);
XS(XS_KinoSearch_Index_Segment_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);

        /* Execute */
        kino_Seg_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Lexicon_destroy);
XS(XS_KinoSearch_Index_Lexicon_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lexicon* self;
        self = (kino_Lexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICON, NULL);

        /* Execute */
        kino_Lex_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegLexicon_destroy);
XS(XS_KinoSearch_Index_SegLexicon_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegLexicon* self;
        self = (kino_SegLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGLEXICON, NULL);

        /* Execute */
        kino_SegLex_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyLexicon_destroy);
XS(XS_KinoSearch_Index_PolyLexicon_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyLexicon* self;
        self = (kino_PolyLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYLEXICON, NULL);

        /* Execute */
        kino_PolyLex_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexIndex_destroy);
XS(XS_KinoSearch_Index_LexIndex_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LexIndex* self;
        self = (kino_LexIndex*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXINDEX, NULL);

        /* Execute */
        kino_LexIndex_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_RawLexicon_destroy);
XS(XS_KinoSearch_Index_RawLexicon_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RawLexicon* self;
        self = (kino_RawLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAWLEXICON, NULL);

        /* Execute */
        kino_RawLex_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_FilePurger_destroy);
XS(XS_KinoSearch_Index_FilePurger_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FilePurger* self;
        self = (kino_FilePurger*)XSBind_sv_to_cfish_obj(ST(0), KINO_FILEPURGER, NULL);

        /* Execute */
        kino_FilePurger_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_destroy);
XS(XS_KinoSearch_Store_OutStream_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_OutStream_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_I32Array_destroy);
XS(XS_KinoSearch_Object_I32Array_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_I32Array* self;
        self = (kino_I32Array*)XSBind_sv_to_cfish_obj(ST(0), KINO_I32ARRAY, NULL);

        /* Execute */
        kino_I32Arr_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_CompoundFileWriter_destroy);
XS(XS_KinoSearch_Store_CompoundFileWriter_destroy)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CompoundFileWriter* self;
        self = (kino_CompoundFileWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPOUNDFILEWRITER, NULL);

        /* Execute */
        kino_CFWriter_destroy(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_equals);
XS(XS_KinoSearch_Object_Obj_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Obj_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Num_equals);
XS(XS_KinoSearch_Object_Num_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Num* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Num*)XSBind_sv_to_cfish_obj(ST(0), KINO_NUM, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Num_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer64_equals);
XS(XS_KinoSearch_Object_Integer64_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer64* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Integer64*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER64, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Int64_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_equals);
XS(XS_KinoSearch_Plan_Architecture_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Arch_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FieldType_equals);
XS(XS_KinoSearch_Plan_FieldType_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_FieldType* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_FieldType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FIELDTYPE, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_FType_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_StringType_equals);
XS(XS_KinoSearch_Plan_StringType_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_StringType* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_StringType*)XSBind_sv_to_cfish_obj(ST(0), KINO_STRINGTYPE, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_StringType_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FullTextType_equals);
XS(XS_KinoSearch_Plan_FullTextType_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_FullTextType* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_FullTextType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FULLTEXTTYPE, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_FullTextType_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Float32Type_equals);
XS(XS_KinoSearch_Plan_Float32Type_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float32Type* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Float32Type*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT32TYPE, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Float32Type_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Float64Type_equals);
XS(XS_KinoSearch_Plan_Float64Type_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float64Type* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Float64Type*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT64TYPE, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Float64Type_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Int64Type_equals);
XS(XS_KinoSearch_Plan_Int64Type_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Int64Type* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Int64Type*)XSBind_sv_to_cfish_obj(ST(0), KINO_INT64TYPE, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Int64Type_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Int32Type_equals);
XS(XS_KinoSearch_Plan_Int32Type_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Int32Type* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Int32Type*)XSBind_sv_to_cfish_obj(ST(0), KINO_INT32TYPE, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Int32Type_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_BlobType_equals);
XS(XS_KinoSearch_Plan_BlobType_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_BlobType* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_BlobType*)XSBind_sv_to_cfish_obj(ST(0), KINO_BLOBTYPE, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_BlobType_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_equals);
XS(XS_KinoSearch_Object_Hash_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Hash_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_equals);
XS(XS_KinoSearch_Object_VArray_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_VA_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchQuery_equals);
XS(XS_KinoSearch_Search_NoMatchQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_NoMatchQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOMATCHQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_NoMatchQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchAllQuery_equals);
XS(XS_KinoSearch_Search_MatchAllQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchAllQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_MatchAllQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHALLQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_MatchAllQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseQuery_equals);
XS(XS_KinoSearch_Search_PhraseQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_PhraseQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASEQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_PhraseQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyQuery_equals);
XS(XS_KinoSearch_Search_PolyQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_PolyQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_PolyQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ANDQuery_equals);
XS(XS_KinoSearch_Search_ANDQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_ANDQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_ANDQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANDQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_ANDQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalQuery_equals);
XS(XS_KinoSearch_Search_RequiredOptionalQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_RequiredOptionalQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_ReqOptQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTQuery_equals);
XS(XS_KinoSearch_Search_NOTQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_NOTQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_NOTQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_NOTQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORQuery_equals);
XS(XS_KinoSearch_Search_ORQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_ORQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_ORQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermQuery_equals);
XS(XS_KinoSearch_Search_TermQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_TermQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_TermQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityQuery_equals);
XS(XS_KSx_Search_ProximityQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_ProximityQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_ProximityQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_LeafQuery_equals);
XS(XS_KinoSearch_Search_LeafQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_LeafQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_LeafQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEAFQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_LeafQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_equals);
XS(XS_KinoSearch_Search_Compiler_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Compiler_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseCompiler_equals);
XS(XS_KinoSearch_Search_PhraseCompiler_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseCompiler* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_PhraseCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASECOMPILER, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_PhraseCompiler_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityCompiler_equals);
XS(XS_KSx_Search_ProximityCompiler_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityCompiler* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_ProximityCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYCOMPILER, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_ProximityCompiler_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermCompiler_equals);
XS(XS_KinoSearch_Search_TermCompiler_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermCompiler* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_TermCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMCOMPILER, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_TermCompiler_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeQuery_equals);
XS(XS_KinoSearch_Search_RangeQuery_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeQuery* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_RangeQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGEQUERY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_RangeQuery_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ByteBuf_equals);
XS(XS_KinoSearch_Object_ByteBuf_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_ByteBuf* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_BYTEBUF, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_BB_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_equals);
XS(XS_KinoSearch_Index_Similarity_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Sim_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_PolyAnalyzer_equals);
XS(XS_KinoSearch_Analysis_PolyAnalyzer_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyAnalyzer* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_PolyAnalyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYANALYZER, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_PolyAnalyzer_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Stopalizer_equals);
XS(XS_KinoSearch_Analysis_Stopalizer_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stopalizer* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Stopalizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_STOPALIZER, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Stopalizer_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_CaseFolder_equals);
XS(XS_KinoSearch_Analysis_CaseFolder_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_CaseFolder* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_CaseFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_CASEFOLDER, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_CaseFolder_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Tokenizer_equals);
XS(XS_KinoSearch_Analysis_Tokenizer_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Tokenizer* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Tokenizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKENIZER, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Tokenizer_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Stemmer_equals);
XS(XS_KinoSearch_Analysis_Stemmer_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stemmer* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Stemmer*)XSBind_sv_to_cfish_obj(ST(0), KINO_STEMMER, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Stemmer_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermVector_equals);
XS(XS_KinoSearch_Index_TermVector_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermVector* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_TermVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMVECTOR, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_TV_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf_equals);
XS(XS_KinoSearch_Object_CharBuf_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_CB_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_Doc_equals);
XS(XS_KinoSearch_Document_Doc_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Doc* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_Doc*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOC, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Doc_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_HitDoc_equals);
XS(XS_KinoSearch_Document_HitDoc_equals)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_HitDoc* self;
        kino_Obj* other;
        chy_bool_t retval;
        self = (kino_HitDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITDOC, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_HitDoc_equals(self, other);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_hash_sum);
XS(XS_KinoSearch_Object_Obj_hash_sum)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        int32_t retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        retval = kino_Obj_hash_sum(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float32_hash_sum);
XS(XS_KinoSearch_Object_Float32_hash_sum)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float32* self;
        int32_t retval;
        self = (kino_Float32*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT32, NULL);

        /* Execute */
        retval = kino_Float32_hash_sum(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float64_hash_sum);
XS(XS_KinoSearch_Object_Float64_hash_sum)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float64* self;
        int32_t retval;
        self = (kino_Float64*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT64, NULL);

        /* Execute */
        retval = kino_Float64_hash_sum(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer32_hash_sum);
XS(XS_KinoSearch_Object_Integer32_hash_sum)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer32* self;
        int32_t retval;
        self = (kino_Integer32*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER32, NULL);

        /* Execute */
        retval = kino_Int32_hash_sum(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer64_hash_sum);
XS(XS_KinoSearch_Object_Integer64_hash_sum)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer64* self;
        int32_t retval;
        self = (kino_Integer64*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER64, NULL);

        /* Execute */
        retval = kino_Int64_hash_sum(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ByteBuf_hash_sum);
XS(XS_KinoSearch_Object_ByteBuf_hash_sum)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ByteBuf* self;
        int32_t retval;
        self = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_BYTEBUF, NULL);

        /* Execute */
        retval = kino_BB_hash_sum(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf_hash_sum);
XS(XS_KinoSearch_Object_CharBuf_hash_sum)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        int32_t retval;
        self = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);

        /* Execute */
        retval = kino_CB_hash_sum(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_Object_StupidHashCharBuf_hash_sum);
XS(XS_KinoSearch_Test_Object_StupidHashCharBuf_hash_sum)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_StupidHashCharBuf* self;
        int32_t retval;
        self = (kino_StupidHashCharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_STUPIDHASHCHARBUF, NULL);

        /* Execute */
        retval = kino_StupidHashCharBuf_hash_sum(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_get_vtable);
XS(XS_KinoSearch_Object_Obj_get_vtable)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        kino_VTable* retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        retval = kino_Obj_get_vtable(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_to_string);
XS(XS_KinoSearch_Object_Obj_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        kino_CharBuf* retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        retval = kino_Obj_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_to_string);
XS(XS_KinoSearch_Index_TermInfo_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        kino_CharBuf* retval;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);

        /* Execute */
        retval = kino_TInfo_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_FloatNum_to_string);
XS(XS_KinoSearch_Object_FloatNum_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FloatNum* self;
        kino_CharBuf* retval;
        self = (kino_FloatNum*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOATNUM, NULL);

        /* Execute */
        retval = kino_FloatNum_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_IntNum_to_string);
XS(XS_KinoSearch_Object_IntNum_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IntNum* self;
        kino_CharBuf* retval;
        self = (kino_IntNum*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTNUM, NULL);

        /* Execute */
        retval = kino_IntNum_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Err_to_string);
XS(XS_KinoSearch_Object_Err_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Err* self;
        kino_CharBuf* retval;
        self = (kino_Err*)XSBind_sv_to_cfish_obj(ST(0), KINO_ERR, NULL);

        /* Execute */
        retval = kino_Err_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SkipStepper_to_string);
XS(XS_KinoSearch_Index_SkipStepper_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SkipStepper* self;
        kino_CharBuf* retval;
        self = (kino_SkipStepper*)XSBind_sv_to_cfish_obj(ST(0), KINO_SKIPSTEPPER, NULL);

        /* Execute */
        retval = kino_SkipStepper_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchQuery_to_string);
XS(XS_KinoSearch_Search_NoMatchQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchQuery* self;
        kino_CharBuf* retval;
        self = (kino_NoMatchQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOMATCHQUERY, NULL);

        /* Execute */
        retval = kino_NoMatchQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchAllQuery_to_string);
XS(XS_KinoSearch_Search_MatchAllQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchAllQuery* self;
        kino_CharBuf* retval;
        self = (kino_MatchAllQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHALLQUERY, NULL);

        /* Execute */
        retval = kino_MatchAllQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseQuery_to_string);
XS(XS_KinoSearch_Search_PhraseQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseQuery* self;
        kino_CharBuf* retval;
        self = (kino_PhraseQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASEQUERY, NULL);

        /* Execute */
        retval = kino_PhraseQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ANDQuery_to_string);
XS(XS_KinoSearch_Search_ANDQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ANDQuery* self;
        kino_CharBuf* retval;
        self = (kino_ANDQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANDQUERY, NULL);

        /* Execute */
        retval = kino_ANDQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalQuery_to_string);
XS(XS_KinoSearch_Search_RequiredOptionalQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalQuery* self;
        kino_CharBuf* retval;
        self = (kino_RequiredOptionalQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALQUERY, NULL);

        /* Execute */
        retval = kino_ReqOptQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTQuery_to_string);
XS(XS_KinoSearch_Search_NOTQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NOTQuery* self;
        kino_CharBuf* retval;
        self = (kino_NOTQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTQUERY, NULL);

        /* Execute */
        retval = kino_NOTQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORQuery_to_string);
XS(XS_KinoSearch_Search_ORQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORQuery* self;
        kino_CharBuf* retval;
        self = (kino_ORQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORQUERY, NULL);

        /* Execute */
        retval = kino_ORQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermQuery_to_string);
XS(XS_KinoSearch_Search_TermQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermQuery* self;
        kino_CharBuf* retval;
        self = (kino_TermQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMQUERY, NULL);

        /* Execute */
        retval = kino_TermQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityQuery_to_string);
XS(XS_KSx_Search_ProximityQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityQuery* self;
        kino_CharBuf* retval;
        self = (kino_ProximityQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYQUERY, NULL);

        /* Execute */
        retval = kino_ProximityQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_LeafQuery_to_string);
XS(XS_KinoSearch_Search_LeafQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LeafQuery* self;
        kino_CharBuf* retval;
        self = (kino_LeafQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEAFQUERY, NULL);

        /* Execute */
        retval = kino_LeafQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_to_string);
XS(XS_KinoSearch_Search_Compiler_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        kino_CharBuf* retval;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);

        /* Execute */
        retval = kino_Compiler_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeQuery_to_string);
XS(XS_KinoSearch_Search_RangeQuery_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeQuery* self;
        kino_CharBuf* retval;
        self = (kino_RangeQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGEQUERY, NULL);

        /* Execute */
        retval = kino_RangeQuery_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf_to_string);
XS(XS_KinoSearch_Object_CharBuf_to_string)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        kino_CharBuf* retval;
        self = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);

        /* Execute */
        retval = kino_CB_to_string(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_to_i64);
XS(XS_KinoSearch_Object_Obj_to_i64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        int64_t retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        retval = kino_Obj_to_i64(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float32_to_i64);
XS(XS_KinoSearch_Object_Float32_to_i64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float32* self;
        int64_t retval;
        self = (kino_Float32*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT32, NULL);

        /* Execute */
        retval = kino_Float32_to_i64(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float64_to_i64);
XS(XS_KinoSearch_Object_Float64_to_i64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float64* self;
        int64_t retval;
        self = (kino_Float64*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT64, NULL);

        /* Execute */
        retval = kino_Float64_to_i64(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer32_to_i64);
XS(XS_KinoSearch_Object_Integer32_to_i64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer32* self;
        int64_t retval;
        self = (kino_Integer32*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER32, NULL);

        /* Execute */
        retval = kino_Int32_to_i64(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer64_to_i64);
XS(XS_KinoSearch_Object_Integer64_to_i64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer64* self;
        int64_t retval;
        self = (kino_Integer64*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER64, NULL);

        /* Execute */
        retval = kino_Int64_to_i64(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf_to_i64);
XS(XS_KinoSearch_Object_CharBuf_to_i64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        int64_t retval;
        self = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);

        /* Execute */
        retval = kino_CB_to_i64(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_to_f64);
XS(XS_KinoSearch_Object_Obj_to_f64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        double retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        retval = kino_Obj_to_f64(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float32_to_f64);
XS(XS_KinoSearch_Object_Float32_to_f64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float32* self;
        double retval;
        self = (kino_Float32*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT32, NULL);

        /* Execute */
        retval = kino_Float32_to_f64(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float64_to_f64);
XS(XS_KinoSearch_Object_Float64_to_f64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float64* self;
        double retval;
        self = (kino_Float64*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT64, NULL);

        /* Execute */
        retval = kino_Float64_to_f64(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer32_to_f64);
XS(XS_KinoSearch_Object_Integer32_to_f64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer32* self;
        double retval;
        self = (kino_Integer32*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER32, NULL);

        /* Execute */
        retval = kino_Int32_to_f64(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer64_to_f64);
XS(XS_KinoSearch_Object_Integer64_to_f64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer64* self;
        double retval;
        self = (kino_Integer64*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER64, NULL);

        /* Execute */
        retval = kino_Int64_to_f64(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf_to_f64);
XS(XS_KinoSearch_Object_CharBuf_to_f64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        double retval;
        self = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);

        /* Execute */
        retval = kino_CB_to_f64(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_serialize);
XS(XS_KinoSearch_Object_Obj_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        kino_OutStream* outstream;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_Obj_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocVector_serialize);
XS(XS_KinoSearch_Index_DocVector_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_DocVector* self;
        kino_OutStream* outstream;
        self = (kino_DocVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCVECTOR, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_DocVec_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TopDocs_serialize);
XS(XS_KinoSearch_Search_TopDocs_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_TopDocs* self;
        kino_OutStream* outstream;
        self = (kino_TopDocs*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOPDOCS, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_TopDocs_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SortRule_serialize);
XS(XS_KinoSearch_Search_SortRule_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortRule* self;
        kino_OutStream* outstream;
        self = (kino_SortRule*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTRULE, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_SortRule_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float32_serialize);
XS(XS_KinoSearch_Object_Float32_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float32* self;
        kino_OutStream* outstream;
        self = (kino_Float32*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT32, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_Float32_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float64_serialize);
XS(XS_KinoSearch_Object_Float64_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float64* self;
        kino_OutStream* outstream;
        self = (kino_Float64*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT64, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_Float64_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer32_serialize);
XS(XS_KinoSearch_Object_Integer32_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer32* self;
        kino_OutStream* outstream;
        self = (kino_Integer32*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER32, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_Int32_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer64_serialize);
XS(XS_KinoSearch_Object_Integer64_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer64* self;
        kino_OutStream* outstream;
        self = (kino_Integer64*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER64, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_Int64_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SortSpec_serialize);
XS(XS_KinoSearch_Search_SortSpec_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortSpec* self;
        kino_OutStream* outstream;
        self = (kino_SortSpec*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTSPEC, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_SortSpec_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_serialize);
XS(XS_KinoSearch_Object_Hash_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        kino_OutStream* outstream;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_Hash_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_serialize);
XS(XS_KinoSearch_Object_VArray_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        kino_OutStream* outstream;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_VA_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Query_serialize);
XS(XS_KinoSearch_Search_Query_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Query* self;
        kino_OutStream* outstream;
        self = (kino_Query*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERY, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_Query_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchQuery_serialize);
XS(XS_KinoSearch_Search_NoMatchQuery_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchQuery* self;
        kino_OutStream* outstream;
        self = (kino_NoMatchQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOMATCHQUERY, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_NoMatchQuery_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseQuery_serialize);
XS(XS_KinoSearch_Search_PhraseQuery_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseQuery* self;
        kino_OutStream* outstream;
        self = (kino_PhraseQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASEQUERY, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_PhraseQuery_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyQuery_serialize);
XS(XS_KinoSearch_Search_PolyQuery_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyQuery* self;
        kino_OutStream* outstream;
        self = (kino_PolyQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYQUERY, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_PolyQuery_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermQuery_serialize);
XS(XS_KinoSearch_Search_TermQuery_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermQuery* self;
        kino_OutStream* outstream;
        self = (kino_TermQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMQUERY, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_TermQuery_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityQuery_serialize);
XS(XS_KSx_Search_ProximityQuery_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityQuery* self;
        kino_OutStream* outstream;
        self = (kino_ProximityQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYQUERY, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_ProximityQuery_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_LeafQuery_serialize);
XS(XS_KinoSearch_Search_LeafQuery_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_LeafQuery* self;
        kino_OutStream* outstream;
        self = (kino_LeafQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEAFQUERY, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_LeafQuery_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_serialize);
XS(XS_KinoSearch_Search_Compiler_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        kino_OutStream* outstream;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_Compiler_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseCompiler_serialize);
XS(XS_KinoSearch_Search_PhraseCompiler_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseCompiler* self;
        kino_OutStream* outstream;
        self = (kino_PhraseCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASECOMPILER, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_PhraseCompiler_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityCompiler_serialize);
XS(XS_KSx_Search_ProximityCompiler_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityCompiler* self;
        kino_OutStream* outstream;
        self = (kino_ProximityCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYCOMPILER, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_ProximityCompiler_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyCompiler_serialize);
XS(XS_KinoSearch_Search_PolyCompiler_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyCompiler* self;
        kino_OutStream* outstream;
        self = (kino_PolyCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYCOMPILER, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_PolyCompiler_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermCompiler_serialize);
XS(XS_KinoSearch_Search_TermCompiler_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermCompiler* self;
        kino_OutStream* outstream;
        self = (kino_TermCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMCOMPILER, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_TermCompiler_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeQuery_serialize);
XS(XS_KinoSearch_Search_RangeQuery_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeQuery* self;
        kino_OutStream* outstream;
        self = (kino_RangeQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGEQUERY, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_RangeQuery_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ByteBuf_serialize);
XS(XS_KinoSearch_Object_ByteBuf_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_ByteBuf* self;
        kino_OutStream* outstream;
        self = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_BYTEBUF, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_BB_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_serialize);
XS(XS_KinoSearch_Index_Similarity_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        kino_OutStream* outstream;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_Sim_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermVector_serialize);
XS(XS_KinoSearch_Index_TermVector_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermVector* self;
        kino_OutStream* outstream;
        self = (kino_TermVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMVECTOR, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_TV_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf_serialize);
XS(XS_KinoSearch_Object_CharBuf_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        kino_OutStream* outstream;
        self = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_CB_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_Doc_serialize);
XS(XS_KinoSearch_Document_Doc_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Doc* self;
        kino_OutStream* outstream;
        self = (kino_Doc*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOC, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_Doc_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_HitDoc_serialize);
XS(XS_KinoSearch_Document_HitDoc_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_HitDoc* self;
        kino_OutStream* outstream;
        self = (kino_HitDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITDOC, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_HitDoc_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchDoc_serialize);
XS(XS_KinoSearch_Search_MatchDoc_serialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, outstream"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchDoc* self;
        kino_OutStream* outstream;
        self = (kino_MatchDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHDOC, NULL);
    outstream = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_MatchDoc_serialize(self, outstream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_deserialize);
XS(XS_KinoSearch_Object_Obj_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        kino_InStream* instream;
        kino_Obj* retval;
        self = (kino_Obj*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_Obj_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocVector_deserialize);
XS(XS_KinoSearch_Index_DocVector_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_DocVector* self;
        kino_InStream* instream;
        kino_DocVector* retval;
        self = (kino_DocVector*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_DOCVECTOR, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_DocVec_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TopDocs_deserialize);
XS(XS_KinoSearch_Search_TopDocs_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_TopDocs* self;
        kino_InStream* instream;
        kino_TopDocs* retval;
        self = (kino_TopDocs*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_TOPDOCS, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_TopDocs_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SortRule_deserialize);
XS(XS_KinoSearch_Search_SortRule_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortRule* self;
        kino_InStream* instream;
        kino_SortRule* retval;
        self = (kino_SortRule*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_SORTRULE, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_SortRule_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float32_deserialize);
XS(XS_KinoSearch_Object_Float32_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float32* self;
        kino_InStream* instream;
        kino_Float32* retval;
        self = (kino_Float32*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_FLOAT32, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_Float32_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float64_deserialize);
XS(XS_KinoSearch_Object_Float64_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float64* self;
        kino_InStream* instream;
        kino_Float64* retval;
        self = (kino_Float64*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_FLOAT64, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_Float64_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer32_deserialize);
XS(XS_KinoSearch_Object_Integer32_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer32* self;
        kino_InStream* instream;
        kino_Integer32* retval;
        self = (kino_Integer32*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_INTEGER32, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_Int32_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer64_deserialize);
XS(XS_KinoSearch_Object_Integer64_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer64* self;
        kino_InStream* instream;
        kino_Integer64* retval;
        self = (kino_Integer64*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_INTEGER64, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_Int64_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SortSpec_deserialize);
XS(XS_KinoSearch_Search_SortSpec_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortSpec* self;
        kino_InStream* instream;
        kino_SortSpec* retval;
        self = (kino_SortSpec*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_SORTSPEC, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_SortSpec_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_deserialize);
XS(XS_KinoSearch_Object_Hash_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        kino_InStream* instream;
        kino_Hash* retval;
        self = (kino_Hash*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_Hash_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_deserialize);
XS(XS_KinoSearch_Object_VArray_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        kino_InStream* instream;
        kino_VArray* retval;
        self = (kino_VArray*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_VA_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Query_deserialize);
XS(XS_KinoSearch_Search_Query_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Query* self;
        kino_InStream* instream;
        kino_Query* retval;
        self = (kino_Query*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_QUERY, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_Query_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchQuery_deserialize);
XS(XS_KinoSearch_Search_NoMatchQuery_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchQuery* self;
        kino_InStream* instream;
        kino_NoMatchQuery* retval;
        self = (kino_NoMatchQuery*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_NOMATCHQUERY, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_NoMatchQuery_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseQuery_deserialize);
XS(XS_KinoSearch_Search_PhraseQuery_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseQuery* self;
        kino_InStream* instream;
        kino_PhraseQuery* retval;
        self = (kino_PhraseQuery*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_PHRASEQUERY, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_PhraseQuery_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyQuery_deserialize);
XS(XS_KinoSearch_Search_PolyQuery_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyQuery* self;
        kino_InStream* instream;
        kino_PolyQuery* retval;
        self = (kino_PolyQuery*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_POLYQUERY, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_PolyQuery_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermQuery_deserialize);
XS(XS_KinoSearch_Search_TermQuery_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermQuery* self;
        kino_InStream* instream;
        kino_TermQuery* retval;
        self = (kino_TermQuery*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_TERMQUERY, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_TermQuery_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityQuery_deserialize);
XS(XS_KSx_Search_ProximityQuery_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityQuery* self;
        kino_InStream* instream;
        kino_ProximityQuery* retval;
        self = (kino_ProximityQuery*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_PROXIMITYQUERY, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_ProximityQuery_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_LeafQuery_deserialize);
XS(XS_KinoSearch_Search_LeafQuery_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_LeafQuery* self;
        kino_InStream* instream;
        kino_LeafQuery* retval;
        self = (kino_LeafQuery*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_LEAFQUERY, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_LeafQuery_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_deserialize);
XS(XS_KinoSearch_Search_Compiler_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        kino_InStream* instream;
        kino_Compiler* retval;
        self = (kino_Compiler*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_Compiler_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseCompiler_deserialize);
XS(XS_KinoSearch_Search_PhraseCompiler_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseCompiler* self;
        kino_InStream* instream;
        kino_PhraseCompiler* retval;
        self = (kino_PhraseCompiler*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_PHRASECOMPILER, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_PhraseCompiler_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityCompiler_deserialize);
XS(XS_KSx_Search_ProximityCompiler_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityCompiler* self;
        kino_InStream* instream;
        kino_ProximityCompiler* retval;
        self = (kino_ProximityCompiler*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_PROXIMITYCOMPILER, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_ProximityCompiler_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyCompiler_deserialize);
XS(XS_KinoSearch_Search_PolyCompiler_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyCompiler* self;
        kino_InStream* instream;
        kino_PolyCompiler* retval;
        self = (kino_PolyCompiler*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_POLYCOMPILER, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_PolyCompiler_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchAllCompiler_deserialize);
XS(XS_KinoSearch_Search_MatchAllCompiler_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchAllCompiler* self;
        kino_InStream* instream;
        kino_MatchAllCompiler* retval;
        self = (kino_MatchAllCompiler*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_MATCHALLCOMPILER, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_MatchAllCompiler_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchCompiler_deserialize);
XS(XS_KinoSearch_Search_NoMatchCompiler_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchCompiler* self;
        kino_InStream* instream;
        kino_NoMatchCompiler* retval;
        self = (kino_NoMatchCompiler*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_NOMATCHCOMPILER, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_NoMatchCompiler_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermCompiler_deserialize);
XS(XS_KinoSearch_Search_TermCompiler_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermCompiler* self;
        kino_InStream* instream;
        kino_TermCompiler* retval;
        self = (kino_TermCompiler*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_TERMCOMPILER, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_TermCompiler_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeCompiler_deserialize);
XS(XS_KinoSearch_Search_RangeCompiler_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeCompiler* self;
        kino_InStream* instream;
        kino_RangeCompiler* retval;
        self = (kino_RangeCompiler*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_RANGECOMPILER, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_RangeCompiler_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeQuery_deserialize);
XS(XS_KinoSearch_Search_RangeQuery_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeQuery* self;
        kino_InStream* instream;
        kino_RangeQuery* retval;
        self = (kino_RangeQuery*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_RANGEQUERY, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_RangeQuery_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ByteBuf_deserialize);
XS(XS_KinoSearch_Object_ByteBuf_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_ByteBuf* self;
        kino_InStream* instream;
        kino_ByteBuf* retval;
        self = (kino_ByteBuf*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_BYTEBUF, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_BB_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_deserialize);
XS(XS_KinoSearch_Index_Similarity_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        kino_InStream* instream;
        kino_Similarity* retval;
        self = (kino_Similarity*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_Sim_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermVector_deserialize);
XS(XS_KinoSearch_Index_TermVector_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermVector* self;
        kino_InStream* instream;
        kino_TermVector* retval;
        self = (kino_TermVector*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_TERMVECTOR, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_TV_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf_deserialize);
XS(XS_KinoSearch_Object_CharBuf_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        kino_InStream* instream;
        kino_CharBuf* retval;
        self = (kino_CharBuf*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_CB_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_Doc_deserialize);
XS(XS_KinoSearch_Document_Doc_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Doc* self;
        kino_InStream* instream;
        kino_Doc* retval;
        self = (kino_Doc*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_DOC, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_Doc_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_HitDoc_deserialize);
XS(XS_KinoSearch_Document_HitDoc_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_HitDoc* self;
        kino_InStream* instream;
        kino_HitDoc* retval;
        self = (kino_HitDoc*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_HITDOC, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_HitDoc_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchDoc_deserialize);
XS(XS_KinoSearch_Search_MatchDoc_deserialize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchDoc* self;
        kino_InStream* instream;
        kino_MatchDoc* retval;
        self = (kino_MatchDoc*)XSBind_maybe_sv_to_cfish_obj(ST(0), KINO_MATCHDOC, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_MatchDoc_deserialize(self, instream);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_dump);
XS(XS_KinoSearch_Object_Obj_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        kino_Obj* retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);

        /* Execute */
        retval = kino_Obj_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot_dump);
XS(XS_KinoSearch_Index_Snapshot_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        kino_Obj* retval;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);

        /* Execute */
        retval = kino_Snapshot_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_StringType_dump);
XS(XS_KinoSearch_Plan_StringType_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_StringType* self;
        kino_Hash* retval;
        self = (kino_StringType*)XSBind_sv_to_cfish_obj(ST(0), KINO_STRINGTYPE, NULL);

        /* Execute */
        retval = kino_StringType_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FullTextType_dump);
XS(XS_KinoSearch_Plan_FullTextType_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FullTextType* self;
        kino_Hash* retval;
        self = (kino_FullTextType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FULLTEXTTYPE, NULL);

        /* Execute */
        retval = kino_FullTextType_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_NumericType_dump);
XS(XS_KinoSearch_Plan_NumericType_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NumericType* self;
        kino_Hash* retval;
        self = (kino_NumericType*)XSBind_sv_to_cfish_obj(ST(0), KINO_NUMERICTYPE, NULL);

        /* Execute */
        retval = kino_NumType_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_BlobType_dump);
XS(XS_KinoSearch_Plan_BlobType_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BlobType* self;
        kino_Hash* retval;
        self = (kino_BlobType*)XSBind_sv_to_cfish_obj(ST(0), KINO_BLOBTYPE, NULL);

        /* Execute */
        retval = kino_BlobType_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_dump);
XS(XS_KinoSearch_Object_Hash_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        kino_Hash* retval;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);

        /* Execute */
        retval = kino_Hash_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_dump);
XS(XS_KinoSearch_Object_VArray_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        kino_VArray* retval;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);

        /* Execute */
        retval = kino_VA_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Query_dump);
XS(XS_KinoSearch_Search_Query_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Query* self;
        kino_Obj* retval;
        self = (kino_Query*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERY, NULL);

        /* Execute */
        retval = kino_Query_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchQuery_dump);
XS(XS_KinoSearch_Search_NoMatchQuery_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchQuery* self;
        kino_Obj* retval;
        self = (kino_NoMatchQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOMATCHQUERY, NULL);

        /* Execute */
        retval = kino_NoMatchQuery_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseQuery_dump);
XS(XS_KinoSearch_Search_PhraseQuery_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseQuery* self;
        kino_Obj* retval;
        self = (kino_PhraseQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASEQUERY, NULL);

        /* Execute */
        retval = kino_PhraseQuery_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyQuery_dump);
XS(XS_KinoSearch_Search_PolyQuery_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyQuery* self;
        kino_Obj* retval;
        self = (kino_PolyQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYQUERY, NULL);

        /* Execute */
        retval = kino_PolyQuery_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermQuery_dump);
XS(XS_KinoSearch_Search_TermQuery_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermQuery* self;
        kino_Obj* retval;
        self = (kino_TermQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMQUERY, NULL);

        /* Execute */
        retval = kino_TermQuery_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityQuery_dump);
XS(XS_KSx_Search_ProximityQuery_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityQuery* self;
        kino_Obj* retval;
        self = (kino_ProximityQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYQUERY, NULL);

        /* Execute */
        retval = kino_ProximityQuery_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_LeafQuery_dump);
XS(XS_KinoSearch_Search_LeafQuery_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LeafQuery* self;
        kino_Obj* retval;
        self = (kino_LeafQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEAFQUERY, NULL);

        /* Execute */
        retval = kino_LeafQuery_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeQuery_dump);
XS(XS_KinoSearch_Search_RangeQuery_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeQuery* self;
        kino_Obj* retval;
        self = (kino_RangeQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGEQUERY, NULL);

        /* Execute */
        retval = kino_RangeQuery_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_dump);
XS(XS_KinoSearch_Index_Similarity_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        kino_Obj* retval;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);

        /* Execute */
        retval = kino_Sim_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Analyzer_dump);
XS(XS_KinoSearch_Analysis_Analyzer_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Analyzer* self;
        kino_Obj* retval;
        self = (kino_Analyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANALYZER, NULL);

        /* Execute */
        retval = kino_Analyzer_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_PolyAnalyzer_dump);
XS(XS_KinoSearch_Analysis_PolyAnalyzer_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyAnalyzer* self;
        kino_Obj* retval;
        self = (kino_PolyAnalyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYANALYZER, NULL);

        /* Execute */
        retval = kino_PolyAnalyzer_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Stopalizer_dump);
XS(XS_KinoSearch_Analysis_Stopalizer_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stopalizer* self;
        kino_Obj* retval;
        self = (kino_Stopalizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_STOPALIZER, NULL);

        /* Execute */
        retval = kino_Stopalizer_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_CaseFolder_dump);
XS(XS_KinoSearch_Analysis_CaseFolder_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CaseFolder* self;
        kino_Hash* retval;
        self = (kino_CaseFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_CASEFOLDER, NULL);

        /* Execute */
        retval = kino_CaseFolder_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Tokenizer_dump);
XS(XS_KinoSearch_Analysis_Tokenizer_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Tokenizer* self;
        kino_Obj* retval;
        self = (kino_Tokenizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKENIZER, NULL);

        /* Execute */
        retval = kino_Tokenizer_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Stemmer_dump);
XS(XS_KinoSearch_Analysis_Stemmer_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stemmer* self;
        kino_Hash* retval;
        self = (kino_Stemmer*)XSBind_sv_to_cfish_obj(ST(0), KINO_STEMMER, NULL);

        /* Execute */
        retval = kino_Stemmer_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_dump);
XS(XS_KinoSearch_Plan_Schema_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        kino_Hash* retval;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);

        /* Execute */
        retval = kino_Schema_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_Doc_dump);
XS(XS_KinoSearch_Document_Doc_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Doc* self;
        kino_Hash* retval;
        self = (kino_Doc*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOC, NULL);

        /* Execute */
        retval = kino_Doc_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_HitDoc_dump);
XS(XS_KinoSearch_Document_HitDoc_dump)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HitDoc* self;
        kino_Hash* retval;
        self = (kino_HitDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITDOC, NULL);

        /* Execute */
        retval = kino_HitDoc_dump(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj__load);
XS(XS_KinoSearch_Object_Obj__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Obj_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot__load);
XS(XS_KinoSearch_Index_Snapshot__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Snapshot_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_StringType__load);
XS(XS_KinoSearch_Plan_StringType__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_StringType* self;
        kino_Obj* dump;
        kino_StringType* retval;
        self = (kino_StringType*)XSBind_sv_to_cfish_obj(ST(0), KINO_STRINGTYPE, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_StringType_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FullTextType__load);
XS(XS_KinoSearch_Plan_FullTextType__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_FullTextType* self;
        kino_Obj* dump;
        kino_FullTextType* retval;
        self = (kino_FullTextType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FULLTEXTTYPE, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_FullTextType_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_NumericType__load);
XS(XS_KinoSearch_Plan_NumericType__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_NumericType* self;
        kino_Obj* dump;
        kino_NumericType* retval;
        self = (kino_NumericType*)XSBind_sv_to_cfish_obj(ST(0), KINO_NUMERICTYPE, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_NumType_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_BlobType__load);
XS(XS_KinoSearch_Plan_BlobType__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_BlobType* self;
        kino_Obj* dump;
        kino_BlobType* retval;
        self = (kino_BlobType*)XSBind_sv_to_cfish_obj(ST(0), KINO_BLOBTYPE, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_BlobType_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash__load);
XS(XS_KinoSearch_Object_Hash__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Hash_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray__load);
XS(XS_KinoSearch_Object_VArray__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        kino_Obj* dump;
        kino_VArray* retval;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_VA_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Query__load);
XS(XS_KinoSearch_Search_Query__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Query* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_Query*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERY, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Query_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchQuery__load);
XS(XS_KinoSearch_Search_NoMatchQuery__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchQuery* self;
        kino_Obj* dump;
        kino_NoMatchQuery* retval;
        self = (kino_NoMatchQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOMATCHQUERY, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_NoMatchQuery_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseQuery__load);
XS(XS_KinoSearch_Search_PhraseQuery__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseQuery* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_PhraseQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASEQUERY, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_PhraseQuery_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyQuery__load);
XS(XS_KinoSearch_Search_PolyQuery__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyQuery* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_PolyQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYQUERY, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_PolyQuery_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermQuery__load);
XS(XS_KinoSearch_Search_TermQuery__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermQuery* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_TermQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMQUERY, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_TermQuery_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityQuery__load);
XS(XS_KSx_Search_ProximityQuery__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityQuery* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_ProximityQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYQUERY, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_ProximityQuery_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_LeafQuery__load);
XS(XS_KinoSearch_Search_LeafQuery__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_LeafQuery* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_LeafQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEAFQUERY, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_LeafQuery_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeQuery__load);
XS(XS_KinoSearch_Search_RangeQuery__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeQuery* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_RangeQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGEQUERY, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_RangeQuery_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity__load);
XS(XS_KinoSearch_Index_Similarity__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        kino_Obj* dump;
        kino_Similarity* retval;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Sim_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Analyzer__load);
XS(XS_KinoSearch_Analysis_Analyzer__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Analyzer* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_Analyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANALYZER, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Analyzer_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_PolyAnalyzer__load);
XS(XS_KinoSearch_Analysis_PolyAnalyzer__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyAnalyzer* self;
        kino_Obj* dump;
        kino_PolyAnalyzer* retval;
        self = (kino_PolyAnalyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYANALYZER, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_PolyAnalyzer_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Stopalizer__load);
XS(XS_KinoSearch_Analysis_Stopalizer__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stopalizer* self;
        kino_Obj* dump;
        kino_Obj* retval;
        self = (kino_Stopalizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_STOPALIZER, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Stopalizer_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_CaseFolder__load);
XS(XS_KinoSearch_Analysis_CaseFolder__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_CaseFolder* self;
        kino_Obj* dump;
        kino_CaseFolder* retval;
        self = (kino_CaseFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_CASEFOLDER, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_CaseFolder_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Tokenizer__load);
XS(XS_KinoSearch_Analysis_Tokenizer__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Tokenizer* self;
        kino_Obj* dump;
        kino_Tokenizer* retval;
        self = (kino_Tokenizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKENIZER, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Tokenizer_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Stemmer__load);
XS(XS_KinoSearch_Analysis_Stemmer__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stemmer* self;
        kino_Obj* dump;
        kino_Stemmer* retval;
        self = (kino_Stemmer*)XSBind_sv_to_cfish_obj(ST(0), KINO_STEMMER, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Stemmer_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf__load);
XS(XS_KinoSearch_Object_CharBuf__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        kino_Obj* dump;
        kino_CharBuf* retval;
        self = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_CB_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema__load);
XS(XS_KinoSearch_Plan_Schema__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        kino_Obj* dump;
        kino_Schema* retval;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Schema_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_Doc__load);
XS(XS_KinoSearch_Document_Doc__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_Doc* self;
        kino_Obj* dump;
        kino_Doc* retval;
        self = (kino_Doc*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOC, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Doc_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_HitDoc__load);
XS(XS_KinoSearch_Document_HitDoc__load)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, dump"); };
    {
        /* Extract vars from Perl stack. */
        kino_HitDoc* self;
        kino_Obj* dump;
        kino_HitDoc* retval;
        self = (kino_HitDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITDOC, NULL);
    dump = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_HitDoc_load(self, dump);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Obj_mimic);
XS(XS_KinoSearch_Object_Obj_mimic)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Obj* self;
        kino_Obj* other;
        self = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(0), KINO_OBJ, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Obj_mimic(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_mimic);
XS(XS_KinoSearch_Index_TermInfo_mimic)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        kino_Obj* other;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_TInfo_mimic(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float32_mimic);
XS(XS_KinoSearch_Object_Float32_mimic)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float32* self;
        kino_Obj* other;
        self = (kino_Float32*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT32, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Float32_mimic(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float64_mimic);
XS(XS_KinoSearch_Object_Float64_mimic)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float64* self;
        kino_Obj* other;
        self = (kino_Float64*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT64, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Float64_mimic(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer32_mimic);
XS(XS_KinoSearch_Object_Integer32_mimic)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer32* self;
        kino_Obj* other;
        self = (kino_Integer32*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER32, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Int32_mimic(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Integer64_mimic);
XS(XS_KinoSearch_Object_Integer64_mimic)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Integer64* self;
        kino_Obj* other;
        self = (kino_Integer64*)XSBind_sv_to_cfish_obj(ST(0), KINO_INTEGER64, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Int64_mimic(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_mimic);
XS(XS_KinoSearch_Object_BitVector_mimic)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        kino_Obj* other;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_BitVec_mimic(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ByteBuf_mimic);
XS(XS_KinoSearch_Object_ByteBuf_mimic)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_ByteBuf* self;
        kino_Obj* other;
        self = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_BYTEBUF, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_BB_mimic(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_CharBuf_mimic);
XS(XS_KinoSearch_Object_CharBuf_mimic)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_CharBuf* self;
        kino_Obj* other;
        self = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_CHARBUF, NULL);
    other = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_CB_mimic(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_create_excerpt);
XS(XS_KinoSearch_Highlight_Highlighter_create_excerpt)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, hit_doc"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        kino_HitDoc* hit_doc;
        kino_CharBuf* retval;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);
    hit_doc = (kino_HitDoc*)XSBind_sv_to_cfish_obj(ST(1), KINO_HITDOC, NULL);

        /* Execute */
        retval = kino_Highlighter_create_excerpt(self, hit_doc);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_encode);
XS(XS_KinoSearch_Highlight_Highlighter_encode)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, text"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        kino_CharBuf* text;
        kino_CharBuf* retval;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);
    text = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Highlighter_encode(self, text);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_find_sentences);
XS(XS_KinoSearch_Highlight_Highlighter_find_sentences)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        kino_CharBuf* text;
        int32_t offset;
        int32_t length;
        kino_VArray* retval;
        SV* text_sv = NULL;
        SV* offset_sv = NULL;
        SV* length_sv = NULL;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Highlight::Highlighter::find_sentences_PARAMS",             &text_sv, "text", 4,
            &offset_sv, "offset", 6,
            &length_sv, "length", 6,
 NULL);

        if ( !text_sv || !XSBind_sv_defined(text_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'text'"); }
         text = (kino_CharBuf*)XSBind_sv_to_cfish_obj(text_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( offset_sv && XSBind_sv_defined(offset_sv) ) {
            offset = (int32_t)SvIV( offset_sv );;
        }
        else {
            offset = 0;
        }
        if ( length_sv && XSBind_sv_defined(length_sv) ) {
            length = (int32_t)SvIV( length_sv );;
        }
        else {
            length = 0;
        }

        /* Execute */
        retval = kino_Highlighter_find_sentences(self, text, offset, length);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_highlight);
XS(XS_KinoSearch_Highlight_Highlighter_highlight)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, text"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        const kino_CharBuf* text;
        kino_CharBuf* retval;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);
    text = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Highlighter_highlight(self, text);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_set_pre_tag);
XS(XS_KinoSearch_Highlight_Highlighter_set_pre_tag)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, pre_tag"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        const kino_CharBuf* pre_tag;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);
    pre_tag = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Highlighter_set_pre_tag(self, pre_tag);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_set_post_tag);
XS(XS_KinoSearch_Highlight_Highlighter_set_post_tag)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, post_tag"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        const kino_CharBuf* post_tag;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);
    post_tag = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Highlighter_set_post_tag(self, post_tag);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_get_pre_tag);
XS(XS_KinoSearch_Highlight_Highlighter_get_pre_tag)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        kino_CharBuf* retval;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);

        /* Execute */
        retval = kino_Highlighter_get_pre_tag(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_get_post_tag);
XS(XS_KinoSearch_Highlight_Highlighter_get_post_tag)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        kino_CharBuf* retval;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);

        /* Execute */
        retval = kino_Highlighter_get_post_tag(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_get_field);
XS(XS_KinoSearch_Highlight_Highlighter_get_field)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        kino_CharBuf* retval;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);

        /* Execute */
        retval = kino_Highlighter_get_field(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_get_excerpt_length);
XS(XS_KinoSearch_Highlight_Highlighter_get_excerpt_length)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        uint32_t retval;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);

        /* Execute */
        retval = kino_Highlighter_get_excerpt_length(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_get_searcher);
XS(XS_KinoSearch_Highlight_Highlighter_get_searcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        kino_Searcher* retval;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);

        /* Execute */
        retval = kino_Highlighter_get_searcher(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_get_query);
XS(XS_KinoSearch_Highlight_Highlighter_get_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        kino_Query* retval;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);

        /* Execute */
        retval = kino_Highlighter_get_query(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter_get_compiler);
XS(XS_KinoSearch_Highlight_Highlighter_get_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        kino_Compiler* retval;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);

        /* Execute */
        retval = kino_Highlighter_get_compiler(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter__find_best_fragment);
XS(XS_KinoSearch_Highlight_Highlighter__find_best_fragment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        const kino_CharBuf* field_val;
        kino_ViewCharBuf* fragment;
        kino_HeatMap* heat_map;
        int32_t retval;
        SV* field_val_sv = NULL;
        SV* fragment_sv = NULL;
        SV* heat_map_sv = NULL;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Highlight::Highlighter::_find_best_fragment_PARAMS",             &field_val_sv, "field_val", 9,
            &fragment_sv, "fragment", 8,
            &heat_map_sv, "heat_map", 8,
 NULL);

        if ( !field_val_sv || !XSBind_sv_defined(field_val_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field_val'"); }
         field_val = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_val_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !fragment_sv || !XSBind_sv_defined(fragment_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'fragment'"); }
         fragment = (kino_ViewCharBuf*)XSBind_sv_to_cfish_obj(fragment_sv, KINO_VIEWCHARBUF, NULL);;
        if ( !heat_map_sv || !XSBind_sv_defined(heat_map_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'heat_map'"); }
         heat_map = (kino_HeatMap*)XSBind_sv_to_cfish_obj(heat_map_sv, KINO_HEATMAP, NULL);;

        /* Execute */
        retval = kino_Highlighter_find_best_fragment(self, field_val, fragment, heat_map);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter__raw_excerpt);
XS(XS_KinoSearch_Highlight_Highlighter__raw_excerpt)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        const kino_CharBuf* field_val;
        const kino_CharBuf* fragment;
        kino_CharBuf* raw_excerpt;
        int32_t top;
        kino_HeatMap* heat_map;
        kino_VArray* sentences;
        int32_t retval;
        SV* field_val_sv = NULL;
        SV* fragment_sv = NULL;
        SV* raw_excerpt_sv = NULL;
        SV* top_sv = NULL;
        SV* heat_map_sv = NULL;
        SV* sentences_sv = NULL;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Highlight::Highlighter::_raw_excerpt_PARAMS",             &field_val_sv, "field_val", 9,
            &fragment_sv, "fragment", 8,
            &raw_excerpt_sv, "raw_excerpt", 11,
            &top_sv, "top", 3,
            &heat_map_sv, "heat_map", 8,
            &sentences_sv, "sentences", 9,
 NULL);

        if ( !field_val_sv || !XSBind_sv_defined(field_val_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field_val'"); }
         field_val = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_val_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !fragment_sv || !XSBind_sv_defined(fragment_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'fragment'"); }
         fragment = (kino_CharBuf*)XSBind_sv_to_cfish_obj(fragment_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !raw_excerpt_sv || !XSBind_sv_defined(raw_excerpt_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'raw_excerpt'"); }
         raw_excerpt = (kino_CharBuf*)XSBind_sv_to_cfish_obj(raw_excerpt_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !top_sv || !XSBind_sv_defined(top_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'top'"); }
         top = (int32_t)SvIV( top_sv );;
        if ( !heat_map_sv || !XSBind_sv_defined(heat_map_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'heat_map'"); }
         heat_map = (kino_HeatMap*)XSBind_sv_to_cfish_obj(heat_map_sv, KINO_HEATMAP, NULL);;
        if ( !sentences_sv || !XSBind_sv_defined(sentences_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'sentences'"); }
         sentences = (kino_VArray*)XSBind_sv_to_cfish_obj(sentences_sv, KINO_VARRAY, NULL);;

        /* Execute */
        retval = kino_Highlighter_raw_excerpt(self, field_val, fragment, raw_excerpt, top, heat_map, sentences);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_Highlighter__highlight_excerpt);
XS(XS_KinoSearch_Highlight_Highlighter__highlight_excerpt)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Highlighter* self;
        kino_VArray* spans;
        kino_CharBuf* raw_excerpt;
        kino_CharBuf* highlighted;
        int32_t top;
        SV* spans_sv = NULL;
        SV* raw_excerpt_sv = NULL;
        SV* highlighted_sv = NULL;
        SV* top_sv = NULL;
        self = (kino_Highlighter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Highlight::Highlighter::_highlight_excerpt_PARAMS",             &spans_sv, "spans", 5,
            &raw_excerpt_sv, "raw_excerpt", 11,
            &highlighted_sv, "highlighted", 11,
            &top_sv, "top", 3,
 NULL);

        if ( !spans_sv || !XSBind_sv_defined(spans_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'spans'"); }
         spans = (kino_VArray*)XSBind_sv_to_cfish_obj(spans_sv, KINO_VARRAY, NULL);;
        if ( !raw_excerpt_sv || !XSBind_sv_defined(raw_excerpt_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'raw_excerpt'"); }
         raw_excerpt = (kino_CharBuf*)XSBind_sv_to_cfish_obj(raw_excerpt_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !highlighted_sv || !XSBind_sv_defined(highlighted_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'highlighted'"); }
         highlighted = (kino_CharBuf*)XSBind_sv_to_cfish_obj(highlighted_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !top_sv || !XSBind_sv_defined(top_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'top'"); }
         top = (int32_t)SvIV( top_sv );;

        /* Execute */
        kino_Highlighter_highlight_excerpt(self, spans, raw_excerpt, highlighted, top);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_get_doc_freq);
XS(XS_KinoSearch_Index_TermInfo_get_doc_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        int32_t retval;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);

        /* Execute */
        retval = kino_TInfo_get_doc_freq(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_get_lex_filepos);
XS(XS_KinoSearch_Index_TermInfo_get_lex_filepos)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        int64_t retval;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);

        /* Execute */
        retval = kino_TInfo_get_lex_filepos(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_get_post_filepos);
XS(XS_KinoSearch_Index_TermInfo_get_post_filepos)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        int64_t retval;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);

        /* Execute */
        retval = kino_TInfo_get_post_filepos(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_get_skip_filepos);
XS(XS_KinoSearch_Index_TermInfo_get_skip_filepos)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        int64_t retval;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);

        /* Execute */
        retval = kino_TInfo_get_skip_filepos(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_set_doc_freq);
XS(XS_KinoSearch_Index_TermInfo_set_doc_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_freq"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        int32_t doc_freq;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);
    doc_freq = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_TInfo_set_doc_freq(self, doc_freq);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_set_lex_filepos);
XS(XS_KinoSearch_Index_TermInfo_set_lex_filepos)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, filepos"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        int64_t filepos;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);
    filepos = (int64_t)SvNV( ST(1) );

        /* Execute */
        kino_TInfo_set_lex_filepos(self, filepos);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_set_post_filepos);
XS(XS_KinoSearch_Index_TermInfo_set_post_filepos)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, filepos"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        int64_t filepos;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);
    filepos = (int64_t)SvNV( ST(1) );

        /* Execute */
        kino_TInfo_set_post_filepos(self, filepos);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_set_skip_filepos);
XS(XS_KinoSearch_Index_TermInfo_set_skip_filepos)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, filepos"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        int64_t filepos;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);
    filepos = (int64_t)SvNV( ST(1) );

        /* Execute */
        kino_TInfo_set_skip_filepos(self, filepos);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermInfo_reset);
XS(XS_KinoSearch_Index_TermInfo_reset)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermInfo* self;
        self = (kino_TermInfo*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMINFO, NULL);

        /* Execute */
        kino_TInfo_reset(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_clear);
XS(XS_KinoSearch_Index_Inverter_clear)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        kino_Inverter_clear(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_iterate);
XS(XS_KinoSearch_Index_Inverter_iterate)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        uint32_t retval;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        retval = kino_Inverter_iterate(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_next);
XS(XS_KinoSearch_Index_Inverter_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        int32_t retval;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        retval = kino_Inverter_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_get_doc);
XS(XS_KinoSearch_Index_Inverter_get_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        kino_Doc* retval;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        retval = kino_Inverter_get_doc(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_get_field_name);
XS(XS_KinoSearch_Index_Inverter_get_field_name)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        kino_CharBuf* retval;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        retval = kino_Inverter_get_field_name(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_get_value);
XS(XS_KinoSearch_Index_Inverter_get_value)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        kino_Obj* retval;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        retval = kino_Inverter_get_value(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_get_type);
XS(XS_KinoSearch_Index_Inverter_get_type)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        kino_FieldType* retval;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        retval = kino_Inverter_get_type(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_get_analyzer);
XS(XS_KinoSearch_Index_Inverter_get_analyzer)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        kino_Analyzer* retval;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        retval = kino_Inverter_get_analyzer(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_get_similarity);
XS(XS_KinoSearch_Index_Inverter_get_similarity)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        kino_Similarity* retval;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        retval = kino_Inverter_get_similarity(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Inverter_get_inversion);
XS(XS_KinoSearch_Index_Inverter_get_inversion)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inverter* self;
        kino_Inversion* retval;
        self = (kino_Inverter*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERTER, NULL);

        /* Execute */
        retval = kino_Inverter_get_inversion(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocVector_term_vector);
XS(XS_KinoSearch_Index_DocVector_term_vector)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DocVector* self;
        const kino_CharBuf* field;
        const kino_CharBuf* term;
        kino_TermVector* retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_DocVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCVECTOR, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DocVector::term_vector_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_CharBuf*)XSBind_sv_to_cfish_obj(term_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_DocVec_term_vector(self, field, term);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocVector_add_field_buf);
XS(XS_KinoSearch_Index_DocVector_add_field_buf)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DocVector* self;
        const kino_CharBuf* field;
        kino_ByteBuf* field_buf;
        SV* field_sv = NULL;
        SV* field_buf_sv = NULL;
        self = (kino_DocVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCVECTOR, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DocVector::add_field_buf_PARAMS",             &field_sv, "field", 5,
            &field_buf_sv, "field_buf", 9,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !field_buf_sv || !XSBind_sv_defined(field_buf_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field_buf'"); }
         field_buf = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(field_buf_sv, KINO_BYTEBUF, NULL);;

        /* Execute */
        kino_DocVec_add_field_buf(self, field, field_buf);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocVector_field_buf);
XS(XS_KinoSearch_Index_DocVector_field_buf)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, field"); };
    {
        /* Extract vars from Perl stack. */
        kino_DocVector* self;
        const kino_CharBuf* field;
        kino_ByteBuf* retval;
        self = (kino_DocVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCVECTOR, NULL);
    field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_DocVec_field_buf(self, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Lock_obtain);
XS(XS_KinoSearch_Store_Lock_obtain)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lock* self;
        chy_bool_t retval;
        self = (kino_Lock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCK, NULL);

        /* Execute */
        retval = kino_Lock_obtain(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Lock_request);
XS(XS_KinoSearch_Store_Lock_request)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lock* self;
        chy_bool_t retval;
        self = (kino_Lock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCK, NULL);

        /* Execute */
        retval = kino_Lock_request(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_LockFileLock_request);
XS(XS_KinoSearch_Store_LockFileLock_request)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LockFileLock* self;
        chy_bool_t retval;
        self = (kino_LockFileLock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFILELOCK, NULL);

        /* Execute */
        retval = kino_LFLock_request(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_SharedLock_request);
XS(XS_KinoSearch_Store_SharedLock_request)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SharedLock* self;
        chy_bool_t retval;
        self = (kino_SharedLock*)XSBind_sv_to_cfish_obj(ST(0), KINO_SHAREDLOCK, NULL);

        /* Execute */
        retval = kino_ShLock_request(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Lock_release);
XS(XS_KinoSearch_Store_Lock_release)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lock* self;
        self = (kino_Lock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCK, NULL);

        /* Execute */
        kino_Lock_release(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_LockFileLock_release);
XS(XS_KinoSearch_Store_LockFileLock_release)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LockFileLock* self;
        self = (kino_LockFileLock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFILELOCK, NULL);

        /* Execute */
        kino_LFLock_release(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_SharedLock_release);
XS(XS_KinoSearch_Store_SharedLock_release)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SharedLock* self;
        self = (kino_SharedLock*)XSBind_sv_to_cfish_obj(ST(0), KINO_SHAREDLOCK, NULL);

        /* Execute */
        kino_ShLock_release(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Lock_is_locked);
XS(XS_KinoSearch_Store_Lock_is_locked)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lock* self;
        chy_bool_t retval;
        self = (kino_Lock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCK, NULL);

        /* Execute */
        retval = kino_Lock_is_locked(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_LockFileLock_is_locked);
XS(XS_KinoSearch_Store_LockFileLock_is_locked)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LockFileLock* self;
        chy_bool_t retval;
        self = (kino_LockFileLock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFILELOCK, NULL);

        /* Execute */
        retval = kino_LFLock_is_locked(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_SharedLock_is_locked);
XS(XS_KinoSearch_Store_SharedLock_is_locked)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SharedLock* self;
        chy_bool_t retval;
        self = (kino_SharedLock*)XSBind_sv_to_cfish_obj(ST(0), KINO_SHAREDLOCK, NULL);

        /* Execute */
        retval = kino_ShLock_is_locked(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Lock_clear_stale);
XS(XS_KinoSearch_Store_Lock_clear_stale)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lock* self;
        self = (kino_Lock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCK, NULL);

        /* Execute */
        kino_Lock_clear_stale(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_LockFileLock_clear_stale);
XS(XS_KinoSearch_Store_LockFileLock_clear_stale)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LockFileLock* self;
        self = (kino_LockFileLock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFILELOCK, NULL);

        /* Execute */
        kino_LFLock_clear_stale(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_SharedLock_clear_stale);
XS(XS_KinoSearch_Store_SharedLock_clear_stale)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SharedLock* self;
        self = (kino_SharedLock*)XSBind_sv_to_cfish_obj(ST(0), KINO_SHAREDLOCK, NULL);

        /* Execute */
        kino_ShLock_clear_stale(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Lock_get_name);
XS(XS_KinoSearch_Store_Lock_get_name)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lock* self;
        kino_CharBuf* retval;
        self = (kino_Lock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCK, NULL);

        /* Execute */
        retval = kino_Lock_get_name(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Lock_get_host);
XS(XS_KinoSearch_Store_Lock_get_host)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lock* self;
        kino_CharBuf* retval;
        self = (kino_Lock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCK, NULL);

        /* Execute */
        retval = kino_Lock_get_host(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Lock_get_lock_path);
XS(XS_KinoSearch_Store_Lock_get_lock_path)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lock* self;
        kino_CharBuf* retval;
        self = (kino_Lock*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCK, NULL);

        /* Execute */
        retval = kino_Lock_get_lock_path(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_parse);
XS(XS_KinoSearch_Search_QueryParser_parse)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        const kino_CharBuf* query_string;
        kino_Query* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            query_string = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else { 
            query_string = NULL;
        }

        /* Execute */
        retval = kino_QParser_parse(self, query_string);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_tree);
XS(XS_KinoSearch_Search_QueryParser_tree)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, query_string"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        const kino_CharBuf* query_string;
        kino_Query* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
    query_string = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_QParser_tree(self, query_string);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_expand);
XS(XS_KinoSearch_Search_QueryParser_expand)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, query"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        kino_Query* query;
        kino_Query* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
    query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);

        /* Execute */
        retval = kino_QParser_expand(self, query);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_expand_leaf);
XS(XS_KinoSearch_Search_QueryParser_expand_leaf)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, query"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        kino_Query* query;
        kino_Query* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
    query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);

        /* Execute */
        retval = kino_QParser_expand_leaf(self, query);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_prune);
XS(XS_KinoSearch_Search_QueryParser_prune)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        kino_Query* query;
        kino_Query* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);
        }
        else { 
            query = NULL;
        }

        /* Execute */
        retval = kino_QParser_prune(self, query);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_make_term_query);
XS(XS_KinoSearch_Search_QueryParser_make_term_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        kino_Query* retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::QueryParser::make_term_query_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_QParser_make_term_query(self, field, term);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_make_phrase_query);
XS(XS_KinoSearch_Search_QueryParser_make_phrase_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        const kino_CharBuf* field;
        kino_VArray* terms;
        kino_Query* retval;
        SV* field_sv = NULL;
        SV* terms_sv = NULL;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::QueryParser::make_phrase_query_PARAMS",             &field_sv, "field", 5,
            &terms_sv, "terms", 5,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !terms_sv || !XSBind_sv_defined(terms_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'terms'"); }
         terms = (kino_VArray*)XSBind_sv_to_cfish_obj(terms_sv, KINO_VARRAY, NULL);;

        /* Execute */
        retval = kino_QParser_make_phrase_query(self, field, terms);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_make_or_query);
XS(XS_KinoSearch_Search_QueryParser_make_or_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        kino_VArray* children;
        kino_Query* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            children = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(1), KINO_VARRAY, NULL);
        }
        else { 
            children = NULL;
        }

        /* Execute */
        retval = kino_QParser_make_or_query(self, children);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_make_and_query);
XS(XS_KinoSearch_Search_QueryParser_make_and_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        kino_VArray* children;
        kino_Query* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            children = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(1), KINO_VARRAY, NULL);
        }
        else { 
            children = NULL;
        }

        /* Execute */
        retval = kino_QParser_make_and_query(self, children);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_make_not_query);
XS(XS_KinoSearch_Search_QueryParser_make_not_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, negated_query"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        kino_Query* negated_query;
        kino_Query* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
    negated_query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);

        /* Execute */
        retval = kino_QParser_make_not_query(self, negated_query);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_make_req_opt_query);
XS(XS_KinoSearch_Search_QueryParser_make_req_opt_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        kino_Query* required_query;
        kino_Query* optional_query;
        kino_Query* retval;
        SV* required_query_sv = NULL;
        SV* optional_query_sv = NULL;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::QueryParser::make_req_opt_query_PARAMS",             &required_query_sv, "required_query", 14,
            &optional_query_sv, "optional_query", 14,
 NULL);

        if ( !required_query_sv || !XSBind_sv_defined(required_query_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'required_query'"); }
         required_query = (kino_Query*)XSBind_sv_to_cfish_obj(required_query_sv, KINO_QUERY, NULL);;
        if ( !optional_query_sv || !XSBind_sv_defined(optional_query_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'optional_query'"); }
         optional_query = (kino_Query*)XSBind_sv_to_cfish_obj(optional_query_sv, KINO_QUERY, NULL);;

        /* Execute */
        retval = kino_QParser_make_req_opt_query(self, required_query, optional_query);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_get_analyzer);
XS(XS_KinoSearch_Search_QueryParser_get_analyzer)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        kino_Analyzer* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);

        /* Execute */
        retval = kino_QParser_get_analyzer(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_get_schema);
XS(XS_KinoSearch_Search_QueryParser_get_schema)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        kino_Schema* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);

        /* Execute */
        retval = kino_QParser_get_schema(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_get_fields);
XS(XS_KinoSearch_Search_QueryParser_get_fields)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        kino_VArray* retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);

        /* Execute */
        retval = kino_QParser_get_fields(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_heed_colons);
XS(XS_KinoSearch_Search_QueryParser_heed_colons)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        chy_bool_t retval;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);

        /* Execute */
        retval = kino_QParser_heed_colons(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_QueryParser_set_heed_colons);
XS(XS_KinoSearch_Search_QueryParser_set_heed_colons)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, heed_colons"); };
    {
        /* Extract vars from Perl stack. */
        kino_QueryParser* self;
        chy_bool_t heed_colons;
        self = (kino_QueryParser*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERYPARSER, NULL);
    heed_colons = SvTRUE( ST(1) ) ? 1 : 0;

        /* Execute */
        kino_QParser_set_heed_colons(self, heed_colons);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_set_folder);
XS(XS_KinoSearch_Index_IndexManager_set_folder)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        kino_Folder* folder;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            folder = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(1), KINO_FOLDER, NULL);
        }
        else { 
            folder = NULL;
        }

        /* Execute */
        kino_IxManager_set_folder(self, folder);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_get_folder);
XS(XS_KinoSearch_Index_IndexManager_get_folder)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        kino_Folder* retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_get_folder(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_get_host);
XS(XS_KinoSearch_Index_IndexManager_get_host)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        kino_CharBuf* retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_get_host(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_recycle);
XS(XS_KinoSearch_Index_IndexManager_recycle)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        kino_PolyReader* reader;
        kino_DeletionsWriter* del_writer;
        int64_t cutoff;
        chy_bool_t optimize;
        kino_VArray* retval;
        SV* reader_sv = NULL;
        SV* del_writer_sv = NULL;
        SV* cutoff_sv = NULL;
        SV* optimize_sv = NULL;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::IndexManager::recycle_PARAMS",             &reader_sv, "reader", 6,
            &del_writer_sv, "del_writer", 10,
            &cutoff_sv, "cutoff", 6,
            &optimize_sv, "optimize", 8,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_PolyReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_POLYREADER, NULL);;
        if ( !del_writer_sv || !XSBind_sv_defined(del_writer_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'del_writer'"); }
         del_writer = (kino_DeletionsWriter*)XSBind_sv_to_cfish_obj(del_writer_sv, KINO_DELETIONSWRITER, NULL);;
        if ( !cutoff_sv || !XSBind_sv_defined(cutoff_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'cutoff'"); }
         cutoff = (int64_t)SvNV( cutoff_sv );;
        if ( optimize_sv && XSBind_sv_defined(optimize_sv) ) {
            optimize = SvTRUE( optimize_sv ) ? 1 : 0;;
        }
        else {
            optimize = false;
        }

        /* Execute */
        retval = kino_IxManager_recycle(self, reader, del_writer, cutoff, optimize);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_make_write_lock);
XS(XS_KinoSearch_Index_IndexManager_make_write_lock)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        kino_Lock* retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_make_write_lock(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_make_deletion_lock);
XS(XS_KinoSearch_Index_IndexManager_make_deletion_lock)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        kino_Lock* retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_make_deletion_lock(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_make_merge_lock);
XS(XS_KinoSearch_Index_IndexManager_make_merge_lock)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        kino_Lock* retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_make_merge_lock(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_make_snapshot_read_lock);
XS(XS_KinoSearch_Index_IndexManager_make_snapshot_read_lock)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, filename"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        const kino_CharBuf* filename;
        kino_Lock* retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);
    filename = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_IxManager_make_snapshot_read_lock(self, filename);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_highest_seg_num);
XS(XS_KinoSearch_Index_IndexManager_highest_seg_num)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, snapshot"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        kino_Snapshot* snapshot;
        int64_t retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);
    snapshot = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(1), KINO_SNAPSHOT, NULL);

        /* Execute */
        retval = kino_IxManager_highest_seg_num(self, snapshot);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_make_snapshot_filename);
XS(XS_KinoSearch_Index_IndexManager_make_snapshot_filename)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        kino_CharBuf* retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_make_snapshot_filename(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_set_write_lock_timeout);
XS(XS_KinoSearch_Index_IndexManager_set_write_lock_timeout)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, timeout"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t timeout;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);
    timeout = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_IxManager_set_write_lock_timeout(self, timeout);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_get_write_lock_timeout);
XS(XS_KinoSearch_Index_IndexManager_get_write_lock_timeout)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_get_write_lock_timeout(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_set_write_lock_interval);
XS(XS_KinoSearch_Index_IndexManager_set_write_lock_interval)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, timeout"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t timeout;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);
    timeout = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_IxManager_set_write_lock_interval(self, timeout);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_get_write_lock_interval);
XS(XS_KinoSearch_Index_IndexManager_get_write_lock_interval)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_get_write_lock_interval(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_set_merge_lock_timeout);
XS(XS_KinoSearch_Index_IndexManager_set_merge_lock_timeout)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, timeout"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t timeout;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);
    timeout = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_IxManager_set_merge_lock_timeout(self, timeout);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_get_merge_lock_timeout);
XS(XS_KinoSearch_Index_IndexManager_get_merge_lock_timeout)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_get_merge_lock_timeout(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_set_merge_lock_interval);
XS(XS_KinoSearch_Index_IndexManager_set_merge_lock_interval)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, timeout"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t timeout;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);
    timeout = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_IxManager_set_merge_lock_interval(self, timeout);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_get_merge_lock_interval);
XS(XS_KinoSearch_Index_IndexManager_get_merge_lock_interval)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_get_merge_lock_interval(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_set_deletion_lock_timeout);
XS(XS_KinoSearch_Index_IndexManager_set_deletion_lock_timeout)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, timeout"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t timeout;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);
    timeout = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_IxManager_set_deletion_lock_timeout(self, timeout);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_get_deletion_lock_timeout);
XS(XS_KinoSearch_Index_IndexManager_get_deletion_lock_timeout)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_get_deletion_lock_timeout(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_set_deletion_lock_interval);
XS(XS_KinoSearch_Index_IndexManager_set_deletion_lock_interval)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, timeout"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t timeout;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);
    timeout = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_IxManager_set_deletion_lock_interval(self, timeout);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexManager_get_deletion_lock_interval);
XS(XS_KinoSearch_Index_IndexManager_get_deletion_lock_interval)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexManager* self;
        uint32_t retval;
        self = (kino_IndexManager*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXMANAGER, NULL);

        /* Execute */
        retval = kino_IxManager_get_deletion_lock_interval(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TopDocs_get_match_docs);
XS(XS_KinoSearch_Search_TopDocs_get_match_docs)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TopDocs* self;
        kino_VArray* retval;
        self = (kino_TopDocs*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOPDOCS, NULL);

        /* Execute */
        retval = kino_TopDocs_get_match_docs(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TopDocs_get_total_hits);
XS(XS_KinoSearch_Search_TopDocs_get_total_hits)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TopDocs* self;
        uint32_t retval;
        self = (kino_TopDocs*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOPDOCS, NULL);

        /* Execute */
        retval = kino_TopDocs_get_total_hits(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TopDocs_set_total_hits);
XS(XS_KinoSearch_Search_TopDocs_set_total_hits)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, total_hits"); };
    {
        /* Extract vars from Perl stack. */
        kino_TopDocs* self;
        uint32_t total_hits;
        self = (kino_TopDocs*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOPDOCS, NULL);
    total_hits = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_TopDocs_set_total_hits(self, total_hits);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Token_get_start_offset);
XS(XS_KinoSearch_Analysis_Token_get_start_offset)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Token* self;
        uint32_t retval;
        self = (kino_Token*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKEN, NULL);

        /* Execute */
        retval = kino_Token_get_start_offset(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Token_get_end_offset);
XS(XS_KinoSearch_Analysis_Token_get_end_offset)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Token* self;
        uint32_t retval;
        self = (kino_Token*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKEN, NULL);

        /* Execute */
        retval = kino_Token_get_end_offset(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Token_get_boost);
XS(XS_KinoSearch_Analysis_Token_get_boost)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Token* self;
        float retval;
        self = (kino_Token*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKEN, NULL);

        /* Execute */
        retval = kino_Token_get_boost(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Token_get_pos_inc);
XS(XS_KinoSearch_Analysis_Token_get_pos_inc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Token* self;
        int32_t retval;
        self = (kino_Token*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKEN, NULL);

        /* Execute */
        retval = kino_Token_get_pos_inc(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot_list);
XS(XS_KinoSearch_Index_Snapshot_list)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        kino_VArray* retval;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);

        /* Execute */
        retval = kino_Snapshot_list(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot_num_entries);
XS(XS_KinoSearch_Index_Snapshot_num_entries)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        uint32_t retval;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);

        /* Execute */
        retval = kino_Snapshot_num_entries(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot_add_entry);
XS(XS_KinoSearch_Index_Snapshot_add_entry)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, entry"); };
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        const kino_CharBuf* entry;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);
    entry = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Snapshot_add_entry(self, entry);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot_delete_entry);
XS(XS_KinoSearch_Index_Snapshot_delete_entry)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, entry"); };
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        const kino_CharBuf* entry;
        chy_bool_t retval;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);
    entry = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Snapshot_delete_entry(self, entry);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot_read_file);
XS(XS_KinoSearch_Index_Snapshot_read_file)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        kino_Folder* folder;
        const kino_CharBuf* path;
        kino_Snapshot* retval;
        SV* folder_sv = NULL;
        SV* path_sv = NULL;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Snapshot::read_file_PARAMS",             &folder_sv, "folder", 6,
            &path_sv, "path", 4,
 NULL);

        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'folder'"); }
         folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);;
        if ( path_sv && XSBind_sv_defined(path_sv) ) {
            path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(path_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        }
        else {
            path = NULL;
        }

        /* Execute */
        retval = kino_Snapshot_read_file(self, folder, path);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot_write_file);
XS(XS_KinoSearch_Index_Snapshot_write_file)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        kino_Folder* folder;
        const kino_CharBuf* path;
        SV* folder_sv = NULL;
        SV* path_sv = NULL;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Snapshot::write_file_PARAMS",             &folder_sv, "folder", 6,
            &path_sv, "path", 4,
 NULL);

        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'folder'"); }
         folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);;
        if ( path_sv && XSBind_sv_defined(path_sv) ) {
            path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(path_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        }
        else {
            path = NULL;
        }

        /* Execute */
        kino_Snapshot_write_file(self, folder, path);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot_set_path);
XS(XS_KinoSearch_Index_Snapshot_set_path)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, path"); };
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        const kino_CharBuf* path;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);
    path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Snapshot_set_path(self, path);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Snapshot_get_path);
XS(XS_KinoSearch_Index_Snapshot_get_path)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Snapshot* self;
        kino_CharBuf* retval;
        self = (kino_Snapshot*)XSBind_sv_to_cfish_obj(ST(0), KINO_SNAPSHOT, NULL);

        /* Execute */
        retval = kino_Snapshot_get_path(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SortRule_get_field);
XS(XS_KinoSearch_Search_SortRule_get_field)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortRule* self;
        kino_CharBuf* retval;
        self = (kino_SortRule*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTRULE, NULL);

        /* Execute */
        retval = kino_SortRule_get_field(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SortRule_get_reverse);
XS(XS_KinoSearch_Search_SortRule_get_reverse)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortRule* self;
        chy_bool_t retval;
        self = (kino_SortRule*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTRULE, NULL);

        /* Execute */
        retval = kino_SortRule_get_reverse(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_HeatMap_flatten_spans);
XS(XS_KinoSearch_Highlight_HeatMap_flatten_spans)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, spans"); };
    {
        /* Extract vars from Perl stack. */
        kino_HeatMap* self;
        kino_VArray* spans;
        kino_VArray* retval;
        self = (kino_HeatMap*)XSBind_sv_to_cfish_obj(ST(0), KINO_HEATMAP, NULL);
    spans = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(1), KINO_VARRAY, NULL);

        /* Execute */
        retval = kino_HeatMap_flatten_spans(self, spans);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_HeatMap_calc_proximity_boost);
XS(XS_KinoSearch_Highlight_HeatMap_calc_proximity_boost)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_HeatMap* self;
        kino_Span* span1;
        kino_Span* span2;
        float retval;
        SV* span1_sv = NULL;
        SV* span2_sv = NULL;
        self = (kino_HeatMap*)XSBind_sv_to_cfish_obj(ST(0), KINO_HEATMAP, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Highlight::HeatMap::calc_proximity_boost_PARAMS",             &span1_sv, "span1", 5,
            &span2_sv, "span2", 5,
 NULL);

        if ( !span1_sv || !XSBind_sv_defined(span1_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'span1'"); }
         span1 = (kino_Span*)XSBind_sv_to_cfish_obj(span1_sv, KINO_SPAN, NULL);;
        if ( !span2_sv || !XSBind_sv_defined(span2_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'span2'"); }
         span2 = (kino_Span*)XSBind_sv_to_cfish_obj(span2_sv, KINO_SPAN, NULL);;

        /* Execute */
        retval = kino_HeatMap_calc_proximity_boost(self, span1, span2);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_HeatMap_generate_proximity_boosts);
XS(XS_KinoSearch_Highlight_HeatMap_generate_proximity_boosts)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, spans"); };
    {
        /* Extract vars from Perl stack. */
        kino_HeatMap* self;
        kino_VArray* spans;
        kino_VArray* retval;
        self = (kino_HeatMap*)XSBind_sv_to_cfish_obj(ST(0), KINO_HEATMAP, NULL);
    spans = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(1), KINO_VARRAY, NULL);

        /* Execute */
        retval = kino_HeatMap_generate_proximity_boosts(self, spans);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Highlight_HeatMap_get_spans);
XS(XS_KinoSearch_Highlight_HeatMap_get_spans)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HeatMap* self;
        kino_VArray* retval;
        self = (kino_HeatMap*)XSBind_sv_to_cfish_obj(ST(0), KINO_HEATMAP, NULL);

        /* Execute */
        retval = kino_HeatMap_get_spans(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_LockFreeRegistry_register);
XS(XS_KinoSearch_Object_LockFreeRegistry_register)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_LockFreeRegistry* self;
        kino_Obj* key;
        kino_Obj* value;
        chy_bool_t retval;
        SV* key_sv = NULL;
        SV* value_sv = NULL;
        self = (kino_LockFreeRegistry*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFREEREGISTRY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Object::LockFreeRegistry::register_PARAMS",             &key_sv, "key", 3,
            &value_sv, "value", 5,
 NULL);

        if ( !key_sv || !XSBind_sv_defined(key_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'key'"); }
         key = (kino_Obj*)XSBind_sv_to_cfish_obj(key_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        if ( !value_sv || !XSBind_sv_defined(value_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'value'"); }
         value = (kino_Obj*)XSBind_sv_to_cfish_obj(value_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_LFReg_register(self, key, value);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_LockFreeRegistry_fetch);
XS(XS_KinoSearch_Object_LockFreeRegistry_fetch)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, key"); };
    {
        /* Extract vars from Perl stack. */
        kino_LockFreeRegistry* self;
        kino_Obj* key;
        kino_Obj* retval;
        self = (kino_LockFreeRegistry*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFREEREGISTRY, NULL);
    key = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_LFReg_fetch(self, key);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortCache_ordinal);
XS(XS_KinoSearch_Index_SortCache_ordinal)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortCache* self;
        int32_t doc_id;
        int32_t retval;
        self = (kino_SortCache*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTCACHE, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_SortCache_ordinal(self, doc_id);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortCache_find);
XS(XS_KinoSearch_Index_SortCache_find)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortCache* self;
        kino_Obj* term;
        int32_t retval;
        self = (kino_SortCache*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTCACHE, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            term = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));
        }
        else { 
            term = NULL;
        }

        /* Execute */
        retval = kino_SortCache_find(self, term);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float32_set_value);
XS(XS_KinoSearch_Object_Float32_set_value)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float32* self;
        float value;
        self = (kino_Float32*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT32, NULL);
    value = (float)SvNV( ST(1) );

        /* Execute */
        kino_Float32_set_value(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float32_get_value);
XS(XS_KinoSearch_Object_Float32_get_value)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float32* self;
        float retval;
        self = (kino_Float32*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT32, NULL);

        /* Execute */
        retval = kino_Float32_get_value(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float64_set_value);
XS(XS_KinoSearch_Object_Float64_set_value)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float64* self;
        double value;
        self = (kino_Float64*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT64, NULL);
    value = SvNV( ST(1) );

        /* Execute */
        kino_Float64_set_value(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Float64_get_value);
XS(XS_KinoSearch_Object_Float64_get_value)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Float64* self;
        double retval;
        self = (kino_Float64*)XSBind_sv_to_cfish_obj(ST(0), KINO_FLOAT64, NULL);

        /* Execute */
        retval = kino_Float64_get_value(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_LockFactory_make_lock);
XS(XS_KinoSearch_Store_LockFactory_make_lock)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_LockFactory* self;
        const kino_CharBuf* name;
        int32_t timeout;
        int32_t interval;
        kino_Lock* retval;
        SV* name_sv = NULL;
        SV* timeout_sv = NULL;
        SV* interval_sv = NULL;
        self = (kino_LockFactory*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFACTORY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::LockFactory::make_lock_PARAMS",             &name_sv, "name", 4,
            &timeout_sv, "timeout", 7,
            &interval_sv, "interval", 8,
 NULL);

        if ( !name_sv || !XSBind_sv_defined(name_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'name'"); }
         name = (kino_CharBuf*)XSBind_sv_to_cfish_obj(name_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( timeout_sv && XSBind_sv_defined(timeout_sv) ) {
            timeout = (int32_t)SvIV( timeout_sv );;
        }
        else {
            timeout = 0;
        }
        if ( interval_sv && XSBind_sv_defined(interval_sv) ) {
            interval = (int32_t)SvIV( interval_sv );;
        }
        else {
            interval = 100;
        }

        /* Execute */
        retval = kino_LockFact_make_lock(self, name, timeout, interval);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_LockFactory_make_shared_lock);
XS(XS_KinoSearch_Store_LockFactory_make_shared_lock)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_LockFactory* self;
        const kino_CharBuf* name;
        int32_t timeout;
        int32_t interval;
        kino_Lock* retval;
        SV* name_sv = NULL;
        SV* timeout_sv = NULL;
        SV* interval_sv = NULL;
        self = (kino_LockFactory*)XSBind_sv_to_cfish_obj(ST(0), KINO_LOCKFACTORY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::LockFactory::make_shared_lock_PARAMS",             &name_sv, "name", 4,
            &timeout_sv, "timeout", 7,
            &interval_sv, "interval", 8,
 NULL);

        if ( !name_sv || !XSBind_sv_defined(name_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'name'"); }
         name = (kino_CharBuf*)XSBind_sv_to_cfish_obj(name_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( timeout_sv && XSBind_sv_defined(timeout_sv) ) {
            timeout = (int32_t)SvIV( timeout_sv );;
        }
        else {
            timeout = 0;
        }
        if ( interval_sv && XSBind_sv_defined(interval_sv) ) {
            interval = (int32_t)SvIV( interval_sv );;
        }
        else {
            interval = 100;
        }

        /* Execute */
        retval = kino_LockFact_make_shared_lock(self, name, timeout, interval);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VTable_get_name);
XS(XS_KinoSearch_Object_VTable_get_name)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VTable* self;
        kino_CharBuf* retval;
        self = (kino_VTable*)XSBind_sv_to_cfish_obj(ST(0), KINO_VTABLE, NULL);

        /* Execute */
        retval = kino_VTable_get_name(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VTable_get_parent);
XS(XS_KinoSearch_Object_VTable_get_parent)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VTable* self;
        kino_VTable* retval;
        self = (kino_VTable*)XSBind_sv_to_cfish_obj(ST(0), KINO_VTABLE, NULL);

        /* Execute */
        retval = kino_VTable_get_parent(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_FileHandle_length);
XS(XS_KinoSearch_Store_FileHandle_length)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FileHandle* self;
        int64_t retval;
        self = (kino_FileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_FILEHANDLE, NULL);

        /* Execute */
        retval = kino_FH_length(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_MockFileHandle_length);
XS(XS_KinoSearch_Store_MockFileHandle_length)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MockFileHandle* self;
        int64_t retval;
        self = (kino_MockFileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_MOCKFILEHANDLE, NULL);

        /* Execute */
        retval = kino_MockFileHandle_length(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_FSFileHandle_length);
XS(XS_KinoSearch_Store_FSFileHandle_length)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FSFileHandle* self;
        int64_t retval;
        self = (kino_FSFileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_FSFILEHANDLE, NULL);

        /* Execute */
        retval = kino_FSFH_length(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_RAMFileHandle_length);
XS(XS_KinoSearch_Store_RAMFileHandle_length)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RAMFileHandle* self;
        int64_t retval;
        self = (kino_RAMFileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAMFILEHANDLE, NULL);

        /* Execute */
        retval = kino_RAMFH_length(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_FileHandle_close);
XS(XS_KinoSearch_Store_FileHandle_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FileHandle* self;
        chy_bool_t retval;
        self = (kino_FileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_FILEHANDLE, NULL);

        /* Execute */
        retval = kino_FH_close(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_MockFileHandle_close);
XS(XS_KinoSearch_Store_MockFileHandle_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MockFileHandle* self;
        chy_bool_t retval;
        self = (kino_MockFileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_MOCKFILEHANDLE, NULL);

        /* Execute */
        retval = kino_MockFileHandle_close(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_FSFileHandle_close);
XS(XS_KinoSearch_Store_FSFileHandle_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FSFileHandle* self;
        chy_bool_t retval;
        self = (kino_FSFileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_FSFILEHANDLE, NULL);

        /* Execute */
        retval = kino_FSFH_close(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_RAMFileHandle_close);
XS(XS_KinoSearch_Store_RAMFileHandle_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RAMFileHandle* self;
        chy_bool_t retval;
        self = (kino_RAMFileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAMFILEHANDLE, NULL);

        /* Execute */
        retval = kino_RAMFH_close(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_RAMFileHandle_get_file);
XS(XS_KinoSearch_Store_RAMFileHandle_get_file)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RAMFileHandle* self;
        kino_RAMFile* retval;
        self = (kino_RAMFileHandle*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAMFILEHANDLE, NULL);

        /* Execute */
        retval = kino_RAMFH_get_file(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SortSpec_get_rules);
XS(XS_KinoSearch_Search_SortSpec_get_rules)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortSpec* self;
        kino_VArray* retval;
        self = (kino_SortSpec*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTSPEC, NULL);

        /* Execute */
        retval = kino_SortSpec_get_rules(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Err_cat_mess);
XS(XS_KinoSearch_Object_Err_cat_mess)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, mess"); };
    {
        /* Extract vars from Perl stack. */
        kino_Err* self;
        const kino_CharBuf* mess;
        self = (kino_Err*)XSBind_sv_to_cfish_obj(ST(0), KINO_ERR, NULL);
    mess = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Err_cat_mess(self, mess);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Err_get_mess);
XS(XS_KinoSearch_Object_Err_get_mess)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Err* self;
        kino_CharBuf* retval;
        self = (kino_Err*)XSBind_sv_to_cfish_obj(ST(0), KINO_ERR, NULL);

        /* Execute */
        retval = kino_Err_get_mess(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Inversion_append);
XS(XS_KinoSearch_Analysis_Inversion_append)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, token"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inversion* self;
        kino_Token* token;
        self = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERSION, NULL);
    token = (kino_Token*)XSBind_sv_to_cfish_obj(ST(1), KINO_TOKEN, NULL);

        /* Execute */
        if (token) (void)KINO_INCREF(token);
        kino_Inversion_append(self, token);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Inversion_next);
XS(XS_KinoSearch_Analysis_Inversion_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inversion* self;
        kino_Token* retval;
        self = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERSION, NULL);

        /* Execute */
        retval = kino_Inversion_next(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Inversion_reset);
XS(XS_KinoSearch_Analysis_Inversion_reset)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inversion* self;
        self = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERSION, NULL);

        /* Execute */
        kino_Inversion_reset(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Inversion_invert);
XS(XS_KinoSearch_Analysis_Inversion_invert)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Inversion* self;
        self = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(0), KINO_INVERSION, NULL);

        /* Execute */
        kino_Inversion_invert(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_add_inverted_doc);
XS(XS_KinoSearch_Index_DataWriter_add_inverted_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        kino_Inverter* inverter;
        int32_t doc_id;
        SV* inverter_sv = NULL;
        SV* doc_id_sv = NULL;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DataWriter::add_inverted_doc_PARAMS",             &inverter_sv, "inverter", 8,
            &doc_id_sv, "doc_id", 6,
 NULL);

        if ( !inverter_sv || !XSBind_sv_defined(inverter_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'inverter'"); }
         inverter = (kino_Inverter*)XSBind_sv_to_cfish_obj(inverter_sv, KINO_INVERTER, NULL);;
        if ( !doc_id_sv || !XSBind_sv_defined(doc_id_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_id'"); }
         doc_id = (int32_t)SvIV( doc_id_sv );;

        /* Execute */
        kino_DataWriter_add_inverted_doc(self, inverter, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_HighlightWriter_add_inverted_doc);
XS(XS_KinoSearch_Index_HighlightWriter_add_inverted_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_HighlightWriter* self;
        kino_Inverter* inverter;
        int32_t doc_id;
        SV* inverter_sv = NULL;
        SV* doc_id_sv = NULL;
        self = (kino_HighlightWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::HighlightWriter::add_inverted_doc_PARAMS",             &inverter_sv, "inverter", 8,
            &doc_id_sv, "doc_id", 6,
 NULL);

        if ( !inverter_sv || !XSBind_sv_defined(inverter_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'inverter'"); }
         inverter = (kino_Inverter*)XSBind_sv_to_cfish_obj(inverter_sv, KINO_INVERTER, NULL);;
        if ( !doc_id_sv || !XSBind_sv_defined(doc_id_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_id'"); }
         doc_id = (int32_t)SvIV( doc_id_sv );;

        /* Execute */
        kino_HLWriter_add_inverted_doc(self, inverter, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingListWriter_add_inverted_doc);
XS(XS_KinoSearch_Index_PostingListWriter_add_inverted_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PostingListWriter* self;
        kino_Inverter* inverter;
        int32_t doc_id;
        SV* inverter_sv = NULL;
        SV* doc_id_sv = NULL;
        self = (kino_PostingListWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLISTWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PostingListWriter::add_inverted_doc_PARAMS",             &inverter_sv, "inverter", 8,
            &doc_id_sv, "doc_id", 6,
 NULL);

        if ( !inverter_sv || !XSBind_sv_defined(inverter_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'inverter'"); }
         inverter = (kino_Inverter*)XSBind_sv_to_cfish_obj(inverter_sv, KINO_INVERTER, NULL);;
        if ( !doc_id_sv || !XSBind_sv_defined(doc_id_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_id'"); }
         doc_id = (int32_t)SvIV( doc_id_sv );;

        /* Execute */
        kino_PListWriter_add_inverted_doc(self, inverter, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocWriter_add_inverted_doc);
XS(XS_KinoSearch_Index_DocWriter_add_inverted_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DocWriter* self;
        kino_Inverter* inverter;
        int32_t doc_id;
        SV* inverter_sv = NULL;
        SV* doc_id_sv = NULL;
        self = (kino_DocWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DocWriter::add_inverted_doc_PARAMS",             &inverter_sv, "inverter", 8,
            &doc_id_sv, "doc_id", 6,
 NULL);

        if ( !inverter_sv || !XSBind_sv_defined(inverter_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'inverter'"); }
         inverter = (kino_Inverter*)XSBind_sv_to_cfish_obj(inverter_sv, KINO_INVERTER, NULL);;
        if ( !doc_id_sv || !XSBind_sv_defined(doc_id_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_id'"); }
         doc_id = (int32_t)SvIV( doc_id_sv );;

        /* Execute */
        kino_DocWriter_add_inverted_doc(self, inverter, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortWriter_add_inverted_doc);
XS(XS_KinoSearch_Index_SortWriter_add_inverted_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_SortWriter* self;
        kino_Inverter* inverter;
        int32_t doc_id;
        SV* inverter_sv = NULL;
        SV* doc_id_sv = NULL;
        self = (kino_SortWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SortWriter::add_inverted_doc_PARAMS",             &inverter_sv, "inverter", 8,
            &doc_id_sv, "doc_id", 6,
 NULL);

        if ( !inverter_sv || !XSBind_sv_defined(inverter_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'inverter'"); }
         inverter = (kino_Inverter*)XSBind_sv_to_cfish_obj(inverter_sv, KINO_INVERTER, NULL);;
        if ( !doc_id_sv || !XSBind_sv_defined(doc_id_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_id'"); }
         doc_id = (int32_t)SvIV( doc_id_sv );;

        /* Execute */
        kino_SortWriter_add_inverted_doc(self, inverter, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegWriter_add_inverted_doc);
XS(XS_KinoSearch_Index_SegWriter_add_inverted_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_SegWriter* self;
        kino_Inverter* inverter;
        int32_t doc_id;
        SV* inverter_sv = NULL;
        SV* doc_id_sv = NULL;
        self = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegWriter::add_inverted_doc_PARAMS",             &inverter_sv, "inverter", 8,
            &doc_id_sv, "doc_id", 6,
 NULL);

        if ( !inverter_sv || !XSBind_sv_defined(inverter_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'inverter'"); }
         inverter = (kino_Inverter*)XSBind_sv_to_cfish_obj(inverter_sv, KINO_INVERTER, NULL);;
        if ( !doc_id_sv || !XSBind_sv_defined(doc_id_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_id'"); }
         doc_id = (int32_t)SvIV( doc_id_sv );;

        /* Execute */
        kino_SegWriter_add_inverted_doc(self, inverter, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_add_segment);
XS(XS_KinoSearch_Index_DataWriter_add_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DataWriter::add_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_DataWriter_add_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_HighlightWriter_add_segment);
XS(XS_KinoSearch_Index_HighlightWriter_add_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_HighlightWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_HighlightWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::HighlightWriter::add_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_HLWriter_add_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexiconWriter_add_segment);
XS(XS_KinoSearch_Index_LexiconWriter_add_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_LexiconWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_LexiconWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICONWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::LexiconWriter::add_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_LexWriter_add_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_add_segment);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_add_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultDeletionsWriter::add_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_DefDelWriter_add_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingListWriter_add_segment);
XS(XS_KinoSearch_Index_PostingListWriter_add_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PostingListWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_PostingListWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLISTWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PostingListWriter::add_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_PListWriter_add_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocWriter_add_segment);
XS(XS_KinoSearch_Index_DocWriter_add_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DocWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_DocWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DocWriter::add_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_DocWriter_add_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortWriter_add_segment);
XS(XS_KinoSearch_Index_SortWriter_add_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_SortWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_SortWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SortWriter::add_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_SortWriter_add_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegWriter_add_segment);
XS(XS_KinoSearch_Index_SegWriter_add_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_SegWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegWriter::add_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_SegWriter_add_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_delete_segment);
XS(XS_KinoSearch_Index_DataWriter_delete_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        kino_SegReader* reader;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_DataWriter_delete_segment(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegWriter_delete_segment);
XS(XS_KinoSearch_Index_SegWriter_delete_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegWriter* self;
        kino_SegReader* reader;
        self = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGWRITER, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_SegWriter_delete_segment(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_merge_segment);
XS(XS_KinoSearch_Index_DataWriter_merge_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DataWriter::merge_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_DataWriter_merge_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_merge_segment);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_merge_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultDeletionsWriter::merge_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_DefDelWriter_merge_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegWriter_merge_segment);
XS(XS_KinoSearch_Index_SegWriter_merge_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_SegWriter* self;
        kino_SegReader* reader;
        kino_I32Array* doc_map;
        SV* reader_sv = NULL;
        SV* doc_map_sv = NULL;
        self = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegWriter::merge_segment_PARAMS",             &reader_sv, "reader", 6,
            &doc_map_sv, "doc_map", 7,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( doc_map_sv && XSBind_sv_defined(doc_map_sv) ) {
            doc_map = (kino_I32Array*)XSBind_sv_to_cfish_obj(doc_map_sv, KINO_I32ARRAY, NULL);;
        }
        else {
            doc_map = NULL;
        }

        /* Execute */
        kino_SegWriter_merge_segment(self, reader, doc_map);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_finish);
XS(XS_KinoSearch_Index_DataWriter_finish)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);

        /* Execute */
        kino_DataWriter_finish(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_HighlightWriter_finish);
XS(XS_KinoSearch_Index_HighlightWriter_finish)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HighlightWriter* self;
        self = (kino_HighlightWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTWRITER, NULL);

        /* Execute */
        kino_HLWriter_finish(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexiconWriter_finish);
XS(XS_KinoSearch_Index_LexiconWriter_finish)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LexiconWriter* self;
        self = (kino_LexiconWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICONWRITER, NULL);

        /* Execute */
        kino_LexWriter_finish(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_finish);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_finish)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);

        /* Execute */
        kino_DefDelWriter_finish(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingListWriter_finish);
XS(XS_KinoSearch_Index_PostingListWriter_finish)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingListWriter* self;
        self = (kino_PostingListWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLISTWRITER, NULL);

        /* Execute */
        kino_PListWriter_finish(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocWriter_finish);
XS(XS_KinoSearch_Index_DocWriter_finish)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DocWriter* self;
        self = (kino_DocWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCWRITER, NULL);

        /* Execute */
        kino_DocWriter_finish(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortWriter_finish);
XS(XS_KinoSearch_Index_SortWriter_finish)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortWriter* self;
        self = (kino_SortWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTWRITER, NULL);

        /* Execute */
        kino_SortWriter_finish(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegWriter_finish);
XS(XS_KinoSearch_Index_SegWriter_finish)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegWriter* self;
        self = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGWRITER, NULL);

        /* Execute */
        kino_SegWriter_finish(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_metadata);
XS(XS_KinoSearch_Index_DataWriter_metadata)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        kino_Hash* retval;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);

        /* Execute */
        retval = kino_DataWriter_metadata(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexiconWriter_metadata);
XS(XS_KinoSearch_Index_LexiconWriter_metadata)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LexiconWriter* self;
        kino_Hash* retval;
        self = (kino_LexiconWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICONWRITER, NULL);

        /* Execute */
        retval = kino_LexWriter_metadata(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_metadata);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_metadata)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        kino_Hash* retval;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);

        /* Execute */
        retval = kino_DefDelWriter_metadata(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortWriter_metadata);
XS(XS_KinoSearch_Index_SortWriter_metadata)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortWriter* self;
        kino_Hash* retval;
        self = (kino_SortWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTWRITER, NULL);

        /* Execute */
        retval = kino_SortWriter_metadata(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_format);
XS(XS_KinoSearch_Index_DataWriter_format)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        int32_t retval;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);

        /* Execute */
        retval = kino_DataWriter_format(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_HighlightWriter_format);
XS(XS_KinoSearch_Index_HighlightWriter_format)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HighlightWriter* self;
        int32_t retval;
        self = (kino_HighlightWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTWRITER, NULL);

        /* Execute */
        retval = kino_HLWriter_format(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexiconWriter_format);
XS(XS_KinoSearch_Index_LexiconWriter_format)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LexiconWriter* self;
        int32_t retval;
        self = (kino_LexiconWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICONWRITER, NULL);

        /* Execute */
        retval = kino_LexWriter_format(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_format);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_format)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        int32_t retval;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);

        /* Execute */
        retval = kino_DefDelWriter_format(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingListWriter_format);
XS(XS_KinoSearch_Index_PostingListWriter_format)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingListWriter* self;
        int32_t retval;
        self = (kino_PostingListWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLISTWRITER, NULL);

        /* Execute */
        retval = kino_PListWriter_format(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocWriter_format);
XS(XS_KinoSearch_Index_DocWriter_format)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DocWriter* self;
        int32_t retval;
        self = (kino_DocWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCWRITER, NULL);

        /* Execute */
        retval = kino_DocWriter_format(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortWriter_format);
XS(XS_KinoSearch_Index_SortWriter_format)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortWriter* self;
        int32_t retval;
        self = (kino_SortWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTWRITER, NULL);

        /* Execute */
        retval = kino_SortWriter_format(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_get_snapshot);
XS(XS_KinoSearch_Index_DataWriter_get_snapshot)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        kino_Snapshot* retval;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);

        /* Execute */
        retval = kino_DataWriter_get_snapshot(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_get_segment);
XS(XS_KinoSearch_Index_DataWriter_get_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        kino_Segment* retval;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);

        /* Execute */
        retval = kino_DataWriter_get_segment(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_get_polyreader);
XS(XS_KinoSearch_Index_DataWriter_get_polyreader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        kino_PolyReader* retval;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);

        /* Execute */
        retval = kino_DataWriter_get_polyreader(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_get_schema);
XS(XS_KinoSearch_Index_DataWriter_get_schema)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        kino_Schema* retval;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);

        /* Execute */
        retval = kino_DataWriter_get_schema(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataWriter_get_folder);
XS(XS_KinoSearch_Index_DataWriter_get_folder)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataWriter* self;
        kino_Folder* retval;
        self = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAWRITER, NULL);

        /* Execute */
        retval = kino_DataWriter_get_folder(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DeletionsWriter_delete_by_term);
XS(XS_KinoSearch_Index_DeletionsWriter_delete_by_term)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DeletionsWriter* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_DeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DELETIONSWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DeletionsWriter::delete_by_term_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        kino_DelWriter_delete_by_term(self, field, term);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_delete_by_term);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_delete_by_term)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultDeletionsWriter::delete_by_term_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        kino_DefDelWriter_delete_by_term(self, field, term);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DeletionsWriter_delete_by_query);
XS(XS_KinoSearch_Index_DeletionsWriter_delete_by_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, query"); };
    {
        /* Extract vars from Perl stack. */
        kino_DeletionsWriter* self;
        kino_Query* query;
        self = (kino_DeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DELETIONSWRITER, NULL);
    query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);

        /* Execute */
        kino_DelWriter_delete_by_query(self, query);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_delete_by_query);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_delete_by_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, query"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        kino_Query* query;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);
    query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);

        /* Execute */
        kino_DefDelWriter_delete_by_query(self, query);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DeletionsWriter_delete_by_doc_id);
XS(XS_KinoSearch_Index_DeletionsWriter_delete_by_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_DeletionsWriter* self;
        int32_t doc_id;
        self = (kino_DeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DELETIONSWRITER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_DelWriter_delete_by_doc_id(self, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_delete_by_doc_id);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_delete_by_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        int32_t doc_id;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_DefDelWriter_delete_by_doc_id(self, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DeletionsWriter_updated);
XS(XS_KinoSearch_Index_DeletionsWriter_updated)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DeletionsWriter* self;
        chy_bool_t retval;
        self = (kino_DeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DELETIONSWRITER, NULL);

        /* Execute */
        retval = kino_DelWriter_updated(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_updated);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_updated)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        chy_bool_t retval;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);

        /* Execute */
        retval = kino_DefDelWriter_updated(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DeletionsWriter_generate_doc_map);
XS(XS_KinoSearch_Index_DeletionsWriter_generate_doc_map)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DeletionsWriter* self;
        kino_Matcher* deletions;
        int32_t doc_max;
        int32_t offset;
        kino_I32Array* retval;
        SV* deletions_sv = NULL;
        SV* doc_max_sv = NULL;
        SV* offset_sv = NULL;
        self = (kino_DeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DELETIONSWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DeletionsWriter::generate_doc_map_PARAMS",             &deletions_sv, "deletions", 9,
            &doc_max_sv, "doc_max", 7,
            &offset_sv, "offset", 6,
 NULL);

        if ( !deletions_sv || !XSBind_sv_defined(deletions_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'deletions'"); }
         deletions = (kino_Matcher*)XSBind_sv_to_cfish_obj(deletions_sv, KINO_MATCHER, NULL);;
        if ( !doc_max_sv || !XSBind_sv_defined(doc_max_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_max'"); }
         doc_max = (int32_t)SvIV( doc_max_sv );;
        if ( !offset_sv || !XSBind_sv_defined(offset_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offset'"); }
         offset = (int32_t)SvIV( offset_sv );;

        /* Execute */
        retval = kino_DelWriter_generate_doc_map(self, deletions, doc_max, offset);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DeletionsWriter_seg_deletions);
XS(XS_KinoSearch_Index_DeletionsWriter_seg_deletions)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, seg_reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_DeletionsWriter* self;
        kino_SegReader* seg_reader;
        kino_Matcher* retval;
        self = (kino_DeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DELETIONSWRITER, NULL);
    seg_reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        retval = kino_DelWriter_seg_deletions(self, seg_reader);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_seg_deletions);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_seg_deletions)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, seg_reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        kino_SegReader* seg_reader;
        kino_Matcher* retval;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);
    seg_reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        retval = kino_DefDelWriter_seg_deletions(self, seg_reader);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DeletionsWriter_seg_del_count);
XS(XS_KinoSearch_Index_DeletionsWriter_seg_del_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, seg_name"); };
    {
        /* Extract vars from Perl stack. */
        kino_DeletionsWriter* self;
        const kino_CharBuf* seg_name;
        int32_t retval;
        self = (kino_DeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DELETIONSWRITER, NULL);
    seg_name = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_DelWriter_seg_del_count(self, seg_name);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsWriter_seg_del_count);
XS(XS_KinoSearch_Index_DefaultDeletionsWriter_seg_del_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, seg_name"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsWriter* self;
        const kino_CharBuf* seg_name;
        int32_t retval;
        self = (kino_DefaultDeletionsWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSWRITER, NULL);
    seg_name = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_DefDelWriter_seg_del_count(self, seg_name);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegWriter_register);
XS(XS_KinoSearch_Index_SegWriter_register)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_SegWriter* self;
        const kino_CharBuf* api;
        kino_DataWriter* component;
        SV* api_sv = NULL;
        SV* component_sv = NULL;
        self = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGWRITER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegWriter::register_PARAMS",             &api_sv, "api", 3,
            &component_sv, "component", 9,
 NULL);

        if ( !api_sv || !XSBind_sv_defined(api_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'api'"); }
         api = (kino_CharBuf*)XSBind_sv_to_cfish_obj(api_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !component_sv || !XSBind_sv_defined(component_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'component'"); }
         component = (kino_DataWriter*)XSBind_sv_to_cfish_obj(component_sv, KINO_DATAWRITER, NULL);;

        /* Execute */
        if (component) (void)KINO_INCREF(component);
        kino_SegWriter_register(self, api, component);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegWriter_fetch);
XS(XS_KinoSearch_Index_SegWriter_fetch)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, api"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegWriter* self;
        const kino_CharBuf* api;
        kino_Obj* retval;
        self = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGWRITER, NULL);
    api = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_SegWriter_fetch(self, api);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegWriter_add_writer);
XS(XS_KinoSearch_Index_SegWriter_add_writer)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, writer"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegWriter* self;
        kino_DataWriter* writer;
        self = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGWRITER, NULL);
    writer = (kino_DataWriter*)XSBind_sv_to_cfish_obj(ST(1), KINO_DATAWRITER, NULL);

        /* Execute */
        if (writer) (void)KINO_INCREF(writer);
        kino_SegWriter_add_writer(self, writer);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_BackgroundMerger_optimize);
XS(XS_KinoSearch_Index_BackgroundMerger_optimize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BackgroundMerger* self;
        self = (kino_BackgroundMerger*)XSBind_sv_to_cfish_obj(ST(0), KINO_BACKGROUNDMERGER, NULL);

        /* Execute */
        kino_BGMerger_optimize(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_BackgroundMerger_commit);
XS(XS_KinoSearch_Index_BackgroundMerger_commit)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BackgroundMerger* self;
        self = (kino_BackgroundMerger*)XSBind_sv_to_cfish_obj(ST(0), KINO_BACKGROUNDMERGER, NULL);

        /* Execute */
        kino_BGMerger_commit(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_BackgroundMerger_prepare_commit);
XS(XS_KinoSearch_Index_BackgroundMerger_prepare_commit)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BackgroundMerger* self;
        self = (kino_BackgroundMerger*)XSBind_sv_to_cfish_obj(ST(0), KINO_BACKGROUNDMERGER, NULL);

        /* Execute */
        kino_BGMerger_prepare_commit(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_RAMFile_get_contents);
XS(XS_KinoSearch_Store_RAMFile_get_contents)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RAMFile* self;
        kino_ByteBuf* retval;
        self = (kino_RAMFile*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAMFILE, NULL);

        /* Execute */
        retval = kino_RAMFile_get_contents(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_get);
XS(XS_KinoSearch_Object_BitVector_get)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, tick"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        uint32_t tick;
        chy_bool_t retval;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    tick = (uint32_t)SvUV( ST(1) );

        /* Execute */
        retval = kino_BitVec_get(self, tick);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_set);
XS(XS_KinoSearch_Object_BitVector_set)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, tick"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        uint32_t tick;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    tick = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_BitVec_set(self, tick);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_get_capacity);
XS(XS_KinoSearch_Object_BitVector_get_capacity)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        uint32_t retval;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);

        /* Execute */
        retval = kino_BitVec_get_capacity(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_next_hit);
XS(XS_KinoSearch_Object_BitVector_next_hit)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, tick"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        uint32_t tick;
        int32_t retval;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    tick = (uint32_t)SvUV( ST(1) );

        /* Execute */
        retval = kino_BitVec_next_hit(self, tick);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_clear);
XS(XS_KinoSearch_Object_BitVector_clear)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, tick"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        uint32_t tick;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    tick = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_BitVec_clear(self, tick);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_clear_all);
XS(XS_KinoSearch_Object_BitVector_clear_all)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);

        /* Execute */
        kino_BitVec_clear_all(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_grow);
XS(XS_KinoSearch_Object_BitVector_grow)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, capacity"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        uint32_t capacity;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    capacity = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_BitVec_grow(self, capacity);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_and);
XS(XS_KinoSearch_Object_BitVector_and)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        const kino_BitVector* other;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    other = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(1), KINO_BITVECTOR, NULL);

        /* Execute */
        kino_BitVec_and(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_or);
XS(XS_KinoSearch_Object_BitVector_or)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        const kino_BitVector* other;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    other = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(1), KINO_BITVECTOR, NULL);

        /* Execute */
        kino_BitVec_or(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_xor);
XS(XS_KinoSearch_Object_BitVector_xor)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        const kino_BitVector* other;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    other = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(1), KINO_BITVECTOR, NULL);

        /* Execute */
        kino_BitVec_xor(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_and_not);
XS(XS_KinoSearch_Object_BitVector_and_not)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        const kino_BitVector* other;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    other = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(1), KINO_BITVECTOR, NULL);

        /* Execute */
        kino_BitVec_and_not(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_flip);
XS(XS_KinoSearch_Object_BitVector_flip)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, tick"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        uint32_t tick;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
    tick = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_BitVec_flip(self, tick);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_flip_block);
XS(XS_KinoSearch_Object_BitVector_flip_block)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        uint32_t offset;
        uint32_t length;
        SV* offset_sv = NULL;
        SV* length_sv = NULL;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Object::BitVector::flip_block_PARAMS",             &offset_sv, "offset", 6,
            &length_sv, "length", 6,
 NULL);

        if ( !offset_sv || !XSBind_sv_defined(offset_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offset'"); }
         offset = (uint32_t)SvUV( offset_sv );;
        if ( !length_sv || !XSBind_sv_defined(length_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'length'"); }
         length = (uint32_t)SvUV( length_sv );;

        /* Execute */
        kino_BitVec_flip_block(self, offset, length);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_count);
XS(XS_KinoSearch_Object_BitVector_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        uint32_t retval;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);

        /* Execute */
        retval = kino_BitVec_count(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_BitVector_to_array);
XS(XS_KinoSearch_Object_BitVector_to_array)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVector* self;
        kino_I32Array* retval;
        self = (kino_BitVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECTOR, NULL);

        /* Execute */
        retval = kino_BitVec_to_array(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_Stepper_read_record);
XS(XS_KinoSearch_Util_Stepper_read_record)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stepper* self;
        kino_InStream* instream;
        self = (kino_Stepper*)XSBind_sv_to_cfish_obj(ST(0), KINO_STEPPER, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        kino_Stepper_read_record(self, instream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SkipStepper_read_record);
XS(XS_KinoSearch_Index_SkipStepper_read_record)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_SkipStepper* self;
        kino_InStream* instream;
        self = (kino_SkipStepper*)XSBind_sv_to_cfish_obj(ST(0), KINO_SKIPSTEPPER, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        kino_SkipStepper_read_record(self, instream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_MatchPosting_read_record);
XS(XS_KinoSearch_Index_Posting_MatchPosting_read_record)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchPosting* self;
        kino_InStream* instream;
        self = (kino_MatchPosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHPOSTING, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        kino_MatchPost_read_record(self, instream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_ScorePosting_read_record);
XS(XS_KinoSearch_Index_Posting_ScorePosting_read_record)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_ScorePosting* self;
        kino_InStream* instream;
        self = (kino_ScorePosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCOREPOSTING, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        kino_ScorePost_read_record(self, instream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_RichPosting_read_record);
XS(XS_KinoSearch_Index_Posting_RichPosting_read_record)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_RichPosting* self;
        kino_InStream* instream;
        self = (kino_RichPosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_RICHPOSTING, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        kino_RichPost_read_record(self, instream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_get_doc_id);
XS(XS_KinoSearch_Index_Posting_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Posting* self;
        int32_t retval;
        self = (kino_Posting*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTING, NULL);

        /* Execute */
        retval = kino_Post_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_MatchPosting_get_freq);
XS(XS_KinoSearch_Index_Posting_MatchPosting_get_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchPosting* self;
        int32_t retval;
        self = (kino_MatchPosting*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHPOSTING, NULL);

        /* Execute */
        retval = kino_MatchPost_get_freq(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_posting_list_writer);
XS(XS_KinoSearch_Plan_Architecture_register_posting_list_writer)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, writer"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegWriter* writer;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    writer = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGWRITER, NULL);

        /* Execute */
        kino_Arch_register_posting_list_writer(self, writer);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_doc_writer);
XS(XS_KinoSearch_Plan_Architecture_register_doc_writer)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, writer"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegWriter* writer;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    writer = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGWRITER, NULL);

        /* Execute */
        kino_Arch_register_doc_writer(self, writer);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_sort_writer);
XS(XS_KinoSearch_Plan_Architecture_register_sort_writer)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, writer"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegWriter* writer;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    writer = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGWRITER, NULL);

        /* Execute */
        kino_Arch_register_sort_writer(self, writer);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_highlight_writer);
XS(XS_KinoSearch_Plan_Architecture_register_highlight_writer)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, writer"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegWriter* writer;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    writer = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGWRITER, NULL);

        /* Execute */
        kino_Arch_register_highlight_writer(self, writer);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_deletions_writer);
XS(XS_KinoSearch_Plan_Architecture_register_deletions_writer)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, writer"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegWriter* writer;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    writer = (kino_SegWriter*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGWRITER, NULL);

        /* Execute */
        kino_Arch_register_deletions_writer(self, writer);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_init_seg_reader);
XS(XS_KinoSearch_Plan_Architecture_init_seg_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegReader* reader;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_Arch_init_seg_reader(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_doc_reader);
XS(XS_KinoSearch_Plan_Architecture_register_doc_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegReader* reader;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_Arch_register_doc_reader(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_posting_list_reader);
XS(XS_KinoSearch_Plan_Architecture_register_posting_list_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegReader* reader;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_Arch_register_posting_list_reader(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_sort_reader);
XS(XS_KinoSearch_Plan_Architecture_register_sort_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegReader* reader;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_Arch_register_sort_reader(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_highlight_reader);
XS(XS_KinoSearch_Plan_Architecture_register_highlight_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegReader* reader;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_Arch_register_highlight_reader(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_lexicon_reader);
XS(XS_KinoSearch_Plan_Architecture_register_lexicon_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegReader* reader;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_Arch_register_lexicon_reader(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_register_deletions_reader);
XS(XS_KinoSearch_Plan_Architecture_register_deletions_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_SegReader* reader;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_Arch_register_deletions_reader(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_make_similarity);
XS(XS_KinoSearch_Plan_Architecture_make_similarity)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        kino_Similarity* retval;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);

        /* Execute */
        retval = kino_Arch_make_similarity(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_index_interval);
XS(XS_KinoSearch_Plan_Architecture_index_interval)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        int32_t retval;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);

        /* Execute */
        retval = kino_Arch_index_interval(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_Plan_TestArchitecture_index_interval);
XS(XS_KinoSearch_Test_Plan_TestArchitecture_index_interval)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TestArchitecture* self;
        int32_t retval;
        self = (kino_TestArchitecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_TESTARCHITECTURE, NULL);

        /* Execute */
        retval = kino_TestArch_index_interval(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Architecture_skip_interval);
XS(XS_KinoSearch_Plan_Architecture_skip_interval)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Architecture* self;
        int32_t retval;
        self = (kino_Architecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_ARCHITECTURE, NULL);

        /* Execute */
        retval = kino_Arch_skip_interval(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_Plan_TestArchitecture_skip_interval);
XS(XS_KinoSearch_Test_Plan_TestArchitecture_skip_interval)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TestArchitecture* self;
        int32_t retval;
        self = (kino_TestArchitecture*)XSBind_sv_to_cfish_obj(ST(0), KINO_TESTARCHITECTURE, NULL);

        /* Execute */
        retval = kino_TestArch_skip_interval(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FieldType_get_boost);
XS(XS_KinoSearch_Plan_FieldType_get_boost)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FieldType* self;
        float retval;
        self = (kino_FieldType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FIELDTYPE, NULL);

        /* Execute */
        retval = kino_FType_get_boost(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FieldType_indexed);
XS(XS_KinoSearch_Plan_FieldType_indexed)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FieldType* self;
        chy_bool_t retval;
        self = (kino_FieldType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FIELDTYPE, NULL);

        /* Execute */
        retval = kino_FType_indexed(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FieldType_stored);
XS(XS_KinoSearch_Plan_FieldType_stored)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FieldType* self;
        chy_bool_t retval;
        self = (kino_FieldType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FIELDTYPE, NULL);

        /* Execute */
        retval = kino_FType_stored(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FieldType_sortable);
XS(XS_KinoSearch_Plan_FieldType_sortable)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FieldType* self;
        chy_bool_t retval;
        self = (kino_FieldType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FIELDTYPE, NULL);

        /* Execute */
        retval = kino_FType_sortable(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FieldType_binary);
XS(XS_KinoSearch_Plan_FieldType_binary)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FieldType* self;
        chy_bool_t retval;
        self = (kino_FieldType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FIELDTYPE, NULL);

        /* Execute */
        retval = kino_FType_binary(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_NumericType_binary);
XS(XS_KinoSearch_Plan_NumericType_binary)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NumericType* self;
        chy_bool_t retval;
        self = (kino_NumericType*)XSBind_sv_to_cfish_obj(ST(0), KINO_NUMERICTYPE, NULL);

        /* Execute */
        retval = kino_NumType_binary(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_BlobType_binary);
XS(XS_KinoSearch_Plan_BlobType_binary)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BlobType* self;
        chy_bool_t retval;
        self = (kino_BlobType*)XSBind_sv_to_cfish_obj(ST(0), KINO_BLOBTYPE, NULL);

        /* Execute */
        retval = kino_BlobType_binary(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FieldType_compare_values);
XS(XS_KinoSearch_Plan_FieldType_compare_values)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_FieldType* self;
        kino_Obj* a;
        kino_Obj* b;
        int32_t retval;
        SV* a_sv = NULL;
        SV* b_sv = NULL;
        self = (kino_FieldType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FIELDTYPE, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::FieldType::compare_values_PARAMS",             &a_sv, "a", 1,
            &b_sv, "b", 1,
 NULL);

        if ( !a_sv || !XSBind_sv_defined(a_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'a'"); }
         a = (kino_Obj*)XSBind_sv_to_cfish_obj(a_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        if ( !b_sv || !XSBind_sv_defined(b_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'b'"); }
         b = (kino_Obj*)XSBind_sv_to_cfish_obj(b_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_FType_compare_values(self, a, b);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FullTextType_set_highlightable);
XS(XS_KinoSearch_Plan_FullTextType_set_highlightable)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, highlightable"); };
    {
        /* Extract vars from Perl stack. */
        kino_FullTextType* self;
        chy_bool_t highlightable;
        self = (kino_FullTextType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FULLTEXTTYPE, NULL);
    highlightable = SvTRUE( ST(1) ) ? 1 : 0;

        /* Execute */
        kino_FullTextType_set_highlightable(self, highlightable);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_FullTextType_highlightable);
XS(XS_KinoSearch_Plan_FullTextType_highlightable)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FullTextType* self;
        chy_bool_t retval;
        self = (kino_FullTextType*)XSBind_sv_to_cfish_obj(ST(0), KINO_FULLTEXTTYPE, NULL);

        /* Execute */
        retval = kino_FullTextType_highlightable(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Span_get_offset);
XS(XS_KinoSearch_Search_Span_get_offset)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Span* self;
        int32_t retval;
        self = (kino_Span*)XSBind_sv_to_cfish_obj(ST(0), KINO_SPAN, NULL);

        /* Execute */
        retval = kino_Span_get_offset(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Span_set_offset);
XS(XS_KinoSearch_Search_Span_set_offset)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, offset"); };
    {
        /* Extract vars from Perl stack. */
        kino_Span* self;
        int32_t offset;
        self = (kino_Span*)XSBind_sv_to_cfish_obj(ST(0), KINO_SPAN, NULL);
    offset = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_Span_set_offset(self, offset);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Span_get_length);
XS(XS_KinoSearch_Search_Span_get_length)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Span* self;
        int32_t retval;
        self = (kino_Span*)XSBind_sv_to_cfish_obj(ST(0), KINO_SPAN, NULL);

        /* Execute */
        retval = kino_Span_get_length(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Span_set_length);
XS(XS_KinoSearch_Search_Span_set_length)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, length"); };
    {
        /* Extract vars from Perl stack. */
        kino_Span* self;
        int32_t length;
        self = (kino_Span*)XSBind_sv_to_cfish_obj(ST(0), KINO_SPAN, NULL);
    length = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_Span_set_length(self, length);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Span_get_weight);
XS(XS_KinoSearch_Search_Span_get_weight)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Span* self;
        float retval;
        self = (kino_Span*)XSBind_sv_to_cfish_obj(ST(0), KINO_SPAN, NULL);

        /* Execute */
        retval = kino_Span_get_weight(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Span_set_weight);
XS(XS_KinoSearch_Search_Span_set_weight)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, weight"); };
    {
        /* Extract vars from Perl stack. */
        kino_Span* self;
        float weight;
        self = (kino_Span*)XSBind_sv_to_cfish_obj(ST(0), KINO_SPAN, NULL);
    weight = (float)SvNV( ST(1) );

        /* Execute */
        kino_Span_set_weight(self, weight);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_get_path);
XS(XS_KinoSearch_Store_Folder_get_path)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        kino_CharBuf* retval;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);

        /* Execute */
        retval = kino_Folder_get_path(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_open_out);
XS(XS_KinoSearch_Store_Folder_open_out)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, path"); };
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        const kino_CharBuf* path;
        kino_OutStream* retval;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);
    path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Folder_open_out(self, path);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_open_in);
XS(XS_KinoSearch_Store_Folder_open_in)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, path"); };
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        const kino_CharBuf* path;
        kino_InStream* retval;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);
    path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Folder_open_in(self, path);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_mkdir);
XS(XS_KinoSearch_Store_Folder_mkdir)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, path"); };
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        const kino_CharBuf* path;
        chy_bool_t retval;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);
    path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Folder_mkdir(self, path);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_list_r);
XS(XS_KinoSearch_Store_Folder_list_r)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        const kino_CharBuf* path;
        kino_VArray* retval;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else { 
            path = NULL;
        }

        /* Execute */
        retval = kino_Folder_list_r(self, path);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_exists);
XS(XS_KinoSearch_Store_Folder_exists)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, path"); };
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        const kino_CharBuf* path;
        chy_bool_t retval;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);
    path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Folder_exists(self, path);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_delete);
XS(XS_KinoSearch_Store_Folder_delete)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, path"); };
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        const kino_CharBuf* path;
        chy_bool_t retval;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);
    path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Folder_delete(self, path);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_rename);
XS(XS_KinoSearch_Store_Folder_rename)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        const kino_CharBuf* from;
        const kino_CharBuf* to;
        chy_bool_t retval;
        SV* from_sv = NULL;
        SV* to_sv = NULL;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::Folder::rename_PARAMS",             &from_sv, "from", 4,
            &to_sv, "to", 2,
 NULL);

        if ( !from_sv || !XSBind_sv_defined(from_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'from'"); }
         from = (kino_CharBuf*)XSBind_sv_to_cfish_obj(from_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !to_sv || !XSBind_sv_defined(to_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'to'"); }
         to = (kino_CharBuf*)XSBind_sv_to_cfish_obj(to_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_Folder_rename(self, from, to);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_FSFolder_rename);
XS(XS_KinoSearch_Store_FSFolder_rename)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_FSFolder* self;
        const kino_CharBuf* from;
        const kino_CharBuf* to;
        chy_bool_t retval;
        SV* from_sv = NULL;
        SV* to_sv = NULL;
        self = (kino_FSFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FSFOLDER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::FSFolder::rename_PARAMS",             &from_sv, "from", 4,
            &to_sv, "to", 2,
 NULL);

        if ( !from_sv || !XSBind_sv_defined(from_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'from'"); }
         from = (kino_CharBuf*)XSBind_sv_to_cfish_obj(from_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !to_sv || !XSBind_sv_defined(to_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'to'"); }
         to = (kino_CharBuf*)XSBind_sv_to_cfish_obj(to_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_FSFolder_rename(self, from, to);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_RAMFolder_rename);
XS(XS_KinoSearch_Store_RAMFolder_rename)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_RAMFolder* self;
        const kino_CharBuf* from;
        const kino_CharBuf* to;
        chy_bool_t retval;
        SV* from_sv = NULL;
        SV* to_sv = NULL;
        self = (kino_RAMFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAMFOLDER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::RAMFolder::rename_PARAMS",             &from_sv, "from", 4,
            &to_sv, "to", 2,
 NULL);

        if ( !from_sv || !XSBind_sv_defined(from_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'from'"); }
         from = (kino_CharBuf*)XSBind_sv_to_cfish_obj(from_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !to_sv || !XSBind_sv_defined(to_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'to'"); }
         to = (kino_CharBuf*)XSBind_sv_to_cfish_obj(to_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_RAMFolder_rename(self, from, to);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_hard_link);
XS(XS_KinoSearch_Store_Folder_hard_link)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        const kino_CharBuf* from;
        const kino_CharBuf* to;
        chy_bool_t retval;
        SV* from_sv = NULL;
        SV* to_sv = NULL;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::Folder::hard_link_PARAMS",             &from_sv, "from", 4,
            &to_sv, "to", 2,
 NULL);

        if ( !from_sv || !XSBind_sv_defined(from_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'from'"); }
         from = (kino_CharBuf*)XSBind_sv_to_cfish_obj(from_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !to_sv || !XSBind_sv_defined(to_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'to'"); }
         to = (kino_CharBuf*)XSBind_sv_to_cfish_obj(to_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_Folder_hard_link(self, from, to);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_FSFolder_hard_link);
XS(XS_KinoSearch_Store_FSFolder_hard_link)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_FSFolder* self;
        const kino_CharBuf* from;
        const kino_CharBuf* to;
        chy_bool_t retval;
        SV* from_sv = NULL;
        SV* to_sv = NULL;
        self = (kino_FSFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FSFOLDER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::FSFolder::hard_link_PARAMS",             &from_sv, "from", 4,
            &to_sv, "to", 2,
 NULL);

        if ( !from_sv || !XSBind_sv_defined(from_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'from'"); }
         from = (kino_CharBuf*)XSBind_sv_to_cfish_obj(from_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !to_sv || !XSBind_sv_defined(to_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'to'"); }
         to = (kino_CharBuf*)XSBind_sv_to_cfish_obj(to_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_FSFolder_hard_link(self, from, to);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_RAMFolder_hard_link);
XS(XS_KinoSearch_Store_RAMFolder_hard_link)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_RAMFolder* self;
        const kino_CharBuf* from;
        const kino_CharBuf* to;
        chy_bool_t retval;
        SV* from_sv = NULL;
        SV* to_sv = NULL;
        self = (kino_RAMFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAMFOLDER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::RAMFolder::hard_link_PARAMS",             &from_sv, "from", 4,
            &to_sv, "to", 2,
 NULL);

        if ( !from_sv || !XSBind_sv_defined(from_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'from'"); }
         from = (kino_CharBuf*)XSBind_sv_to_cfish_obj(from_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !to_sv || !XSBind_sv_defined(to_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'to'"); }
         to = (kino_CharBuf*)XSBind_sv_to_cfish_obj(to_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_RAMFolder_hard_link(self, from, to);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_slurp_file);
XS(XS_KinoSearch_Store_Folder_slurp_file)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, path"); };
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        const kino_CharBuf* path;
        kino_ByteBuf* retval;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);
    path = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Folder_slurp_file(self, path);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_Folder_close);
XS(XS_KinoSearch_Store_Folder_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Folder* self;
        self = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FOLDER, NULL);

        /* Execute */
        kino_Folder_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_FSFolder_close);
XS(XS_KinoSearch_Store_FSFolder_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FSFolder* self;
        self = (kino_FSFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_FSFOLDER, NULL);

        /* Execute */
        kino_FSFolder_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_RAMFolder_close);
XS(XS_KinoSearch_Store_RAMFolder_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RAMFolder* self;
        self = (kino_RAMFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAMFOLDER, NULL);

        /* Execute */
        kino_RAMFolder_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_CompoundFileReader_close);
XS(XS_KinoSearch_Store_CompoundFileReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_CompoundFileReader* self;
        self = (kino_CompoundFileReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPOUNDFILEREADER, NULL);

        /* Execute */
        kino_CFReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_PriorityQueue_less_than);
XS(XS_KinoSearch_Util_PriorityQueue_less_than)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PriorityQueue* self;
        kino_Obj* a;
        kino_Obj* b;
        chy_bool_t retval;
        SV* a_sv = NULL;
        SV* b_sv = NULL;
        self = (kino_PriorityQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_PRIORITYQUEUE, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Util::PriorityQueue::less_than_PARAMS",             &a_sv, "a", 1,
            &b_sv, "b", 1,
 NULL);

        if ( !a_sv || !XSBind_sv_defined(a_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'a'"); }
         a = (kino_Obj*)XSBind_sv_to_cfish_obj(a_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        if ( !b_sv || !XSBind_sv_defined(b_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'b'"); }
         b = (kino_Obj*)XSBind_sv_to_cfish_obj(b_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_PriQ_less_than(self, a, b);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_Util_NumPriorityQueue_less_than);
XS(XS_KinoSearch_Test_Util_NumPriorityQueue_less_than)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_NumPriorityQueue* self;
        kino_Obj* a;
        kino_Obj* b;
        chy_bool_t retval;
        SV* a_sv = NULL;
        SV* b_sv = NULL;
        self = (kino_NumPriorityQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_NUMPRIORITYQUEUE, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Test::Util::NumPriorityQueue::less_than_PARAMS",             &a_sv, "a", 1,
            &b_sv, "b", 1,
 NULL);

        if ( !a_sv || !XSBind_sv_defined(a_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'a'"); }
         a = (kino_Obj*)XSBind_sv_to_cfish_obj(a_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        if ( !b_sv || !XSBind_sv_defined(b_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'b'"); }
         b = (kino_Obj*)XSBind_sv_to_cfish_obj(b_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_NumPriQ_less_than(self, a, b);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegLexQueue_less_than);
XS(XS_KinoSearch_Index_SegLexQueue_less_than)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_SegLexQueue* self;
        kino_Obj* a;
        kino_Obj* b;
        chy_bool_t retval;
        SV* a_sv = NULL;
        SV* b_sv = NULL;
        self = (kino_SegLexQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGLEXQUEUE, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegLexQueue::less_than_PARAMS",             &a_sv, "a", 1,
            &b_sv, "b", 1,
 NULL);

        if ( !a_sv || !XSBind_sv_defined(a_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'a'"); }
         a = (kino_Obj*)XSBind_sv_to_cfish_obj(a_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        if ( !b_sv || !XSBind_sv_defined(b_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'b'"); }
         b = (kino_Obj*)XSBind_sv_to_cfish_obj(b_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_SegLexQ_less_than(self, a, b);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_HitQueue_less_than);
XS(XS_KinoSearch_Search_HitQueue_less_than)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_HitQueue* self;
        kino_Obj* a;
        kino_Obj* b;
        chy_bool_t retval;
        SV* a_sv = NULL;
        SV* b_sv = NULL;
        self = (kino_HitQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITQUEUE, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::HitQueue::less_than_PARAMS",             &a_sv, "a", 1,
            &b_sv, "b", 1,
 NULL);

        if ( !a_sv || !XSBind_sv_defined(a_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'a'"); }
         a = (kino_Obj*)XSBind_sv_to_cfish_obj(a_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        if ( !b_sv || !XSBind_sv_defined(b_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'b'"); }
         b = (kino_Obj*)XSBind_sv_to_cfish_obj(b_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_HitQ_less_than(self, a, b);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_PriorityQueue_insert);
XS(XS_KinoSearch_Util_PriorityQueue_insert)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, element"); };
    {
        /* Extract vars from Perl stack. */
        kino_PriorityQueue* self;
        kino_Obj* element;
        chy_bool_t retval;
        self = (kino_PriorityQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_PRIORITYQUEUE, NULL);
    element = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        if (element) (void)KINO_INCREF(element);
        retval = kino_PriQ_insert(self, element);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_PriorityQueue_pop);
XS(XS_KinoSearch_Util_PriorityQueue_pop)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PriorityQueue* self;
        kino_Obj* retval;
        self = (kino_PriorityQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_PRIORITYQUEUE, NULL);

        /* Execute */
        retval = kino_PriQ_pop(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_PriorityQueue_pop_all);
XS(XS_KinoSearch_Util_PriorityQueue_pop_all)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PriorityQueue* self;
        kino_VArray* retval;
        self = (kino_PriorityQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_PRIORITYQUEUE, NULL);

        /* Execute */
        retval = kino_PriQ_pop_all(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_PriorityQueue_peek);
XS(XS_KinoSearch_Util_PriorityQueue_peek)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PriorityQueue* self;
        kino_Obj* retval;
        self = (kino_PriorityQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_PRIORITYQUEUE, NULL);

        /* Execute */
        retval = kino_PriQ_peek(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_PriorityQueue_get_size);
XS(XS_KinoSearch_Util_PriorityQueue_get_size)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PriorityQueue* self;
        uint32_t retval;
        self = (kino_PriorityQueue*)XSBind_sv_to_cfish_obj(ST(0), KINO_PRIORITYQUEUE, NULL);

        /* Execute */
        retval = kino_PriQ_get_size(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Matcher_next);
XS(XS_KinoSearch_Search_Matcher_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Matcher* self;
        int32_t retval;
        self = (kino_Matcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHER, NULL);

        /* Execute */
        retval = kino_Matcher_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_BitVecMatcher_next);
XS(XS_KinoSearch_Search_BitVecMatcher_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVecMatcher* self;
        int32_t retval;
        self = (kino_BitVecMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECMATCHER, NULL);

        /* Execute */
        retval = kino_BitVecMatcher_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseScorer_next);
XS(XS_KinoSearch_Search_PhraseScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseScorer* self;
        int32_t retval;
        self = (kino_PhraseScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASESCORER, NULL);

        /* Execute */
        retval = kino_PhraseScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermScorer_next);
XS(XS_KinoSearch_Search_TermScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermScorer* self;
        int32_t retval;
        self = (kino_TermScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMSCORER, NULL);

        /* Execute */
        retval = kino_TermScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SeriesMatcher_next);
XS(XS_KinoSearch_Search_SeriesMatcher_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SeriesMatcher* self;
        int32_t retval;
        self = (kino_SeriesMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SERIESMATCHER, NULL);

        /* Execute */
        retval = kino_SeriesMatcher_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegPostingList_next);
XS(XS_KinoSearch_Index_SegPostingList_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegPostingList* self;
        int32_t retval;
        self = (kino_SegPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGPOSTINGLIST, NULL);

        /* Execute */
        retval = kino_SegPList_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_FilterScorer_next);
XS(XS_KSx_Search_FilterScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FilterScorer* self;
        int32_t retval;
        self = (kino_FilterScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_FILTERSCORER, NULL);

        /* Execute */
        retval = kino_FilterScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityScorer_next);
XS(XS_KSx_Search_ProximityScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityScorer* self;
        int32_t retval;
        self = (kino_ProximityScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYSCORER, NULL);

        /* Execute */
        retval = kino_ProximityScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchScorer_next);
XS(XS_KinoSearch_Search_NoMatchScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchScorer* self;
        int32_t retval;
        self = (kino_NoMatchScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOMATCHSCORER, NULL);

        /* Execute */
        retval = kino_NoMatchScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_MockMatcher_next);
XS(XS_KSx_Search_MockMatcher_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MockMatcher* self;
        int32_t retval;
        self = (kino_MockMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_MOCKMATCHER, NULL);

        /* Execute */
        retval = kino_MockMatcher_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORMatcher_next);
XS(XS_KinoSearch_Search_ORMatcher_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORMatcher* self;
        int32_t retval;
        self = (kino_ORMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORMATCHER, NULL);

        /* Execute */
        retval = kino_ORMatcher_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORScorer_next);
XS(XS_KinoSearch_Search_ORScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORScorer* self;
        int32_t retval;
        self = (kino_ORScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORSCORER, NULL);

        /* Execute */
        retval = kino_ORScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ANDScorer_next);
XS(XS_KinoSearch_Search_ANDScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ANDScorer* self;
        int32_t retval;
        self = (kino_ANDScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANDSCORER, NULL);

        /* Execute */
        retval = kino_ANDScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTScorer_next);
XS(XS_KinoSearch_Search_NOTScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NOTScorer* self;
        int32_t retval;
        self = (kino_NOTScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTSCORER, NULL);

        /* Execute */
        retval = kino_NOTScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalScorer_next);
XS(XS_KinoSearch_Search_RequiredOptionalScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalScorer* self;
        int32_t retval;
        self = (kino_RequiredOptionalScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALSCORER, NULL);

        /* Execute */
        retval = kino_ReqOptScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeScorer_next);
XS(XS_KinoSearch_Search_RangeScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeScorer* self;
        int32_t retval;
        self = (kino_RangeScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGESCORER, NULL);

        /* Execute */
        retval = kino_RangeScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchAllScorer_next);
XS(XS_KinoSearch_Search_MatchAllScorer_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchAllScorer* self;
        int32_t retval;
        self = (kino_MatchAllScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHALLSCORER, NULL);

        /* Execute */
        retval = kino_MatchAllScorer_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Matcher_advance);
XS(XS_KinoSearch_Search_Matcher_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_Matcher* self;
        int32_t target;
        int32_t retval;
        self = (kino_Matcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_Matcher_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_BitVecMatcher_advance);
XS(XS_KinoSearch_Search_BitVecMatcher_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVecMatcher* self;
        int32_t target;
        int32_t retval;
        self = (kino_BitVecMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECMATCHER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_BitVecMatcher_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseScorer_advance);
XS(XS_KinoSearch_Search_PhraseScorer_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseScorer* self;
        int32_t target;
        int32_t retval;
        self = (kino_PhraseScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASESCORER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_PhraseScorer_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermScorer_advance);
XS(XS_KinoSearch_Search_TermScorer_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermScorer* self;
        int32_t target;
        int32_t retval;
        self = (kino_TermScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMSCORER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_TermScorer_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SeriesMatcher_advance);
XS(XS_KinoSearch_Search_SeriesMatcher_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_SeriesMatcher* self;
        int32_t target;
        int32_t retval;
        self = (kino_SeriesMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SERIESMATCHER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_SeriesMatcher_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegPostingList_advance);
XS(XS_KinoSearch_Index_SegPostingList_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegPostingList* self;
        int32_t target;
        int32_t retval;
        self = (kino_SegPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGPOSTINGLIST, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_SegPList_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityScorer_advance);
XS(XS_KSx_Search_ProximityScorer_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityScorer* self;
        int32_t target;
        int32_t retval;
        self = (kino_ProximityScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYSCORER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_ProximityScorer_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchScorer_advance);
XS(XS_KinoSearch_Search_NoMatchScorer_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchScorer* self;
        int32_t target;
        int32_t retval;
        self = (kino_NoMatchScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOMATCHSCORER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_NoMatchScorer_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORMatcher_advance);
XS(XS_KinoSearch_Search_ORMatcher_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORMatcher* self;
        int32_t target;
        int32_t retval;
        self = (kino_ORMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORMATCHER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_ORMatcher_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORScorer_advance);
XS(XS_KinoSearch_Search_ORScorer_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORScorer* self;
        int32_t target;
        int32_t retval;
        self = (kino_ORScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORSCORER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_ORScorer_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ANDScorer_advance);
XS(XS_KinoSearch_Search_ANDScorer_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_ANDScorer* self;
        int32_t target;
        int32_t retval;
        self = (kino_ANDScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANDSCORER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_ANDScorer_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTScorer_advance);
XS(XS_KinoSearch_Search_NOTScorer_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_NOTScorer* self;
        int32_t target;
        int32_t retval;
        self = (kino_NOTScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTSCORER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_NOTScorer_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalScorer_advance);
XS(XS_KinoSearch_Search_RequiredOptionalScorer_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalScorer* self;
        int32_t target;
        int32_t retval;
        self = (kino_RequiredOptionalScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALSCORER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_ReqOptScorer_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeScorer_advance);
XS(XS_KinoSearch_Search_RangeScorer_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeScorer* self;
        int32_t target;
        int32_t retval;
        self = (kino_RangeScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGESCORER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_RangeScorer_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchAllScorer_advance);
XS(XS_KinoSearch_Search_MatchAllScorer_advance)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchAllScorer* self;
        int32_t target;
        int32_t retval;
        self = (kino_MatchAllScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHALLSCORER, NULL);
    target = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_MatchAllScorer_advance(self, target);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Matcher_get_doc_id);
XS(XS_KinoSearch_Search_Matcher_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Matcher* self;
        int32_t retval;
        self = (kino_Matcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHER, NULL);

        /* Execute */
        retval = kino_Matcher_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_BitVecMatcher_get_doc_id);
XS(XS_KinoSearch_Search_BitVecMatcher_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitVecMatcher* self;
        int32_t retval;
        self = (kino_BitVecMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITVECMATCHER, NULL);

        /* Execute */
        retval = kino_BitVecMatcher_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseScorer_get_doc_id);
XS(XS_KinoSearch_Search_PhraseScorer_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseScorer* self;
        int32_t retval;
        self = (kino_PhraseScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASESCORER, NULL);

        /* Execute */
        retval = kino_PhraseScorer_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermScorer_get_doc_id);
XS(XS_KinoSearch_Search_TermScorer_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermScorer* self;
        int32_t retval;
        self = (kino_TermScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMSCORER, NULL);

        /* Execute */
        retval = kino_TermScorer_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_SeriesMatcher_get_doc_id);
XS(XS_KinoSearch_Search_SeriesMatcher_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SeriesMatcher* self;
        int32_t retval;
        self = (kino_SeriesMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SERIESMATCHER, NULL);

        /* Execute */
        retval = kino_SeriesMatcher_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegPostingList_get_doc_id);
XS(XS_KinoSearch_Index_SegPostingList_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegPostingList* self;
        int32_t retval;
        self = (kino_SegPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGPOSTINGLIST, NULL);

        /* Execute */
        retval = kino_SegPList_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_FilterScorer_get_doc_id);
XS(XS_KSx_Search_FilterScorer_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FilterScorer* self;
        int32_t retval;
        self = (kino_FilterScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_FILTERSCORER, NULL);

        /* Execute */
        retval = kino_FilterScorer_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityScorer_get_doc_id);
XS(XS_KSx_Search_ProximityScorer_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityScorer* self;
        int32_t retval;
        self = (kino_ProximityScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYSCORER, NULL);

        /* Execute */
        retval = kino_ProximityScorer_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_MockMatcher_get_doc_id);
XS(XS_KSx_Search_MockMatcher_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MockMatcher* self;
        int32_t retval;
        self = (kino_MockMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_MOCKMATCHER, NULL);

        /* Execute */
        retval = kino_MockMatcher_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORMatcher_get_doc_id);
XS(XS_KinoSearch_Search_ORMatcher_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORMatcher* self;
        int32_t retval;
        self = (kino_ORMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORMATCHER, NULL);

        /* Execute */
        retval = kino_ORMatcher_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORScorer_get_doc_id);
XS(XS_KinoSearch_Search_ORScorer_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORScorer* self;
        int32_t retval;
        self = (kino_ORScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORSCORER, NULL);

        /* Execute */
        retval = kino_ORScorer_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ANDScorer_get_doc_id);
XS(XS_KinoSearch_Search_ANDScorer_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ANDScorer* self;
        int32_t retval;
        self = (kino_ANDScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANDSCORER, NULL);

        /* Execute */
        retval = kino_ANDScorer_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTScorer_get_doc_id);
XS(XS_KinoSearch_Search_NOTScorer_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NOTScorer* self;
        int32_t retval;
        self = (kino_NOTScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTSCORER, NULL);

        /* Execute */
        retval = kino_NOTScorer_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalScorer_get_doc_id);
XS(XS_KinoSearch_Search_RequiredOptionalScorer_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalScorer* self;
        int32_t retval;
        self = (kino_RequiredOptionalScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALSCORER, NULL);

        /* Execute */
        retval = kino_ReqOptScorer_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeScorer_get_doc_id);
XS(XS_KinoSearch_Search_RangeScorer_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeScorer* self;
        int32_t retval;
        self = (kino_RangeScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGESCORER, NULL);

        /* Execute */
        retval = kino_RangeScorer_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchAllScorer_get_doc_id);
XS(XS_KinoSearch_Search_MatchAllScorer_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchAllScorer* self;
        int32_t retval;
        self = (kino_MatchAllScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHALLSCORER, NULL);

        /* Execute */
        retval = kino_MatchAllScorer_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Matcher_score);
XS(XS_KinoSearch_Search_Matcher_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Matcher* self;
        float retval;
        self = (kino_Matcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHER, NULL);

        /* Execute */
        retval = kino_Matcher_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseScorer_score);
XS(XS_KinoSearch_Search_PhraseScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseScorer* self;
        float retval;
        self = (kino_PhraseScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASESCORER, NULL);

        /* Execute */
        retval = kino_PhraseScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_MatchPostingScorer_score);
XS(XS_KinoSearch_Index_Posting_MatchPostingScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchPostingScorer* self;
        float retval;
        self = (kino_MatchPostingScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHPOSTINGSCORER, NULL);

        /* Execute */
        retval = kino_MatchPostScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Posting_ScorePostingScorer_score);
XS(XS_KinoSearch_Index_Posting_ScorePostingScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ScorePostingScorer* self;
        float retval;
        self = (kino_ScorePostingScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCOREPOSTINGSCORER, NULL);

        /* Execute */
        retval = kino_ScorePostScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_FilterScorer_score);
XS(XS_KSx_Search_FilterScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FilterScorer* self;
        float retval;
        self = (kino_FilterScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_FILTERSCORER, NULL);

        /* Execute */
        retval = kino_FilterScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityScorer_score);
XS(XS_KSx_Search_ProximityScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityScorer* self;
        float retval;
        self = (kino_ProximityScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYSCORER, NULL);

        /* Execute */
        retval = kino_ProximityScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_MockMatcher_score);
XS(XS_KSx_Search_MockMatcher_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MockMatcher* self;
        float retval;
        self = (kino_MockMatcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_MOCKMATCHER, NULL);

        /* Execute */
        retval = kino_MockMatcher_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORScorer_score);
XS(XS_KinoSearch_Search_ORScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ORScorer* self;
        float retval;
        self = (kino_ORScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORSCORER, NULL);

        /* Execute */
        retval = kino_ORScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ANDScorer_score);
XS(XS_KinoSearch_Search_ANDScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ANDScorer* self;
        float retval;
        self = (kino_ANDScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANDSCORER, NULL);

        /* Execute */
        retval = kino_ANDScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTScorer_score);
XS(XS_KinoSearch_Search_NOTScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NOTScorer* self;
        float retval;
        self = (kino_NOTScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTSCORER, NULL);

        /* Execute */
        retval = kino_NOTScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalScorer_score);
XS(XS_KinoSearch_Search_RequiredOptionalScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalScorer* self;
        float retval;
        self = (kino_RequiredOptionalScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALSCORER, NULL);

        /* Execute */
        retval = kino_ReqOptScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeScorer_score);
XS(XS_KinoSearch_Search_RangeScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RangeScorer* self;
        float retval;
        self = (kino_RangeScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGESCORER, NULL);

        /* Execute */
        retval = kino_RangeScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchAllScorer_score);
XS(XS_KinoSearch_Search_MatchAllScorer_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchAllScorer* self;
        float retval;
        self = (kino_MatchAllScorer*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHALLSCORER, NULL);

        /* Execute */
        retval = kino_MatchAllScorer_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Matcher_collect);
XS(XS_KinoSearch_Search_Matcher_collect)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Matcher* self;
        kino_Collector* collector;
        kino_Matcher* deletions;
        SV* collector_sv = NULL;
        SV* deletions_sv = NULL;
        self = (kino_Matcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Matcher::collect_PARAMS",             &collector_sv, "collector", 9,
            &deletions_sv, "deletions", 9,
 NULL);

        if ( !collector_sv || !XSBind_sv_defined(collector_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'collector'"); }
         collector = (kino_Collector*)XSBind_sv_to_cfish_obj(collector_sv, KINO_COLLECTOR, NULL);;
        if ( deletions_sv && XSBind_sv_defined(deletions_sv) ) {
            deletions = (kino_Matcher*)XSBind_sv_to_cfish_obj(deletions_sv, KINO_MATCHER, NULL);;
        }
        else {
            deletions = NULL;
        }

        /* Execute */
        kino_Matcher_collect(self, collector, deletions);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingList_get_posting);
XS(XS_KinoSearch_Index_PostingList_get_posting)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingList* self;
        kino_Posting* retval;
        self = (kino_PostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLIST, NULL);

        /* Execute */
        retval = kino_PList_get_posting(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegPostingList_get_posting);
XS(XS_KinoSearch_Index_SegPostingList_get_posting)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegPostingList* self;
        kino_Posting* retval;
        self = (kino_SegPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGPOSTINGLIST, NULL);

        /* Execute */
        retval = kino_SegPList_get_posting(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_RawPostingList_get_posting);
XS(XS_KinoSearch_Index_RawPostingList_get_posting)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RawPostingList* self;
        kino_Posting* retval;
        self = (kino_RawPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAWPOSTINGLIST, NULL);

        /* Execute */
        retval = kino_RawPList_get_posting(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingList_get_doc_freq);
XS(XS_KinoSearch_Index_PostingList_get_doc_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingList* self;
        uint32_t retval;
        self = (kino_PostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLIST, NULL);

        /* Execute */
        retval = kino_PList_get_doc_freq(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegPostingList_get_doc_freq);
XS(XS_KinoSearch_Index_SegPostingList_get_doc_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegPostingList* self;
        uint32_t retval;
        self = (kino_SegPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGPOSTINGLIST, NULL);

        /* Execute */
        retval = kino_SegPList_get_doc_freq(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingList_seek);
XS(XS_KinoSearch_Index_PostingList_seek)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingList* self;
        kino_Obj* target;
        self = (kino_PostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLIST, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            target = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));
        }
        else { 
            target = NULL;
        }

        /* Execute */
        kino_PList_seek(self, target);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegPostingList_seek);
XS(XS_KinoSearch_Index_SegPostingList_seek)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegPostingList* self;
        kino_Obj* target;
        self = (kino_SegPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGPOSTINGLIST, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            target = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));
        }
        else { 
            target = NULL;
        }

        /* Execute */
        kino_SegPList_seek(self, target);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingList_make_matcher);
XS(XS_KinoSearch_Index_PostingList_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PostingList* self;
        kino_Similarity* similarity;
        kino_Compiler* compiler;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* similarity_sv = NULL;
        SV* compiler_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_PostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLIST, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PostingList::make_matcher_PARAMS",             &similarity_sv, "similarity", 10,
            &compiler_sv, "compiler", 8,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !similarity_sv || !XSBind_sv_defined(similarity_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'similarity'"); }
         similarity = (kino_Similarity*)XSBind_sv_to_cfish_obj(similarity_sv, KINO_SIMILARITY, NULL);;
        if ( !compiler_sv || !XSBind_sv_defined(compiler_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'compiler'"); }
         compiler = (kino_Compiler*)XSBind_sv_to_cfish_obj(compiler_sv, KINO_COMPILER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_PList_make_matcher(self, similarity, compiler, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegPostingList_make_matcher);
XS(XS_KinoSearch_Index_SegPostingList_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_SegPostingList* self;
        kino_Similarity* similarity;
        kino_Compiler* compiler;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* similarity_sv = NULL;
        SV* compiler_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_SegPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGPOSTINGLIST, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegPostingList::make_matcher_PARAMS",             &similarity_sv, "similarity", 10,
            &compiler_sv, "compiler", 8,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !similarity_sv || !XSBind_sv_defined(similarity_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'similarity'"); }
         similarity = (kino_Similarity*)XSBind_sv_to_cfish_obj(similarity_sv, KINO_SIMILARITY, NULL);;
        if ( !compiler_sv || !XSBind_sv_defined(compiler_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'compiler'"); }
         compiler = (kino_Compiler*)XSBind_sv_to_cfish_obj(compiler_sv, KINO_COMPILER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_SegPList_make_matcher(self, similarity, compiler, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegPostingList_get_post_stream);
XS(XS_KinoSearch_Index_SegPostingList_get_post_stream)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegPostingList* self;
        kino_InStream* retval;
        self = (kino_SegPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGPOSTINGLIST, NULL);

        /* Execute */
        retval = kino_SegPList_get_post_stream(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegPostingList_get_count);
XS(XS_KinoSearch_Index_SegPostingList_get_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegPostingList* self;
        uint32_t retval;
        self = (kino_SegPostingList*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGPOSTINGLIST, NULL);

        /* Execute */
        retval = kino_SegPList_get_count(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_clear);
XS(XS_KinoSearch_Object_Hash_clear)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);

        /* Execute */
        kino_Hash_clear(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_fetch);
XS(XS_KinoSearch_Object_Hash_fetch)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, key"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        const kino_Obj* key;
        kino_Obj* retval;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);
    key = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Hash_fetch(self, key);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_delete);
XS(XS_KinoSearch_Object_Hash_delete)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, key"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        const kino_Obj* key;
        kino_Obj* retval;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);
    key = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Hash_delete(self, key);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_iterate);
XS(XS_KinoSearch_Object_Hash_iterate)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        uint32_t retval;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);

        /* Execute */
        retval = kino_Hash_iterate(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_find_key);
XS(XS_KinoSearch_Object_Hash_find_key)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        const kino_Obj* key;
        int32_t hash_sum;
        kino_Obj* retval;
        SV* key_sv = NULL;
        SV* hash_sum_sv = NULL;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Object::Hash::find_key_PARAMS",             &key_sv, "key", 3,
            &hash_sum_sv, "hash_sum", 8,
 NULL);

        if ( !key_sv || !XSBind_sv_defined(key_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'key'"); }
         key = (kino_Obj*)XSBind_sv_to_cfish_obj(key_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        if ( !hash_sum_sv || !XSBind_sv_defined(hash_sum_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'hash_sum'"); }
         hash_sum = (int32_t)SvIV( hash_sum_sv );;

        /* Execute */
        retval = kino_Hash_find_key(self, key, hash_sum);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_keys);
XS(XS_KinoSearch_Object_Hash_keys)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        kino_VArray* retval;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);

        /* Execute */
        retval = kino_Hash_keys(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_values);
XS(XS_KinoSearch_Object_Hash_values)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        kino_VArray* retval;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);

        /* Execute */
        retval = kino_Hash_values(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_Hash_get_size);
XS(XS_KinoSearch_Object_Hash_get_size)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hash* self;
        uint32_t retval;
        self = (kino_Hash*)XSBind_sv_to_cfish_obj(ST(0), KINO_HASH, NULL);

        /* Execute */
        retval = kino_Hash_get_size(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Hits_next);
XS(XS_KinoSearch_Search_Hits_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hits* self;
        kino_HitDoc* retval;
        self = (kino_Hits*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITS, NULL);

        /* Execute */
        retval = kino_Hits_next(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Hits_total_hits);
XS(XS_KinoSearch_Search_Hits_total_hits)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Hits* self;
        uint32_t retval;
        self = (kino_Hits*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITS, NULL);

        /* Execute */
        retval = kino_Hits_total_hits(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_push);
XS(XS_KinoSearch_Object_VArray_push)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, element"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        kino_Obj* element;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);
    element = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        if (element) (void)KINO_INCREF(element);
        kino_VA_push(self, element);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_push_varray);
XS(XS_KinoSearch_Object_VArray_push_varray)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        kino_VArray* other;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);
    other = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(1), KINO_VARRAY, NULL);

        /* Execute */
        kino_VA_push_varray(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_unshift);
XS(XS_KinoSearch_Object_VArray_unshift)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, element"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        kino_Obj* element;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);
    element = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        if (element) (void)KINO_INCREF(element);
        kino_VA_unshift(self, element);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_excise);
XS(XS_KinoSearch_Object_VArray_excise)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        uint32_t offset;
        uint32_t length;
        SV* offset_sv = NULL;
        SV* length_sv = NULL;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Object::VArray::excise_PARAMS",             &offset_sv, "offset", 6,
            &length_sv, "length", 6,
 NULL);

        if ( !offset_sv || !XSBind_sv_defined(offset_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offset'"); }
         offset = (uint32_t)SvUV( offset_sv );;
        if ( !length_sv || !XSBind_sv_defined(length_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'length'"); }
         length = (uint32_t)SvUV( length_sv );;

        /* Execute */
        kino_VA_excise(self, offset, length);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_resize);
XS(XS_KinoSearch_Object_VArray_resize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, size"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        uint32_t size;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);
    size = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_VA_resize(self, size);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_VArray_get_size);
XS(XS_KinoSearch_Object_VArray_get_size)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_VArray* self;
        uint32_t retval;
        self = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(0), KINO_VARRAY, NULL);

        /* Execute */
        retval = kino_VA_get_size(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Query__make_compiler);
XS(XS_KinoSearch_Search_Query__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Query* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_Query*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Query::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_Query_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchQuery__make_compiler);
XS(XS_KinoSearch_Search_NoMatchQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_NoMatchQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOMATCHQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::NoMatchQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_NoMatchQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchAllQuery__make_compiler);
XS(XS_KinoSearch_Search_MatchAllQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_MatchAllQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_MatchAllQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHALLQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::MatchAllQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_MatchAllQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseQuery__make_compiler);
XS(XS_KinoSearch_Search_PhraseQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PhraseQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_PhraseQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASEQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PhraseQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_PhraseQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ANDQuery__make_compiler);
XS(XS_KinoSearch_Search_ANDQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_ANDQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_ANDQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANDQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::ANDQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_ANDQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalQuery__make_compiler);
XS(XS_KinoSearch_Search_RequiredOptionalQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_RequiredOptionalQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::RequiredOptionalQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_ReqOptQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTQuery__make_compiler);
XS(XS_KinoSearch_Search_NOTQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_NOTQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_NOTQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::NOTQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_NOTQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORQuery__make_compiler);
XS(XS_KinoSearch_Search_ORQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_ORQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_ORQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::ORQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_ORQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermQuery__make_compiler);
XS(XS_KinoSearch_Search_TermQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_TermQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_TermQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::TermQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_TermQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityQuery__make_compiler);
XS(XS_KSx_Search_ProximityQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_ProximityQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_ProximityQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KSx::Search::ProximityQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_ProximityQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_LeafQuery__make_compiler);
XS(XS_KinoSearch_Search_LeafQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_LeafQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_Compiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_LeafQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEAFQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::LeafQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_LeafQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeQuery__make_compiler);
XS(XS_KinoSearch_Search_RangeQuery__make_compiler)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_RangeQuery* self;
        kino_Searcher* searcher;
        float boost;
        kino_RangeCompiler* retval;
        SV* searcher_sv = NULL;
        SV* boost_sv = NULL;
        self = (kino_RangeQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGEQUERY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::RangeQuery::_make_compiler_PARAMS",             &searcher_sv, "searcher", 8,
            &boost_sv, "boost", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !boost_sv || !XSBind_sv_defined(boost_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'boost'"); }
         boost = (float)SvNV( boost_sv );;

        /* Execute */
        retval = kino_RangeQuery_make_compiler(self, searcher, boost);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Query_set_boost);
XS(XS_KinoSearch_Search_Query_set_boost)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, boost"); };
    {
        /* Extract vars from Perl stack. */
        kino_Query* self;
        float boost;
        self = (kino_Query*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERY, NULL);
    boost = (float)SvNV( ST(1) );

        /* Execute */
        kino_Query_set_boost(self, boost);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Query_get_boost);
XS(XS_KinoSearch_Search_Query_get_boost)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Query* self;
        float retval;
        self = (kino_Query*)XSBind_sv_to_cfish_obj(ST(0), KINO_QUERY, NULL);

        /* Execute */
        retval = kino_Query_get_boost(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseQuery_get_field);
XS(XS_KinoSearch_Search_PhraseQuery_get_field)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseQuery* self;
        kino_CharBuf* retval;
        self = (kino_PhraseQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASEQUERY, NULL);

        /* Execute */
        retval = kino_PhraseQuery_get_field(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseQuery_get_terms);
XS(XS_KinoSearch_Search_PhraseQuery_get_terms)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseQuery* self;
        kino_VArray* retval;
        self = (kino_PhraseQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASEQUERY, NULL);

        /* Execute */
        retval = kino_PhraseQuery_get_terms(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyQuery_add_child);
XS(XS_KinoSearch_Search_PolyQuery_add_child)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, query"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyQuery* self;
        kino_Query* query;
        self = (kino_PolyQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYQUERY, NULL);
    query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);

        /* Execute */
        kino_PolyQuery_add_child(self, query);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyQuery_set_children);
XS(XS_KinoSearch_Search_PolyQuery_set_children)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, children"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyQuery* self;
        kino_VArray* children;
        self = (kino_PolyQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYQUERY, NULL);
    children = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(1), KINO_VARRAY, NULL);

        /* Execute */
        kino_PolyQuery_set_children(self, children);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyQuery_get_children);
XS(XS_KinoSearch_Search_PolyQuery_get_children)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyQuery* self;
        kino_VArray* retval;
        self = (kino_PolyQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYQUERY, NULL);

        /* Execute */
        retval = kino_PolyQuery_get_children(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalQuery_get_required_query);
XS(XS_KinoSearch_Search_RequiredOptionalQuery_get_required_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalQuery* self;
        kino_Query* retval;
        self = (kino_RequiredOptionalQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALQUERY, NULL);

        /* Execute */
        retval = kino_ReqOptQuery_get_required_query(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalQuery_set_required_query);
XS(XS_KinoSearch_Search_RequiredOptionalQuery_set_required_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, required_query"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalQuery* self;
        kino_Query* required_query;
        self = (kino_RequiredOptionalQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALQUERY, NULL);
    required_query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);

        /* Execute */
        kino_ReqOptQuery_set_required_query(self, required_query);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalQuery_get_optional_query);
XS(XS_KinoSearch_Search_RequiredOptionalQuery_get_optional_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalQuery* self;
        kino_Query* retval;
        self = (kino_RequiredOptionalQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALQUERY, NULL);

        /* Execute */
        retval = kino_ReqOptQuery_get_optional_query(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalQuery_set_optional_query);
XS(XS_KinoSearch_Search_RequiredOptionalQuery_set_optional_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, optional_query"); };
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalQuery* self;
        kino_Query* optional_query;
        self = (kino_RequiredOptionalQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALQUERY, NULL);
    optional_query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);

        /* Execute */
        kino_ReqOptQuery_set_optional_query(self, optional_query);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTQuery_get_negated_query);
XS(XS_KinoSearch_Search_NOTQuery_get_negated_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NOTQuery* self;
        kino_Query* retval;
        self = (kino_NOTQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTQUERY, NULL);

        /* Execute */
        retval = kino_NOTQuery_get_negated_query(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTQuery_set_negated_query);
XS(XS_KinoSearch_Search_NOTQuery_set_negated_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, negated_query"); };
    {
        /* Extract vars from Perl stack. */
        kino_NOTQuery* self;
        kino_Query* negated_query;
        self = (kino_NOTQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTQUERY, NULL);
    negated_query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);

        /* Execute */
        kino_NOTQuery_set_negated_query(self, negated_query);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermQuery_get_field);
XS(XS_KinoSearch_Search_TermQuery_get_field)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermQuery* self;
        kino_CharBuf* retval;
        self = (kino_TermQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMQUERY, NULL);

        /* Execute */
        retval = kino_TermQuery_get_field(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermQuery_get_term);
XS(XS_KinoSearch_Search_TermQuery_get_term)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermQuery* self;
        kino_Obj* retval;
        self = (kino_TermQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMQUERY, NULL);

        /* Execute */
        retval = kino_TermQuery_get_term(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityQuery_get_field);
XS(XS_KSx_Search_ProximityQuery_get_field)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityQuery* self;
        kino_CharBuf* retval;
        self = (kino_ProximityQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYQUERY, NULL);

        /* Execute */
        retval = kino_ProximityQuery_get_field(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityQuery_get_terms);
XS(XS_KSx_Search_ProximityQuery_get_terms)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityQuery* self;
        kino_VArray* retval;
        self = (kino_ProximityQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYQUERY, NULL);

        /* Execute */
        retval = kino_ProximityQuery_get_terms(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_LeafQuery_get_field);
XS(XS_KinoSearch_Search_LeafQuery_get_field)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LeafQuery* self;
        kino_CharBuf* retval;
        self = (kino_LeafQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEAFQUERY, NULL);

        /* Execute */
        retval = kino_LeafQuery_get_field(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_LeafQuery_get_text);
XS(XS_KinoSearch_Search_LeafQuery_get_text)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LeafQuery* self;
        kino_CharBuf* retval;
        self = (kino_LeafQuery*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEAFQUERY, NULL);

        /* Execute */
        retval = kino_LeafQuery_get_text(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_make_matcher);
XS(XS_KinoSearch_Search_Compiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Compiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_Compiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseCompiler_make_matcher);
XS(XS_KinoSearch_Search_PhraseCompiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PhraseCompiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_PhraseCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASECOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PhraseCompiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_PhraseCompiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityCompiler_make_matcher);
XS(XS_KSx_Search_ProximityCompiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_ProximityCompiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_ProximityCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KSx::Search::ProximityCompiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_ProximityCompiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RequiredOptionalCompiler_make_matcher);
XS(XS_KinoSearch_Search_RequiredOptionalCompiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_RequiredOptionalCompiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_RequiredOptionalCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_REQUIREDOPTIONALCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::RequiredOptionalCompiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_ReqOptCompiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ANDCompiler_make_matcher);
XS(XS_KinoSearch_Search_ANDCompiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_ANDCompiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_ANDCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANDCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::ANDCompiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_ANDCompiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTCompiler_make_matcher);
XS(XS_KinoSearch_Search_NOTCompiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_NOTCompiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_NOTCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::NOTCompiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_NOTCompiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_ORCompiler_make_matcher);
XS(XS_KinoSearch_Search_ORCompiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_ORCompiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_ORCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_ORCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::ORCompiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_ORCompiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchAllCompiler_make_matcher);
XS(XS_KinoSearch_Search_MatchAllCompiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_MatchAllCompiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_MatchAllCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHALLCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::MatchAllCompiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_MatchAllCompiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NoMatchCompiler_make_matcher);
XS(XS_KinoSearch_Search_NoMatchCompiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_NoMatchCompiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_NoMatchCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOMATCHCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::NoMatchCompiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_NoMatchCompiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermCompiler_make_matcher);
XS(XS_KinoSearch_Search_TermCompiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_TermCompiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_TermCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::TermCompiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_TermCompiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_RangeCompiler_make_matcher);
XS(XS_KinoSearch_Search_RangeCompiler_make_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_RangeCompiler* self;
        kino_SegReader* reader;
        chy_bool_t need_score;
        kino_Matcher* retval;
        SV* reader_sv = NULL;
        SV* need_score_sv = NULL;
        self = (kino_RangeCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_RANGECOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::RangeCompiler::make_matcher_PARAMS",             &reader_sv, "reader", 6,
            &need_score_sv, "need_score", 10,
 NULL);

        if ( !reader_sv || !XSBind_sv_defined(reader_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'reader'"); }
         reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(reader_sv, KINO_SEGREADER, NULL);;
        if ( !need_score_sv || !XSBind_sv_defined(need_score_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'need_score'"); }
         need_score = SvTRUE( need_score_sv ) ? 1 : 0;;

        /* Execute */
        retval = kino_RangeCompiler_make_matcher(self, reader, need_score);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_get_weight);
XS(XS_KinoSearch_Search_Compiler_get_weight)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        float retval;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);

        /* Execute */
        retval = kino_Compiler_get_weight(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseCompiler_get_weight);
XS(XS_KinoSearch_Search_PhraseCompiler_get_weight)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseCompiler* self;
        float retval;
        self = (kino_PhraseCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASECOMPILER, NULL);

        /* Execute */
        retval = kino_PhraseCompiler_get_weight(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityCompiler_get_weight);
XS(XS_KSx_Search_ProximityCompiler_get_weight)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityCompiler* self;
        float retval;
        self = (kino_ProximityCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYCOMPILER, NULL);

        /* Execute */
        retval = kino_ProximityCompiler_get_weight(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermCompiler_get_weight);
XS(XS_KinoSearch_Search_TermCompiler_get_weight)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermCompiler* self;
        float retval;
        self = (kino_TermCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMCOMPILER, NULL);

        /* Execute */
        retval = kino_TermCompiler_get_weight(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_get_similarity);
XS(XS_KinoSearch_Search_Compiler_get_similarity)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        kino_Similarity* retval;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);

        /* Execute */
        retval = kino_Compiler_get_similarity(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_get_parent);
XS(XS_KinoSearch_Search_Compiler_get_parent)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        kino_Query* retval;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);

        /* Execute */
        retval = kino_Compiler_get_parent(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_sum_of_squared_weights);
XS(XS_KinoSearch_Search_Compiler_sum_of_squared_weights)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        float retval;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);

        /* Execute */
        retval = kino_Compiler_sum_of_squared_weights(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseCompiler_sum_of_squared_weights);
XS(XS_KinoSearch_Search_PhraseCompiler_sum_of_squared_weights)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseCompiler* self;
        float retval;
        self = (kino_PhraseCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASECOMPILER, NULL);

        /* Execute */
        retval = kino_PhraseCompiler_sum_of_squared_weights(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityCompiler_sum_of_squared_weights);
XS(XS_KSx_Search_ProximityCompiler_sum_of_squared_weights)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityCompiler* self;
        float retval;
        self = (kino_ProximityCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYCOMPILER, NULL);

        /* Execute */
        retval = kino_ProximityCompiler_sum_of_squared_weights(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyCompiler_sum_of_squared_weights);
XS(XS_KinoSearch_Search_PolyCompiler_sum_of_squared_weights)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyCompiler* self;
        float retval;
        self = (kino_PolyCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYCOMPILER, NULL);

        /* Execute */
        retval = kino_PolyCompiler_sum_of_squared_weights(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTCompiler_sum_of_squared_weights);
XS(XS_KinoSearch_Search_NOTCompiler_sum_of_squared_weights)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_NOTCompiler* self;
        float retval;
        self = (kino_NOTCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTCOMPILER, NULL);

        /* Execute */
        retval = kino_NOTCompiler_sum_of_squared_weights(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermCompiler_sum_of_squared_weights);
XS(XS_KinoSearch_Search_TermCompiler_sum_of_squared_weights)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermCompiler* self;
        float retval;
        self = (kino_TermCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMCOMPILER, NULL);

        /* Execute */
        retval = kino_TermCompiler_sum_of_squared_weights(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_apply_norm_factor);
XS(XS_KinoSearch_Search_Compiler_apply_norm_factor)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, factor"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        float factor;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);
    factor = (float)SvNV( ST(1) );

        /* Execute */
        kino_Compiler_apply_norm_factor(self, factor);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseCompiler_apply_norm_factor);
XS(XS_KinoSearch_Search_PhraseCompiler_apply_norm_factor)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, factor"); };
    {
        /* Extract vars from Perl stack. */
        kino_PhraseCompiler* self;
        float factor;
        self = (kino_PhraseCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASECOMPILER, NULL);
    factor = (float)SvNV( ST(1) );

        /* Execute */
        kino_PhraseCompiler_apply_norm_factor(self, factor);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityCompiler_apply_norm_factor);
XS(XS_KSx_Search_ProximityCompiler_apply_norm_factor)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, factor"); };
    {
        /* Extract vars from Perl stack. */
        kino_ProximityCompiler* self;
        float factor;
        self = (kino_ProximityCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYCOMPILER, NULL);
    factor = (float)SvNV( ST(1) );

        /* Execute */
        kino_ProximityCompiler_apply_norm_factor(self, factor);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyCompiler_apply_norm_factor);
XS(XS_KinoSearch_Search_PolyCompiler_apply_norm_factor)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, factor"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyCompiler* self;
        float factor;
        self = (kino_PolyCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYCOMPILER, NULL);
    factor = (float)SvNV( ST(1) );

        /* Execute */
        kino_PolyCompiler_apply_norm_factor(self, factor);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermCompiler_apply_norm_factor);
XS(XS_KinoSearch_Search_TermCompiler_apply_norm_factor)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, factor"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermCompiler* self;
        float factor;
        self = (kino_TermCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMCOMPILER, NULL);
    factor = (float)SvNV( ST(1) );

        /* Execute */
        kino_TermCompiler_apply_norm_factor(self, factor);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_normalize);
XS(XS_KinoSearch_Search_Compiler_normalize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);

        /* Execute */
        kino_Compiler_normalize(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Compiler_highlight_spans);
XS(XS_KinoSearch_Search_Compiler_highlight_spans)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Compiler* self;
        kino_Searcher* searcher;
        kino_DocVector* doc_vec;
        const kino_CharBuf* field;
        kino_VArray* retval;
        SV* searcher_sv = NULL;
        SV* doc_vec_sv = NULL;
        SV* field_sv = NULL;
        self = (kino_Compiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_COMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Compiler::highlight_spans_PARAMS",             &searcher_sv, "searcher", 8,
            &doc_vec_sv, "doc_vec", 7,
            &field_sv, "field", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !doc_vec_sv || !XSBind_sv_defined(doc_vec_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_vec'"); }
         doc_vec = (kino_DocVector*)XSBind_sv_to_cfish_obj(doc_vec_sv, KINO_DOCVECTOR, NULL);;
        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_Compiler_highlight_spans(self, searcher, doc_vec, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PhraseCompiler_highlight_spans);
XS(XS_KinoSearch_Search_PhraseCompiler_highlight_spans)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PhraseCompiler* self;
        kino_Searcher* searcher;
        kino_DocVector* doc_vec;
        const kino_CharBuf* field;
        kino_VArray* retval;
        SV* searcher_sv = NULL;
        SV* doc_vec_sv = NULL;
        SV* field_sv = NULL;
        self = (kino_PhraseCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PHRASECOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PhraseCompiler::highlight_spans_PARAMS",             &searcher_sv, "searcher", 8,
            &doc_vec_sv, "doc_vec", 7,
            &field_sv, "field", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !doc_vec_sv || !XSBind_sv_defined(doc_vec_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_vec'"); }
         doc_vec = (kino_DocVector*)XSBind_sv_to_cfish_obj(doc_vec_sv, KINO_DOCVECTOR, NULL);;
        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_PhraseCompiler_highlight_spans(self, searcher, doc_vec, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KSx_Search_ProximityCompiler_highlight_spans);
XS(XS_KSx_Search_ProximityCompiler_highlight_spans)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_ProximityCompiler* self;
        kino_Searcher* searcher;
        kino_DocVector* doc_vec;
        const kino_CharBuf* field;
        kino_VArray* retval;
        SV* searcher_sv = NULL;
        SV* doc_vec_sv = NULL;
        SV* field_sv = NULL;
        self = (kino_ProximityCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_PROXIMITYCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KSx::Search::ProximityCompiler::highlight_spans_PARAMS",             &searcher_sv, "searcher", 8,
            &doc_vec_sv, "doc_vec", 7,
            &field_sv, "field", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !doc_vec_sv || !XSBind_sv_defined(doc_vec_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_vec'"); }
         doc_vec = (kino_DocVector*)XSBind_sv_to_cfish_obj(doc_vec_sv, KINO_DOCVECTOR, NULL);;
        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_ProximityCompiler_highlight_spans(self, searcher, doc_vec, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolyCompiler_highlight_spans);
XS(XS_KinoSearch_Search_PolyCompiler_highlight_spans)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PolyCompiler* self;
        kino_Searcher* searcher;
        kino_DocVector* doc_vec;
        const kino_CharBuf* field;
        kino_VArray* retval;
        SV* searcher_sv = NULL;
        SV* doc_vec_sv = NULL;
        SV* field_sv = NULL;
        self = (kino_PolyCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PolyCompiler::highlight_spans_PARAMS",             &searcher_sv, "searcher", 8,
            &doc_vec_sv, "doc_vec", 7,
            &field_sv, "field", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !doc_vec_sv || !XSBind_sv_defined(doc_vec_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_vec'"); }
         doc_vec = (kino_DocVector*)XSBind_sv_to_cfish_obj(doc_vec_sv, KINO_DOCVECTOR, NULL);;
        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_PolyCompiler_highlight_spans(self, searcher, doc_vec, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_NOTCompiler_highlight_spans);
XS(XS_KinoSearch_Search_NOTCompiler_highlight_spans)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_NOTCompiler* self;
        kino_Searcher* searcher;
        kino_DocVector* doc_vec;
        const kino_CharBuf* field;
        kino_VArray* retval;
        SV* searcher_sv = NULL;
        SV* doc_vec_sv = NULL;
        SV* field_sv = NULL;
        self = (kino_NOTCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_NOTCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::NOTCompiler::highlight_spans_PARAMS",             &searcher_sv, "searcher", 8,
            &doc_vec_sv, "doc_vec", 7,
            &field_sv, "field", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !doc_vec_sv || !XSBind_sv_defined(doc_vec_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_vec'"); }
         doc_vec = (kino_DocVector*)XSBind_sv_to_cfish_obj(doc_vec_sv, KINO_DOCVECTOR, NULL);;
        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_NOTCompiler_highlight_spans(self, searcher, doc_vec, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_TermCompiler_highlight_spans);
XS(XS_KinoSearch_Search_TermCompiler_highlight_spans)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_TermCompiler* self;
        kino_Searcher* searcher;
        kino_DocVector* doc_vec;
        const kino_CharBuf* field;
        kino_VArray* retval;
        SV* searcher_sv = NULL;
        SV* doc_vec_sv = NULL;
        SV* field_sv = NULL;
        self = (kino_TermCompiler*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMCOMPILER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::TermCompiler::highlight_spans_PARAMS",             &searcher_sv, "searcher", 8,
            &doc_vec_sv, "doc_vec", 7,
            &field_sv, "field", 5,
 NULL);

        if ( !searcher_sv || !XSBind_sv_defined(searcher_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'searcher'"); }
         searcher = (kino_Searcher*)XSBind_sv_to_cfish_obj(searcher_sv, KINO_SEARCHER, NULL);;
        if ( !doc_vec_sv || !XSBind_sv_defined(doc_vec_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_vec'"); }
         doc_vec = (kino_DocVector*)XSBind_sv_to_cfish_obj(doc_vec_sv, KINO_DOCVECTOR, NULL);;
        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_TermCompiler_highlight_spans(self, searcher, doc_vec, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ByteBuf_get_size);
XS(XS_KinoSearch_Object_ByteBuf_get_size)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ByteBuf* self;
        size_t retval;
        self = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_BYTEBUF, NULL);

        /* Execute */
        retval = kino_BB_get_size(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ByteBuf_get_capacity);
XS(XS_KinoSearch_Object_ByteBuf_get_capacity)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_ByteBuf* self;
        size_t retval;
        self = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_BYTEBUF, NULL);

        /* Execute */
        retval = kino_BB_get_capacity(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_ByteBuf_cat);
XS(XS_KinoSearch_Object_ByteBuf_cat)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_ByteBuf* self;
        const kino_ByteBuf* other;
        self = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(ST(0), KINO_BYTEBUF, NULL);
    other = (kino_ByteBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_BYTEBUF, NULL);

        /* Execute */
        kino_BB_cat(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Indexer_add_index);
XS(XS_KinoSearch_Index_Indexer_add_index)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, index"); };
    {
        /* Extract vars from Perl stack. */
        kino_Indexer* self;
        kino_Obj* index;
        self = (kino_Indexer*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXER, NULL);
    index = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));

        /* Execute */
        kino_Indexer_add_index(self, index);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Indexer_delete_by_term);
XS(XS_KinoSearch_Index_Indexer_delete_by_term)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Indexer* self;
        kino_CharBuf* field;
        kino_Obj* term;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_Indexer*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Indexer::delete_by_term_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        kino_Indexer_delete_by_term(self, field, term);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Indexer_delete_by_query);
XS(XS_KinoSearch_Index_Indexer_delete_by_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, query"); };
    {
        /* Extract vars from Perl stack. */
        kino_Indexer* self;
        kino_Query* query;
        self = (kino_Indexer*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXER, NULL);
    query = (kino_Query*)XSBind_sv_to_cfish_obj(ST(1), KINO_QUERY, NULL);

        /* Execute */
        kino_Indexer_delete_by_query(self, query);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Indexer_optimize);
XS(XS_KinoSearch_Index_Indexer_optimize)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Indexer* self;
        self = (kino_Indexer*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXER, NULL);

        /* Execute */
        kino_Indexer_optimize(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Indexer_commit);
XS(XS_KinoSearch_Index_Indexer_commit)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Indexer* self;
        self = (kino_Indexer*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXER, NULL);

        /* Execute */
        kino_Indexer_commit(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Indexer_prepare_commit);
XS(XS_KinoSearch_Index_Indexer_prepare_commit)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Indexer* self;
        self = (kino_Indexer*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXER, NULL);

        /* Execute */
        kino_Indexer_prepare_commit(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_doc_max);
XS(XS_KinoSearch_Search_Searcher_doc_max)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        int32_t retval;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);

        /* Execute */
        retval = kino_Searcher_doc_max(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolySearcher_doc_max);
XS(XS_KinoSearch_Search_PolySearcher_doc_max)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolySearcher* self;
        int32_t retval;
        self = (kino_PolySearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYSEARCHER, NULL);

        /* Execute */
        retval = kino_PolySearcher_doc_max(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_IndexSearcher_doc_max);
XS(XS_KinoSearch_Search_IndexSearcher_doc_max)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexSearcher* self;
        int32_t retval;
        self = (kino_IndexSearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXSEARCHER, NULL);

        /* Execute */
        retval = kino_IxSearcher_doc_max(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_doc_freq);
XS(XS_KinoSearch_Search_Searcher_doc_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        uint32_t retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Searcher::doc_freq_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_Searcher_doc_freq(self, field, term);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolySearcher_doc_freq);
XS(XS_KinoSearch_Search_PolySearcher_doc_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PolySearcher* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        uint32_t retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_PolySearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYSEARCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PolySearcher::doc_freq_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_PolySearcher_doc_freq(self, field, term);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_IndexSearcher_doc_freq);
XS(XS_KinoSearch_Search_IndexSearcher_doc_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_IndexSearcher* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        uint32_t retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_IndexSearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXSEARCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::IndexSearcher::doc_freq_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_IxSearcher_doc_freq(self, field, term);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_glean_query);
XS(XS_KinoSearch_Search_Searcher_glean_query)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        kino_Obj* query;
        kino_Query* retval;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            query = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));
        }
        else { 
            query = NULL;
        }

        /* Execute */
        retval = kino_Searcher_glean_query(self, query);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_hits);
XS(XS_KinoSearch_Search_Searcher_hits)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        kino_Obj* query;
        uint32_t offset;
        uint32_t num_wanted;
        kino_SortSpec* sort_spec;
        kino_Hits* retval;
        SV* query_sv = NULL;
        SV* offset_sv = NULL;
        SV* num_wanted_sv = NULL;
        SV* sort_spec_sv = NULL;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Searcher::hits_PARAMS",             &query_sv, "query", 5,
            &offset_sv, "offset", 6,
            &num_wanted_sv, "num_wanted", 10,
            &sort_spec_sv, "sort_spec", 9,
 NULL);

        if ( !query_sv || !XSBind_sv_defined(query_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'query'"); }
         query = (kino_Obj*)XSBind_sv_to_cfish_obj(query_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        if ( offset_sv && XSBind_sv_defined(offset_sv) ) {
            offset = (uint32_t)SvUV( offset_sv );;
        }
        else {
            offset = 0;
        }
        if ( num_wanted_sv && XSBind_sv_defined(num_wanted_sv) ) {
            num_wanted = (uint32_t)SvUV( num_wanted_sv );;
        }
        else {
            num_wanted = 10;
        }
        if ( sort_spec_sv && XSBind_sv_defined(sort_spec_sv) ) {
            sort_spec = (kino_SortSpec*)XSBind_sv_to_cfish_obj(sort_spec_sv, KINO_SORTSPEC, NULL);;
        }
        else {
            sort_spec = NULL;
        }

        /* Execute */
        retval = kino_Searcher_hits(self, query, offset, num_wanted, sort_spec);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_collect);
XS(XS_KinoSearch_Search_Searcher_collect)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        kino_Query* query;
        kino_Collector* collector;
        SV* query_sv = NULL;
        SV* collector_sv = NULL;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Searcher::collect_PARAMS",             &query_sv, "query", 5,
            &collector_sv, "collector", 9,
 NULL);

        if ( !query_sv || !XSBind_sv_defined(query_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'query'"); }
         query = (kino_Query*)XSBind_sv_to_cfish_obj(query_sv, KINO_QUERY, NULL);;
        if ( !collector_sv || !XSBind_sv_defined(collector_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'collector'"); }
         collector = (kino_Collector*)XSBind_sv_to_cfish_obj(collector_sv, KINO_COLLECTOR, NULL);;

        /* Execute */
        kino_Searcher_collect(self, query, collector);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolySearcher_collect);
XS(XS_KinoSearch_Search_PolySearcher_collect)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PolySearcher* self;
        kino_Query* query;
        kino_Collector* collector;
        SV* query_sv = NULL;
        SV* collector_sv = NULL;
        self = (kino_PolySearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYSEARCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PolySearcher::collect_PARAMS",             &query_sv, "query", 5,
            &collector_sv, "collector", 9,
 NULL);

        if ( !query_sv || !XSBind_sv_defined(query_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'query'"); }
         query = (kino_Query*)XSBind_sv_to_cfish_obj(query_sv, KINO_QUERY, NULL);;
        if ( !collector_sv || !XSBind_sv_defined(collector_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'collector'"); }
         collector = (kino_Collector*)XSBind_sv_to_cfish_obj(collector_sv, KINO_COLLECTOR, NULL);;

        /* Execute */
        kino_PolySearcher_collect(self, query, collector);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_IndexSearcher_collect);
XS(XS_KinoSearch_Search_IndexSearcher_collect)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_IndexSearcher* self;
        kino_Query* query;
        kino_Collector* collector;
        SV* query_sv = NULL;
        SV* collector_sv = NULL;
        self = (kino_IndexSearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXSEARCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::IndexSearcher::collect_PARAMS",             &query_sv, "query", 5,
            &collector_sv, "collector", 9,
 NULL);

        if ( !query_sv || !XSBind_sv_defined(query_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'query'"); }
         query = (kino_Query*)XSBind_sv_to_cfish_obj(query_sv, KINO_QUERY, NULL);;
        if ( !collector_sv || !XSBind_sv_defined(collector_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'collector'"); }
         collector = (kino_Collector*)XSBind_sv_to_cfish_obj(collector_sv, KINO_COLLECTOR, NULL);;

        /* Execute */
        kino_IxSearcher_collect(self, query, collector);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_top_docs);
XS(XS_KinoSearch_Search_Searcher_top_docs)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        kino_Query* query;
        uint32_t num_wanted;
        kino_SortSpec* sort_spec;
        kino_TopDocs* retval;
        SV* query_sv = NULL;
        SV* num_wanted_sv = NULL;
        SV* sort_spec_sv = NULL;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::Searcher::top_docs_PARAMS",             &query_sv, "query", 5,
            &num_wanted_sv, "num_wanted", 10,
            &sort_spec_sv, "sort_spec", 9,
 NULL);

        if ( !query_sv || !XSBind_sv_defined(query_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'query'"); }
         query = (kino_Query*)XSBind_sv_to_cfish_obj(query_sv, KINO_QUERY, NULL);;
        if ( !num_wanted_sv || !XSBind_sv_defined(num_wanted_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'num_wanted'"); }
         num_wanted = (uint32_t)SvUV( num_wanted_sv );;
        if ( sort_spec_sv && XSBind_sv_defined(sort_spec_sv) ) {
            sort_spec = (kino_SortSpec*)XSBind_sv_to_cfish_obj(sort_spec_sv, KINO_SORTSPEC, NULL);;
        }
        else {
            sort_spec = NULL;
        }

        /* Execute */
        retval = kino_Searcher_top_docs(self, query, num_wanted, sort_spec);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolySearcher_top_docs);
XS(XS_KinoSearch_Search_PolySearcher_top_docs)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PolySearcher* self;
        kino_Query* query;
        uint32_t num_wanted;
        kino_SortSpec* sort_spec;
        kino_TopDocs* retval;
        SV* query_sv = NULL;
        SV* num_wanted_sv = NULL;
        SV* sort_spec_sv = NULL;
        self = (kino_PolySearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYSEARCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::PolySearcher::top_docs_PARAMS",             &query_sv, "query", 5,
            &num_wanted_sv, "num_wanted", 10,
            &sort_spec_sv, "sort_spec", 9,
 NULL);

        if ( !query_sv || !XSBind_sv_defined(query_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'query'"); }
         query = (kino_Query*)XSBind_sv_to_cfish_obj(query_sv, KINO_QUERY, NULL);;
        if ( !num_wanted_sv || !XSBind_sv_defined(num_wanted_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'num_wanted'"); }
         num_wanted = (uint32_t)SvUV( num_wanted_sv );;
        if ( sort_spec_sv && XSBind_sv_defined(sort_spec_sv) ) {
            sort_spec = (kino_SortSpec*)XSBind_sv_to_cfish_obj(sort_spec_sv, KINO_SORTSPEC, NULL);;
        }
        else {
            sort_spec = NULL;
        }

        /* Execute */
        retval = kino_PolySearcher_top_docs(self, query, num_wanted, sort_spec);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_IndexSearcher_top_docs);
XS(XS_KinoSearch_Search_IndexSearcher_top_docs)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_IndexSearcher* self;
        kino_Query* query;
        uint32_t num_wanted;
        kino_SortSpec* sort_spec;
        kino_TopDocs* retval;
        SV* query_sv = NULL;
        SV* num_wanted_sv = NULL;
        SV* sort_spec_sv = NULL;
        self = (kino_IndexSearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXSEARCHER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Search::IndexSearcher::top_docs_PARAMS",             &query_sv, "query", 5,
            &num_wanted_sv, "num_wanted", 10,
            &sort_spec_sv, "sort_spec", 9,
 NULL);

        if ( !query_sv || !XSBind_sv_defined(query_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'query'"); }
         query = (kino_Query*)XSBind_sv_to_cfish_obj(query_sv, KINO_QUERY, NULL);;
        if ( !num_wanted_sv || !XSBind_sv_defined(num_wanted_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'num_wanted'"); }
         num_wanted = (uint32_t)SvUV( num_wanted_sv );;
        if ( sort_spec_sv && XSBind_sv_defined(sort_spec_sv) ) {
            sort_spec = (kino_SortSpec*)XSBind_sv_to_cfish_obj(sort_spec_sv, KINO_SORTSPEC, NULL);;
        }
        else {
            sort_spec = NULL;
        }

        /* Execute */
        retval = kino_IxSearcher_top_docs(self, query, num_wanted, sort_spec);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_fetch_doc);
XS(XS_KinoSearch_Search_Searcher_fetch_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        int32_t doc_id;
        kino_HitDoc* retval;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_Searcher_fetch_doc(self, doc_id);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolySearcher_fetch_doc);
XS(XS_KinoSearch_Search_PolySearcher_fetch_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolySearcher* self;
        int32_t doc_id;
        kino_HitDoc* retval;
        self = (kino_PolySearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYSEARCHER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_PolySearcher_fetch_doc(self, doc_id);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_IndexSearcher_fetch_doc);
XS(XS_KinoSearch_Search_IndexSearcher_fetch_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexSearcher* self;
        int32_t doc_id;
        kino_HitDoc* retval;
        self = (kino_IndexSearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXSEARCHER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_IxSearcher_fetch_doc(self, doc_id);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_fetch_doc_vec);
XS(XS_KinoSearch_Search_Searcher_fetch_doc_vec)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        int32_t doc_id;
        kino_DocVector* retval;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_Searcher_fetch_doc_vec(self, doc_id);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_PolySearcher_fetch_doc_vec);
XS(XS_KinoSearch_Search_PolySearcher_fetch_doc_vec)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolySearcher* self;
        int32_t doc_id;
        kino_DocVector* retval;
        self = (kino_PolySearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYSEARCHER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_PolySearcher_fetch_doc_vec(self, doc_id);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_IndexSearcher_fetch_doc_vec);
XS(XS_KinoSearch_Search_IndexSearcher_fetch_doc_vec)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexSearcher* self;
        int32_t doc_id;
        kino_DocVector* retval;
        self = (kino_IndexSearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXSEARCHER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_IxSearcher_fetch_doc_vec(self, doc_id);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_get_schema);
XS(XS_KinoSearch_Search_Searcher_get_schema)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        kino_Schema* retval;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);

        /* Execute */
        retval = kino_Searcher_get_schema(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Searcher_close);
XS(XS_KinoSearch_Search_Searcher_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Searcher* self;
        self = (kino_Searcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEARCHER, NULL);

        /* Execute */
        kino_Searcher_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_IndexSearcher_close);
XS(XS_KinoSearch_Search_IndexSearcher_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexSearcher* self;
        self = (kino_IndexSearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXSEARCHER, NULL);

        /* Execute */
        kino_IxSearcher_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_IndexSearcher_get_reader);
XS(XS_KinoSearch_Search_IndexSearcher_get_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexSearcher* self;
        kino_IndexReader* retval;
        self = (kino_IndexSearcher*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXSEARCHER, NULL);

        /* Execute */
        retval = kino_IxSearcher_get_reader(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_tf);
XS(XS_KinoSearch_Index_Similarity_tf)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, freq"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        float freq;
        float retval;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
    freq = (float)SvNV( ST(1) );

        /* Execute */
        retval = kino_Sim_tf(self, freq);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_idf);
XS(XS_KinoSearch_Index_Similarity_idf)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        int64_t doc_freq;
        int64_t total_docs;
        float retval;
        SV* doc_freq_sv = NULL;
        SV* total_docs_sv = NULL;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Similarity::idf_PARAMS",             &doc_freq_sv, "doc_freq", 8,
            &total_docs_sv, "total_docs", 10,
 NULL);

        if ( !doc_freq_sv || !XSBind_sv_defined(doc_freq_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'doc_freq'"); }
         doc_freq = (int64_t)SvNV( doc_freq_sv );;
        if ( !total_docs_sv || !XSBind_sv_defined(total_docs_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'total_docs'"); }
         total_docs = (int64_t)SvNV( total_docs_sv );;

        /* Execute */
        retval = kino_Sim_idf(self, doc_freq, total_docs);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_coord);
XS(XS_KinoSearch_Index_Similarity_coord)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        uint32_t overlap;
        uint32_t max_overlap;
        float retval;
        SV* overlap_sv = NULL;
        SV* max_overlap_sv = NULL;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Similarity::coord_PARAMS",             &overlap_sv, "overlap", 7,
            &max_overlap_sv, "max_overlap", 11,
 NULL);

        if ( !overlap_sv || !XSBind_sv_defined(overlap_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'overlap'"); }
         overlap = (uint32_t)SvUV( overlap_sv );;
        if ( !max_overlap_sv || !XSBind_sv_defined(max_overlap_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'max_overlap'"); }
         max_overlap = (uint32_t)SvUV( max_overlap_sv );;

        /* Execute */
        retval = kino_Sim_coord(self, overlap, max_overlap);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_length_norm);
XS(XS_KinoSearch_Index_Similarity_length_norm)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, num_tokens"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        uint32_t num_tokens;
        float retval;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
    num_tokens = (uint32_t)SvUV( ST(1) );

        /* Execute */
        retval = kino_Sim_length_norm(self, num_tokens);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_query_norm);
XS(XS_KinoSearch_Index_Similarity_query_norm)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, sum_of_squared_weights"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        float sum_of_squared_weights;
        float retval;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
    sum_of_squared_weights = (float)SvNV( ST(1) );

        /* Execute */
        retval = kino_Sim_query_norm(self, sum_of_squared_weights);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_encode_norm);
XS(XS_KinoSearch_Index_Similarity_encode_norm)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, f"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        float f;
        uint32_t retval;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
    f = (float)SvNV( ST(1) );

        /* Execute */
        retval = kino_Sim_encode_norm(self, f);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Similarity_decode_norm);
XS(XS_KinoSearch_Index_Similarity_decode_norm)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, input"); };
    {
        /* Extract vars from Perl stack. */
        kino_Similarity* self;
        uint32_t input;
        float retval;
        self = (kino_Similarity*)XSBind_sv_to_cfish_obj(ST(0), KINO_SIMILARITY, NULL);
    input = (uint32_t)SvUV( ST(1) );

        /* Execute */
        retval = kino_Sim_decode_norm(self, input);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Analyzer_transform);
XS(XS_KinoSearch_Analysis_Analyzer_transform)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, inversion"); };
    {
        /* Extract vars from Perl stack. */
        kino_Analyzer* self;
        kino_Inversion* inversion;
        kino_Inversion* retval;
        self = (kino_Analyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANALYZER, NULL);
    inversion = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(1), KINO_INVERSION, NULL);

        /* Execute */
        retval = kino_Analyzer_transform(self, inversion);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_Analysis_DummyAnalyzer_transform);
XS(XS_KinoSearch_Test_Analysis_DummyAnalyzer_transform)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, inversion"); };
    {
        /* Extract vars from Perl stack. */
        kino_DummyAnalyzer* self;
        kino_Inversion* inversion;
        kino_Inversion* retval;
        self = (kino_DummyAnalyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_DUMMYANALYZER, NULL);
    inversion = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(1), KINO_INVERSION, NULL);

        /* Execute */
        retval = kino_DummyAnalyzer_transform(self, inversion);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_PolyAnalyzer_transform);
XS(XS_KinoSearch_Analysis_PolyAnalyzer_transform)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, inversion"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyAnalyzer* self;
        kino_Inversion* inversion;
        kino_Inversion* retval;
        self = (kino_PolyAnalyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYANALYZER, NULL);
    inversion = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(1), KINO_INVERSION, NULL);

        /* Execute */
        retval = kino_PolyAnalyzer_transform(self, inversion);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Stopalizer_transform);
XS(XS_KinoSearch_Analysis_Stopalizer_transform)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, inversion"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stopalizer* self;
        kino_Inversion* inversion;
        kino_Inversion* retval;
        self = (kino_Stopalizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_STOPALIZER, NULL);
    inversion = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(1), KINO_INVERSION, NULL);

        /* Execute */
        retval = kino_Stopalizer_transform(self, inversion);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_CaseFolder_transform);
XS(XS_KinoSearch_Analysis_CaseFolder_transform)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, inversion"); };
    {
        /* Extract vars from Perl stack. */
        kino_CaseFolder* self;
        kino_Inversion* inversion;
        kino_Inversion* retval;
        self = (kino_CaseFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_CASEFOLDER, NULL);
    inversion = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(1), KINO_INVERSION, NULL);

        /* Execute */
        retval = kino_CaseFolder_transform(self, inversion);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Tokenizer_transform);
XS(XS_KinoSearch_Analysis_Tokenizer_transform)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, inversion"); };
    {
        /* Extract vars from Perl stack. */
        kino_Tokenizer* self;
        kino_Inversion* inversion;
        kino_Inversion* retval;
        self = (kino_Tokenizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKENIZER, NULL);
    inversion = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(1), KINO_INVERSION, NULL);

        /* Execute */
        retval = kino_Tokenizer_transform(self, inversion);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Stemmer_transform);
XS(XS_KinoSearch_Analysis_Stemmer_transform)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, inversion"); };
    {
        /* Extract vars from Perl stack. */
        kino_Stemmer* self;
        kino_Inversion* inversion;
        kino_Inversion* retval;
        self = (kino_Stemmer*)XSBind_sv_to_cfish_obj(ST(0), KINO_STEMMER, NULL);
    inversion = (kino_Inversion*)XSBind_sv_to_cfish_obj(ST(1), KINO_INVERSION, NULL);

        /* Execute */
        retval = kino_Stemmer_transform(self, inversion);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Analyzer_transform_text);
XS(XS_KinoSearch_Analysis_Analyzer_transform_text)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, text"); };
    {
        /* Extract vars from Perl stack. */
        kino_Analyzer* self;
        kino_CharBuf* text;
        kino_Inversion* retval;
        self = (kino_Analyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANALYZER, NULL);
    text = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Analyzer_transform_text(self, text);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_PolyAnalyzer_transform_text);
XS(XS_KinoSearch_Analysis_PolyAnalyzer_transform_text)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, text"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyAnalyzer* self;
        kino_CharBuf* text;
        kino_Inversion* retval;
        self = (kino_PolyAnalyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYANALYZER, NULL);
    text = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_PolyAnalyzer_transform_text(self, text);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_CaseFolder_transform_text);
XS(XS_KinoSearch_Analysis_CaseFolder_transform_text)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, text"); };
    {
        /* Extract vars from Perl stack. */
        kino_CaseFolder* self;
        kino_CharBuf* text;
        kino_Inversion* retval;
        self = (kino_CaseFolder*)XSBind_sv_to_cfish_obj(ST(0), KINO_CASEFOLDER, NULL);
    text = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_CaseFolder_transform_text(self, text);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Tokenizer_transform_text);
XS(XS_KinoSearch_Analysis_Tokenizer_transform_text)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, text"); };
    {
        /* Extract vars from Perl stack. */
        kino_Tokenizer* self;
        kino_CharBuf* text;
        kino_Inversion* retval;
        self = (kino_Tokenizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKENIZER, NULL);
    text = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Tokenizer_transform_text(self, text);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Analyzer_split);
XS(XS_KinoSearch_Analysis_Analyzer_split)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, text"); };
    {
        /* Extract vars from Perl stack. */
        kino_Analyzer* self;
        kino_CharBuf* text;
        kino_VArray* retval;
        self = (kino_Analyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_ANALYZER, NULL);
    text = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Analyzer_split(self, text);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_PolyAnalyzer_get_analyzers);
XS(XS_KinoSearch_Analysis_PolyAnalyzer_get_analyzers)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyAnalyzer* self;
        kino_VArray* retval;
        self = (kino_PolyAnalyzer*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYANALYZER, NULL);

        /* Execute */
        retval = kino_PolyAnalyzer_get_analyzers(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Analysis_Tokenizer_set_token_re);
XS(XS_KinoSearch_Analysis_Tokenizer_set_token_re)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, token_re"); };
    {
        /* Extract vars from Perl stack. */
        kino_Tokenizer* self;
        void* token_re;
        self = (kino_Tokenizer*)XSBind_sv_to_cfish_obj(ST(0), KINO_TOKENIZER, NULL);
    if (SvROK(ST(1))) {
            token_re = SvRV(ST(1));
        }
        else {
            token_re = NULL; /* avoid uninitialized compiler warning */
            CFISH_THROW(CFISH_ERR, "token_re is not a reference");
        }


        /* Execute */
        kino_Tokenizer_set_token_re(self, token_re);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermVector_get_positions);
XS(XS_KinoSearch_Index_TermVector_get_positions)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermVector* self;
        kino_I32Array* retval;
        self = (kino_TermVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMVECTOR, NULL);

        /* Execute */
        retval = kino_TV_get_positions(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermVector_get_start_offsets);
XS(XS_KinoSearch_Index_TermVector_get_start_offsets)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermVector* self;
        kino_I32Array* retval;
        self = (kino_TermVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMVECTOR, NULL);

        /* Execute */
        retval = kino_TV_get_start_offsets(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_TermVector_get_end_offsets);
XS(XS_KinoSearch_Index_TermVector_get_end_offsets)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TermVector* self;
        kino_I32Array* retval;
        self = (kino_TermVector*)XSBind_sv_to_cfish_obj(ST(0), KINO_TERMVECTOR, NULL);

        /* Execute */
        retval = kino_TV_get_end_offsets(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_reopen);
XS(XS_KinoSearch_Store_InStream_reopen)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        const kino_CharBuf* filename;
        int64_t offset;
        int64_t len;
        kino_InStream* retval;
        SV* filename_sv = NULL;
        SV* offset_sv = NULL;
        SV* len_sv = NULL;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Store::InStream::reopen_PARAMS",             &filename_sv, "filename", 8,
            &offset_sv, "offset", 6,
            &len_sv, "len", 3,
 NULL);

        if ( filename_sv && XSBind_sv_defined(filename_sv) ) {
            filename = (kino_CharBuf*)XSBind_sv_to_cfish_obj(filename_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        }
        else {
            filename = NULL;
        }
        if ( !offset_sv || !XSBind_sv_defined(offset_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offset'"); }
         offset = (int64_t)SvNV( offset_sv );;
        if ( !len_sv || !XSBind_sv_defined(len_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'len'"); }
         len = (int64_t)SvNV( len_sv );;

        /* Execute */
        retval = kino_InStream_reopen(self, filename, offset, len);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_close);
XS(XS_KinoSearch_Store_InStream_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        kino_InStream_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_seek);
XS(XS_KinoSearch_Store_InStream_seek)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, target"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        int64_t target;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);
    target = (int64_t)SvNV( ST(1) );

        /* Execute */
        kino_InStream_seek(self, target);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_tell);
XS(XS_KinoSearch_Store_InStream_tell)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        int64_t retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_tell(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_length);
XS(XS_KinoSearch_Store_InStream_length)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        int64_t retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_length(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_read_i8);
XS(XS_KinoSearch_Store_InStream_read_i8)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        int8_t retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_read_i8(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_read_u8);
XS(XS_KinoSearch_Store_InStream_read_u8)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        uint8_t retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_read_u8(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_read_i32);
XS(XS_KinoSearch_Store_InStream_read_i32)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        int32_t retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_read_i32(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_read_u32);
XS(XS_KinoSearch_Store_InStream_read_u32)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        uint32_t retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_read_u32(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_read_i64);
XS(XS_KinoSearch_Store_InStream_read_i64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        int64_t retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_read_i64(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_read_u64);
XS(XS_KinoSearch_Store_InStream_read_u64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        uint64_t retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_read_u64(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_read_f32);
XS(XS_KinoSearch_Store_InStream_read_f32)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        float retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_read_f32(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_read_f64);
XS(XS_KinoSearch_Store_InStream_read_f64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        double retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_read_f64(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_read_c32);
XS(XS_KinoSearch_Store_InStream_read_c32)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        uint32_t retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_read_c32(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_InStream_read_c64);
XS(XS_KinoSearch_Store_InStream_read_c64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_InStream* self;
        uint64_t retval;
        self = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_INSTREAM, NULL);

        /* Execute */
        retval = kino_InStream_read_c64(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataReader_aggregator);
XS(XS_KinoSearch_Index_DataReader_aggregator)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DataReader* self;
        kino_VArray* readers;
        kino_I32Array* offsets;
        kino_DataReader* retval;
        SV* readers_sv = NULL;
        SV* offsets_sv = NULL;
        self = (kino_DataReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DataReader::aggregator_PARAMS",             &readers_sv, "readers", 7,
            &offsets_sv, "offsets", 7,
 NULL);

        if ( !readers_sv || !XSBind_sv_defined(readers_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'readers'"); }
         readers = (kino_VArray*)XSBind_sv_to_cfish_obj(readers_sv, KINO_VARRAY, NULL);;
        if ( !offsets_sv || !XSBind_sv_defined(offsets_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offsets'"); }
         offsets = (kino_I32Array*)XSBind_sv_to_cfish_obj(offsets_sv, KINO_I32ARRAY, NULL);;

        /* Execute */
        retval = kino_DataReader_aggregator(self, readers, offsets);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingListReader_aggregator);
XS(XS_KinoSearch_Index_PostingListReader_aggregator)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PostingListReader* self;
        kino_VArray* readers;
        kino_I32Array* offsets;
        kino_PostingListReader* retval;
        SV* readers_sv = NULL;
        SV* offsets_sv = NULL;
        self = (kino_PostingListReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLISTREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PostingListReader::aggregator_PARAMS",             &readers_sv, "readers", 7,
            &offsets_sv, "offsets", 7,
 NULL);

        if ( !readers_sv || !XSBind_sv_defined(readers_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'readers'"); }
         readers = (kino_VArray*)XSBind_sv_to_cfish_obj(readers_sv, KINO_VARRAY, NULL);;
        if ( !offsets_sv || !XSBind_sv_defined(offsets_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offsets'"); }
         offsets = (kino_I32Array*)XSBind_sv_to_cfish_obj(offsets_sv, KINO_I32ARRAY, NULL);;

        /* Execute */
        retval = kino_PListReader_aggregator(self, readers, offsets);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexiconReader_aggregator);
XS(XS_KinoSearch_Index_LexiconReader_aggregator)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_LexiconReader* self;
        kino_VArray* readers;
        kino_I32Array* offsets;
        kino_LexiconReader* retval;
        SV* readers_sv = NULL;
        SV* offsets_sv = NULL;
        self = (kino_LexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICONREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::LexiconReader::aggregator_PARAMS",             &readers_sv, "readers", 7,
            &offsets_sv, "offsets", 7,
 NULL);

        if ( !readers_sv || !XSBind_sv_defined(readers_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'readers'"); }
         readers = (kino_VArray*)XSBind_sv_to_cfish_obj(readers_sv, KINO_VARRAY, NULL);;
        if ( !offsets_sv || !XSBind_sv_defined(offsets_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offsets'"); }
         offsets = (kino_I32Array*)XSBind_sv_to_cfish_obj(offsets_sv, KINO_I32ARRAY, NULL);;

        /* Execute */
        retval = kino_LexReader_aggregator(self, readers, offsets);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_HighlightReader_aggregator);
XS(XS_KinoSearch_Index_HighlightReader_aggregator)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_HighlightReader* self;
        kino_VArray* readers;
        kino_I32Array* offsets;
        kino_HighlightReader* retval;
        SV* readers_sv = NULL;
        SV* offsets_sv = NULL;
        self = (kino_HighlightReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_HIGHLIGHTREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::HighlightReader::aggregator_PARAMS",             &readers_sv, "readers", 7,
            &offsets_sv, "offsets", 7,
 NULL);

        if ( !readers_sv || !XSBind_sv_defined(readers_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'readers'"); }
         readers = (kino_VArray*)XSBind_sv_to_cfish_obj(readers_sv, KINO_VARRAY, NULL);;
        if ( !offsets_sv || !XSBind_sv_defined(offsets_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offsets'"); }
         offsets = (kino_I32Array*)XSBind_sv_to_cfish_obj(offsets_sv, KINO_I32ARRAY, NULL);;

        /* Execute */
        retval = kino_HLReader_aggregator(self, readers, offsets);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocReader_aggregator);
XS(XS_KinoSearch_Index_DocReader_aggregator)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DocReader* self;
        kino_VArray* readers;
        kino_I32Array* offsets;
        kino_DocReader* retval;
        SV* readers_sv = NULL;
        SV* offsets_sv = NULL;
        self = (kino_DocReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DocReader::aggregator_PARAMS",             &readers_sv, "readers", 7,
            &offsets_sv, "offsets", 7,
 NULL);

        if ( !readers_sv || !XSBind_sv_defined(readers_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'readers'"); }
         readers = (kino_VArray*)XSBind_sv_to_cfish_obj(readers_sv, KINO_VARRAY, NULL);;
        if ( !offsets_sv || !XSBind_sv_defined(offsets_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offsets'"); }
         offsets = (kino_I32Array*)XSBind_sv_to_cfish_obj(offsets_sv, KINO_I32ARRAY, NULL);;

        /* Execute */
        retval = kino_DocReader_aggregator(self, readers, offsets);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortReader_aggregator);
XS(XS_KinoSearch_Index_SortReader_aggregator)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_SortReader* self;
        kino_VArray* readers;
        kino_I32Array* offsets;
        kino_DataReader* retval;
        SV* readers_sv = NULL;
        SV* offsets_sv = NULL;
        self = (kino_SortReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SortReader::aggregator_PARAMS",             &readers_sv, "readers", 7,
            &offsets_sv, "offsets", 7,
 NULL);

        if ( !readers_sv || !XSBind_sv_defined(readers_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'readers'"); }
         readers = (kino_VArray*)XSBind_sv_to_cfish_obj(readers_sv, KINO_VARRAY, NULL);;
        if ( !offsets_sv || !XSBind_sv_defined(offsets_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offsets'"); }
         offsets = (kino_I32Array*)XSBind_sv_to_cfish_obj(offsets_sv, KINO_I32ARRAY, NULL);;

        /* Execute */
        retval = kino_SortReader_aggregator(self, readers, offsets);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DeletionsReader_aggregator);
XS(XS_KinoSearch_Index_DeletionsReader_aggregator)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DeletionsReader* self;
        kino_VArray* readers;
        kino_I32Array* offsets;
        kino_DeletionsReader* retval;
        SV* readers_sv = NULL;
        SV* offsets_sv = NULL;
        self = (kino_DeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DELETIONSREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DeletionsReader::aggregator_PARAMS",             &readers_sv, "readers", 7,
            &offsets_sv, "offsets", 7,
 NULL);

        if ( !readers_sv || !XSBind_sv_defined(readers_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'readers'"); }
         readers = (kino_VArray*)XSBind_sv_to_cfish_obj(readers_sv, KINO_VARRAY, NULL);;
        if ( !offsets_sv || !XSBind_sv_defined(offsets_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'offsets'"); }
         offsets = (kino_I32Array*)XSBind_sv_to_cfish_obj(offsets_sv, KINO_I32ARRAY, NULL);;

        /* Execute */
        retval = kino_DelReader_aggregator(self, readers, offsets);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataReader_get_schema);
XS(XS_KinoSearch_Index_DataReader_get_schema)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataReader* self;
        kino_Schema* retval;
        self = (kino_DataReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAREADER, NULL);

        /* Execute */
        retval = kino_DataReader_get_schema(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataReader_get_folder);
XS(XS_KinoSearch_Index_DataReader_get_folder)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataReader* self;
        kino_Folder* retval;
        self = (kino_DataReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAREADER, NULL);

        /* Execute */
        retval = kino_DataReader_get_folder(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataReader_get_snapshot);
XS(XS_KinoSearch_Index_DataReader_get_snapshot)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataReader* self;
        kino_Snapshot* retval;
        self = (kino_DataReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAREADER, NULL);

        /* Execute */
        retval = kino_DataReader_get_snapshot(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataReader_get_segments);
XS(XS_KinoSearch_Index_DataReader_get_segments)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataReader* self;
        kino_VArray* retval;
        self = (kino_DataReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAREADER, NULL);

        /* Execute */
        retval = kino_DataReader_get_segments(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataReader_get_segment);
XS(XS_KinoSearch_Index_DataReader_get_segment)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataReader* self;
        kino_Segment* retval;
        self = (kino_DataReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAREADER, NULL);

        /* Execute */
        retval = kino_DataReader_get_segment(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataReader_get_seg_tick);
XS(XS_KinoSearch_Index_DataReader_get_seg_tick)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataReader* self;
        int32_t retval;
        self = (kino_DataReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAREADER, NULL);

        /* Execute */
        retval = kino_DataReader_get_seg_tick(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DataReader_close);
XS(XS_KinoSearch_Index_DataReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DataReader* self;
        self = (kino_DataReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DATAREADER, NULL);

        /* Execute */
        kino_DataReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultPostingListReader_close);
XS(XS_KinoSearch_Index_DefaultPostingListReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultPostingListReader* self;
        self = (kino_DefaultPostingListReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTPOSTINGLISTREADER, NULL);

        /* Execute */
        kino_DefPListReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyLexiconReader_close);
XS(XS_KinoSearch_Index_PolyLexiconReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyLexiconReader* self;
        self = (kino_PolyLexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYLEXICONREADER, NULL);

        /* Execute */
        kino_PolyLexReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultLexiconReader_close);
XS(XS_KinoSearch_Index_DefaultLexiconReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultLexiconReader* self;
        self = (kino_DefaultLexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTLEXICONREADER, NULL);

        /* Execute */
        kino_DefLexReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyHighlightReader_close);
XS(XS_KinoSearch_Index_PolyHighlightReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyHighlightReader* self;
        self = (kino_PolyHighlightReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYHIGHLIGHTREADER, NULL);

        /* Execute */
        kino_PolyHLReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultHighlightReader_close);
XS(XS_KinoSearch_Index_DefaultHighlightReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultHighlightReader* self;
        self = (kino_DefaultHighlightReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTHIGHLIGHTREADER, NULL);

        /* Execute */
        kino_DefHLReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDocReader_close);
XS(XS_KinoSearch_Index_DefaultDocReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDocReader* self;
        self = (kino_DefaultDocReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDOCREADER, NULL);

        /* Execute */
        kino_DefDocReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyDocReader_close);
XS(XS_KinoSearch_Index_PolyDocReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyDocReader* self;
        self = (kino_PolyDocReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYDOCREADER, NULL);

        /* Execute */
        kino_PolyDocReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexReader_close);
XS(XS_KinoSearch_Index_IndexReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexReader* self;
        self = (kino_IndexReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXREADER, NULL);

        /* Execute */
        kino_IxReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyReader_close);
XS(XS_KinoSearch_Index_PolyReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyReader* self;
        self = (kino_PolyReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYREADER, NULL);

        /* Execute */
        kino_PolyReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultSortReader_close);
XS(XS_KinoSearch_Index_DefaultSortReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultSortReader* self;
        self = (kino_DefaultSortReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTSORTREADER, NULL);

        /* Execute */
        kino_DefSortReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyDeletionsReader_close);
XS(XS_KinoSearch_Index_PolyDeletionsReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyDeletionsReader* self;
        self = (kino_PolyDeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYDELETIONSREADER, NULL);

        /* Execute */
        kino_PolyDelReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsReader_close);
XS(XS_KinoSearch_Index_DefaultDeletionsReader_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsReader* self;
        self = (kino_DefaultDeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSREADER, NULL);

        /* Execute */
        kino_DefDelReader_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingListReader_posting_list);
XS(XS_KinoSearch_Index_PostingListReader_posting_list)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PostingListReader* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        kino_PostingList* retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_PostingListReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLISTREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PostingListReader::posting_list_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( field_sv && XSBind_sv_defined(field_sv) ) {
            field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        }
        else {
            field = NULL;
        }
        if ( term_sv && XSBind_sv_defined(term_sv) ) {
            term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        }
        else {
            term = NULL;
        }

        /* Execute */
        retval = kino_PListReader_posting_list(self, field, term);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultPostingListReader_posting_list);
XS(XS_KinoSearch_Index_DefaultPostingListReader_posting_list)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DefaultPostingListReader* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        kino_SegPostingList* retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_DefaultPostingListReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTPOSTINGLISTREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultPostingListReader::posting_list_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( field_sv && XSBind_sv_defined(field_sv) ) {
            field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        }
        else {
            field = NULL;
        }
        if ( term_sv && XSBind_sv_defined(term_sv) ) {
            term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        }
        else {
            term = NULL;
        }

        /* Execute */
        retval = kino_DefPListReader_posting_list(self, field, term);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingListReader_get_lex_reader);
XS(XS_KinoSearch_Index_PostingListReader_get_lex_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingListReader* self;
        kino_LexiconReader* retval;
        self = (kino_PostingListReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGLISTREADER, NULL);

        /* Execute */
        retval = kino_PListReader_get_lex_reader(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultPostingListReader_get_lex_reader);
XS(XS_KinoSearch_Index_DefaultPostingListReader_get_lex_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultPostingListReader* self;
        kino_LexiconReader* retval;
        self = (kino_DefaultPostingListReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTPOSTINGLISTREADER, NULL);

        /* Execute */
        retval = kino_DefPListReader_get_lex_reader(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexiconReader_lexicon);
XS(XS_KinoSearch_Index_LexiconReader_lexicon)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_LexiconReader* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        kino_Lexicon* retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_LexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICONREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::LexiconReader::lexicon_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( term_sv && XSBind_sv_defined(term_sv) ) {
            term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        }
        else {
            term = NULL;
        }

        /* Execute */
        retval = kino_LexReader_lexicon(self, field, term);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyLexiconReader_lexicon);
XS(XS_KinoSearch_Index_PolyLexiconReader_lexicon)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PolyLexiconReader* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        kino_Lexicon* retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_PolyLexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYLEXICONREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PolyLexiconReader::lexicon_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( term_sv && XSBind_sv_defined(term_sv) ) {
            term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        }
        else {
            term = NULL;
        }

        /* Execute */
        retval = kino_PolyLexReader_lexicon(self, field, term);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultLexiconReader_lexicon);
XS(XS_KinoSearch_Index_DefaultLexiconReader_lexicon)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DefaultLexiconReader* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        kino_Lexicon* retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_DefaultLexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTLEXICONREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultLexiconReader::lexicon_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( term_sv && XSBind_sv_defined(term_sv) ) {
            term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;
        }
        else {
            term = NULL;
        }

        /* Execute */
        retval = kino_DefLexReader_lexicon(self, field, term);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexiconReader_doc_freq);
XS(XS_KinoSearch_Index_LexiconReader_doc_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_LexiconReader* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        uint32_t retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_LexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICONREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::LexiconReader::doc_freq_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_LexReader_doc_freq(self, field, term);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyLexiconReader_doc_freq);
XS(XS_KinoSearch_Index_PolyLexiconReader_doc_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_PolyLexiconReader* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        uint32_t retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_PolyLexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYLEXICONREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::PolyLexiconReader::doc_freq_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_PolyLexReader_doc_freq(self, field, term);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultLexiconReader_doc_freq);
XS(XS_KinoSearch_Index_DefaultLexiconReader_doc_freq)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DefaultLexiconReader* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        uint32_t retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_DefaultLexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTLEXICONREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultLexiconReader::doc_freq_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_DefLexReader_doc_freq(self, field, term);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexiconReader_fetch_term_info);
XS(XS_KinoSearch_Index_LexiconReader_fetch_term_info)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_LexiconReader* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        kino_TermInfo* retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_LexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICONREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::LexiconReader::fetch_term_info_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_LexReader_fetch_term_info(self, field, term);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultLexiconReader_fetch_term_info);
XS(XS_KinoSearch_Index_DefaultLexiconReader_fetch_term_info)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_DefaultLexiconReader* self;
        const kino_CharBuf* field;
        kino_Obj* term;
        kino_TermInfo* retval;
        SV* field_sv = NULL;
        SV* term_sv = NULL;
        self = (kino_DefaultLexiconReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTLEXICONREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::DefaultLexiconReader::fetch_term_info_PARAMS",             &field_sv, "field", 5,
            &term_sv, "term", 4,
 NULL);

        if ( !field_sv || !XSBind_sv_defined(field_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'field'"); }
         field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(field_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !term_sv || !XSBind_sv_defined(term_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'term'"); }
         term = (kino_Obj*)XSBind_sv_to_cfish_obj(term_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        retval = kino_DefLexReader_fetch_term_info(self, field, term);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DocReader_fetch_doc);
XS(XS_KinoSearch_Index_DocReader_fetch_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_DocReader* self;
        int32_t doc_id;
        kino_HitDoc* retval;
        self = (kino_DocReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOCREADER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_DocReader_fetch_doc(self, doc_id);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDocReader_fetch_doc);
XS(XS_KinoSearch_Index_DefaultDocReader_fetch_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDocReader* self;
        int32_t doc_id;
        kino_HitDoc* retval;
        self = (kino_DefaultDocReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDOCREADER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_DefDocReader_fetch_doc(self, doc_id);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyDocReader_fetch_doc);
XS(XS_KinoSearch_Index_PolyDocReader_fetch_doc)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyDocReader* self;
        int32_t doc_id;
        kino_HitDoc* retval;
        self = (kino_PolyDocReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYDOCREADER, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_PolyDocReader_fetch_doc(self, doc_id);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexReader_doc_max);
XS(XS_KinoSearch_Index_IndexReader_doc_max)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexReader* self;
        int32_t retval;
        self = (kino_IndexReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXREADER, NULL);

        /* Execute */
        retval = kino_IxReader_doc_max(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegReader_doc_max);
XS(XS_KinoSearch_Index_SegReader_doc_max)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegReader* self;
        int32_t retval;
        self = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGREADER, NULL);

        /* Execute */
        retval = kino_SegReader_doc_max(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyReader_doc_max);
XS(XS_KinoSearch_Index_PolyReader_doc_max)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyReader* self;
        int32_t retval;
        self = (kino_PolyReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYREADER, NULL);

        /* Execute */
        retval = kino_PolyReader_doc_max(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexReader_doc_count);
XS(XS_KinoSearch_Index_IndexReader_doc_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexReader* self;
        int32_t retval;
        self = (kino_IndexReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXREADER, NULL);

        /* Execute */
        retval = kino_IxReader_doc_count(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegReader_doc_count);
XS(XS_KinoSearch_Index_SegReader_doc_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegReader* self;
        int32_t retval;
        self = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGREADER, NULL);

        /* Execute */
        retval = kino_SegReader_doc_count(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyReader_doc_count);
XS(XS_KinoSearch_Index_PolyReader_doc_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyReader* self;
        int32_t retval;
        self = (kino_PolyReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYREADER, NULL);

        /* Execute */
        retval = kino_PolyReader_doc_count(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexReader_del_count);
XS(XS_KinoSearch_Index_IndexReader_del_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexReader* self;
        int32_t retval;
        self = (kino_IndexReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXREADER, NULL);

        /* Execute */
        retval = kino_IxReader_del_count(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegReader_del_count);
XS(XS_KinoSearch_Index_SegReader_del_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegReader* self;
        int32_t retval;
        self = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGREADER, NULL);

        /* Execute */
        retval = kino_SegReader_del_count(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyReader_del_count);
XS(XS_KinoSearch_Index_PolyReader_del_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyReader* self;
        int32_t retval;
        self = (kino_PolyReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYREADER, NULL);

        /* Execute */
        retval = kino_PolyReader_del_count(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexReader__offsets);
XS(XS_KinoSearch_Index_IndexReader__offsets)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexReader* self;
        kino_I32Array* retval;
        self = (kino_IndexReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXREADER, NULL);

        /* Execute */
        retval = kino_IxReader_offsets(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegReader__offsets);
XS(XS_KinoSearch_Index_SegReader__offsets)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegReader* self;
        kino_I32Array* retval;
        self = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGREADER, NULL);

        /* Execute */
        retval = kino_SegReader_offsets(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyReader__offsets);
XS(XS_KinoSearch_Index_PolyReader__offsets)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyReader* self;
        kino_I32Array* retval;
        self = (kino_PolyReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYREADER, NULL);

        /* Execute */
        retval = kino_PolyReader_offsets(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexReader_seg_readers);
XS(XS_KinoSearch_Index_IndexReader_seg_readers)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexReader* self;
        kino_VArray* retval;
        self = (kino_IndexReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXREADER, NULL);

        /* Execute */
        retval = kino_IxReader_seg_readers(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegReader_seg_readers);
XS(XS_KinoSearch_Index_SegReader_seg_readers)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegReader* self;
        kino_VArray* retval;
        self = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGREADER, NULL);

        /* Execute */
        retval = kino_SegReader_seg_readers(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyReader_seg_readers);
XS(XS_KinoSearch_Index_PolyReader_seg_readers)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyReader* self;
        kino_VArray* retval;
        self = (kino_PolyReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYREADER, NULL);

        /* Execute */
        retval = kino_PolyReader_seg_readers(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexReader_obtain);
XS(XS_KinoSearch_Index_IndexReader_obtain)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, api"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexReader* self;
        const kino_CharBuf* api;
        kino_DataReader* retval;
        self = (kino_IndexReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXREADER, NULL);
    api = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_IxReader_obtain(self, api);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexReader_fetch);
XS(XS_KinoSearch_Index_IndexReader_fetch)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, api"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexReader* self;
        const kino_CharBuf* api;
        kino_DataReader* retval;
        self = (kino_IndexReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXREADER, NULL);
    api = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_IxReader_fetch(self, api);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_IndexReader_get_components);
XS(XS_KinoSearch_Index_IndexReader_get_components)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_IndexReader* self;
        kino_Hash* retval;
        self = (kino_IndexReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_INDEXREADER, NULL);

        /* Execute */
        retval = kino_IxReader_get_components(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegReader_register);
XS(XS_KinoSearch_Index_SegReader_register)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_SegReader* self;
        const kino_CharBuf* api;
        kino_DataReader* component;
        SV* api_sv = NULL;
        SV* component_sv = NULL;
        self = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGREADER, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::SegReader::register_PARAMS",             &api_sv, "api", 3,
            &component_sv, "component", 9,
 NULL);

        if ( !api_sv || !XSBind_sv_defined(api_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'api'"); }
         api = (kino_CharBuf*)XSBind_sv_to_cfish_obj(api_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !component_sv || !XSBind_sv_defined(component_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'component'"); }
         component = (kino_DataReader*)XSBind_sv_to_cfish_obj(component_sv, KINO_DATAREADER, NULL);;

        /* Execute */
        if (component) (void)KINO_INCREF(component);
        kino_SegReader_register(self, api, component);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegReader_get_seg_name);
XS(XS_KinoSearch_Index_SegReader_get_seg_name)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegReader* self;
        kino_CharBuf* retval;
        self = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGREADER, NULL);

        /* Execute */
        retval = kino_SegReader_get_seg_name(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegReader_get_seg_num);
XS(XS_KinoSearch_Index_SegReader_get_seg_num)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegReader* self;
        int64_t retval;
        self = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGREADER, NULL);

        /* Execute */
        retval = kino_SegReader_get_seg_num(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyReader_get_seg_readers);
XS(XS_KinoSearch_Index_PolyReader_get_seg_readers)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyReader* self;
        kino_VArray* retval;
        self = (kino_PolyReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYREADER, NULL);

        /* Execute */
        retval = kino_PolyReader_get_seg_readers(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortReader_fetch_sort_cache);
XS(XS_KinoSearch_Index_SortReader_fetch_sort_cache)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, field"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortReader* self;
        const kino_CharBuf* field;
        kino_SortCache* retval;
        self = (kino_SortReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTREADER, NULL);
    field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_SortReader_fetch_sort_cache(self, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultSortReader_fetch_sort_cache);
XS(XS_KinoSearch_Index_DefaultSortReader_fetch_sort_cache)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, field"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultSortReader* self;
        const kino_CharBuf* field;
        kino_SortCache* retval;
        self = (kino_DefaultSortReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTSORTREADER, NULL);
    field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_DefSortReader_fetch_sort_cache(self, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DeletionsReader_del_count);
XS(XS_KinoSearch_Index_DeletionsReader_del_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DeletionsReader* self;
        int32_t retval;
        self = (kino_DeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DELETIONSREADER, NULL);

        /* Execute */
        retval = kino_DelReader_del_count(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyDeletionsReader_del_count);
XS(XS_KinoSearch_Index_PolyDeletionsReader_del_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyDeletionsReader* self;
        int32_t retval;
        self = (kino_PolyDeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYDELETIONSREADER, NULL);

        /* Execute */
        retval = kino_PolyDelReader_del_count(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsReader_del_count);
XS(XS_KinoSearch_Index_DefaultDeletionsReader_del_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsReader* self;
        int32_t retval;
        self = (kino_DefaultDeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSREADER, NULL);

        /* Execute */
        retval = kino_DefDelReader_del_count(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DeletionsReader_iterator);
XS(XS_KinoSearch_Index_DeletionsReader_iterator)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DeletionsReader* self;
        kino_Matcher* retval;
        self = (kino_DeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DELETIONSREADER, NULL);

        /* Execute */
        retval = kino_DelReader_iterator(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyDeletionsReader_iterator);
XS(XS_KinoSearch_Index_PolyDeletionsReader_iterator)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyDeletionsReader* self;
        kino_Matcher* retval;
        self = (kino_PolyDeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYDELETIONSREADER, NULL);

        /* Execute */
        retval = kino_PolyDelReader_iterator(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsReader_iterator);
XS(XS_KinoSearch_Index_DefaultDeletionsReader_iterator)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsReader* self;
        kino_Matcher* retval;
        self = (kino_DefaultDeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSREADER, NULL);

        /* Execute */
        retval = kino_DefDelReader_iterator(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_DefaultDeletionsReader_read_deletions);
XS(XS_KinoSearch_Index_DefaultDeletionsReader_read_deletions)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_DefaultDeletionsReader* self;
        kino_BitVector* retval;
        self = (kino_DefaultDeletionsReader*)XSBind_sv_to_cfish_obj(ST(0), KINO_DEFAULTDELETIONSREADER, NULL);

        /* Execute */
        retval = kino_DefDelReader_read_deletions(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_collect);
XS(XS_KinoSearch_Search_Collector_collect)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_Collector* self;
        int32_t doc_id;
        self = (kino_Collector*)XSBind_sv_to_cfish_obj(ST(0), KINO_COLLECTOR, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_Coll_collect(self, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_SortCollector_collect);
XS(XS_KinoSearch_Search_Collector_SortCollector_collect)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortCollector* self;
        int32_t doc_id;
        self = (kino_SortCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTCOLLECTOR, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_SortColl_collect(self, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_BitCollector_collect);
XS(XS_KinoSearch_Search_Collector_BitCollector_collect)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitCollector* self;
        int32_t doc_id;
        self = (kino_BitCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITCOLLECTOR, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_BitColl_collect(self, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_OffsetCollector_collect);
XS(XS_KinoSearch_Search_Collector_OffsetCollector_collect)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_OffsetCollector* self;
        int32_t doc_id;
        self = (kino_OffsetCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_OFFSETCOLLECTOR, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_OffsetColl_collect(self, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_set_reader);
XS(XS_KinoSearch_Search_Collector_set_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_Collector* self;
        kino_SegReader* reader;
        self = (kino_Collector*)XSBind_sv_to_cfish_obj(ST(0), KINO_COLLECTOR, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_Coll_set_reader(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_SortCollector_set_reader);
XS(XS_KinoSearch_Search_Collector_SortCollector_set_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortCollector* self;
        kino_SegReader* reader;
        self = (kino_SortCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTCOLLECTOR, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_SortColl_set_reader(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_OffsetCollector_set_reader);
XS(XS_KinoSearch_Search_Collector_OffsetCollector_set_reader)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, reader"); };
    {
        /* Extract vars from Perl stack. */
        kino_OffsetCollector* self;
        kino_SegReader* reader;
        self = (kino_OffsetCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_OFFSETCOLLECTOR, NULL);
    reader = (kino_SegReader*)XSBind_sv_to_cfish_obj(ST(1), KINO_SEGREADER, NULL);

        /* Execute */
        kino_OffsetColl_set_reader(self, reader);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_set_base);
XS(XS_KinoSearch_Search_Collector_set_base)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, base"); };
    {
        /* Extract vars from Perl stack. */
        kino_Collector* self;
        int32_t base;
        self = (kino_Collector*)XSBind_sv_to_cfish_obj(ST(0), KINO_COLLECTOR, NULL);
    base = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_Coll_set_base(self, base);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_OffsetCollector_set_base);
XS(XS_KinoSearch_Search_Collector_OffsetCollector_set_base)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, base"); };
    {
        /* Extract vars from Perl stack. */
        kino_OffsetCollector* self;
        int32_t base;
        self = (kino_OffsetCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_OFFSETCOLLECTOR, NULL);
    base = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_OffsetColl_set_base(self, base);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_need_score);
XS(XS_KinoSearch_Search_Collector_need_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Collector* self;
        chy_bool_t retval;
        self = (kino_Collector*)XSBind_sv_to_cfish_obj(ST(0), KINO_COLLECTOR, NULL);

        /* Execute */
        retval = kino_Coll_need_score(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_SortCollector_need_score);
XS(XS_KinoSearch_Search_Collector_SortCollector_need_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortCollector* self;
        chy_bool_t retval;
        self = (kino_SortCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTCOLLECTOR, NULL);

        /* Execute */
        retval = kino_SortColl_need_score(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_BitCollector_need_score);
XS(XS_KinoSearch_Search_Collector_BitCollector_need_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BitCollector* self;
        chy_bool_t retval;
        self = (kino_BitCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_BITCOLLECTOR, NULL);

        /* Execute */
        retval = kino_BitColl_need_score(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_OffsetCollector_need_score);
XS(XS_KinoSearch_Search_Collector_OffsetCollector_need_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_OffsetCollector* self;
        chy_bool_t retval;
        self = (kino_OffsetCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_OFFSETCOLLECTOR, NULL);

        /* Execute */
        retval = kino_OffsetColl_need_score(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_set_matcher);
XS(XS_KinoSearch_Search_Collector_set_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, matcher"); };
    {
        /* Extract vars from Perl stack. */
        kino_Collector* self;
        kino_Matcher* matcher;
        self = (kino_Collector*)XSBind_sv_to_cfish_obj(ST(0), KINO_COLLECTOR, NULL);
    matcher = (kino_Matcher*)XSBind_sv_to_cfish_obj(ST(1), KINO_MATCHER, NULL);

        /* Execute */
        kino_Coll_set_matcher(self, matcher);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_OffsetCollector_set_matcher);
XS(XS_KinoSearch_Search_Collector_OffsetCollector_set_matcher)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, matcher"); };
    {
        /* Extract vars from Perl stack. */
        kino_OffsetCollector* self;
        kino_Matcher* matcher;
        self = (kino_OffsetCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_OFFSETCOLLECTOR, NULL);
    matcher = (kino_Matcher*)XSBind_sv_to_cfish_obj(ST(1), KINO_MATCHER, NULL);

        /* Execute */
        kino_OffsetColl_set_matcher(self, matcher);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_SortCollector_pop_match_docs);
XS(XS_KinoSearch_Search_Collector_SortCollector_pop_match_docs)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortCollector* self;
        kino_VArray* retval;
        self = (kino_SortCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTCOLLECTOR, NULL);

        /* Execute */
        retval = kino_SortColl_pop_match_docs(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_Collector_SortCollector_get_total_hits);
XS(XS_KinoSearch_Search_Collector_SortCollector_get_total_hits)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortCollector* self;
        uint32_t retval;
        self = (kino_SortCollector*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTCOLLECTOR, NULL);

        /* Execute */
        retval = kino_SortColl_get_total_hits(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_architecture);
XS(XS_KinoSearch_Plan_Schema_architecture)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        kino_Architecture* retval;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);

        /* Execute */
        retval = kino_Schema_architecture(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_TestSchema_architecture);
XS(XS_KinoSearch_Test_TestSchema_architecture)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_TestSchema* self;
        kino_Architecture* retval;
        self = (kino_TestSchema*)XSBind_sv_to_cfish_obj(ST(0), KINO_TESTSCHEMA, NULL);

        /* Execute */
        retval = kino_TestSchema_architecture(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_spec_field);
XS(XS_KinoSearch_Plan_Schema_spec_field)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        const kino_CharBuf* name;
        kino_FieldType* type;
        SV* name_sv = NULL;
        SV* type_sv = NULL;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::Schema::spec_field_PARAMS",             &name_sv, "name", 4,
            &type_sv, "type", 4,
 NULL);

        if ( !name_sv || !XSBind_sv_defined(name_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'name'"); }
         name = (kino_CharBuf*)XSBind_sv_to_cfish_obj(name_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !type_sv || !XSBind_sv_defined(type_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'type'"); }
         type = (kino_FieldType*)XSBind_sv_to_cfish_obj(type_sv, KINO_FIELDTYPE, NULL);;

        /* Execute */
        kino_Schema_spec_field(self, name, type);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_fetch_type);
XS(XS_KinoSearch_Plan_Schema_fetch_type)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, field"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        const kino_CharBuf* field;
        kino_FieldType* retval;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);
    field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Schema_fetch_type(self, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_fetch_analyzer);
XS(XS_KinoSearch_Plan_Schema_fetch_analyzer)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        const kino_CharBuf* field;
        kino_Analyzer* retval;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else { 
            field = NULL;
        }

        /* Execute */
        retval = kino_Schema_fetch_analyzer(self, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_fetch_sim);
XS(XS_KinoSearch_Plan_Schema_fetch_sim)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        const kino_CharBuf* field;
        kino_Similarity* retval;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));
        }
        else { 
            field = NULL;
        }

        /* Execute */
        retval = kino_Schema_fetch_sim(self, field);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_num_fields);
XS(XS_KinoSearch_Plan_Schema_num_fields)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        uint32_t retval;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);

        /* Execute */
        retval = kino_Schema_num_fields(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_all_fields);
XS(XS_KinoSearch_Plan_Schema_all_fields)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        kino_VArray* retval;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);

        /* Execute */
        retval = kino_Schema_all_fields(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);KINO_DECREF(retval);

        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_get_architecture);
XS(XS_KinoSearch_Plan_Schema_get_architecture)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        kino_Architecture* retval;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);

        /* Execute */
        retval = kino_Schema_get_architecture(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_get_similarity);
XS(XS_KinoSearch_Plan_Schema_get_similarity)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        kino_Similarity* retval;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);

        /* Execute */
        retval = kino_Schema_get_similarity(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_eat);
XS(XS_KinoSearch_Plan_Schema_eat)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, other"); };
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        kino_Schema* other;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);
    other = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(1), KINO_SCHEMA, NULL);

        /* Execute */
        kino_Schema_eat(self, other);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Plan_Schema_write);
XS(XS_KinoSearch_Plan_Schema_write)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Schema* self;
        kino_Folder* folder;
        const kino_CharBuf* filename;
        SV* folder_sv = NULL;
        SV* filename_sv = NULL;
        self = (kino_Schema*)XSBind_sv_to_cfish_obj(ST(0), KINO_SCHEMA, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Plan::Schema::write_PARAMS",             &folder_sv, "folder", 6,
            &filename_sv, "filename", 8,
 NULL);

        if ( !folder_sv || !XSBind_sv_defined(folder_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'folder'"); }
         folder = (kino_Folder*)XSBind_sv_to_cfish_obj(folder_sv, KINO_FOLDER, NULL);;
        if ( filename_sv && XSBind_sv_defined(filename_sv) ) {
            filename = (kino_CharBuf*)XSBind_sv_to_cfish_obj(filename_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        }
        else {
            filename = NULL;
        }

        /* Execute */
        kino_Schema_write(self, folder, filename);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_Doc_set_doc_id);
XS(XS_KinoSearch_Document_Doc_set_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_Doc* self;
        int32_t doc_id;
        self = (kino_Doc*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOC, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_Doc_set_doc_id(self, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_Doc_get_doc_id);
XS(XS_KinoSearch_Document_Doc_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Doc* self;
        int32_t retval;
        self = (kino_Doc*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOC, NULL);

        /* Execute */
        retval = kino_Doc_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_Doc_set_fields);
XS(XS_KinoSearch_Document_Doc_set_fields)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, fields"); };
    {
        /* Extract vars from Perl stack. */
        kino_Doc* self;
        void* fields;
        self = (kino_Doc*)XSBind_sv_to_cfish_obj(ST(0), KINO_DOC, NULL);
    if (SvROK(ST(1))) {
            fields = SvRV(ST(1));
        }
        else {
            fields = NULL; /* avoid uninitialized compiler warning */
            CFISH_THROW(CFISH_ERR, "fields is not a reference");
        }


        /* Execute */
        kino_Doc_set_fields(self, fields);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_HitDoc_set_score);
XS(XS_KinoSearch_Document_HitDoc_set_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, score"); };
    {
        /* Extract vars from Perl stack. */
        kino_HitDoc* self;
        float score;
        self = (kino_HitDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITDOC, NULL);
    score = (float)SvNV( ST(1) );

        /* Execute */
        kino_HitDoc_set_score(self, score);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Document_HitDoc_get_score);
XS(XS_KinoSearch_Document_HitDoc_get_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_HitDoc* self;
        float retval;
        self = (kino_HitDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_HITDOC, NULL);

        /* Execute */
        retval = kino_HitDoc_get_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_SortExternal_flush);
XS(XS_KinoSearch_Util_SortExternal_flush)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortExternal* self;
        self = (kino_SortExternal*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTEXTERNAL, NULL);

        /* Execute */
        kino_SortEx_flush(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_Util_BBSortEx_flush);
XS(XS_KinoSearch_Test_Util_BBSortEx_flush)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BBSortEx* self;
        self = (kino_BBSortEx*)XSBind_sv_to_cfish_obj(ST(0), KINO_BBSORTEX, NULL);

        /* Execute */
        kino_BBSortEx_flush(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingPool_flush);
XS(XS_KinoSearch_Index_PostingPool_flush)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingPool* self;
        self = (kino_PostingPool*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGPOOL, NULL);

        /* Execute */
        kino_PostPool_flush(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortFieldWriter_flush);
XS(XS_KinoSearch_Index_SortFieldWriter_flush)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortFieldWriter* self;
        self = (kino_SortFieldWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTFIELDWRITER, NULL);

        /* Execute */
        kino_SortFieldWriter_flush(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_SortExternal_flip);
XS(XS_KinoSearch_Util_SortExternal_flip)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortExternal* self;
        self = (kino_SortExternal*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTEXTERNAL, NULL);

        /* Execute */
        kino_SortEx_flip(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_Util_BBSortEx_flip);
XS(XS_KinoSearch_Test_Util_BBSortEx_flip)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BBSortEx* self;
        self = (kino_BBSortEx*)XSBind_sv_to_cfish_obj(ST(0), KINO_BBSORTEX, NULL);

        /* Execute */
        kino_BBSortEx_flip(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingPool_flip);
XS(XS_KinoSearch_Index_PostingPool_flip)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingPool* self;
        self = (kino_PostingPool*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGPOOL, NULL);

        /* Execute */
        kino_PostPool_flip(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortFieldWriter_flip);
XS(XS_KinoSearch_Index_SortFieldWriter_flip)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortFieldWriter* self;
        self = (kino_SortFieldWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTFIELDWRITER, NULL);

        /* Execute */
        kino_SortFieldWriter_flip(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_SortExternal_add_run);
XS(XS_KinoSearch_Util_SortExternal_add_run)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, run"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortExternal* self;
        kino_SortExternal* run;
        self = (kino_SortExternal*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTEXTERNAL, NULL);
    run = (kino_SortExternal*)XSBind_sv_to_cfish_obj(ST(1), KINO_SORTEXTERNAL, NULL);

        /* Execute */
        if (run) (void)KINO_INCREF(run);
        kino_SortEx_add_run(self, run);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_SortExternal_refill);
XS(XS_KinoSearch_Util_SortExternal_refill)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortExternal* self;
        uint32_t retval;
        self = (kino_SortExternal*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTEXTERNAL, NULL);

        /* Execute */
        retval = kino_SortEx_refill(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_Util_BBSortEx_refill);
XS(XS_KinoSearch_Test_Util_BBSortEx_refill)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BBSortEx* self;
        uint32_t retval;
        self = (kino_BBSortEx*)XSBind_sv_to_cfish_obj(ST(0), KINO_BBSORTEX, NULL);

        /* Execute */
        retval = kino_BBSortEx_refill(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PostingPool_refill);
XS(XS_KinoSearch_Index_PostingPool_refill)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PostingPool* self;
        uint32_t retval;
        self = (kino_PostingPool*)XSBind_sv_to_cfish_obj(ST(0), KINO_POSTINGPOOL, NULL);

        /* Execute */
        retval = kino_PostPool_refill(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortFieldWriter_refill);
XS(XS_KinoSearch_Index_SortFieldWriter_refill)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortFieldWriter* self;
        uint32_t retval;
        self = (kino_SortFieldWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTFIELDWRITER, NULL);

        /* Execute */
        retval = kino_SortFieldWriter_refill(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_SortExternal_sort_cache);
XS(XS_KinoSearch_Util_SortExternal_sort_cache)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortExternal* self;
        self = (kino_SortExternal*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTEXTERNAL, NULL);

        /* Execute */
        kino_SortEx_sort_cache(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_SortExternal_clear_cache);
XS(XS_KinoSearch_Util_SortExternal_clear_cache)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortExternal* self;
        self = (kino_SortExternal*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTEXTERNAL, NULL);

        /* Execute */
        kino_SortEx_clear_cache(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Test_Util_BBSortEx_clear_cache);
XS(XS_KinoSearch_Test_Util_BBSortEx_clear_cache)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_BBSortEx* self;
        self = (kino_BBSortEx*)XSBind_sv_to_cfish_obj(ST(0), KINO_BBSORTEX, NULL);

        /* Execute */
        kino_BBSortEx_clear_cache(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SortFieldWriter_clear_cache);
XS(XS_KinoSearch_Index_SortFieldWriter_clear_cache)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortFieldWriter* self;
        self = (kino_SortFieldWriter*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTFIELDWRITER, NULL);

        /* Execute */
        kino_SortFieldWriter_clear_cache(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_SortExternal_cache_count);
XS(XS_KinoSearch_Util_SortExternal_cache_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortExternal* self;
        uint32_t retval;
        self = (kino_SortExternal*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTEXTERNAL, NULL);

        /* Execute */
        retval = kino_SortEx_cache_count(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Util_SortExternal_set_mem_thresh);
XS(XS_KinoSearch_Util_SortExternal_set_mem_thresh)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, mem_thresh"); };
    {
        /* Extract vars from Perl stack. */
        kino_SortExternal* self;
        uint32_t mem_thresh;
        self = (kino_SortExternal*)XSBind_sv_to_cfish_obj(ST(0), KINO_SORTEXTERNAL, NULL);
    mem_thresh = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_SortEx_set_mem_thresh(self, mem_thresh);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchDoc_get_doc_id);
XS(XS_KinoSearch_Search_MatchDoc_get_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchDoc* self;
        int32_t retval;
        self = (kino_MatchDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHDOC, NULL);

        /* Execute */
        retval = kino_MatchDoc_get_doc_id(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchDoc_set_doc_id);
XS(XS_KinoSearch_Search_MatchDoc_set_doc_id)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, doc_id"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchDoc* self;
        int32_t doc_id;
        self = (kino_MatchDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHDOC, NULL);
    doc_id = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_MatchDoc_set_doc_id(self, doc_id);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchDoc_get_score);
XS(XS_KinoSearch_Search_MatchDoc_get_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchDoc* self;
        float retval;
        self = (kino_MatchDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHDOC, NULL);

        /* Execute */
        retval = kino_MatchDoc_get_score(self);
        ST(0) = newSVnv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchDoc_set_score);
XS(XS_KinoSearch_Search_MatchDoc_set_score)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, score"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchDoc* self;
        float score;
        self = (kino_MatchDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHDOC, NULL);
    score = (float)SvNV( ST(1) );

        /* Execute */
        kino_MatchDoc_set_score(self, score);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchDoc_get_values);
XS(XS_KinoSearch_Search_MatchDoc_get_values)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchDoc* self;
        kino_VArray* retval;
        self = (kino_MatchDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHDOC, NULL);

        /* Execute */
        retval = kino_MatchDoc_get_values(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Search_MatchDoc_set_values);
XS(XS_KinoSearch_Search_MatchDoc_set_values)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, values"); };
    {
        /* Extract vars from Perl stack. */
        kino_MatchDoc* self;
        kino_VArray* values;
        self = (kino_MatchDoc*)XSBind_sv_to_cfish_obj(ST(0), KINO_MATCHDOC, NULL);
    values = (kino_VArray*)XSBind_sv_to_cfish_obj(ST(1), KINO_VARRAY, NULL);

        /* Execute */
        kino_MatchDoc_set_values(self, values);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_add_field);
XS(XS_KinoSearch_Index_Segment_add_field)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, field"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        const kino_CharBuf* field;
        int32_t retval;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);
    field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Seg_add_field(self, field);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment__store_metadata);
XS(XS_KinoSearch_Index_Segment__store_metadata)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, ..."); };
    SP -= items;
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        const kino_CharBuf* key;
        kino_Obj* metadata;
        SV* key_sv = NULL;
        SV* metadata_sv = NULL;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);
        XSBind_allot_params( &(ST(0)), 1, items, "KinoSearch::Index::Segment::_store_metadata_PARAMS",             &key_sv, "key", 3,
            &metadata_sv, "metadata", 8,
 NULL);

        if ( !key_sv || !XSBind_sv_defined(key_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'key'"); }
         key = (kino_CharBuf*)XSBind_sv_to_cfish_obj(key_sv, KINO_CHARBUF, alloca(cfish_ZCB_size()));;
        if ( !metadata_sv || !XSBind_sv_defined(metadata_sv) ) { CFISH_THROW(CFISH_ERR, "Missing required param 'metadata'"); }
         metadata = (kino_Obj*)XSBind_sv_to_cfish_obj(metadata_sv, KINO_OBJ, alloca(cfish_ZCB_size()));;

        /* Execute */
        if (metadata) (void)KINO_INCREF(metadata);
        kino_Seg_store_metadata(self, key, metadata);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_fetch_metadata);
XS(XS_KinoSearch_Index_Segment_fetch_metadata)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, key"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        const kino_CharBuf* key;
        kino_Obj* retval;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);
    key = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Seg_fetch_metadata(self, key);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_field_num);
XS(XS_KinoSearch_Index_Segment_field_num)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, field"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        const kino_CharBuf* field;
        int32_t retval;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);
    field = (kino_CharBuf*)XSBind_sv_to_cfish_obj(ST(1), KINO_CHARBUF, alloca(cfish_ZCB_size()));

        /* Execute */
        retval = kino_Seg_field_num(self, field);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_field_name);
XS(XS_KinoSearch_Index_Segment_field_name)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, field_num"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        int32_t field_num;
        kino_CharBuf* retval;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);
    field_num = (int32_t)SvIV( ST(1) );

        /* Execute */
        retval = kino_Seg_field_name(self, field_num);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_get_name);
XS(XS_KinoSearch_Index_Segment_get_name)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        kino_CharBuf* retval;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);

        /* Execute */
        retval = kino_Seg_get_name(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_get_number);
XS(XS_KinoSearch_Index_Segment_get_number)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        int64_t retval;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);

        /* Execute */
        retval = kino_Seg_get_number(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_set_count);
XS(XS_KinoSearch_Index_Segment_set_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, count"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        int64_t count;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);
    count = (int64_t)SvNV( ST(1) );

        /* Execute */
        kino_Seg_set_count(self, count);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_get_count);
XS(XS_KinoSearch_Index_Segment_get_count)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        int64_t retval;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);

        /* Execute */
        retval = kino_Seg_get_count(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_write_file);
XS(XS_KinoSearch_Index_Segment_write_file)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, folder"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        kino_Folder* folder;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);
    folder = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(1), KINO_FOLDER, NULL);

        /* Execute */
        kino_Seg_write_file(self, folder);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Segment_read_file);
XS(XS_KinoSearch_Index_Segment_read_file)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, folder"); };
    {
        /* Extract vars from Perl stack. */
        kino_Segment* self;
        kino_Folder* folder;
        chy_bool_t retval;
        self = (kino_Segment*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGMENT, NULL);
    folder = (kino_Folder*)XSBind_sv_to_cfish_obj(ST(1), KINO_FOLDER, NULL);

        /* Execute */
        retval = kino_Seg_read_file(self, folder);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Lexicon_seek);
XS(XS_KinoSearch_Index_Lexicon_seek)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lexicon* self;
        kino_Obj* target;
        self = (kino_Lexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICON, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            target = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));
        }
        else { 
            target = NULL;
        }

        /* Execute */
        kino_Lex_seek(self, target);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegLexicon_seek);
XS(XS_KinoSearch_Index_SegLexicon_seek)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegLexicon* self;
        kino_Obj* target;
        self = (kino_SegLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGLEXICON, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            target = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));
        }
        else { 
            target = NULL;
        }

        /* Execute */
        kino_SegLex_seek(self, target);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyLexicon_seek);
XS(XS_KinoSearch_Index_PolyLexicon_seek)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyLexicon* self;
        kino_Obj* target;
        self = (kino_PolyLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYLEXICON, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            target = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));
        }
        else { 
            target = NULL;
        }

        /* Execute */
        kino_PolyLex_seek(self, target);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexIndex_seek);
XS(XS_KinoSearch_Index_LexIndex_seek)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items < 1) { CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LexIndex* self;
        kino_Obj* target;
        self = (kino_LexIndex*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXINDEX, NULL);
        if ( items >= 1 && XSBind_sv_defined(ST(1)) ) {
            target = (kino_Obj*)XSBind_sv_to_cfish_obj(ST(1), KINO_OBJ, alloca(cfish_ZCB_size()));
        }
        else { 
            target = NULL;
        }

        /* Execute */
        kino_LexIndex_seek(self, target);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Lexicon_next);
XS(XS_KinoSearch_Index_Lexicon_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lexicon* self;
        chy_bool_t retval;
        self = (kino_Lexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICON, NULL);

        /* Execute */
        retval = kino_Lex_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegLexicon_next);
XS(XS_KinoSearch_Index_SegLexicon_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegLexicon* self;
        chy_bool_t retval;
        self = (kino_SegLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGLEXICON, NULL);

        /* Execute */
        retval = kino_SegLex_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyLexicon_next);
XS(XS_KinoSearch_Index_PolyLexicon_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyLexicon* self;
        chy_bool_t retval;
        self = (kino_PolyLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYLEXICON, NULL);

        /* Execute */
        retval = kino_PolyLex_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_RawLexicon_next);
XS(XS_KinoSearch_Index_RawLexicon_next)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RawLexicon* self;
        chy_bool_t retval;
        self = (kino_RawLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAWLEXICON, NULL);

        /* Execute */
        retval = kino_RawLex_next(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Lexicon_reset);
XS(XS_KinoSearch_Index_Lexicon_reset)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lexicon* self;
        self = (kino_Lexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICON, NULL);

        /* Execute */
        kino_Lex_reset(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegLexicon_reset);
XS(XS_KinoSearch_Index_SegLexicon_reset)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegLexicon* self;
        self = (kino_SegLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGLEXICON, NULL);

        /* Execute */
        kino_SegLex_reset(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyLexicon_reset);
XS(XS_KinoSearch_Index_PolyLexicon_reset)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyLexicon* self;
        self = (kino_PolyLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYLEXICON, NULL);

        /* Execute */
        kino_PolyLex_reset(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Lexicon_get_term);
XS(XS_KinoSearch_Index_Lexicon_get_term)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lexicon* self;
        kino_Obj* retval;
        self = (kino_Lexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICON, NULL);

        /* Execute */
        retval = kino_Lex_get_term(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegLexicon_get_term);
XS(XS_KinoSearch_Index_SegLexicon_get_term)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegLexicon* self;
        kino_Obj* retval;
        self = (kino_SegLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGLEXICON, NULL);

        /* Execute */
        retval = kino_SegLex_get_term(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_PolyLexicon_get_term);
XS(XS_KinoSearch_Index_PolyLexicon_get_term)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_PolyLexicon* self;
        kino_Obj* retval;
        self = (kino_PolyLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_POLYLEXICON, NULL);

        /* Execute */
        retval = kino_PolyLex_get_term(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_LexIndex_get_term);
XS(XS_KinoSearch_Index_LexIndex_get_term)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_LexIndex* self;
        kino_Obj* retval;
        self = (kino_LexIndex*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXINDEX, NULL);

        /* Execute */
        retval = kino_LexIndex_get_term(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_RawLexicon_get_term);
XS(XS_KinoSearch_Index_RawLexicon_get_term)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_RawLexicon* self;
        kino_Obj* retval;
        self = (kino_RawLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_RAWLEXICON, NULL);

        /* Execute */
        retval = kino_RawLex_get_term(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_Lexicon_get_field);
XS(XS_KinoSearch_Index_Lexicon_get_field)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_Lexicon* self;
        kino_CharBuf* retval;
        self = (kino_Lexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_LEXICON, NULL);

        /* Execute */
        retval = kino_Lex_get_field(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegLexicon_get_term_info);
XS(XS_KinoSearch_Index_SegLexicon_get_term_info)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegLexicon* self;
        kino_TermInfo* retval;
        self = (kino_SegLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGLEXICON, NULL);

        /* Execute */
        retval = kino_SegLex_get_term_info(self);
        ST(0) = retval == NULL ? newSV(0) : XSBind_cfish_to_perl((cfish_Obj*)retval);
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_SegLexicon_get_field_num);
XS(XS_KinoSearch_Index_SegLexicon_get_field_num)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_SegLexicon* self;
        int32_t retval;
        self = (kino_SegLexicon*)XSBind_sv_to_cfish_obj(ST(0), KINO_SEGLEXICON, NULL);

        /* Execute */
        retval = kino_SegLex_get_field_num(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Index_FilePurger_purge);
XS(XS_KinoSearch_Index_FilePurger_purge)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_FilePurger* self;
        self = (kino_FilePurger*)XSBind_sv_to_cfish_obj(ST(0), KINO_FILEPURGER, NULL);

        /* Execute */
        kino_FilePurger_purge(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_tell);
XS(XS_KinoSearch_Store_OutStream_tell)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        int64_t retval;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);

        /* Execute */
        retval = kino_OutStream_tell(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_flush);
XS(XS_KinoSearch_Store_OutStream_flush)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_OutStream_flush(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_length);
XS(XS_KinoSearch_Store_OutStream_length)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        int64_t retval;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);

        /* Execute */
        retval = kino_OutStream_length(self);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_write_i8);
XS(XS_KinoSearch_Store_OutStream_write_i8)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        int8_t value;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    value = (int8_t)SvIV( ST(1) );

        /* Execute */
        kino_OutStream_write_i8(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_write_u8);
XS(XS_KinoSearch_Store_OutStream_write_u8)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        uint8_t value;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    value = (uint8_t)SvUV( ST(1) );

        /* Execute */
        kino_OutStream_write_u8(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_write_i32);
XS(XS_KinoSearch_Store_OutStream_write_i32)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        int32_t value;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    value = (int32_t)SvIV( ST(1) );

        /* Execute */
        kino_OutStream_write_i32(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_write_u32);
XS(XS_KinoSearch_Store_OutStream_write_u32)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        uint32_t value;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    value = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_OutStream_write_u32(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_write_i64);
XS(XS_KinoSearch_Store_OutStream_write_i64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        int64_t value;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    value = (int64_t)SvNV( ST(1) );

        /* Execute */
        kino_OutStream_write_i64(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_write_u64);
XS(XS_KinoSearch_Store_OutStream_write_u64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        uint64_t value;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    value = (uint64_t)SvNV( ST(1) );

        /* Execute */
        kino_OutStream_write_u64(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_write_c32);
XS(XS_KinoSearch_Store_OutStream_write_c32)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        uint32_t value;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    value = (uint32_t)SvUV( ST(1) );

        /* Execute */
        kino_OutStream_write_c32(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_write_c64);
XS(XS_KinoSearch_Store_OutStream_write_c64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        uint64_t value;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    value = (uint64_t)SvNV( ST(1) );

        /* Execute */
        kino_OutStream_write_c64(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_write_f32);
XS(XS_KinoSearch_Store_OutStream_write_f32)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        float value;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    value = (float)SvNV( ST(1) );

        /* Execute */
        kino_OutStream_write_f32(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_write_f64);
XS(XS_KinoSearch_Store_OutStream_write_f64)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, value"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        double value;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    value = SvNV( ST(1) );

        /* Execute */
        kino_OutStream_write_f64(self, value);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_absorb);
XS(XS_KinoSearch_Store_OutStream_absorb)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, instream"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        kino_InStream* instream;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);
    instream = (kino_InStream*)XSBind_sv_to_cfish_obj(ST(1), KINO_INSTREAM, NULL);

        /* Execute */
        kino_OutStream_absorb(self, instream);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Store_OutStream_close);
XS(XS_KinoSearch_Store_OutStream_close)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_OutStream* self;
        self = (kino_OutStream*)XSBind_sv_to_cfish_obj(ST(0), KINO_OUTSTREAM, NULL);

        /* Execute */
        kino_OutStream_close(self);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_I32Array_get);
XS(XS_KinoSearch_Object_I32Array_get)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 2) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self, tick"); };
    {
        /* Extract vars from Perl stack. */
        kino_I32Array* self;
        uint32_t tick;
        int32_t retval;
        self = (kino_I32Array*)XSBind_sv_to_cfish_obj(ST(0), KINO_I32ARRAY, NULL);
    tick = (uint32_t)SvUV( ST(1) );

        /* Execute */
        retval = kino_I32Arr_get(self, tick);
        ST(0) = newSViv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}

XS(XS_KinoSearch_Object_I32Array_get_size);
XS(XS_KinoSearch_Object_I32Array_get_size)
{
    dXSARGS;
    CHY_UNUSED_VAR(cv);
    CHY_UNUSED_VAR(ax);
    SP -= items;
    if (items != 1) {  CFISH_THROW(CFISH_ERR, "Usage: %s(%s)",  GvNAME(CvGV(cv)), "self"); };
    {
        /* Extract vars from Perl stack. */
        kino_I32Array* self;
        uint32_t retval;
        self = (kino_I32Array*)XSBind_sv_to_cfish_obj(ST(0), KINO_I32ARRAY, NULL);

        /* Execute */
        retval = kino_I32Arr_get_size(self);
        ST(0) = newSVuv( retval );
        sv_2mortal( ST(0) );
        XSRETURN(1);
    }
    PUTBACK;
}



MODULE = KinoSearch   PACKAGE = KinoSearch::Autobinding

void
init_autobindings()
PPCODE:
{
    char* file = __FILE__;
    CHY_UNUSED_VAR(cv); 
    CHY_UNUSED_VAR(items); newXS("KinoSearch::Object::Obj::new", XS_KinoSearch_Object_Obj_new, file);
    newXS("KinoSearch::Highlight::Highlighter::new", XS_KinoSearch_Highlight_Highlighter_new, file);
    newXS("KinoSearch::Index::TermInfo::new", XS_KinoSearch_Index_TermInfo_new, file);
    newXS("KinoSearch::Index::Inverter::new", XS_KinoSearch_Index_Inverter_new, file);
    newXS("KinoSearch::Index::DocVector::new", XS_KinoSearch_Index_DocVector_new, file);
    newXS("KinoSearch::Store::Lock::new", XS_KinoSearch_Store_Lock_new, file);
    newXS("KinoSearch::Store::LockFileLock::new", XS_KinoSearch_Store_LockFileLock_new, file);
    newXS("KinoSearch::Store::SharedLock::new", XS_KinoSearch_Store_SharedLock_new, file);
    newXS("KinoSearch::Search::QueryParser::new", XS_KinoSearch_Search_QueryParser_new, file);
    newXS("KinoSearch::Index::IndexManager::new", XS_KinoSearch_Index_IndexManager_new, file);
    newXS("KinoSearch::Search::TopDocs::new", XS_KinoSearch_Search_TopDocs_new, file);
    newXS("KinoSearch::Index::Snapshot::new", XS_KinoSearch_Index_Snapshot_new, file);
    newXS("KinoSearch::Search::SortRule::_new", XS_KinoSearch_Search_SortRule__new, file);
    newXS("KinoSearch::Highlight::HeatMap::new", XS_KinoSearch_Highlight_HeatMap_new, file);
    newXS("KinoSearch::Object::LockFreeRegistry::new", XS_KinoSearch_Object_LockFreeRegistry_new, file);
    newXS("KinoSearch::Util::MemoryPool::new", XS_KinoSearch_Util_MemoryPool_new, file);
    newXS("KinoSearch::Index::SortCache::new", XS_KinoSearch_Index_SortCache_new, file);
    newXS("KinoSearch::Store::LockFactory::new", XS_KinoSearch_Store_LockFactory_new, file);
    newXS("KinoSearch::Store::FileHandle::_open", XS_KinoSearch_Store_FileHandle__open, file);
    newXS("KinoSearch::Store::FSFileHandle::_open", XS_KinoSearch_Store_FSFileHandle__open, file);
    newXS("KinoSearch::Store::RAMFileHandle::_open", XS_KinoSearch_Store_RAMFileHandle__open, file);
    newXS("KinoSearch::Search::SortSpec::new", XS_KinoSearch_Search_SortSpec_new, file);
    newXS("KinoSearch::Object::Err::_new", XS_KinoSearch_Object_Err__new, file);
    newXS("KinoSearch::Index::DataWriter::new", XS_KinoSearch_Index_DataWriter_new, file);
    newXS("KinoSearch::Index::HighlightWriter::new", XS_KinoSearch_Index_HighlightWriter_new, file);
    newXS("KinoSearch::Index::LexiconWriter::new", XS_KinoSearch_Index_LexiconWriter_new, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::new", XS_KinoSearch_Index_DefaultDeletionsWriter_new, file);
    newXS("KinoSearch::Index::PostingListWriter::new", XS_KinoSearch_Index_PostingListWriter_new, file);
    newXS("KinoSearch::Index::DocWriter::new", XS_KinoSearch_Index_DocWriter_new, file);
    newXS("KinoSearch::Index::SortWriter::new", XS_KinoSearch_Index_SortWriter_new, file);
    newXS("KinoSearch::Index::SegWriter::new", XS_KinoSearch_Index_SegWriter_new, file);
    newXS("KinoSearch::Index::BackgroundMerger::new", XS_KinoSearch_Index_BackgroundMerger_new, file);
    newXS("KinoSearch::Store::RAMFile::new", XS_KinoSearch_Store_RAMFile_new, file);
    newXS("KinoSearch::Object::BitVector::new", XS_KinoSearch_Object_BitVector_new, file);
    newXS("KinoSearch::Index::Posting::MatchPosting::new", XS_KinoSearch_Index_Posting_MatchPosting_new, file);
    newXS("KinoSearch::Index::Posting::ScorePosting::new", XS_KinoSearch_Index_Posting_ScorePosting_new, file);
    newXS("KinoSearch::Index::Posting::RichPosting::new", XS_KinoSearch_Index_Posting_RichPosting_new, file);
    newXS("KinoSearch::Plan::Architecture::new", XS_KinoSearch_Plan_Architecture_new, file);
    newXS("KinoSearch::Plan::FieldType::new", XS_KinoSearch_Plan_FieldType_new, file);
    newXS("KinoSearch::Plan::StringType::new", XS_KinoSearch_Plan_StringType_new, file);
    newXS("KinoSearch::Plan::FullTextType::new", XS_KinoSearch_Plan_FullTextType_new, file);
    newXS("KinoSearch::Plan::Float32Type::new", XS_KinoSearch_Plan_Float32Type_new, file);
    newXS("KinoSearch::Plan::Float64Type::new", XS_KinoSearch_Plan_Float64Type_new, file);
    newXS("KinoSearch::Plan::Int64Type::new", XS_KinoSearch_Plan_Int64Type_new, file);
    newXS("KinoSearch::Plan::Int32Type::new", XS_KinoSearch_Plan_Int32Type_new, file);
    newXS("KinoSearch::Plan::BlobType::new", XS_KinoSearch_Plan_BlobType_new, file);
    newXS("KinoSearch::Search::Span::new", XS_KinoSearch_Search_Span_new, file);
    newXS("KinoSearch::Store::Folder::new", XS_KinoSearch_Store_Folder_new, file);
    newXS("KinoSearch::Store::FSFolder::new", XS_KinoSearch_Store_FSFolder_new, file);
    newXS("KinoSearch::Store::RAMFolder::new", XS_KinoSearch_Store_RAMFolder_new, file);
    newXS("KinoSearch::Util::PriorityQueue::new", XS_KinoSearch_Util_PriorityQueue_new, file);
    newXS("KinoSearch::Search::HitQueue::new", XS_KinoSearch_Search_HitQueue_new, file);
    newXS("KinoSearch::Search::Matcher::new", XS_KinoSearch_Search_Matcher_new, file);
    newXS("KinoSearch::Search::BitVecMatcher::new", XS_KinoSearch_Search_BitVecMatcher_new, file);
    newXS("KinoSearch::Index::PostingList::new", XS_KinoSearch_Index_PostingList_new, file);
    newXS("KinoSearch::Index::SegPostingList::new", XS_KinoSearch_Index_SegPostingList_new, file);
    newXS("KSx::Search::FilterScorer::new", XS_KSx_Search_FilterScorer_new, file);
    newXS("KSx::Search::MockMatcher::_new", XS_KSx_Search_MockMatcher__new, file);
    newXS("KinoSearch::Search::ORScorer::new", XS_KinoSearch_Search_ORScorer_new, file);
    newXS("KinoSearch::Search::ANDScorer::new", XS_KinoSearch_Search_ANDScorer_new, file);
    newXS("KinoSearch::Search::NOTScorer::new", XS_KinoSearch_Search_NOTScorer_new, file);
    newXS("KinoSearch::Search::RequiredOptionalScorer::new", XS_KinoSearch_Search_RequiredOptionalScorer_new, file);
    newXS("KinoSearch::Object::Hash::new", XS_KinoSearch_Object_Hash_new, file);
    newXS("KinoSearch::Search::Hits::new", XS_KinoSearch_Search_Hits_new, file);
    newXS("KinoSearch::Object::VArray::new", XS_KinoSearch_Object_VArray_new, file);
    newXS("KinoSearch::Search::Query::new", XS_KinoSearch_Search_Query_new, file);
    newXS("KinoSearch::Search::NoMatchQuery::new", XS_KinoSearch_Search_NoMatchQuery_new, file);
    newXS("KinoSearch::Search::MatchAllQuery::new", XS_KinoSearch_Search_MatchAllQuery_new, file);
    newXS("KinoSearch::Search::PhraseQuery::new", XS_KinoSearch_Search_PhraseQuery_new, file);
    newXS("KinoSearch::Search::PolyQuery::new", XS_KinoSearch_Search_PolyQuery_new, file);
    newXS("KinoSearch::Search::ANDQuery::new", XS_KinoSearch_Search_ANDQuery_new, file);
    newXS("KinoSearch::Search::RequiredOptionalQuery::new", XS_KinoSearch_Search_RequiredOptionalQuery_new, file);
    newXS("KinoSearch::Search::NOTQuery::new", XS_KinoSearch_Search_NOTQuery_new, file);
    newXS("KinoSearch::Search::ORQuery::new", XS_KinoSearch_Search_ORQuery_new, file);
    newXS("KinoSearch::Search::TermQuery::new", XS_KinoSearch_Search_TermQuery_new, file);
    newXS("KSx::Search::ProximityQuery::new", XS_KSx_Search_ProximityQuery_new, file);
    newXS("KinoSearch::Search::LeafQuery::new", XS_KinoSearch_Search_LeafQuery_new, file);
    newXS("KinoSearch::Search::Compiler::do_new", XS_KinoSearch_Search_Compiler_do_new, file);
    newXS("KinoSearch::Search::PhraseCompiler::do_new", XS_KinoSearch_Search_PhraseCompiler_do_new, file);
    newXS("KSx::Search::ProximityCompiler::do_new", XS_KSx_Search_ProximityCompiler_do_new, file);
    newXS("KinoSearch::Search::TermCompiler::do_new", XS_KinoSearch_Search_TermCompiler_do_new, file);
    newXS("KinoSearch::Search::RangeQuery::new", XS_KinoSearch_Search_RangeQuery_new, file);
    newXS("KinoSearch::Index::Indexer::_new", XS_KinoSearch_Index_Indexer__new, file);
    newXS("KinoSearch::Search::Searcher::new", XS_KinoSearch_Search_Searcher_new, file);
    newXS("KinoSearch::Search::PolySearcher::new", XS_KinoSearch_Search_PolySearcher_new, file);
    newXS("KinoSearch::Search::IndexSearcher::new", XS_KinoSearch_Search_IndexSearcher_new, file);
    newXS("KinoSearch::Index::Similarity::new", XS_KinoSearch_Index_Similarity_new, file);
    newXS("KinoSearch::Analysis::Analyzer::new", XS_KinoSearch_Analysis_Analyzer_new, file);
    newXS("KinoSearch::Analysis::PolyAnalyzer::new", XS_KinoSearch_Analysis_PolyAnalyzer_new, file);
    newXS("KinoSearch::Analysis::Stopalizer::new", XS_KinoSearch_Analysis_Stopalizer_new, file);
    newXS("KinoSearch::Analysis::CaseFolder::new", XS_KinoSearch_Analysis_CaseFolder_new, file);
    newXS("KinoSearch::Analysis::Tokenizer::_new", XS_KinoSearch_Analysis_Tokenizer__new, file);
    newXS("KinoSearch::Analysis::Stemmer::new", XS_KinoSearch_Analysis_Stemmer_new, file);
    newXS("KinoSearch::Index::TermVector::new", XS_KinoSearch_Index_TermVector_new, file);
    newXS("KinoSearch::Store::InStream::open", XS_KinoSearch_Store_InStream_open, file);
    newXS("KinoSearch::Index::DataReader::new", XS_KinoSearch_Index_DataReader_new, file);
    newXS("KinoSearch::Index::PostingListReader::new", XS_KinoSearch_Index_PostingListReader_new, file);
    newXS("KinoSearch::Index::DefaultPostingListReader::new", XS_KinoSearch_Index_DefaultPostingListReader_new, file);
    newXS("KinoSearch::Index::LexiconReader::new", XS_KinoSearch_Index_LexiconReader_new, file);
    newXS("KinoSearch::Index::DefaultLexiconReader::new", XS_KinoSearch_Index_DefaultLexiconReader_new, file);
    newXS("KinoSearch::Index::HighlightReader::new", XS_KinoSearch_Index_HighlightReader_new, file);
    newXS("KinoSearch::Index::DefaultHighlightReader::new", XS_KinoSearch_Index_DefaultHighlightReader_new, file);
    newXS("KinoSearch::Index::DocReader::new", XS_KinoSearch_Index_DocReader_new, file);
    newXS("KinoSearch::Index::DefaultDocReader::new", XS_KinoSearch_Index_DefaultDocReader_new, file);
    newXS("KinoSearch::Index::IndexReader::open", XS_KinoSearch_Index_IndexReader_open, file);
    newXS("KinoSearch::Index::SegReader::new", XS_KinoSearch_Index_SegReader_new, file);
    newXS("KinoSearch::Index::PolyReader::new", XS_KinoSearch_Index_PolyReader_new, file);
    newXS("KinoSearch::Index::PolyReader::open", XS_KinoSearch_Index_PolyReader_open, file);
    newXS("KinoSearch::Index::SortReader::new", XS_KinoSearch_Index_SortReader_new, file);
    newXS("KinoSearch::Index::DefaultSortReader::new", XS_KinoSearch_Index_DefaultSortReader_new, file);
    newXS("KinoSearch::Index::DeletionsReader::new", XS_KinoSearch_Index_DeletionsReader_new, file);
    newXS("KinoSearch::Index::DefaultDeletionsReader::new", XS_KinoSearch_Index_DefaultDeletionsReader_new, file);
    newXS("KinoSearch::Search::Collector::new", XS_KinoSearch_Search_Collector_new, file);
    newXS("KinoSearch::Search::Collector::SortCollector::new", XS_KinoSearch_Search_Collector_SortCollector_new, file);
    newXS("KinoSearch::Search::Collector::BitCollector::new", XS_KinoSearch_Search_Collector_BitCollector_new, file);
    newXS("KinoSearch::Search::Collector::OffsetCollector::new", XS_KinoSearch_Search_Collector_OffsetCollector_new, file);
    newXS("KinoSearch::Plan::Schema::new", XS_KinoSearch_Plan_Schema_new, file);
    newXS("KinoSearch::Test::TestSchema::new", XS_KinoSearch_Test_TestSchema_new, file);
    newXS("KinoSearch::Document::Doc::new", XS_KinoSearch_Document_Doc_new, file);
    newXS("KinoSearch::Document::HitDoc::new", XS_KinoSearch_Document_HitDoc_new, file);
    newXS("KinoSearch::Test::Util::BBSortEx::new", XS_KinoSearch_Test_Util_BBSortEx_new, file);
    newXS("KinoSearch::Search::MatchDoc::new", XS_KinoSearch_Search_MatchDoc_new, file);
    newXS("KinoSearch::Index::Segment::new", XS_KinoSearch_Index_Segment_new, file);
    newXS("KinoSearch::Index::Lexicon::new", XS_KinoSearch_Index_Lexicon_new, file);
    newXS("KinoSearch::Index::SegLexicon::new", XS_KinoSearch_Index_SegLexicon_new, file);
    newXS("KinoSearch::Index::PolyLexicon::new", XS_KinoSearch_Index_PolyLexicon_new, file);
    newXS("KinoSearch::Index::FilePurger::new", XS_KinoSearch_Index_FilePurger_new, file);
    newXS("KinoSearch::Store::OutStream::open", XS_KinoSearch_Store_OutStream_open, file);
    newXS("KinoSearch::Object::Obj::get_refcount", XS_KinoSearch_Object_Obj_get_refcount, file);
    newXS("KinoSearch::Object::VTable::get_refcount", XS_KinoSearch_Object_VTable_get_refcount, file);
    newXS("KinoSearch::Object::Hash::HashTombStone::get_refcount", XS_KinoSearch_Object_Hash_HashTombStone_get_refcount, file);
    newXS("KinoSearch::Index::RawPosting::get_refcount", XS_KinoSearch_Index_RawPosting_get_refcount, file);
    newXS("KinoSearch::Object::Obj::inc_refcount", XS_KinoSearch_Object_Obj_inc_refcount, file);
    newXS("KinoSearch::Object::VTable::inc_refcount", XS_KinoSearch_Object_VTable_inc_refcount, file);
    newXS("KinoSearch::Object::Hash::HashTombStone::inc_refcount", XS_KinoSearch_Object_Hash_HashTombStone_inc_refcount, file);
    newXS("KinoSearch::Index::RawPosting::inc_refcount", XS_KinoSearch_Index_RawPosting_inc_refcount, file);
    newXS("KinoSearch::Object::Obj::dec_refcount", XS_KinoSearch_Object_Obj_dec_refcount, file);
    newXS("KinoSearch::Object::VTable::dec_refcount", XS_KinoSearch_Object_VTable_dec_refcount, file);
    newXS("KinoSearch::Object::Hash::HashTombStone::dec_refcount", XS_KinoSearch_Object_Hash_HashTombStone_dec_refcount, file);
    newXS("KinoSearch::Index::RawPosting::dec_refcount", XS_KinoSearch_Index_RawPosting_dec_refcount, file);
    newXS("KinoSearch::Object::Obj::clone", XS_KinoSearch_Object_Obj_clone, file);
    newXS("KinoSearch::Index::TermInfo::clone", XS_KinoSearch_Index_TermInfo_clone, file);
    newXS("KinoSearch::Object::Float32::clone", XS_KinoSearch_Object_Float32_clone, file);
    newXS("KinoSearch::Object::Float64::clone", XS_KinoSearch_Object_Float64_clone, file);
    newXS("KinoSearch::Object::Integer32::clone", XS_KinoSearch_Object_Integer32_clone, file);
    newXS("KinoSearch::Object::Integer64::clone", XS_KinoSearch_Object_Integer64_clone, file);
    newXS("KinoSearch::Object::VTable::clone", XS_KinoSearch_Object_VTable_clone, file);
    newXS("KinoSearch::Object::BitVector::clone", XS_KinoSearch_Object_BitVector_clone, file);
    newXS("KinoSearch::Object::VArray::clone", XS_KinoSearch_Object_VArray_clone, file);
    newXS("KinoSearch::Object::ByteBuf::clone", XS_KinoSearch_Object_ByteBuf_clone, file);
    newXS("KinoSearch::Store::InStream::clone", XS_KinoSearch_Store_InStream_clone, file);
    newXS("KinoSearch::Object::CharBuf::clone", XS_KinoSearch_Object_CharBuf_clone, file);
    newXS("KinoSearch::Object::Obj::destroy", XS_KinoSearch_Object_Obj_destroy, file);
    newXS("KinoSearch::Highlight::Highlighter::destroy", XS_KinoSearch_Highlight_Highlighter_destroy, file);
    newXS("KinoSearch::Index::Inverter::destroy", XS_KinoSearch_Index_Inverter_destroy, file);
    newXS("KinoSearch::Index::DocVector::destroy", XS_KinoSearch_Index_DocVector_destroy, file);
    newXS("KinoSearch::Index::Inverter::InverterEntry::destroy", XS_KinoSearch_Index_Inverter_InverterEntry_destroy, file);
    newXS("KinoSearch::Store::Lock::destroy", XS_KinoSearch_Store_Lock_destroy, file);
    newXS("KinoSearch::Store::LockFileLock::destroy", XS_KinoSearch_Store_LockFileLock_destroy, file);
    newXS("KinoSearch::Search::QueryParser::destroy", XS_KinoSearch_Search_QueryParser_destroy, file);
    newXS("KinoSearch::Index::IndexManager::destroy", XS_KinoSearch_Index_IndexManager_destroy, file);
    newXS("KinoSearch::QueryParser::ParserToken::destroy", XS_KinoSearch_QueryParser_ParserToken_destroy, file);
    newXS("KinoSearch::Search::TopDocs::destroy", XS_KinoSearch_Search_TopDocs_destroy, file);
    newXS("KinoSearch::Analysis::Token::destroy", XS_KinoSearch_Analysis_Token_destroy, file);
    newXS("KinoSearch::Index::Snapshot::destroy", XS_KinoSearch_Index_Snapshot_destroy, file);
    newXS("KinoSearch::Search::SortRule::destroy", XS_KinoSearch_Search_SortRule_destroy, file);
    newXS("KinoSearch::Highlight::HeatMap::destroy", XS_KinoSearch_Highlight_HeatMap_destroy, file);
    newXS("KinoSearch::Object::LockFreeRegistry::destroy", XS_KinoSearch_Object_LockFreeRegistry_destroy, file);
    newXS("KinoSearch::Util::MemoryPool::destroy", XS_KinoSearch_Util_MemoryPool_destroy, file);
    newXS("KinoSearch::Index::SortCache::destroy", XS_KinoSearch_Index_SortCache_destroy, file);
    newXS("KinoSearch::Index::SortCache::TextSortCache::destroy", XS_KinoSearch_Index_SortCache_TextSortCache_destroy, file);
    newXS("KinoSearch::Index::SortCache::NumericSortCache::destroy", XS_KinoSearch_Index_SortCache_NumericSortCache_destroy, file);
    newXS("KinoSearch::Store::LockFactory::destroy", XS_KinoSearch_Store_LockFactory_destroy, file);
    newXS("KinoSearch::Object::VTable::destroy", XS_KinoSearch_Object_VTable_destroy, file);
    newXS("KinoSearch::Store::FileHandle::destroy", XS_KinoSearch_Store_FileHandle_destroy, file);
    newXS("KinoSearch::Store::RAMFileHandle::destroy", XS_KinoSearch_Store_RAMFileHandle_destroy, file);
    newXS("KinoSearch::Search::SortSpec::destroy", XS_KinoSearch_Search_SortSpec_destroy, file);
    newXS("KinoSearch::Object::Err::destroy", XS_KinoSearch_Object_Err_destroy, file);
    newXS("KinoSearch::QueryParser::ParserClause::destroy", XS_KinoSearch_QueryParser_ParserClause_destroy, file);
    newXS("KinoSearch::Analysis::Inversion::destroy", XS_KinoSearch_Analysis_Inversion_destroy, file);
    newXS("KinoSearch::Index::DataWriter::destroy", XS_KinoSearch_Index_DataWriter_destroy, file);
    newXS("KinoSearch::Index::HighlightWriter::destroy", XS_KinoSearch_Index_HighlightWriter_destroy, file);
    newXS("KinoSearch::Index::LexiconWriter::destroy", XS_KinoSearch_Index_LexiconWriter_destroy, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::destroy", XS_KinoSearch_Index_DefaultDeletionsWriter_destroy, file);
    newXS("KinoSearch::Index::PostingListWriter::destroy", XS_KinoSearch_Index_PostingListWriter_destroy, file);
    newXS("KinoSearch::Index::DocWriter::destroy", XS_KinoSearch_Index_DocWriter_destroy, file);
    newXS("KinoSearch::Index::SortWriter::destroy", XS_KinoSearch_Index_SortWriter_destroy, file);
    newXS("KinoSearch::Index::Posting::RawPostingWriter::destroy", XS_KinoSearch_Index_Posting_RawPostingWriter_destroy, file);
    newXS("KinoSearch::Index::Posting::MatchPostingWriter::destroy", XS_KinoSearch_Index_Posting_MatchPostingWriter_destroy, file);
    newXS("KinoSearch::Index::SegWriter::destroy", XS_KinoSearch_Index_SegWriter_destroy, file);
    newXS("KinoSearch::Index::BackgroundMerger::destroy", XS_KinoSearch_Index_BackgroundMerger_destroy, file);
    newXS("KinoSearch::Store::RAMFile::destroy", XS_KinoSearch_Store_RAMFile_destroy, file);
    newXS("KinoSearch::Object::BitVector::destroy", XS_KinoSearch_Object_BitVector_destroy, file);
    newXS("KinoSearch::Index::BitVecDelDocs::destroy", XS_KinoSearch_Index_BitVecDelDocs_destroy, file);
    newXS("KinoSearch::Index::Posting::MatchPosting::destroy", XS_KinoSearch_Index_Posting_MatchPosting_destroy, file);
    newXS("KinoSearch::Index::Posting::ScorePosting::destroy", XS_KinoSearch_Index_Posting_ScorePosting_destroy, file);
    newXS("KinoSearch::Index::Posting::RichPosting::destroy", XS_KinoSearch_Index_Posting_RichPosting_destroy, file);
    newXS("KinoSearch::Index::RawPosting::destroy", XS_KinoSearch_Index_RawPosting_destroy, file);
    newXS("KinoSearch::Index::TermStepper::destroy", XS_KinoSearch_Index_TermStepper_destroy, file);
    newXS("KinoSearch::Plan::FullTextType::destroy", XS_KinoSearch_Plan_FullTextType_destroy, file);
    newXS("KinoSearch::Store::Folder::destroy", XS_KinoSearch_Store_Folder_destroy, file);
    newXS("KinoSearch::Store::CompoundFileReader::destroy", XS_KinoSearch_Store_CompoundFileReader_destroy, file);
    newXS("KinoSearch::Util::PriorityQueue::destroy", XS_KinoSearch_Util_PriorityQueue_destroy, file);
    newXS("KinoSearch::Search::HitQueue::destroy", XS_KinoSearch_Search_HitQueue_destroy, file);
    newXS("KinoSearch::Search::BitVecMatcher::destroy", XS_KinoSearch_Search_BitVecMatcher_destroy, file);
    newXS("KinoSearch::Search::PhraseScorer::destroy", XS_KinoSearch_Search_PhraseScorer_destroy, file);
    newXS("KinoSearch::Search::TermScorer::destroy", XS_KinoSearch_Search_TermScorer_destroy, file);
    newXS("KinoSearch::Index::Posting::ScorePostingScorer::destroy", XS_KinoSearch_Index_Posting_ScorePostingScorer_destroy, file);
    newXS("KinoSearch::Search::SeriesMatcher::destroy", XS_KinoSearch_Search_SeriesMatcher_destroy, file);
    newXS("KinoSearch::Index::SegPostingList::destroy", XS_KinoSearch_Index_SegPostingList_destroy, file);
    newXS("KinoSearch::Index::RawPostingList::destroy", XS_KinoSearch_Index_RawPostingList_destroy, file);
    newXS("KSx::Search::FilterScorer::destroy", XS_KSx_Search_FilterScorer_destroy, file);
    newXS("KSx::Search::ProximityScorer::destroy", XS_KSx_Search_ProximityScorer_destroy, file);
    newXS("KSx::Search::MockMatcher::destroy", XS_KSx_Search_MockMatcher_destroy, file);
    newXS("KinoSearch::Search::PolyMatcher::destroy", XS_KinoSearch_Search_PolyMatcher_destroy, file);
    newXS("KinoSearch::Search::ORMatcher::destroy", XS_KinoSearch_Search_ORMatcher_destroy, file);
    newXS("KinoSearch::Search::ORScorer::destroy", XS_KinoSearch_Search_ORScorer_destroy, file);
    newXS("KinoSearch::Search::ANDScorer::destroy", XS_KinoSearch_Search_ANDScorer_destroy, file);
    newXS("KinoSearch::Search::NOTScorer::destroy", XS_KinoSearch_Search_NOTScorer_destroy, file);
    newXS("KinoSearch::Search::RequiredOptionalScorer::destroy", XS_KinoSearch_Search_RequiredOptionalScorer_destroy, file);
    newXS("KinoSearch::Search::RangeScorer::destroy", XS_KinoSearch_Search_RangeScorer_destroy, file);
    newXS("KinoSearch::Test::TestQueryParser::destroy", XS_KinoSearch_Test_TestQueryParser_destroy, file);
    newXS("KinoSearch::Object::Hash::destroy", XS_KinoSearch_Object_Hash_destroy, file);
    newXS("KinoSearch::Index::SortFieldWriter::ZombieKeyedHash::destroy", XS_KinoSearch_Index_SortFieldWriter_ZombieKeyedHash_destroy, file);
    newXS("KinoSearch::Search::Hits::destroy", XS_KinoSearch_Search_Hits_destroy, file);
    newXS("KinoSearch::Object::VArray::destroy", XS_KinoSearch_Object_VArray_destroy, file);
    newXS("KinoSearch::Search::PhraseQuery::destroy", XS_KinoSearch_Search_PhraseQuery_destroy, file);
    newXS("KinoSearch::Search::PolyQuery::destroy", XS_KinoSearch_Search_PolyQuery_destroy, file);
    newXS("KinoSearch::Search::TermQuery::destroy", XS_KinoSearch_Search_TermQuery_destroy, file);
    newXS("KSx::Search::ProximityQuery::destroy", XS_KSx_Search_ProximityQuery_destroy, file);
    newXS("KinoSearch::Search::LeafQuery::destroy", XS_KinoSearch_Search_LeafQuery_destroy, file);
    newXS("KinoSearch::Search::Compiler::destroy", XS_KinoSearch_Search_Compiler_destroy, file);
    newXS("KinoSearch::Search::PolyCompiler::destroy", XS_KinoSearch_Search_PolyCompiler_destroy, file);
    newXS("KinoSearch::Search::RangeQuery::destroy", XS_KinoSearch_Search_RangeQuery_destroy, file);
    newXS("KinoSearch::Object::ByteBuf::destroy", XS_KinoSearch_Object_ByteBuf_destroy, file);
    newXS("KinoSearch::Object::ViewByteBuf::destroy", XS_KinoSearch_Object_ViewByteBuf_destroy, file);
    newXS("KinoSearch::Store::DirHandle::destroy", XS_KinoSearch_Store_DirHandle_destroy, file);
    newXS("KinoSearch::Store::FSDirHandle::destroy", XS_KinoSearch_Store_FSDirHandle_destroy, file);
    newXS("KinoSearch::Index::Indexer::destroy", XS_KinoSearch_Index_Indexer_destroy, file);
    newXS("KinoSearch::Search::Searcher::destroy", XS_KinoSearch_Search_Searcher_destroy, file);
    newXS("KinoSearch::Search::PolySearcher::destroy", XS_KinoSearch_Search_PolySearcher_destroy, file);
    newXS("KinoSearch::Search::IndexSearcher::destroy", XS_KinoSearch_Search_IndexSearcher_destroy, file);
    newXS("KinoSearch::Index::Similarity::destroy", XS_KinoSearch_Index_Similarity_destroy, file);
    newXS("KinoSearch::Analysis::PolyAnalyzer::destroy", XS_KinoSearch_Analysis_PolyAnalyzer_destroy, file);
    newXS("KinoSearch::Analysis::Stopalizer::destroy", XS_KinoSearch_Analysis_Stopalizer_destroy, file);
    newXS("KinoSearch::Analysis::CaseFolder::destroy", XS_KinoSearch_Analysis_CaseFolder_destroy, file);
    newXS("KinoSearch::Analysis::Tokenizer::destroy", XS_KinoSearch_Analysis_Tokenizer_destroy, file);
    newXS("KinoSearch::Analysis::Stemmer::destroy", XS_KinoSearch_Analysis_Stemmer_destroy, file);
    newXS("KinoSearch::Index::TermVector::destroy", XS_KinoSearch_Index_TermVector_destroy, file);
    newXS("KinoSearch::Store::InStream::destroy", XS_KinoSearch_Store_InStream_destroy, file);
    newXS("KinoSearch::Object::CharBuf::destroy", XS_KinoSearch_Object_CharBuf_destroy, file);
    newXS("KinoSearch::Object::ViewCharBuf::destroy", XS_KinoSearch_Object_ViewCharBuf_destroy, file);
    newXS("KinoSearch::Object::ZombieCharBuf::destroy", XS_KinoSearch_Object_ZombieCharBuf_destroy, file);
    newXS("KinoSearch::Index::DataReader::destroy", XS_KinoSearch_Index_DataReader_destroy, file);
    newXS("KinoSearch::Index::DefaultPostingListReader::destroy", XS_KinoSearch_Index_DefaultPostingListReader_destroy, file);
    newXS("KinoSearch::Index::PolyLexiconReader::destroy", XS_KinoSearch_Index_PolyLexiconReader_destroy, file);
    newXS("KinoSearch::Index::DefaultLexiconReader::destroy", XS_KinoSearch_Index_DefaultLexiconReader_destroy, file);
    newXS("KinoSearch::Index::PolyHighlightReader::destroy", XS_KinoSearch_Index_PolyHighlightReader_destroy, file);
    newXS("KinoSearch::Index::DefaultHighlightReader::destroy", XS_KinoSearch_Index_DefaultHighlightReader_destroy, file);
    newXS("KinoSearch::Index::DefaultDocReader::destroy", XS_KinoSearch_Index_DefaultDocReader_destroy, file);
    newXS("KinoSearch::Index::PolyDocReader::destroy", XS_KinoSearch_Index_PolyDocReader_destroy, file);
    newXS("KinoSearch::Index::IndexReader::destroy", XS_KinoSearch_Index_IndexReader_destroy, file);
    newXS("KinoSearch::Index::SegReader::destroy", XS_KinoSearch_Index_SegReader_destroy, file);
    newXS("KinoSearch::Index::PolyReader::destroy", XS_KinoSearch_Index_PolyReader_destroy, file);
    newXS("KinoSearch::Index::DefaultSortReader::destroy", XS_KinoSearch_Index_DefaultSortReader_destroy, file);
    newXS("KinoSearch::Index::PolyDeletionsReader::destroy", XS_KinoSearch_Index_PolyDeletionsReader_destroy, file);
    newXS("KinoSearch::Index::DefaultDeletionsReader::destroy", XS_KinoSearch_Index_DefaultDeletionsReader_destroy, file);
    newXS("KinoSearch::Search::Collector::destroy", XS_KinoSearch_Search_Collector_destroy, file);
    newXS("KinoSearch::Search::Collector::SortCollector::destroy", XS_KinoSearch_Search_Collector_SortCollector_destroy, file);
    newXS("KinoSearch::Search::Collector::BitCollector::destroy", XS_KinoSearch_Search_Collector_BitCollector_destroy, file);
    newXS("KinoSearch::Search::Collector::OffsetCollector::destroy", XS_KinoSearch_Search_Collector_OffsetCollector_destroy, file);
    newXS("KinoSearch::Plan::Schema::destroy", XS_KinoSearch_Plan_Schema_destroy, file);
    newXS("KinoSearch::Document::Doc::destroy", XS_KinoSearch_Document_Doc_destroy, file);
    newXS("KinoSearch::Util::SortExternal::destroy", XS_KinoSearch_Util_SortExternal_destroy, file);
    newXS("KinoSearch::Test::Util::BBSortEx::destroy", XS_KinoSearch_Test_Util_BBSortEx_destroy, file);
    newXS("KinoSearch::Index::PostingPool::destroy", XS_KinoSearch_Index_PostingPool_destroy, file);
    newXS("KinoSearch::Index::SortFieldWriter::destroy", XS_KinoSearch_Index_SortFieldWriter_destroy, file);
    newXS("KinoSearch::Search::MatchDoc::destroy", XS_KinoSearch_Search_MatchDoc_destroy, file);
    newXS("KinoSearch::Index::Segment::destroy", XS_KinoSearch_Index_Segment_destroy, file);
    newXS("KinoSearch::Index::Lexicon::destroy", XS_KinoSearch_Index_Lexicon_destroy, file);
    newXS("KinoSearch::Index::SegLexicon::destroy", XS_KinoSearch_Index_SegLexicon_destroy, file);
    newXS("KinoSearch::Index::PolyLexicon::destroy", XS_KinoSearch_Index_PolyLexicon_destroy, file);
    newXS("KinoSearch::Index::LexIndex::destroy", XS_KinoSearch_Index_LexIndex_destroy, file);
    newXS("KinoSearch::Index::RawLexicon::destroy", XS_KinoSearch_Index_RawLexicon_destroy, file);
    newXS("KinoSearch::Index::FilePurger::destroy", XS_KinoSearch_Index_FilePurger_destroy, file);
    newXS("KinoSearch::Store::OutStream::destroy", XS_KinoSearch_Store_OutStream_destroy, file);
    newXS("KinoSearch::Object::I32Array::destroy", XS_KinoSearch_Object_I32Array_destroy, file);
    newXS("KinoSearch::Store::CompoundFileWriter::destroy", XS_KinoSearch_Store_CompoundFileWriter_destroy, file);
    newXS("KinoSearch::Object::Obj::equals", XS_KinoSearch_Object_Obj_equals, file);
    newXS("KinoSearch::Object::Num::equals", XS_KinoSearch_Object_Num_equals, file);
    newXS("KinoSearch::Object::Integer64::equals", XS_KinoSearch_Object_Integer64_equals, file);
    newXS("KinoSearch::Plan::Architecture::equals", XS_KinoSearch_Plan_Architecture_equals, file);
    newXS("KinoSearch::Plan::FieldType::equals", XS_KinoSearch_Plan_FieldType_equals, file);
    newXS("KinoSearch::Plan::StringType::equals", XS_KinoSearch_Plan_StringType_equals, file);
    newXS("KinoSearch::Plan::FullTextType::equals", XS_KinoSearch_Plan_FullTextType_equals, file);
    newXS("KinoSearch::Plan::Float32Type::equals", XS_KinoSearch_Plan_Float32Type_equals, file);
    newXS("KinoSearch::Plan::Float64Type::equals", XS_KinoSearch_Plan_Float64Type_equals, file);
    newXS("KinoSearch::Plan::Int64Type::equals", XS_KinoSearch_Plan_Int64Type_equals, file);
    newXS("KinoSearch::Plan::Int32Type::equals", XS_KinoSearch_Plan_Int32Type_equals, file);
    newXS("KinoSearch::Plan::BlobType::equals", XS_KinoSearch_Plan_BlobType_equals, file);
    newXS("KinoSearch::Object::Hash::equals", XS_KinoSearch_Object_Hash_equals, file);
    newXS("KinoSearch::Object::VArray::equals", XS_KinoSearch_Object_VArray_equals, file);
    newXS("KinoSearch::Search::NoMatchQuery::equals", XS_KinoSearch_Search_NoMatchQuery_equals, file);
    newXS("KinoSearch::Search::MatchAllQuery::equals", XS_KinoSearch_Search_MatchAllQuery_equals, file);
    newXS("KinoSearch::Search::PhraseQuery::equals", XS_KinoSearch_Search_PhraseQuery_equals, file);
    newXS("KinoSearch::Search::PolyQuery::equals", XS_KinoSearch_Search_PolyQuery_equals, file);
    newXS("KinoSearch::Search::ANDQuery::equals", XS_KinoSearch_Search_ANDQuery_equals, file);
    newXS("KinoSearch::Search::RequiredOptionalQuery::equals", XS_KinoSearch_Search_RequiredOptionalQuery_equals, file);
    newXS("KinoSearch::Search::NOTQuery::equals", XS_KinoSearch_Search_NOTQuery_equals, file);
    newXS("KinoSearch::Search::ORQuery::equals", XS_KinoSearch_Search_ORQuery_equals, file);
    newXS("KinoSearch::Search::TermQuery::equals", XS_KinoSearch_Search_TermQuery_equals, file);
    newXS("KSx::Search::ProximityQuery::equals", XS_KSx_Search_ProximityQuery_equals, file);
    newXS("KinoSearch::Search::LeafQuery::equals", XS_KinoSearch_Search_LeafQuery_equals, file);
    newXS("KinoSearch::Search::Compiler::equals", XS_KinoSearch_Search_Compiler_equals, file);
    newXS("KinoSearch::Search::PhraseCompiler::equals", XS_KinoSearch_Search_PhraseCompiler_equals, file);
    newXS("KSx::Search::ProximityCompiler::equals", XS_KSx_Search_ProximityCompiler_equals, file);
    newXS("KinoSearch::Search::TermCompiler::equals", XS_KinoSearch_Search_TermCompiler_equals, file);
    newXS("KinoSearch::Search::RangeQuery::equals", XS_KinoSearch_Search_RangeQuery_equals, file);
    newXS("KinoSearch::Object::ByteBuf::equals", XS_KinoSearch_Object_ByteBuf_equals, file);
    newXS("KinoSearch::Index::Similarity::equals", XS_KinoSearch_Index_Similarity_equals, file);
    newXS("KinoSearch::Analysis::PolyAnalyzer::equals", XS_KinoSearch_Analysis_PolyAnalyzer_equals, file);
    newXS("KinoSearch::Analysis::Stopalizer::equals", XS_KinoSearch_Analysis_Stopalizer_equals, file);
    newXS("KinoSearch::Analysis::CaseFolder::equals", XS_KinoSearch_Analysis_CaseFolder_equals, file);
    newXS("KinoSearch::Analysis::Tokenizer::equals", XS_KinoSearch_Analysis_Tokenizer_equals, file);
    newXS("KinoSearch::Analysis::Stemmer::equals", XS_KinoSearch_Analysis_Stemmer_equals, file);
    newXS("KinoSearch::Index::TermVector::equals", XS_KinoSearch_Index_TermVector_equals, file);
    newXS("KinoSearch::Object::CharBuf::equals", XS_KinoSearch_Object_CharBuf_equals, file);
    newXS("KinoSearch::Document::Doc::equals", XS_KinoSearch_Document_Doc_equals, file);
    newXS("KinoSearch::Document::HitDoc::equals", XS_KinoSearch_Document_HitDoc_equals, file);
    newXS("KinoSearch::Object::Obj::hash_sum", XS_KinoSearch_Object_Obj_hash_sum, file);
    newXS("KinoSearch::Object::Float32::hash_sum", XS_KinoSearch_Object_Float32_hash_sum, file);
    newXS("KinoSearch::Object::Float64::hash_sum", XS_KinoSearch_Object_Float64_hash_sum, file);
    newXS("KinoSearch::Object::Integer32::hash_sum", XS_KinoSearch_Object_Integer32_hash_sum, file);
    newXS("KinoSearch::Object::Integer64::hash_sum", XS_KinoSearch_Object_Integer64_hash_sum, file);
    newXS("KinoSearch::Object::ByteBuf::hash_sum", XS_KinoSearch_Object_ByteBuf_hash_sum, file);
    newXS("KinoSearch::Object::CharBuf::hash_sum", XS_KinoSearch_Object_CharBuf_hash_sum, file);
    newXS("KinoSearch::Test::Object::StupidHashCharBuf::hash_sum", XS_KinoSearch_Test_Object_StupidHashCharBuf_hash_sum, file);
    newXS("KinoSearch::Object::Obj::get_vtable", XS_KinoSearch_Object_Obj_get_vtable, file);
    newXS("KinoSearch::Object::Obj::to_string", XS_KinoSearch_Object_Obj_to_string, file);
    newXS("KinoSearch::Index::TermInfo::to_string", XS_KinoSearch_Index_TermInfo_to_string, file);
    newXS("KinoSearch::Object::FloatNum::to_string", XS_KinoSearch_Object_FloatNum_to_string, file);
    newXS("KinoSearch::Object::IntNum::to_string", XS_KinoSearch_Object_IntNum_to_string, file);
    newXS("KinoSearch::Object::Err::to_string", XS_KinoSearch_Object_Err_to_string, file);
    newXS("KinoSearch::Index::SkipStepper::to_string", XS_KinoSearch_Index_SkipStepper_to_string, file);
    newXS("KinoSearch::Search::NoMatchQuery::to_string", XS_KinoSearch_Search_NoMatchQuery_to_string, file);
    newXS("KinoSearch::Search::MatchAllQuery::to_string", XS_KinoSearch_Search_MatchAllQuery_to_string, file);
    newXS("KinoSearch::Search::PhraseQuery::to_string", XS_KinoSearch_Search_PhraseQuery_to_string, file);
    newXS("KinoSearch::Search::ANDQuery::to_string", XS_KinoSearch_Search_ANDQuery_to_string, file);
    newXS("KinoSearch::Search::RequiredOptionalQuery::to_string", XS_KinoSearch_Search_RequiredOptionalQuery_to_string, file);
    newXS("KinoSearch::Search::NOTQuery::to_string", XS_KinoSearch_Search_NOTQuery_to_string, file);
    newXS("KinoSearch::Search::ORQuery::to_string", XS_KinoSearch_Search_ORQuery_to_string, file);
    newXS("KinoSearch::Search::TermQuery::to_string", XS_KinoSearch_Search_TermQuery_to_string, file);
    newXS("KSx::Search::ProximityQuery::to_string", XS_KSx_Search_ProximityQuery_to_string, file);
    newXS("KinoSearch::Search::LeafQuery::to_string", XS_KinoSearch_Search_LeafQuery_to_string, file);
    newXS("KinoSearch::Search::Compiler::to_string", XS_KinoSearch_Search_Compiler_to_string, file);
    newXS("KinoSearch::Search::RangeQuery::to_string", XS_KinoSearch_Search_RangeQuery_to_string, file);
    newXS("KinoSearch::Object::CharBuf::to_string", XS_KinoSearch_Object_CharBuf_to_string, file);
    newXS("KinoSearch::Object::Obj::to_i64", XS_KinoSearch_Object_Obj_to_i64, file);
    newXS("KinoSearch::Object::Float32::to_i64", XS_KinoSearch_Object_Float32_to_i64, file);
    newXS("KinoSearch::Object::Float64::to_i64", XS_KinoSearch_Object_Float64_to_i64, file);
    newXS("KinoSearch::Object::Integer32::to_i64", XS_KinoSearch_Object_Integer32_to_i64, file);
    newXS("KinoSearch::Object::Integer64::to_i64", XS_KinoSearch_Object_Integer64_to_i64, file);
    newXS("KinoSearch::Object::CharBuf::to_i64", XS_KinoSearch_Object_CharBuf_to_i64, file);
    newXS("KinoSearch::Object::Obj::to_f64", XS_KinoSearch_Object_Obj_to_f64, file);
    newXS("KinoSearch::Object::Float32::to_f64", XS_KinoSearch_Object_Float32_to_f64, file);
    newXS("KinoSearch::Object::Float64::to_f64", XS_KinoSearch_Object_Float64_to_f64, file);
    newXS("KinoSearch::Object::Integer32::to_f64", XS_KinoSearch_Object_Integer32_to_f64, file);
    newXS("KinoSearch::Object::Integer64::to_f64", XS_KinoSearch_Object_Integer64_to_f64, file);
    newXS("KinoSearch::Object::CharBuf::to_f64", XS_KinoSearch_Object_CharBuf_to_f64, file);
    newXS("KinoSearch::Object::Obj::serialize", XS_KinoSearch_Object_Obj_serialize, file);
    newXS("KinoSearch::Index::DocVector::serialize", XS_KinoSearch_Index_DocVector_serialize, file);
    newXS("KinoSearch::Search::TopDocs::serialize", XS_KinoSearch_Search_TopDocs_serialize, file);
    newXS("KinoSearch::Search::SortRule::serialize", XS_KinoSearch_Search_SortRule_serialize, file);
    newXS("KinoSearch::Object::Float32::serialize", XS_KinoSearch_Object_Float32_serialize, file);
    newXS("KinoSearch::Object::Float64::serialize", XS_KinoSearch_Object_Float64_serialize, file);
    newXS("KinoSearch::Object::Integer32::serialize", XS_KinoSearch_Object_Integer32_serialize, file);
    newXS("KinoSearch::Object::Integer64::serialize", XS_KinoSearch_Object_Integer64_serialize, file);
    newXS("KinoSearch::Search::SortSpec::serialize", XS_KinoSearch_Search_SortSpec_serialize, file);
    newXS("KinoSearch::Object::Hash::serialize", XS_KinoSearch_Object_Hash_serialize, file);
    newXS("KinoSearch::Object::VArray::serialize", XS_KinoSearch_Object_VArray_serialize, file);
    newXS("KinoSearch::Search::Query::serialize", XS_KinoSearch_Search_Query_serialize, file);
    newXS("KinoSearch::Search::NoMatchQuery::serialize", XS_KinoSearch_Search_NoMatchQuery_serialize, file);
    newXS("KinoSearch::Search::PhraseQuery::serialize", XS_KinoSearch_Search_PhraseQuery_serialize, file);
    newXS("KinoSearch::Search::PolyQuery::serialize", XS_KinoSearch_Search_PolyQuery_serialize, file);
    newXS("KinoSearch::Search::TermQuery::serialize", XS_KinoSearch_Search_TermQuery_serialize, file);
    newXS("KSx::Search::ProximityQuery::serialize", XS_KSx_Search_ProximityQuery_serialize, file);
    newXS("KinoSearch::Search::LeafQuery::serialize", XS_KinoSearch_Search_LeafQuery_serialize, file);
    newXS("KinoSearch::Search::Compiler::serialize", XS_KinoSearch_Search_Compiler_serialize, file);
    newXS("KinoSearch::Search::PhraseCompiler::serialize", XS_KinoSearch_Search_PhraseCompiler_serialize, file);
    newXS("KSx::Search::ProximityCompiler::serialize", XS_KSx_Search_ProximityCompiler_serialize, file);
    newXS("KinoSearch::Search::PolyCompiler::serialize", XS_KinoSearch_Search_PolyCompiler_serialize, file);
    newXS("KinoSearch::Search::TermCompiler::serialize", XS_KinoSearch_Search_TermCompiler_serialize, file);
    newXS("KinoSearch::Search::RangeQuery::serialize", XS_KinoSearch_Search_RangeQuery_serialize, file);
    newXS("KinoSearch::Object::ByteBuf::serialize", XS_KinoSearch_Object_ByteBuf_serialize, file);
    newXS("KinoSearch::Index::Similarity::serialize", XS_KinoSearch_Index_Similarity_serialize, file);
    newXS("KinoSearch::Index::TermVector::serialize", XS_KinoSearch_Index_TermVector_serialize, file);
    newXS("KinoSearch::Object::CharBuf::serialize", XS_KinoSearch_Object_CharBuf_serialize, file);
    newXS("KinoSearch::Document::Doc::serialize", XS_KinoSearch_Document_Doc_serialize, file);
    newXS("KinoSearch::Document::HitDoc::serialize", XS_KinoSearch_Document_HitDoc_serialize, file);
    newXS("KinoSearch::Search::MatchDoc::serialize", XS_KinoSearch_Search_MatchDoc_serialize, file);
    newXS("KinoSearch::Object::Obj::deserialize", XS_KinoSearch_Object_Obj_deserialize, file);
    newXS("KinoSearch::Index::DocVector::deserialize", XS_KinoSearch_Index_DocVector_deserialize, file);
    newXS("KinoSearch::Search::TopDocs::deserialize", XS_KinoSearch_Search_TopDocs_deserialize, file);
    newXS("KinoSearch::Search::SortRule::deserialize", XS_KinoSearch_Search_SortRule_deserialize, file);
    newXS("KinoSearch::Object::Float32::deserialize", XS_KinoSearch_Object_Float32_deserialize, file);
    newXS("KinoSearch::Object::Float64::deserialize", XS_KinoSearch_Object_Float64_deserialize, file);
    newXS("KinoSearch::Object::Integer32::deserialize", XS_KinoSearch_Object_Integer32_deserialize, file);
    newXS("KinoSearch::Object::Integer64::deserialize", XS_KinoSearch_Object_Integer64_deserialize, file);
    newXS("KinoSearch::Search::SortSpec::deserialize", XS_KinoSearch_Search_SortSpec_deserialize, file);
    newXS("KinoSearch::Object::Hash::deserialize", XS_KinoSearch_Object_Hash_deserialize, file);
    newXS("KinoSearch::Object::VArray::deserialize", XS_KinoSearch_Object_VArray_deserialize, file);
    newXS("KinoSearch::Search::Query::deserialize", XS_KinoSearch_Search_Query_deserialize, file);
    newXS("KinoSearch::Search::NoMatchQuery::deserialize", XS_KinoSearch_Search_NoMatchQuery_deserialize, file);
    newXS("KinoSearch::Search::PhraseQuery::deserialize", XS_KinoSearch_Search_PhraseQuery_deserialize, file);
    newXS("KinoSearch::Search::PolyQuery::deserialize", XS_KinoSearch_Search_PolyQuery_deserialize, file);
    newXS("KinoSearch::Search::TermQuery::deserialize", XS_KinoSearch_Search_TermQuery_deserialize, file);
    newXS("KSx::Search::ProximityQuery::deserialize", XS_KSx_Search_ProximityQuery_deserialize, file);
    newXS("KinoSearch::Search::LeafQuery::deserialize", XS_KinoSearch_Search_LeafQuery_deserialize, file);
    newXS("KinoSearch::Search::Compiler::deserialize", XS_KinoSearch_Search_Compiler_deserialize, file);
    newXS("KinoSearch::Search::PhraseCompiler::deserialize", XS_KinoSearch_Search_PhraseCompiler_deserialize, file);
    newXS("KSx::Search::ProximityCompiler::deserialize", XS_KSx_Search_ProximityCompiler_deserialize, file);
    newXS("KinoSearch::Search::PolyCompiler::deserialize", XS_KinoSearch_Search_PolyCompiler_deserialize, file);
    newXS("KinoSearch::Search::MatchAllCompiler::deserialize", XS_KinoSearch_Search_MatchAllCompiler_deserialize, file);
    newXS("KinoSearch::Search::NoMatchCompiler::deserialize", XS_KinoSearch_Search_NoMatchCompiler_deserialize, file);
    newXS("KinoSearch::Search::TermCompiler::deserialize", XS_KinoSearch_Search_TermCompiler_deserialize, file);
    newXS("KinoSearch::Search::RangeCompiler::deserialize", XS_KinoSearch_Search_RangeCompiler_deserialize, file);
    newXS("KinoSearch::Search::RangeQuery::deserialize", XS_KinoSearch_Search_RangeQuery_deserialize, file);
    newXS("KinoSearch::Object::ByteBuf::deserialize", XS_KinoSearch_Object_ByteBuf_deserialize, file);
    newXS("KinoSearch::Index::Similarity::deserialize", XS_KinoSearch_Index_Similarity_deserialize, file);
    newXS("KinoSearch::Index::TermVector::deserialize", XS_KinoSearch_Index_TermVector_deserialize, file);
    newXS("KinoSearch::Object::CharBuf::deserialize", XS_KinoSearch_Object_CharBuf_deserialize, file);
    newXS("KinoSearch::Document::Doc::deserialize", XS_KinoSearch_Document_Doc_deserialize, file);
    newXS("KinoSearch::Document::HitDoc::deserialize", XS_KinoSearch_Document_HitDoc_deserialize, file);
    newXS("KinoSearch::Search::MatchDoc::deserialize", XS_KinoSearch_Search_MatchDoc_deserialize, file);
    newXS("KinoSearch::Object::Obj::dump", XS_KinoSearch_Object_Obj_dump, file);
    newXS("KinoSearch::Index::Snapshot::dump", XS_KinoSearch_Index_Snapshot_dump, file);
    newXS("KinoSearch::Plan::StringType::dump", XS_KinoSearch_Plan_StringType_dump, file);
    newXS("KinoSearch::Plan::FullTextType::dump", XS_KinoSearch_Plan_FullTextType_dump, file);
    newXS("KinoSearch::Plan::NumericType::dump", XS_KinoSearch_Plan_NumericType_dump, file);
    newXS("KinoSearch::Plan::BlobType::dump", XS_KinoSearch_Plan_BlobType_dump, file);
    newXS("KinoSearch::Object::Hash::dump", XS_KinoSearch_Object_Hash_dump, file);
    newXS("KinoSearch::Object::VArray::dump", XS_KinoSearch_Object_VArray_dump, file);
    newXS("KinoSearch::Search::Query::dump", XS_KinoSearch_Search_Query_dump, file);
    newXS("KinoSearch::Search::NoMatchQuery::dump", XS_KinoSearch_Search_NoMatchQuery_dump, file);
    newXS("KinoSearch::Search::PhraseQuery::dump", XS_KinoSearch_Search_PhraseQuery_dump, file);
    newXS("KinoSearch::Search::PolyQuery::dump", XS_KinoSearch_Search_PolyQuery_dump, file);
    newXS("KinoSearch::Search::TermQuery::dump", XS_KinoSearch_Search_TermQuery_dump, file);
    newXS("KSx::Search::ProximityQuery::dump", XS_KSx_Search_ProximityQuery_dump, file);
    newXS("KinoSearch::Search::LeafQuery::dump", XS_KinoSearch_Search_LeafQuery_dump, file);
    newXS("KinoSearch::Search::RangeQuery::dump", XS_KinoSearch_Search_RangeQuery_dump, file);
    newXS("KinoSearch::Index::Similarity::dump", XS_KinoSearch_Index_Similarity_dump, file);
    newXS("KinoSearch::Analysis::Analyzer::dump", XS_KinoSearch_Analysis_Analyzer_dump, file);
    newXS("KinoSearch::Analysis::PolyAnalyzer::dump", XS_KinoSearch_Analysis_PolyAnalyzer_dump, file);
    newXS("KinoSearch::Analysis::Stopalizer::dump", XS_KinoSearch_Analysis_Stopalizer_dump, file);
    newXS("KinoSearch::Analysis::CaseFolder::dump", XS_KinoSearch_Analysis_CaseFolder_dump, file);
    newXS("KinoSearch::Analysis::Tokenizer::dump", XS_KinoSearch_Analysis_Tokenizer_dump, file);
    newXS("KinoSearch::Analysis::Stemmer::dump", XS_KinoSearch_Analysis_Stemmer_dump, file);
    newXS("KinoSearch::Plan::Schema::dump", XS_KinoSearch_Plan_Schema_dump, file);
    newXS("KinoSearch::Document::Doc::dump", XS_KinoSearch_Document_Doc_dump, file);
    newXS("KinoSearch::Document::HitDoc::dump", XS_KinoSearch_Document_HitDoc_dump, file);
    newXS("KinoSearch::Object::Obj::_load", XS_KinoSearch_Object_Obj__load, file);
    newXS("KinoSearch::Index::Snapshot::_load", XS_KinoSearch_Index_Snapshot__load, file);
    newXS("KinoSearch::Plan::StringType::_load", XS_KinoSearch_Plan_StringType__load, file);
    newXS("KinoSearch::Plan::FullTextType::_load", XS_KinoSearch_Plan_FullTextType__load, file);
    newXS("KinoSearch::Plan::NumericType::_load", XS_KinoSearch_Plan_NumericType__load, file);
    newXS("KinoSearch::Plan::BlobType::_load", XS_KinoSearch_Plan_BlobType__load, file);
    newXS("KinoSearch::Object::Hash::_load", XS_KinoSearch_Object_Hash__load, file);
    newXS("KinoSearch::Object::VArray::_load", XS_KinoSearch_Object_VArray__load, file);
    newXS("KinoSearch::Search::Query::_load", XS_KinoSearch_Search_Query__load, file);
    newXS("KinoSearch::Search::NoMatchQuery::_load", XS_KinoSearch_Search_NoMatchQuery__load, file);
    newXS("KinoSearch::Search::PhraseQuery::_load", XS_KinoSearch_Search_PhraseQuery__load, file);
    newXS("KinoSearch::Search::PolyQuery::_load", XS_KinoSearch_Search_PolyQuery__load, file);
    newXS("KinoSearch::Search::TermQuery::_load", XS_KinoSearch_Search_TermQuery__load, file);
    newXS("KSx::Search::ProximityQuery::_load", XS_KSx_Search_ProximityQuery__load, file);
    newXS("KinoSearch::Search::LeafQuery::_load", XS_KinoSearch_Search_LeafQuery__load, file);
    newXS("KinoSearch::Search::RangeQuery::_load", XS_KinoSearch_Search_RangeQuery__load, file);
    newXS("KinoSearch::Index::Similarity::_load", XS_KinoSearch_Index_Similarity__load, file);
    newXS("KinoSearch::Analysis::Analyzer::_load", XS_KinoSearch_Analysis_Analyzer__load, file);
    newXS("KinoSearch::Analysis::PolyAnalyzer::_load", XS_KinoSearch_Analysis_PolyAnalyzer__load, file);
    newXS("KinoSearch::Analysis::Stopalizer::_load", XS_KinoSearch_Analysis_Stopalizer__load, file);
    newXS("KinoSearch::Analysis::CaseFolder::_load", XS_KinoSearch_Analysis_CaseFolder__load, file);
    newXS("KinoSearch::Analysis::Tokenizer::_load", XS_KinoSearch_Analysis_Tokenizer__load, file);
    newXS("KinoSearch::Analysis::Stemmer::_load", XS_KinoSearch_Analysis_Stemmer__load, file);
    newXS("KinoSearch::Object::CharBuf::_load", XS_KinoSearch_Object_CharBuf__load, file);
    newXS("KinoSearch::Plan::Schema::_load", XS_KinoSearch_Plan_Schema__load, file);
    newXS("KinoSearch::Document::Doc::_load", XS_KinoSearch_Document_Doc__load, file);
    newXS("KinoSearch::Document::HitDoc::_load", XS_KinoSearch_Document_HitDoc__load, file);
    newXS("KinoSearch::Object::Obj::mimic", XS_KinoSearch_Object_Obj_mimic, file);
    newXS("KinoSearch::Index::TermInfo::mimic", XS_KinoSearch_Index_TermInfo_mimic, file);
    newXS("KinoSearch::Object::Float32::mimic", XS_KinoSearch_Object_Float32_mimic, file);
    newXS("KinoSearch::Object::Float64::mimic", XS_KinoSearch_Object_Float64_mimic, file);
    newXS("KinoSearch::Object::Integer32::mimic", XS_KinoSearch_Object_Integer32_mimic, file);
    newXS("KinoSearch::Object::Integer64::mimic", XS_KinoSearch_Object_Integer64_mimic, file);
    newXS("KinoSearch::Object::BitVector::mimic", XS_KinoSearch_Object_BitVector_mimic, file);
    newXS("KinoSearch::Object::ByteBuf::mimic", XS_KinoSearch_Object_ByteBuf_mimic, file);
    newXS("KinoSearch::Object::CharBuf::mimic", XS_KinoSearch_Object_CharBuf_mimic, file);
    newXS("KinoSearch::Highlight::Highlighter::create_excerpt", XS_KinoSearch_Highlight_Highlighter_create_excerpt, file);
    newXS("KinoSearch::Highlight::Highlighter::encode", XS_KinoSearch_Highlight_Highlighter_encode, file);
    newXS("KinoSearch::Highlight::Highlighter::find_sentences", XS_KinoSearch_Highlight_Highlighter_find_sentences, file);
    newXS("KinoSearch::Highlight::Highlighter::highlight", XS_KinoSearch_Highlight_Highlighter_highlight, file);
    newXS("KinoSearch::Highlight::Highlighter::set_pre_tag", XS_KinoSearch_Highlight_Highlighter_set_pre_tag, file);
    newXS("KinoSearch::Highlight::Highlighter::set_post_tag", XS_KinoSearch_Highlight_Highlighter_set_post_tag, file);
    newXS("KinoSearch::Highlight::Highlighter::get_pre_tag", XS_KinoSearch_Highlight_Highlighter_get_pre_tag, file);
    newXS("KinoSearch::Highlight::Highlighter::get_post_tag", XS_KinoSearch_Highlight_Highlighter_get_post_tag, file);
    newXS("KinoSearch::Highlight::Highlighter::get_field", XS_KinoSearch_Highlight_Highlighter_get_field, file);
    newXS("KinoSearch::Highlight::Highlighter::get_excerpt_length", XS_KinoSearch_Highlight_Highlighter_get_excerpt_length, file);
    newXS("KinoSearch::Highlight::Highlighter::get_searcher", XS_KinoSearch_Highlight_Highlighter_get_searcher, file);
    newXS("KinoSearch::Highlight::Highlighter::get_query", XS_KinoSearch_Highlight_Highlighter_get_query, file);
    newXS("KinoSearch::Highlight::Highlighter::get_compiler", XS_KinoSearch_Highlight_Highlighter_get_compiler, file);
    newXS("KinoSearch::Highlight::Highlighter::_find_best_fragment", XS_KinoSearch_Highlight_Highlighter__find_best_fragment, file);
    newXS("KinoSearch::Highlight::Highlighter::_raw_excerpt", XS_KinoSearch_Highlight_Highlighter__raw_excerpt, file);
    newXS("KinoSearch::Highlight::Highlighter::_highlight_excerpt", XS_KinoSearch_Highlight_Highlighter__highlight_excerpt, file);
    newXS("KinoSearch::Index::TermInfo::get_doc_freq", XS_KinoSearch_Index_TermInfo_get_doc_freq, file);
    newXS("KinoSearch::Index::TermInfo::get_lex_filepos", XS_KinoSearch_Index_TermInfo_get_lex_filepos, file);
    newXS("KinoSearch::Index::TermInfo::get_post_filepos", XS_KinoSearch_Index_TermInfo_get_post_filepos, file);
    newXS("KinoSearch::Index::TermInfo::get_skip_filepos", XS_KinoSearch_Index_TermInfo_get_skip_filepos, file);
    newXS("KinoSearch::Index::TermInfo::set_doc_freq", XS_KinoSearch_Index_TermInfo_set_doc_freq, file);
    newXS("KinoSearch::Index::TermInfo::set_lex_filepos", XS_KinoSearch_Index_TermInfo_set_lex_filepos, file);
    newXS("KinoSearch::Index::TermInfo::set_post_filepos", XS_KinoSearch_Index_TermInfo_set_post_filepos, file);
    newXS("KinoSearch::Index::TermInfo::set_skip_filepos", XS_KinoSearch_Index_TermInfo_set_skip_filepos, file);
    newXS("KinoSearch::Index::TermInfo::reset", XS_KinoSearch_Index_TermInfo_reset, file);
    newXS("KinoSearch::Index::Inverter::clear", XS_KinoSearch_Index_Inverter_clear, file);
    newXS("KinoSearch::Index::Inverter::iterate", XS_KinoSearch_Index_Inverter_iterate, file);
    newXS("KinoSearch::Index::Inverter::next", XS_KinoSearch_Index_Inverter_next, file);
    newXS("KinoSearch::Index::Inverter::get_doc", XS_KinoSearch_Index_Inverter_get_doc, file);
    newXS("KinoSearch::Index::Inverter::get_field_name", XS_KinoSearch_Index_Inverter_get_field_name, file);
    newXS("KinoSearch::Index::Inverter::get_value", XS_KinoSearch_Index_Inverter_get_value, file);
    newXS("KinoSearch::Index::Inverter::get_type", XS_KinoSearch_Index_Inverter_get_type, file);
    newXS("KinoSearch::Index::Inverter::get_analyzer", XS_KinoSearch_Index_Inverter_get_analyzer, file);
    newXS("KinoSearch::Index::Inverter::get_similarity", XS_KinoSearch_Index_Inverter_get_similarity, file);
    newXS("KinoSearch::Index::Inverter::get_inversion", XS_KinoSearch_Index_Inverter_get_inversion, file);
    newXS("KinoSearch::Index::DocVector::term_vector", XS_KinoSearch_Index_DocVector_term_vector, file);
    newXS("KinoSearch::Index::DocVector::add_field_buf", XS_KinoSearch_Index_DocVector_add_field_buf, file);
    newXS("KinoSearch::Index::DocVector::field_buf", XS_KinoSearch_Index_DocVector_field_buf, file);
    newXS("KinoSearch::Store::Lock::obtain", XS_KinoSearch_Store_Lock_obtain, file);
    newXS("KinoSearch::Store::Lock::request", XS_KinoSearch_Store_Lock_request, file);
    newXS("KinoSearch::Store::LockFileLock::request", XS_KinoSearch_Store_LockFileLock_request, file);
    newXS("KinoSearch::Store::SharedLock::request", XS_KinoSearch_Store_SharedLock_request, file);
    newXS("KinoSearch::Store::Lock::release", XS_KinoSearch_Store_Lock_release, file);
    newXS("KinoSearch::Store::LockFileLock::release", XS_KinoSearch_Store_LockFileLock_release, file);
    newXS("KinoSearch::Store::SharedLock::release", XS_KinoSearch_Store_SharedLock_release, file);
    newXS("KinoSearch::Store::Lock::is_locked", XS_KinoSearch_Store_Lock_is_locked, file);
    newXS("KinoSearch::Store::LockFileLock::is_locked", XS_KinoSearch_Store_LockFileLock_is_locked, file);
    newXS("KinoSearch::Store::SharedLock::is_locked", XS_KinoSearch_Store_SharedLock_is_locked, file);
    newXS("KinoSearch::Store::Lock::clear_stale", XS_KinoSearch_Store_Lock_clear_stale, file);
    newXS("KinoSearch::Store::LockFileLock::clear_stale", XS_KinoSearch_Store_LockFileLock_clear_stale, file);
    newXS("KinoSearch::Store::SharedLock::clear_stale", XS_KinoSearch_Store_SharedLock_clear_stale, file);
    newXS("KinoSearch::Store::Lock::get_name", XS_KinoSearch_Store_Lock_get_name, file);
    newXS("KinoSearch::Store::Lock::get_host", XS_KinoSearch_Store_Lock_get_host, file);
    newXS("KinoSearch::Store::Lock::get_lock_path", XS_KinoSearch_Store_Lock_get_lock_path, file);
    newXS("KinoSearch::Search::QueryParser::parse", XS_KinoSearch_Search_QueryParser_parse, file);
    newXS("KinoSearch::Search::QueryParser::tree", XS_KinoSearch_Search_QueryParser_tree, file);
    newXS("KinoSearch::Search::QueryParser::expand", XS_KinoSearch_Search_QueryParser_expand, file);
    newXS("KinoSearch::Search::QueryParser::expand_leaf", XS_KinoSearch_Search_QueryParser_expand_leaf, file);
    newXS("KinoSearch::Search::QueryParser::prune", XS_KinoSearch_Search_QueryParser_prune, file);
    newXS("KinoSearch::Search::QueryParser::make_term_query", XS_KinoSearch_Search_QueryParser_make_term_query, file);
    newXS("KinoSearch::Search::QueryParser::make_phrase_query", XS_KinoSearch_Search_QueryParser_make_phrase_query, file);
    newXS("KinoSearch::Search::QueryParser::make_or_query", XS_KinoSearch_Search_QueryParser_make_or_query, file);
    newXS("KinoSearch::Search::QueryParser::make_and_query", XS_KinoSearch_Search_QueryParser_make_and_query, file);
    newXS("KinoSearch::Search::QueryParser::make_not_query", XS_KinoSearch_Search_QueryParser_make_not_query, file);
    newXS("KinoSearch::Search::QueryParser::make_req_opt_query", XS_KinoSearch_Search_QueryParser_make_req_opt_query, file);
    newXS("KinoSearch::Search::QueryParser::get_analyzer", XS_KinoSearch_Search_QueryParser_get_analyzer, file);
    newXS("KinoSearch::Search::QueryParser::get_schema", XS_KinoSearch_Search_QueryParser_get_schema, file);
    newXS("KinoSearch::Search::QueryParser::get_fields", XS_KinoSearch_Search_QueryParser_get_fields, file);
    newXS("KinoSearch::Search::QueryParser::heed_colons", XS_KinoSearch_Search_QueryParser_heed_colons, file);
    newXS("KinoSearch::Search::QueryParser::set_heed_colons", XS_KinoSearch_Search_QueryParser_set_heed_colons, file);
    newXS("KinoSearch::Index::IndexManager::set_folder", XS_KinoSearch_Index_IndexManager_set_folder, file);
    newXS("KinoSearch::Index::IndexManager::get_folder", XS_KinoSearch_Index_IndexManager_get_folder, file);
    newXS("KinoSearch::Index::IndexManager::get_host", XS_KinoSearch_Index_IndexManager_get_host, file);
    newXS("KinoSearch::Index::IndexManager::recycle", XS_KinoSearch_Index_IndexManager_recycle, file);
    newXS("KinoSearch::Index::IndexManager::make_write_lock", XS_KinoSearch_Index_IndexManager_make_write_lock, file);
    newXS("KinoSearch::Index::IndexManager::make_deletion_lock", XS_KinoSearch_Index_IndexManager_make_deletion_lock, file);
    newXS("KinoSearch::Index::IndexManager::make_merge_lock", XS_KinoSearch_Index_IndexManager_make_merge_lock, file);
    newXS("KinoSearch::Index::IndexManager::make_snapshot_read_lock", XS_KinoSearch_Index_IndexManager_make_snapshot_read_lock, file);
    newXS("KinoSearch::Index::IndexManager::highest_seg_num", XS_KinoSearch_Index_IndexManager_highest_seg_num, file);
    newXS("KinoSearch::Index::IndexManager::make_snapshot_filename", XS_KinoSearch_Index_IndexManager_make_snapshot_filename, file);
    newXS("KinoSearch::Index::IndexManager::set_write_lock_timeout", XS_KinoSearch_Index_IndexManager_set_write_lock_timeout, file);
    newXS("KinoSearch::Index::IndexManager::get_write_lock_timeout", XS_KinoSearch_Index_IndexManager_get_write_lock_timeout, file);
    newXS("KinoSearch::Index::IndexManager::set_write_lock_interval", XS_KinoSearch_Index_IndexManager_set_write_lock_interval, file);
    newXS("KinoSearch::Index::IndexManager::get_write_lock_interval", XS_KinoSearch_Index_IndexManager_get_write_lock_interval, file);
    newXS("KinoSearch::Index::IndexManager::set_merge_lock_timeout", XS_KinoSearch_Index_IndexManager_set_merge_lock_timeout, file);
    newXS("KinoSearch::Index::IndexManager::get_merge_lock_timeout", XS_KinoSearch_Index_IndexManager_get_merge_lock_timeout, file);
    newXS("KinoSearch::Index::IndexManager::set_merge_lock_interval", XS_KinoSearch_Index_IndexManager_set_merge_lock_interval, file);
    newXS("KinoSearch::Index::IndexManager::get_merge_lock_interval", XS_KinoSearch_Index_IndexManager_get_merge_lock_interval, file);
    newXS("KinoSearch::Index::IndexManager::set_deletion_lock_timeout", XS_KinoSearch_Index_IndexManager_set_deletion_lock_timeout, file);
    newXS("KinoSearch::Index::IndexManager::get_deletion_lock_timeout", XS_KinoSearch_Index_IndexManager_get_deletion_lock_timeout, file);
    newXS("KinoSearch::Index::IndexManager::set_deletion_lock_interval", XS_KinoSearch_Index_IndexManager_set_deletion_lock_interval, file);
    newXS("KinoSearch::Index::IndexManager::get_deletion_lock_interval", XS_KinoSearch_Index_IndexManager_get_deletion_lock_interval, file);
    newXS("KinoSearch::Search::TopDocs::get_match_docs", XS_KinoSearch_Search_TopDocs_get_match_docs, file);
    newXS("KinoSearch::Search::TopDocs::get_total_hits", XS_KinoSearch_Search_TopDocs_get_total_hits, file);
    newXS("KinoSearch::Search::TopDocs::set_total_hits", XS_KinoSearch_Search_TopDocs_set_total_hits, file);
    newXS("KinoSearch::Analysis::Token::get_start_offset", XS_KinoSearch_Analysis_Token_get_start_offset, file);
    newXS("KinoSearch::Analysis::Token::get_end_offset", XS_KinoSearch_Analysis_Token_get_end_offset, file);
    newXS("KinoSearch::Analysis::Token::get_boost", XS_KinoSearch_Analysis_Token_get_boost, file);
    newXS("KinoSearch::Analysis::Token::get_pos_inc", XS_KinoSearch_Analysis_Token_get_pos_inc, file);
    newXS("KinoSearch::Index::Snapshot::list", XS_KinoSearch_Index_Snapshot_list, file);
    newXS("KinoSearch::Index::Snapshot::num_entries", XS_KinoSearch_Index_Snapshot_num_entries, file);
    newXS("KinoSearch::Index::Snapshot::add_entry", XS_KinoSearch_Index_Snapshot_add_entry, file);
    newXS("KinoSearch::Index::Snapshot::delete_entry", XS_KinoSearch_Index_Snapshot_delete_entry, file);
    newXS("KinoSearch::Index::Snapshot::read_file", XS_KinoSearch_Index_Snapshot_read_file, file);
    newXS("KinoSearch::Index::Snapshot::write_file", XS_KinoSearch_Index_Snapshot_write_file, file);
    newXS("KinoSearch::Index::Snapshot::set_path", XS_KinoSearch_Index_Snapshot_set_path, file);
    newXS("KinoSearch::Index::Snapshot::get_path", XS_KinoSearch_Index_Snapshot_get_path, file);
    newXS("KinoSearch::Search::SortRule::get_field", XS_KinoSearch_Search_SortRule_get_field, file);
    newXS("KinoSearch::Search::SortRule::get_reverse", XS_KinoSearch_Search_SortRule_get_reverse, file);
    newXS("KinoSearch::Highlight::HeatMap::flatten_spans", XS_KinoSearch_Highlight_HeatMap_flatten_spans, file);
    newXS("KinoSearch::Highlight::HeatMap::calc_proximity_boost", XS_KinoSearch_Highlight_HeatMap_calc_proximity_boost, file);
    newXS("KinoSearch::Highlight::HeatMap::generate_proximity_boosts", XS_KinoSearch_Highlight_HeatMap_generate_proximity_boosts, file);
    newXS("KinoSearch::Highlight::HeatMap::get_spans", XS_KinoSearch_Highlight_HeatMap_get_spans, file);
    newXS("KinoSearch::Object::LockFreeRegistry::register", XS_KinoSearch_Object_LockFreeRegistry_register, file);
    newXS("KinoSearch::Object::LockFreeRegistry::fetch", XS_KinoSearch_Object_LockFreeRegistry_fetch, file);
    newXS("KinoSearch::Index::SortCache::ordinal", XS_KinoSearch_Index_SortCache_ordinal, file);
    newXS("KinoSearch::Index::SortCache::find", XS_KinoSearch_Index_SortCache_find, file);
    newXS("KinoSearch::Object::Float32::set_value", XS_KinoSearch_Object_Float32_set_value, file);
    newXS("KinoSearch::Object::Float32::get_value", XS_KinoSearch_Object_Float32_get_value, file);
    newXS("KinoSearch::Object::Float64::set_value", XS_KinoSearch_Object_Float64_set_value, file);
    newXS("KinoSearch::Object::Float64::get_value", XS_KinoSearch_Object_Float64_get_value, file);
    newXS("KinoSearch::Store::LockFactory::make_lock", XS_KinoSearch_Store_LockFactory_make_lock, file);
    newXS("KinoSearch::Store::LockFactory::make_shared_lock", XS_KinoSearch_Store_LockFactory_make_shared_lock, file);
    newXS("KinoSearch::Object::VTable::get_name", XS_KinoSearch_Object_VTable_get_name, file);
    newXS("KinoSearch::Object::VTable::get_parent", XS_KinoSearch_Object_VTable_get_parent, file);
    newXS("KinoSearch::Store::FileHandle::length", XS_KinoSearch_Store_FileHandle_length, file);
    newXS("KinoSearch::Store::MockFileHandle::length", XS_KinoSearch_Store_MockFileHandle_length, file);
    newXS("KinoSearch::Store::FSFileHandle::length", XS_KinoSearch_Store_FSFileHandle_length, file);
    newXS("KinoSearch::Store::RAMFileHandle::length", XS_KinoSearch_Store_RAMFileHandle_length, file);
    newXS("KinoSearch::Store::FileHandle::close", XS_KinoSearch_Store_FileHandle_close, file);
    newXS("KinoSearch::Store::MockFileHandle::close", XS_KinoSearch_Store_MockFileHandle_close, file);
    newXS("KinoSearch::Store::FSFileHandle::close", XS_KinoSearch_Store_FSFileHandle_close, file);
    newXS("KinoSearch::Store::RAMFileHandle::close", XS_KinoSearch_Store_RAMFileHandle_close, file);
    newXS("KinoSearch::Store::RAMFileHandle::get_file", XS_KinoSearch_Store_RAMFileHandle_get_file, file);
    newXS("KinoSearch::Search::SortSpec::get_rules", XS_KinoSearch_Search_SortSpec_get_rules, file);
    newXS("KinoSearch::Object::Err::cat_mess", XS_KinoSearch_Object_Err_cat_mess, file);
    newXS("KinoSearch::Object::Err::get_mess", XS_KinoSearch_Object_Err_get_mess, file);
    newXS("KinoSearch::Analysis::Inversion::append", XS_KinoSearch_Analysis_Inversion_append, file);
    newXS("KinoSearch::Analysis::Inversion::next", XS_KinoSearch_Analysis_Inversion_next, file);
    newXS("KinoSearch::Analysis::Inversion::reset", XS_KinoSearch_Analysis_Inversion_reset, file);
    newXS("KinoSearch::Analysis::Inversion::invert", XS_KinoSearch_Analysis_Inversion_invert, file);
    newXS("KinoSearch::Index::DataWriter::add_inverted_doc", XS_KinoSearch_Index_DataWriter_add_inverted_doc, file);
    newXS("KinoSearch::Index::HighlightWriter::add_inverted_doc", XS_KinoSearch_Index_HighlightWriter_add_inverted_doc, file);
    newXS("KinoSearch::Index::PostingListWriter::add_inverted_doc", XS_KinoSearch_Index_PostingListWriter_add_inverted_doc, file);
    newXS("KinoSearch::Index::DocWriter::add_inverted_doc", XS_KinoSearch_Index_DocWriter_add_inverted_doc, file);
    newXS("KinoSearch::Index::SortWriter::add_inverted_doc", XS_KinoSearch_Index_SortWriter_add_inverted_doc, file);
    newXS("KinoSearch::Index::SegWriter::add_inverted_doc", XS_KinoSearch_Index_SegWriter_add_inverted_doc, file);
    newXS("KinoSearch::Index::DataWriter::add_segment", XS_KinoSearch_Index_DataWriter_add_segment, file);
    newXS("KinoSearch::Index::HighlightWriter::add_segment", XS_KinoSearch_Index_HighlightWriter_add_segment, file);
    newXS("KinoSearch::Index::LexiconWriter::add_segment", XS_KinoSearch_Index_LexiconWriter_add_segment, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::add_segment", XS_KinoSearch_Index_DefaultDeletionsWriter_add_segment, file);
    newXS("KinoSearch::Index::PostingListWriter::add_segment", XS_KinoSearch_Index_PostingListWriter_add_segment, file);
    newXS("KinoSearch::Index::DocWriter::add_segment", XS_KinoSearch_Index_DocWriter_add_segment, file);
    newXS("KinoSearch::Index::SortWriter::add_segment", XS_KinoSearch_Index_SortWriter_add_segment, file);
    newXS("KinoSearch::Index::SegWriter::add_segment", XS_KinoSearch_Index_SegWriter_add_segment, file);
    newXS("KinoSearch::Index::DataWriter::delete_segment", XS_KinoSearch_Index_DataWriter_delete_segment, file);
    newXS("KinoSearch::Index::SegWriter::delete_segment", XS_KinoSearch_Index_SegWriter_delete_segment, file);
    newXS("KinoSearch::Index::DataWriter::merge_segment", XS_KinoSearch_Index_DataWriter_merge_segment, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::merge_segment", XS_KinoSearch_Index_DefaultDeletionsWriter_merge_segment, file);
    newXS("KinoSearch::Index::SegWriter::merge_segment", XS_KinoSearch_Index_SegWriter_merge_segment, file);
    newXS("KinoSearch::Index::DataWriter::finish", XS_KinoSearch_Index_DataWriter_finish, file);
    newXS("KinoSearch::Index::HighlightWriter::finish", XS_KinoSearch_Index_HighlightWriter_finish, file);
    newXS("KinoSearch::Index::LexiconWriter::finish", XS_KinoSearch_Index_LexiconWriter_finish, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::finish", XS_KinoSearch_Index_DefaultDeletionsWriter_finish, file);
    newXS("KinoSearch::Index::PostingListWriter::finish", XS_KinoSearch_Index_PostingListWriter_finish, file);
    newXS("KinoSearch::Index::DocWriter::finish", XS_KinoSearch_Index_DocWriter_finish, file);
    newXS("KinoSearch::Index::SortWriter::finish", XS_KinoSearch_Index_SortWriter_finish, file);
    newXS("KinoSearch::Index::SegWriter::finish", XS_KinoSearch_Index_SegWriter_finish, file);
    newXS("KinoSearch::Index::DataWriter::metadata", XS_KinoSearch_Index_DataWriter_metadata, file);
    newXS("KinoSearch::Index::LexiconWriter::metadata", XS_KinoSearch_Index_LexiconWriter_metadata, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::metadata", XS_KinoSearch_Index_DefaultDeletionsWriter_metadata, file);
    newXS("KinoSearch::Index::SortWriter::metadata", XS_KinoSearch_Index_SortWriter_metadata, file);
    newXS("KinoSearch::Index::DataWriter::format", XS_KinoSearch_Index_DataWriter_format, file);
    newXS("KinoSearch::Index::HighlightWriter::format", XS_KinoSearch_Index_HighlightWriter_format, file);
    newXS("KinoSearch::Index::LexiconWriter::format", XS_KinoSearch_Index_LexiconWriter_format, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::format", XS_KinoSearch_Index_DefaultDeletionsWriter_format, file);
    newXS("KinoSearch::Index::PostingListWriter::format", XS_KinoSearch_Index_PostingListWriter_format, file);
    newXS("KinoSearch::Index::DocWriter::format", XS_KinoSearch_Index_DocWriter_format, file);
    newXS("KinoSearch::Index::SortWriter::format", XS_KinoSearch_Index_SortWriter_format, file);
    newXS("KinoSearch::Index::DataWriter::get_snapshot", XS_KinoSearch_Index_DataWriter_get_snapshot, file);
    newXS("KinoSearch::Index::DataWriter::get_segment", XS_KinoSearch_Index_DataWriter_get_segment, file);
    newXS("KinoSearch::Index::DataWriter::get_polyreader", XS_KinoSearch_Index_DataWriter_get_polyreader, file);
    newXS("KinoSearch::Index::DataWriter::get_schema", XS_KinoSearch_Index_DataWriter_get_schema, file);
    newXS("KinoSearch::Index::DataWriter::get_folder", XS_KinoSearch_Index_DataWriter_get_folder, file);
    newXS("KinoSearch::Index::DeletionsWriter::delete_by_term", XS_KinoSearch_Index_DeletionsWriter_delete_by_term, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::delete_by_term", XS_KinoSearch_Index_DefaultDeletionsWriter_delete_by_term, file);
    newXS("KinoSearch::Index::DeletionsWriter::delete_by_query", XS_KinoSearch_Index_DeletionsWriter_delete_by_query, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::delete_by_query", XS_KinoSearch_Index_DefaultDeletionsWriter_delete_by_query, file);
    newXS("KinoSearch::Index::DeletionsWriter::delete_by_doc_id", XS_KinoSearch_Index_DeletionsWriter_delete_by_doc_id, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::delete_by_doc_id", XS_KinoSearch_Index_DefaultDeletionsWriter_delete_by_doc_id, file);
    newXS("KinoSearch::Index::DeletionsWriter::updated", XS_KinoSearch_Index_DeletionsWriter_updated, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::updated", XS_KinoSearch_Index_DefaultDeletionsWriter_updated, file);
    newXS("KinoSearch::Index::DeletionsWriter::generate_doc_map", XS_KinoSearch_Index_DeletionsWriter_generate_doc_map, file);
    newXS("KinoSearch::Index::DeletionsWriter::seg_deletions", XS_KinoSearch_Index_DeletionsWriter_seg_deletions, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::seg_deletions", XS_KinoSearch_Index_DefaultDeletionsWriter_seg_deletions, file);
    newXS("KinoSearch::Index::DeletionsWriter::seg_del_count", XS_KinoSearch_Index_DeletionsWriter_seg_del_count, file);
    newXS("KinoSearch::Index::DefaultDeletionsWriter::seg_del_count", XS_KinoSearch_Index_DefaultDeletionsWriter_seg_del_count, file);
    newXS("KinoSearch::Index::SegWriter::register", XS_KinoSearch_Index_SegWriter_register, file);
    newXS("KinoSearch::Index::SegWriter::fetch", XS_KinoSearch_Index_SegWriter_fetch, file);
    newXS("KinoSearch::Index::SegWriter::add_writer", XS_KinoSearch_Index_SegWriter_add_writer, file);
    newXS("KinoSearch::Index::BackgroundMerger::optimize", XS_KinoSearch_Index_BackgroundMerger_optimize, file);
    newXS("KinoSearch::Index::BackgroundMerger::commit", XS_KinoSearch_Index_BackgroundMerger_commit, file);
    newXS("KinoSearch::Index::BackgroundMerger::prepare_commit", XS_KinoSearch_Index_BackgroundMerger_prepare_commit, file);
    newXS("KinoSearch::Store::RAMFile::get_contents", XS_KinoSearch_Store_RAMFile_get_contents, file);
    newXS("KinoSearch::Object::BitVector::get", XS_KinoSearch_Object_BitVector_get, file);
    newXS("KinoSearch::Object::BitVector::set", XS_KinoSearch_Object_BitVector_set, file);
    newXS("KinoSearch::Object::BitVector::get_capacity", XS_KinoSearch_Object_BitVector_get_capacity, file);
    newXS("KinoSearch::Object::BitVector::next_hit", XS_KinoSearch_Object_BitVector_next_hit, file);
    newXS("KinoSearch::Object::BitVector::clear", XS_KinoSearch_Object_BitVector_clear, file);
    newXS("KinoSearch::Object::BitVector::clear_all", XS_KinoSearch_Object_BitVector_clear_all, file);
    newXS("KinoSearch::Object::BitVector::grow", XS_KinoSearch_Object_BitVector_grow, file);
    newXS("KinoSearch::Object::BitVector::and", XS_KinoSearch_Object_BitVector_and, file);
    newXS("KinoSearch::Object::BitVector::or", XS_KinoSearch_Object_BitVector_or, file);
    newXS("KinoSearch::Object::BitVector::xor", XS_KinoSearch_Object_BitVector_xor, file);
    newXS("KinoSearch::Object::BitVector::and_not", XS_KinoSearch_Object_BitVector_and_not, file);
    newXS("KinoSearch::Object::BitVector::flip", XS_KinoSearch_Object_BitVector_flip, file);
    newXS("KinoSearch::Object::BitVector::flip_block", XS_KinoSearch_Object_BitVector_flip_block, file);
    newXS("KinoSearch::Object::BitVector::count", XS_KinoSearch_Object_BitVector_count, file);
    newXS("KinoSearch::Object::BitVector::to_array", XS_KinoSearch_Object_BitVector_to_array, file);
    newXS("KinoSearch::Util::Stepper::read_record", XS_KinoSearch_Util_Stepper_read_record, file);
    newXS("KinoSearch::Index::SkipStepper::read_record", XS_KinoSearch_Index_SkipStepper_read_record, file);
    newXS("KinoSearch::Index::Posting::MatchPosting::read_record", XS_KinoSearch_Index_Posting_MatchPosting_read_record, file);
    newXS("KinoSearch::Index::Posting::ScorePosting::read_record", XS_KinoSearch_Index_Posting_ScorePosting_read_record, file);
    newXS("KinoSearch::Index::Posting::RichPosting::read_record", XS_KinoSearch_Index_Posting_RichPosting_read_record, file);
    newXS("KinoSearch::Index::Posting::get_doc_id", XS_KinoSearch_Index_Posting_get_doc_id, file);
    newXS("KinoSearch::Index::Posting::MatchPosting::get_freq", XS_KinoSearch_Index_Posting_MatchPosting_get_freq, file);
    newXS("KinoSearch::Plan::Architecture::register_posting_list_writer", XS_KinoSearch_Plan_Architecture_register_posting_list_writer, file);
    newXS("KinoSearch::Plan::Architecture::register_doc_writer", XS_KinoSearch_Plan_Architecture_register_doc_writer, file);
    newXS("KinoSearch::Plan::Architecture::register_sort_writer", XS_KinoSearch_Plan_Architecture_register_sort_writer, file);
    newXS("KinoSearch::Plan::Architecture::register_highlight_writer", XS_KinoSearch_Plan_Architecture_register_highlight_writer, file);
    newXS("KinoSearch::Plan::Architecture::register_deletions_writer", XS_KinoSearch_Plan_Architecture_register_deletions_writer, file);
    newXS("KinoSearch::Plan::Architecture::init_seg_reader", XS_KinoSearch_Plan_Architecture_init_seg_reader, file);
    newXS("KinoSearch::Plan::Architecture::register_doc_reader", XS_KinoSearch_Plan_Architecture_register_doc_reader, file);
    newXS("KinoSearch::Plan::Architecture::register_posting_list_reader", XS_KinoSearch_Plan_Architecture_register_posting_list_reader, file);
    newXS("KinoSearch::Plan::Architecture::register_sort_reader", XS_KinoSearch_Plan_Architecture_register_sort_reader, file);
    newXS("KinoSearch::Plan::Architecture::register_highlight_reader", XS_KinoSearch_Plan_Architecture_register_highlight_reader, file);
    newXS("KinoSearch::Plan::Architecture::register_lexicon_reader", XS_KinoSearch_Plan_Architecture_register_lexicon_reader, file);
    newXS("KinoSearch::Plan::Architecture::register_deletions_reader", XS_KinoSearch_Plan_Architecture_register_deletions_reader, file);
    newXS("KinoSearch::Plan::Architecture::make_similarity", XS_KinoSearch_Plan_Architecture_make_similarity, file);
    newXS("KinoSearch::Plan::Architecture::index_interval", XS_KinoSearch_Plan_Architecture_index_interval, file);
    newXS("KinoSearch::Test::Plan::TestArchitecture::index_interval", XS_KinoSearch_Test_Plan_TestArchitecture_index_interval, file);
    newXS("KinoSearch::Plan::Architecture::skip_interval", XS_KinoSearch_Plan_Architecture_skip_interval, file);
    newXS("KinoSearch::Test::Plan::TestArchitecture::skip_interval", XS_KinoSearch_Test_Plan_TestArchitecture_skip_interval, file);
    newXS("KinoSearch::Plan::FieldType::get_boost", XS_KinoSearch_Plan_FieldType_get_boost, file);
    newXS("KinoSearch::Plan::FieldType::indexed", XS_KinoSearch_Plan_FieldType_indexed, file);
    newXS("KinoSearch::Plan::FieldType::stored", XS_KinoSearch_Plan_FieldType_stored, file);
    newXS("KinoSearch::Plan::FieldType::sortable", XS_KinoSearch_Plan_FieldType_sortable, file);
    newXS("KinoSearch::Plan::FieldType::binary", XS_KinoSearch_Plan_FieldType_binary, file);
    newXS("KinoSearch::Plan::NumericType::binary", XS_KinoSearch_Plan_NumericType_binary, file);
    newXS("KinoSearch::Plan::BlobType::binary", XS_KinoSearch_Plan_BlobType_binary, file);
    newXS("KinoSearch::Plan::FieldType::compare_values", XS_KinoSearch_Plan_FieldType_compare_values, file);
    newXS("KinoSearch::Plan::FullTextType::set_highlightable", XS_KinoSearch_Plan_FullTextType_set_highlightable, file);
    newXS("KinoSearch::Plan::FullTextType::highlightable", XS_KinoSearch_Plan_FullTextType_highlightable, file);
    newXS("KinoSearch::Search::Span::get_offset", XS_KinoSearch_Search_Span_get_offset, file);
    newXS("KinoSearch::Search::Span::set_offset", XS_KinoSearch_Search_Span_set_offset, file);
    newXS("KinoSearch::Search::Span::get_length", XS_KinoSearch_Search_Span_get_length, file);
    newXS("KinoSearch::Search::Span::set_length", XS_KinoSearch_Search_Span_set_length, file);
    newXS("KinoSearch::Search::Span::get_weight", XS_KinoSearch_Search_Span_get_weight, file);
    newXS("KinoSearch::Search::Span::set_weight", XS_KinoSearch_Search_Span_set_weight, file);
    newXS("KinoSearch::Store::Folder::get_path", XS_KinoSearch_Store_Folder_get_path, file);
    newXS("KinoSearch::Store::Folder::open_out", XS_KinoSearch_Store_Folder_open_out, file);
    newXS("KinoSearch::Store::Folder::open_in", XS_KinoSearch_Store_Folder_open_in, file);
    newXS("KinoSearch::Store::Folder::mkdir", XS_KinoSearch_Store_Folder_mkdir, file);
    newXS("KinoSearch::Store::Folder::list_r", XS_KinoSearch_Store_Folder_list_r, file);
    newXS("KinoSearch::Store::Folder::exists", XS_KinoSearch_Store_Folder_exists, file);
    newXS("KinoSearch::Store::Folder::delete", XS_KinoSearch_Store_Folder_delete, file);
    newXS("KinoSearch::Store::Folder::rename", XS_KinoSearch_Store_Folder_rename, file);
    newXS("KinoSearch::Store::FSFolder::rename", XS_KinoSearch_Store_FSFolder_rename, file);
    newXS("KinoSearch::Store::RAMFolder::rename", XS_KinoSearch_Store_RAMFolder_rename, file);
    newXS("KinoSearch::Store::Folder::hard_link", XS_KinoSearch_Store_Folder_hard_link, file);
    newXS("KinoSearch::Store::FSFolder::hard_link", XS_KinoSearch_Store_FSFolder_hard_link, file);
    newXS("KinoSearch::Store::RAMFolder::hard_link", XS_KinoSearch_Store_RAMFolder_hard_link, file);
    newXS("KinoSearch::Store::Folder::slurp_file", XS_KinoSearch_Store_Folder_slurp_file, file);
    newXS("KinoSearch::Store::Folder::close", XS_KinoSearch_Store_Folder_close, file);
    newXS("KinoSearch::Store::FSFolder::close", XS_KinoSearch_Store_FSFolder_close, file);
    newXS("KinoSearch::Store::RAMFolder::close", XS_KinoSearch_Store_RAMFolder_close, file);
    newXS("KinoSearch::Store::CompoundFileReader::close", XS_KinoSearch_Store_CompoundFileReader_close, file);
    newXS("KinoSearch::Util::PriorityQueue::less_than", XS_KinoSearch_Util_PriorityQueue_less_than, file);
    newXS("KinoSearch::Test::Util::NumPriorityQueue::less_than", XS_KinoSearch_Test_Util_NumPriorityQueue_less_than, file);
    newXS("KinoSearch::Index::SegLexQueue::less_than", XS_KinoSearch_Index_SegLexQueue_less_than, file);
    newXS("KinoSearch::Search::HitQueue::less_than", XS_KinoSearch_Search_HitQueue_less_than, file);
    newXS("KinoSearch::Util::PriorityQueue::insert", XS_KinoSearch_Util_PriorityQueue_insert, file);
    newXS("KinoSearch::Util::PriorityQueue::pop", XS_KinoSearch_Util_PriorityQueue_pop, file);
    newXS("KinoSearch::Util::PriorityQueue::pop_all", XS_KinoSearch_Util_PriorityQueue_pop_all, file);
    newXS("KinoSearch::Util::PriorityQueue::peek", XS_KinoSearch_Util_PriorityQueue_peek, file);
    newXS("KinoSearch::Util::PriorityQueue::get_size", XS_KinoSearch_Util_PriorityQueue_get_size, file);
    newXS("KinoSearch::Search::Matcher::next", XS_KinoSearch_Search_Matcher_next, file);
    newXS("KinoSearch::Search::BitVecMatcher::next", XS_KinoSearch_Search_BitVecMatcher_next, file);
    newXS("KinoSearch::Search::PhraseScorer::next", XS_KinoSearch_Search_PhraseScorer_next, file);
    newXS("KinoSearch::Search::TermScorer::next", XS_KinoSearch_Search_TermScorer_next, file);
    newXS("KinoSearch::Search::SeriesMatcher::next", XS_KinoSearch_Search_SeriesMatcher_next, file);
    newXS("KinoSearch::Index::SegPostingList::next", XS_KinoSearch_Index_SegPostingList_next, file);
    newXS("KSx::Search::FilterScorer::next", XS_KSx_Search_FilterScorer_next, file);
    newXS("KSx::Search::ProximityScorer::next", XS_KSx_Search_ProximityScorer_next, file);
    newXS("KinoSearch::Search::NoMatchScorer::next", XS_KinoSearch_Search_NoMatchScorer_next, file);
    newXS("KSx::Search::MockMatcher::next", XS_KSx_Search_MockMatcher_next, file);
    newXS("KinoSearch::Search::ORMatcher::next", XS_KinoSearch_Search_ORMatcher_next, file);
    newXS("KinoSearch::Search::ORScorer::next", XS_KinoSearch_Search_ORScorer_next, file);
    newXS("KinoSearch::Search::ANDScorer::next", XS_KinoSearch_Search_ANDScorer_next, file);
    newXS("KinoSearch::Search::NOTScorer::next", XS_KinoSearch_Search_NOTScorer_next, file);
    newXS("KinoSearch::Search::RequiredOptionalScorer::next", XS_KinoSearch_Search_RequiredOptionalScorer_next, file);
    newXS("KinoSearch::Search::RangeScorer::next", XS_KinoSearch_Search_RangeScorer_next, file);
    newXS("KinoSearch::Search::MatchAllScorer::next", XS_KinoSearch_Search_MatchAllScorer_next, file);
    newXS("KinoSearch::Search::Matcher::advance", XS_KinoSearch_Search_Matcher_advance, file);
    newXS("KinoSearch::Search::BitVecMatcher::advance", XS_KinoSearch_Search_BitVecMatcher_advance, file);
    newXS("KinoSearch::Search::PhraseScorer::advance", XS_KinoSearch_Search_PhraseScorer_advance, file);
    newXS("KinoSearch::Search::TermScorer::advance", XS_KinoSearch_Search_TermScorer_advance, file);
    newXS("KinoSearch::Search::SeriesMatcher::advance", XS_KinoSearch_Search_SeriesMatcher_advance, file);
    newXS("KinoSearch::Index::SegPostingList::advance", XS_KinoSearch_Index_SegPostingList_advance, file);
    newXS("KSx::Search::ProximityScorer::advance", XS_KSx_Search_ProximityScorer_advance, file);
    newXS("KinoSearch::Search::NoMatchScorer::advance", XS_KinoSearch_Search_NoMatchScorer_advance, file);
    newXS("KinoSearch::Search::ORMatcher::advance", XS_KinoSearch_Search_ORMatcher_advance, file);
    newXS("KinoSearch::Search::ORScorer::advance", XS_KinoSearch_Search_ORScorer_advance, file);
    newXS("KinoSearch::Search::ANDScorer::advance", XS_KinoSearch_Search_ANDScorer_advance, file);
    newXS("KinoSearch::Search::NOTScorer::advance", XS_KinoSearch_Search_NOTScorer_advance, file);
    newXS("KinoSearch::Search::RequiredOptionalScorer::advance", XS_KinoSearch_Search_RequiredOptionalScorer_advance, file);
    newXS("KinoSearch::Search::RangeScorer::advance", XS_KinoSearch_Search_RangeScorer_advance, file);
    newXS("KinoSearch::Search::MatchAllScorer::advance", XS_KinoSearch_Search_MatchAllScorer_advance, file);
    newXS("KinoSearch::Search::Matcher::get_doc_id", XS_KinoSearch_Search_Matcher_get_doc_id, file);
    newXS("KinoSearch::Search::BitVecMatcher::get_doc_id", XS_KinoSearch_Search_BitVecMatcher_get_doc_id, file);
    newXS("KinoSearch::Search::PhraseScorer::get_doc_id", XS_KinoSearch_Search_PhraseScorer_get_doc_id, file);
    newXS("KinoSearch::Search::TermScorer::get_doc_id", XS_KinoSearch_Search_TermScorer_get_doc_id, file);
    newXS("KinoSearch::Search::SeriesMatcher::get_doc_id", XS_KinoSearch_Search_SeriesMatcher_get_doc_id, file);
    newXS("KinoSearch::Index::SegPostingList::get_doc_id", XS_KinoSearch_Index_SegPostingList_get_doc_id, file);
    newXS("KSx::Search::FilterScorer::get_doc_id", XS_KSx_Search_FilterScorer_get_doc_id, file);
    newXS("KSx::Search::ProximityScorer::get_doc_id", XS_KSx_Search_ProximityScorer_get_doc_id, file);
    newXS("KSx::Search::MockMatcher::get_doc_id", XS_KSx_Search_MockMatcher_get_doc_id, file);
    newXS("KinoSearch::Search::ORMatcher::get_doc_id", XS_KinoSearch_Search_ORMatcher_get_doc_id, file);
    newXS("KinoSearch::Search::ORScorer::get_doc_id", XS_KinoSearch_Search_ORScorer_get_doc_id, file);
    newXS("KinoSearch::Search::ANDScorer::get_doc_id", XS_KinoSearch_Search_ANDScorer_get_doc_id, file);
    newXS("KinoSearch::Search::NOTScorer::get_doc_id", XS_KinoSearch_Search_NOTScorer_get_doc_id, file);
    newXS("KinoSearch::Search::RequiredOptionalScorer::get_doc_id", XS_KinoSearch_Search_RequiredOptionalScorer_get_doc_id, file);
    newXS("KinoSearch::Search::RangeScorer::get_doc_id", XS_KinoSearch_Search_RangeScorer_get_doc_id, file);
    newXS("KinoSearch::Search::MatchAllScorer::get_doc_id", XS_KinoSearch_Search_MatchAllScorer_get_doc_id, file);
    newXS("KinoSearch::Search::Matcher::score", XS_KinoSearch_Search_Matcher_score, file);
    newXS("KinoSearch::Search::PhraseScorer::score", XS_KinoSearch_Search_PhraseScorer_score, file);
    newXS("KinoSearch::Index::Posting::MatchPostingScorer::score", XS_KinoSearch_Index_Posting_MatchPostingScorer_score, file);
    newXS("KinoSearch::Index::Posting::ScorePostingScorer::score", XS_KinoSearch_Index_Posting_ScorePostingScorer_score, file);
    newXS("KSx::Search::FilterScorer::score", XS_KSx_Search_FilterScorer_score, file);
    newXS("KSx::Search::ProximityScorer::score", XS_KSx_Search_ProximityScorer_score, file);
    newXS("KSx::Search::MockMatcher::score", XS_KSx_Search_MockMatcher_score, file);
    newXS("KinoSearch::Search::ORScorer::score", XS_KinoSearch_Search_ORScorer_score, file);
    newXS("KinoSearch::Search::ANDScorer::score", XS_KinoSearch_Search_ANDScorer_score, file);
    newXS("KinoSearch::Search::NOTScorer::score", XS_KinoSearch_Search_NOTScorer_score, file);
    newXS("KinoSearch::Search::RequiredOptionalScorer::score", XS_KinoSearch_Search_RequiredOptionalScorer_score, file);
    newXS("KinoSearch::Search::RangeScorer::score", XS_KinoSearch_Search_RangeScorer_score, file);
    newXS("KinoSearch::Search::MatchAllScorer::score", XS_KinoSearch_Search_MatchAllScorer_score, file);
    newXS("KinoSearch::Search::Matcher::collect", XS_KinoSearch_Search_Matcher_collect, file);
    newXS("KinoSearch::Index::PostingList::get_posting", XS_KinoSearch_Index_PostingList_get_posting, file);
    newXS("KinoSearch::Index::SegPostingList::get_posting", XS_KinoSearch_Index_SegPostingList_get_posting, file);
    newXS("KinoSearch::Index::RawPostingList::get_posting", XS_KinoSearch_Index_RawPostingList_get_posting, file);
    newXS("KinoSearch::Index::PostingList::get_doc_freq", XS_KinoSearch_Index_PostingList_get_doc_freq, file);
    newXS("KinoSearch::Index::SegPostingList::get_doc_freq", XS_KinoSearch_Index_SegPostingList_get_doc_freq, file);
    newXS("KinoSearch::Index::PostingList::seek", XS_KinoSearch_Index_PostingList_seek, file);
    newXS("KinoSearch::Index::SegPostingList::seek", XS_KinoSearch_Index_SegPostingList_seek, file);
    newXS("KinoSearch::Index::PostingList::make_matcher", XS_KinoSearch_Index_PostingList_make_matcher, file);
    newXS("KinoSearch::Index::SegPostingList::make_matcher", XS_KinoSearch_Index_SegPostingList_make_matcher, file);
    newXS("KinoSearch::Index::SegPostingList::get_post_stream", XS_KinoSearch_Index_SegPostingList_get_post_stream, file);
    newXS("KinoSearch::Index::SegPostingList::get_count", XS_KinoSearch_Index_SegPostingList_get_count, file);
    newXS("KinoSearch::Object::Hash::clear", XS_KinoSearch_Object_Hash_clear, file);
    newXS("KinoSearch::Object::Hash::fetch", XS_KinoSearch_Object_Hash_fetch, file);
    newXS("KinoSearch::Object::Hash::delete", XS_KinoSearch_Object_Hash_delete, file);
    newXS("KinoSearch::Object::Hash::iterate", XS_KinoSearch_Object_Hash_iterate, file);
    newXS("KinoSearch::Object::Hash::find_key", XS_KinoSearch_Object_Hash_find_key, file);
    newXS("KinoSearch::Object::Hash::keys", XS_KinoSearch_Object_Hash_keys, file);
    newXS("KinoSearch::Object::Hash::values", XS_KinoSearch_Object_Hash_values, file);
    newXS("KinoSearch::Object::Hash::get_size", XS_KinoSearch_Object_Hash_get_size, file);
    newXS("KinoSearch::Search::Hits::next", XS_KinoSearch_Search_Hits_next, file);
    newXS("KinoSearch::Search::Hits::total_hits", XS_KinoSearch_Search_Hits_total_hits, file);
    newXS("KinoSearch::Object::VArray::push", XS_KinoSearch_Object_VArray_push, file);
    newXS("KinoSearch::Object::VArray::push_varray", XS_KinoSearch_Object_VArray_push_varray, file);
    newXS("KinoSearch::Object::VArray::unshift", XS_KinoSearch_Object_VArray_unshift, file);
    newXS("KinoSearch::Object::VArray::excise", XS_KinoSearch_Object_VArray_excise, file);
    newXS("KinoSearch::Object::VArray::resize", XS_KinoSearch_Object_VArray_resize, file);
    newXS("KinoSearch::Object::VArray::get_size", XS_KinoSearch_Object_VArray_get_size, file);
    newXS("KinoSearch::Search::Query::_make_compiler", XS_KinoSearch_Search_Query__make_compiler, file);
    newXS("KinoSearch::Search::NoMatchQuery::_make_compiler", XS_KinoSearch_Search_NoMatchQuery__make_compiler, file);
    newXS("KinoSearch::Search::MatchAllQuery::_make_compiler", XS_KinoSearch_Search_MatchAllQuery__make_compiler, file);
    newXS("KinoSearch::Search::PhraseQuery::_make_compiler", XS_KinoSearch_Search_PhraseQuery__make_compiler, file);
    newXS("KinoSearch::Search::ANDQuery::_make_compiler", XS_KinoSearch_Search_ANDQuery__make_compiler, file);
    newXS("KinoSearch::Search::RequiredOptionalQuery::_make_compiler", XS_KinoSearch_Search_RequiredOptionalQuery__make_compiler, file);
    newXS("KinoSearch::Search::NOTQuery::_make_compiler", XS_KinoSearch_Search_NOTQuery__make_compiler, file);
    newXS("KinoSearch::Search::ORQuery::_make_compiler", XS_KinoSearch_Search_ORQuery__make_compiler, file);
    newXS("KinoSearch::Search::TermQuery::_make_compiler", XS_KinoSearch_Search_TermQuery__make_compiler, file);
    newXS("KSx::Search::ProximityQuery::_make_compiler", XS_KSx_Search_ProximityQuery__make_compiler, file);
    newXS("KinoSearch::Search::LeafQuery::_make_compiler", XS_KinoSearch_Search_LeafQuery__make_compiler, file);
    newXS("KinoSearch::Search::RangeQuery::_make_compiler", XS_KinoSearch_Search_RangeQuery__make_compiler, file);
    newXS("KinoSearch::Search::Query::set_boost", XS_KinoSearch_Search_Query_set_boost, file);
    newXS("KinoSearch::Search::Query::get_boost", XS_KinoSearch_Search_Query_get_boost, file);
    newXS("KinoSearch::Search::PhraseQuery::get_field", XS_KinoSearch_Search_PhraseQuery_get_field, file);
    newXS("KinoSearch::Search::PhraseQuery::get_terms", XS_KinoSearch_Search_PhraseQuery_get_terms, file);
    newXS("KinoSearch::Search::PolyQuery::add_child", XS_KinoSearch_Search_PolyQuery_add_child, file);
    newXS("KinoSearch::Search::PolyQuery::set_children", XS_KinoSearch_Search_PolyQuery_set_children, file);
    newXS("KinoSearch::Search::PolyQuery::get_children", XS_KinoSearch_Search_PolyQuery_get_children, file);
    newXS("KinoSearch::Search::RequiredOptionalQuery::get_required_query", XS_KinoSearch_Search_RequiredOptionalQuery_get_required_query, file);
    newXS("KinoSearch::Search::RequiredOptionalQuery::set_required_query", XS_KinoSearch_Search_RequiredOptionalQuery_set_required_query, file);
    newXS("KinoSearch::Search::RequiredOptionalQuery::get_optional_query", XS_KinoSearch_Search_RequiredOptionalQuery_get_optional_query, file);
    newXS("KinoSearch::Search::RequiredOptionalQuery::set_optional_query", XS_KinoSearch_Search_RequiredOptionalQuery_set_optional_query, file);
    newXS("KinoSearch::Search::NOTQuery::get_negated_query", XS_KinoSearch_Search_NOTQuery_get_negated_query, file);
    newXS("KinoSearch::Search::NOTQuery::set_negated_query", XS_KinoSearch_Search_NOTQuery_set_negated_query, file);
    newXS("KinoSearch::Search::TermQuery::get_field", XS_KinoSearch_Search_TermQuery_get_field, file);
    newXS("KinoSearch::Search::TermQuery::get_term", XS_KinoSearch_Search_TermQuery_get_term, file);
    newXS("KSx::Search::ProximityQuery::get_field", XS_KSx_Search_ProximityQuery_get_field, file);
    newXS("KSx::Search::ProximityQuery::get_terms", XS_KSx_Search_ProximityQuery_get_terms, file);
    newXS("KinoSearch::Search::LeafQuery::get_field", XS_KinoSearch_Search_LeafQuery_get_field, file);
    newXS("KinoSearch::Search::LeafQuery::get_text", XS_KinoSearch_Search_LeafQuery_get_text, file);
    newXS("KinoSearch::Search::Compiler::make_matcher", XS_KinoSearch_Search_Compiler_make_matcher, file);
    newXS("KinoSearch::Search::PhraseCompiler::make_matcher", XS_KinoSearch_Search_PhraseCompiler_make_matcher, file);
    newXS("KSx::Search::ProximityCompiler::make_matcher", XS_KSx_Search_ProximityCompiler_make_matcher, file);
    newXS("KinoSearch::Search::RequiredOptionalCompiler::make_matcher", XS_KinoSearch_Search_RequiredOptionalCompiler_make_matcher, file);
    newXS("KinoSearch::Search::ANDCompiler::make_matcher", XS_KinoSearch_Search_ANDCompiler_make_matcher, file);
    newXS("KinoSearch::Search::NOTCompiler::make_matcher", XS_KinoSearch_Search_NOTCompiler_make_matcher, file);
    newXS("KinoSearch::Search::ORCompiler::make_matcher", XS_KinoSearch_Search_ORCompiler_make_matcher, file);
    newXS("KinoSearch::Search::MatchAllCompiler::make_matcher", XS_KinoSearch_Search_MatchAllCompiler_make_matcher, file);
    newXS("KinoSearch::Search::NoMatchCompiler::make_matcher", XS_KinoSearch_Search_NoMatchCompiler_make_matcher, file);
    newXS("KinoSearch::Search::TermCompiler::make_matcher", XS_KinoSearch_Search_TermCompiler_make_matcher, file);
    newXS("KinoSearch::Search::RangeCompiler::make_matcher", XS_KinoSearch_Search_RangeCompiler_make_matcher, file);
    newXS("KinoSearch::Search::Compiler::get_weight", XS_KinoSearch_Search_Compiler_get_weight, file);
    newXS("KinoSearch::Search::PhraseCompiler::get_weight", XS_KinoSearch_Search_PhraseCompiler_get_weight, file);
    newXS("KSx::Search::ProximityCompiler::get_weight", XS_KSx_Search_ProximityCompiler_get_weight, file);
    newXS("KinoSearch::Search::TermCompiler::get_weight", XS_KinoSearch_Search_TermCompiler_get_weight, file);
    newXS("KinoSearch::Search::Compiler::get_similarity", XS_KinoSearch_Search_Compiler_get_similarity, file);
    newXS("KinoSearch::Search::Compiler::get_parent", XS_KinoSearch_Search_Compiler_get_parent, file);
    newXS("KinoSearch::Search::Compiler::sum_of_squared_weights", XS_KinoSearch_Search_Compiler_sum_of_squared_weights, file);
    newXS("KinoSearch::Search::PhraseCompiler::sum_of_squared_weights", XS_KinoSearch_Search_PhraseCompiler_sum_of_squared_weights, file);
    newXS("KSx::Search::ProximityCompiler::sum_of_squared_weights", XS_KSx_Search_ProximityCompiler_sum_of_squared_weights, file);
    newXS("KinoSearch::Search::PolyCompiler::sum_of_squared_weights", XS_KinoSearch_Search_PolyCompiler_sum_of_squared_weights, file);
    newXS("KinoSearch::Search::NOTCompiler::sum_of_squared_weights", XS_KinoSearch_Search_NOTCompiler_sum_of_squared_weights, file);
    newXS("KinoSearch::Search::TermCompiler::sum_of_squared_weights", XS_KinoSearch_Search_TermCompiler_sum_of_squared_weights, file);
    newXS("KinoSearch::Search::Compiler::apply_norm_factor", XS_KinoSearch_Search_Compiler_apply_norm_factor, file);
    newXS("KinoSearch::Search::PhraseCompiler::apply_norm_factor", XS_KinoSearch_Search_PhraseCompiler_apply_norm_factor, file);
    newXS("KSx::Search::ProximityCompiler::apply_norm_factor", XS_KSx_Search_ProximityCompiler_apply_norm_factor, file);
    newXS("KinoSearch::Search::PolyCompiler::apply_norm_factor", XS_KinoSearch_Search_PolyCompiler_apply_norm_factor, file);
    newXS("KinoSearch::Search::TermCompiler::apply_norm_factor", XS_KinoSearch_Search_TermCompiler_apply_norm_factor, file);
    newXS("KinoSearch::Search::Compiler::normalize", XS_KinoSearch_Search_Compiler_normalize, file);
    newXS("KinoSearch::Search::Compiler::highlight_spans", XS_KinoSearch_Search_Compiler_highlight_spans, file);
    newXS("KinoSearch::Search::PhraseCompiler::highlight_spans", XS_KinoSearch_Search_PhraseCompiler_highlight_spans, file);
    newXS("KSx::Search::ProximityCompiler::highlight_spans", XS_KSx_Search_ProximityCompiler_highlight_spans, file);
    newXS("KinoSearch::Search::PolyCompiler::highlight_spans", XS_KinoSearch_Search_PolyCompiler_highlight_spans, file);
    newXS("KinoSearch::Search::NOTCompiler::highlight_spans", XS_KinoSearch_Search_NOTCompiler_highlight_spans, file);
    newXS("KinoSearch::Search::TermCompiler::highlight_spans", XS_KinoSearch_Search_TermCompiler_highlight_spans, file);
    newXS("KinoSearch::Object::ByteBuf::get_size", XS_KinoSearch_Object_ByteBuf_get_size, file);
    newXS("KinoSearch::Object::ByteBuf::get_capacity", XS_KinoSearch_Object_ByteBuf_get_capacity, file);
    newXS("KinoSearch::Object::ByteBuf::cat", XS_KinoSearch_Object_ByteBuf_cat, file);
    newXS("KinoSearch::Index::Indexer::add_index", XS_KinoSearch_Index_Indexer_add_index, file);
    newXS("KinoSearch::Index::Indexer::delete_by_term", XS_KinoSearch_Index_Indexer_delete_by_term, file);
    newXS("KinoSearch::Index::Indexer::delete_by_query", XS_KinoSearch_Index_Indexer_delete_by_query, file);
    newXS("KinoSearch::Index::Indexer::optimize", XS_KinoSearch_Index_Indexer_optimize, file);
    newXS("KinoSearch::Index::Indexer::commit", XS_KinoSearch_Index_Indexer_commit, file);
    newXS("KinoSearch::Index::Indexer::prepare_commit", XS_KinoSearch_Index_Indexer_prepare_commit, file);
    newXS("KinoSearch::Search::Searcher::doc_max", XS_KinoSearch_Search_Searcher_doc_max, file);
    newXS("KinoSearch::Search::PolySearcher::doc_max", XS_KinoSearch_Search_PolySearcher_doc_max, file);
    newXS("KinoSearch::Search::IndexSearcher::doc_max", XS_KinoSearch_Search_IndexSearcher_doc_max, file);
    newXS("KinoSearch::Search::Searcher::doc_freq", XS_KinoSearch_Search_Searcher_doc_freq, file);
    newXS("KinoSearch::Search::PolySearcher::doc_freq", XS_KinoSearch_Search_PolySearcher_doc_freq, file);
    newXS("KinoSearch::Search::IndexSearcher::doc_freq", XS_KinoSearch_Search_IndexSearcher_doc_freq, file);
    newXS("KinoSearch::Search::Searcher::glean_query", XS_KinoSearch_Search_Searcher_glean_query, file);
    newXS("KinoSearch::Search::Searcher::hits", XS_KinoSearch_Search_Searcher_hits, file);
    newXS("KinoSearch::Search::Searcher::collect", XS_KinoSearch_Search_Searcher_collect, file);
    newXS("KinoSearch::Search::PolySearcher::collect", XS_KinoSearch_Search_PolySearcher_collect, file);
    newXS("KinoSearch::Search::IndexSearcher::collect", XS_KinoSearch_Search_IndexSearcher_collect, file);
    newXS("KinoSearch::Search::Searcher::top_docs", XS_KinoSearch_Search_Searcher_top_docs, file);
    newXS("KinoSearch::Search::PolySearcher::top_docs", XS_KinoSearch_Search_PolySearcher_top_docs, file);
    newXS("KinoSearch::Search::IndexSearcher::top_docs", XS_KinoSearch_Search_IndexSearcher_top_docs, file);
    newXS("KinoSearch::Search::Searcher::fetch_doc", XS_KinoSearch_Search_Searcher_fetch_doc, file);
    newXS("KinoSearch::Search::PolySearcher::fetch_doc", XS_KinoSearch_Search_PolySearcher_fetch_doc, file);
    newXS("KinoSearch::Search::IndexSearcher::fetch_doc", XS_KinoSearch_Search_IndexSearcher_fetch_doc, file);
    newXS("KinoSearch::Search::Searcher::fetch_doc_vec", XS_KinoSearch_Search_Searcher_fetch_doc_vec, file);
    newXS("KinoSearch::Search::PolySearcher::fetch_doc_vec", XS_KinoSearch_Search_PolySearcher_fetch_doc_vec, file);
    newXS("KinoSearch::Search::IndexSearcher::fetch_doc_vec", XS_KinoSearch_Search_IndexSearcher_fetch_doc_vec, file);
    newXS("KinoSearch::Search::Searcher::get_schema", XS_KinoSearch_Search_Searcher_get_schema, file);
    newXS("KinoSearch::Search::Searcher::close", XS_KinoSearch_Search_Searcher_close, file);
    newXS("KinoSearch::Search::IndexSearcher::close", XS_KinoSearch_Search_IndexSearcher_close, file);
    newXS("KinoSearch::Search::IndexSearcher::get_reader", XS_KinoSearch_Search_IndexSearcher_get_reader, file);
    newXS("KinoSearch::Index::Similarity::tf", XS_KinoSearch_Index_Similarity_tf, file);
    newXS("KinoSearch::Index::Similarity::idf", XS_KinoSearch_Index_Similarity_idf, file);
    newXS("KinoSearch::Index::Similarity::coord", XS_KinoSearch_Index_Similarity_coord, file);
    newXS("KinoSearch::Index::Similarity::length_norm", XS_KinoSearch_Index_Similarity_length_norm, file);
    newXS("KinoSearch::Index::Similarity::query_norm", XS_KinoSearch_Index_Similarity_query_norm, file);
    newXS("KinoSearch::Index::Similarity::encode_norm", XS_KinoSearch_Index_Similarity_encode_norm, file);
    newXS("KinoSearch::Index::Similarity::decode_norm", XS_KinoSearch_Index_Similarity_decode_norm, file);
    newXS("KinoSearch::Analysis::Analyzer::transform", XS_KinoSearch_Analysis_Analyzer_transform, file);
    newXS("KinoSearch::Test::Analysis::DummyAnalyzer::transform", XS_KinoSearch_Test_Analysis_DummyAnalyzer_transform, file);
    newXS("KinoSearch::Analysis::PolyAnalyzer::transform", XS_KinoSearch_Analysis_PolyAnalyzer_transform, file);
    newXS("KinoSearch::Analysis::Stopalizer::transform", XS_KinoSearch_Analysis_Stopalizer_transform, file);
    newXS("KinoSearch::Analysis::CaseFolder::transform", XS_KinoSearch_Analysis_CaseFolder_transform, file);
    newXS("KinoSearch::Analysis::Tokenizer::transform", XS_KinoSearch_Analysis_Tokenizer_transform, file);
    newXS("KinoSearch::Analysis::Stemmer::transform", XS_KinoSearch_Analysis_Stemmer_transform, file);
    newXS("KinoSearch::Analysis::Analyzer::transform_text", XS_KinoSearch_Analysis_Analyzer_transform_text, file);
    newXS("KinoSearch::Analysis::PolyAnalyzer::transform_text", XS_KinoSearch_Analysis_PolyAnalyzer_transform_text, file);
    newXS("KinoSearch::Analysis::CaseFolder::transform_text", XS_KinoSearch_Analysis_CaseFolder_transform_text, file);
    newXS("KinoSearch::Analysis::Tokenizer::transform_text", XS_KinoSearch_Analysis_Tokenizer_transform_text, file);
    newXS("KinoSearch::Analysis::Analyzer::split", XS_KinoSearch_Analysis_Analyzer_split, file);
    newXS("KinoSearch::Analysis::PolyAnalyzer::get_analyzers", XS_KinoSearch_Analysis_PolyAnalyzer_get_analyzers, file);
    newXS("KinoSearch::Analysis::Tokenizer::set_token_re", XS_KinoSearch_Analysis_Tokenizer_set_token_re, file);
    newXS("KinoSearch::Index::TermVector::get_positions", XS_KinoSearch_Index_TermVector_get_positions, file);
    newXS("KinoSearch::Index::TermVector::get_start_offsets", XS_KinoSearch_Index_TermVector_get_start_offsets, file);
    newXS("KinoSearch::Index::TermVector::get_end_offsets", XS_KinoSearch_Index_TermVector_get_end_offsets, file);
    newXS("KinoSearch::Store::InStream::reopen", XS_KinoSearch_Store_InStream_reopen, file);
    newXS("KinoSearch::Store::InStream::close", XS_KinoSearch_Store_InStream_close, file);
    newXS("KinoSearch::Store::InStream::seek", XS_KinoSearch_Store_InStream_seek, file);
    newXS("KinoSearch::Store::InStream::tell", XS_KinoSearch_Store_InStream_tell, file);
    newXS("KinoSearch::Store::InStream::length", XS_KinoSearch_Store_InStream_length, file);
    newXS("KinoSearch::Store::InStream::read_i8", XS_KinoSearch_Store_InStream_read_i8, file);
    newXS("KinoSearch::Store::InStream::read_u8", XS_KinoSearch_Store_InStream_read_u8, file);
    newXS("KinoSearch::Store::InStream::read_i32", XS_KinoSearch_Store_InStream_read_i32, file);
    newXS("KinoSearch::Store::InStream::read_u32", XS_KinoSearch_Store_InStream_read_u32, file);
    newXS("KinoSearch::Store::InStream::read_i64", XS_KinoSearch_Store_InStream_read_i64, file);
    newXS("KinoSearch::Store::InStream::read_u64", XS_KinoSearch_Store_InStream_read_u64, file);
    newXS("KinoSearch::Store::InStream::read_f32", XS_KinoSearch_Store_InStream_read_f32, file);
    newXS("KinoSearch::Store::InStream::read_f64", XS_KinoSearch_Store_InStream_read_f64, file);
    newXS("KinoSearch::Store::InStream::read_c32", XS_KinoSearch_Store_InStream_read_c32, file);
    newXS("KinoSearch::Store::InStream::read_c64", XS_KinoSearch_Store_InStream_read_c64, file);
    newXS("KinoSearch::Index::DataReader::aggregator", XS_KinoSearch_Index_DataReader_aggregator, file);
    newXS("KinoSearch::Index::PostingListReader::aggregator", XS_KinoSearch_Index_PostingListReader_aggregator, file);
    newXS("KinoSearch::Index::LexiconReader::aggregator", XS_KinoSearch_Index_LexiconReader_aggregator, file);
    newXS("KinoSearch::Index::HighlightReader::aggregator", XS_KinoSearch_Index_HighlightReader_aggregator, file);
    newXS("KinoSearch::Index::DocReader::aggregator", XS_KinoSearch_Index_DocReader_aggregator, file);
    newXS("KinoSearch::Index::SortReader::aggregator", XS_KinoSearch_Index_SortReader_aggregator, file);
    newXS("KinoSearch::Index::DeletionsReader::aggregator", XS_KinoSearch_Index_DeletionsReader_aggregator, file);
    newXS("KinoSearch::Index::DataReader::get_schema", XS_KinoSearch_Index_DataReader_get_schema, file);
    newXS("KinoSearch::Index::DataReader::get_folder", XS_KinoSearch_Index_DataReader_get_folder, file);
    newXS("KinoSearch::Index::DataReader::get_snapshot", XS_KinoSearch_Index_DataReader_get_snapshot, file);
    newXS("KinoSearch::Index::DataReader::get_segments", XS_KinoSearch_Index_DataReader_get_segments, file);
    newXS("KinoSearch::Index::DataReader::get_segment", XS_KinoSearch_Index_DataReader_get_segment, file);
    newXS("KinoSearch::Index::DataReader::get_seg_tick", XS_KinoSearch_Index_DataReader_get_seg_tick, file);
    newXS("KinoSearch::Index::DataReader::close", XS_KinoSearch_Index_DataReader_close, file);
    newXS("KinoSearch::Index::DefaultPostingListReader::close", XS_KinoSearch_Index_DefaultPostingListReader_close, file);
    newXS("KinoSearch::Index::PolyLexiconReader::close", XS_KinoSearch_Index_PolyLexiconReader_close, file);
    newXS("KinoSearch::Index::DefaultLexiconReader::close", XS_KinoSearch_Index_DefaultLexiconReader_close, file);
    newXS("KinoSearch::Index::PolyHighlightReader::close", XS_KinoSearch_Index_PolyHighlightReader_close, file);
    newXS("KinoSearch::Index::DefaultHighlightReader::close", XS_KinoSearch_Index_DefaultHighlightReader_close, file);
    newXS("KinoSearch::Index::DefaultDocReader::close", XS_KinoSearch_Index_DefaultDocReader_close, file);
    newXS("KinoSearch::Index::PolyDocReader::close", XS_KinoSearch_Index_PolyDocReader_close, file);
    newXS("KinoSearch::Index::IndexReader::close", XS_KinoSearch_Index_IndexReader_close, file);
    newXS("KinoSearch::Index::PolyReader::close", XS_KinoSearch_Index_PolyReader_close, file);
    newXS("KinoSearch::Index::DefaultSortReader::close", XS_KinoSearch_Index_DefaultSortReader_close, file);
    newXS("KinoSearch::Index::PolyDeletionsReader::close", XS_KinoSearch_Index_PolyDeletionsReader_close, file);
    newXS("KinoSearch::Index::DefaultDeletionsReader::close", XS_KinoSearch_Index_DefaultDeletionsReader_close, file);
    newXS("KinoSearch::Index::PostingListReader::posting_list", XS_KinoSearch_Index_PostingListReader_posting_list, file);
    newXS("KinoSearch::Index::DefaultPostingListReader::posting_list", XS_KinoSearch_Index_DefaultPostingListReader_posting_list, file);
    newXS("KinoSearch::Index::PostingListReader::get_lex_reader", XS_KinoSearch_Index_PostingListReader_get_lex_reader, file);
    newXS("KinoSearch::Index::DefaultPostingListReader::get_lex_reader", XS_KinoSearch_Index_DefaultPostingListReader_get_lex_reader, file);
    newXS("KinoSearch::Index::LexiconReader::lexicon", XS_KinoSearch_Index_LexiconReader_lexicon, file);
    newXS("KinoSearch::Index::PolyLexiconReader::lexicon", XS_KinoSearch_Index_PolyLexiconReader_lexicon, file);
    newXS("KinoSearch::Index::DefaultLexiconReader::lexicon", XS_KinoSearch_Index_DefaultLexiconReader_lexicon, file);
    newXS("KinoSearch::Index::LexiconReader::doc_freq", XS_KinoSearch_Index_LexiconReader_doc_freq, file);
    newXS("KinoSearch::Index::PolyLexiconReader::doc_freq", XS_KinoSearch_Index_PolyLexiconReader_doc_freq, file);
    newXS("KinoSearch::Index::DefaultLexiconReader::doc_freq", XS_KinoSearch_Index_DefaultLexiconReader_doc_freq, file);
    newXS("KinoSearch::Index::LexiconReader::fetch_term_info", XS_KinoSearch_Index_LexiconReader_fetch_term_info, file);
    newXS("KinoSearch::Index::DefaultLexiconReader::fetch_term_info", XS_KinoSearch_Index_DefaultLexiconReader_fetch_term_info, file);
    newXS("KinoSearch::Index::DocReader::fetch_doc", XS_KinoSearch_Index_DocReader_fetch_doc, file);
    newXS("KinoSearch::Index::DefaultDocReader::fetch_doc", XS_KinoSearch_Index_DefaultDocReader_fetch_doc, file);
    newXS("KinoSearch::Index::PolyDocReader::fetch_doc", XS_KinoSearch_Index_PolyDocReader_fetch_doc, file);
    newXS("KinoSearch::Index::IndexReader::doc_max", XS_KinoSearch_Index_IndexReader_doc_max, file);
    newXS("KinoSearch::Index::SegReader::doc_max", XS_KinoSearch_Index_SegReader_doc_max, file);
    newXS("KinoSearch::Index::PolyReader::doc_max", XS_KinoSearch_Index_PolyReader_doc_max, file);
    newXS("KinoSearch::Index::IndexReader::doc_count", XS_KinoSearch_Index_IndexReader_doc_count, file);
    newXS("KinoSearch::Index::SegReader::doc_count", XS_KinoSearch_Index_SegReader_doc_count, file);
    newXS("KinoSearch::Index::PolyReader::doc_count", XS_KinoSearch_Index_PolyReader_doc_count, file);
    newXS("KinoSearch::Index::IndexReader::del_count", XS_KinoSearch_Index_IndexReader_del_count, file);
    newXS("KinoSearch::Index::SegReader::del_count", XS_KinoSearch_Index_SegReader_del_count, file);
    newXS("KinoSearch::Index::PolyReader::del_count", XS_KinoSearch_Index_PolyReader_del_count, file);
    newXS("KinoSearch::Index::IndexReader::_offsets", XS_KinoSearch_Index_IndexReader__offsets, file);
    newXS("KinoSearch::Index::SegReader::_offsets", XS_KinoSearch_Index_SegReader__offsets, file);
    newXS("KinoSearch::Index::PolyReader::_offsets", XS_KinoSearch_Index_PolyReader__offsets, file);
    newXS("KinoSearch::Index::IndexReader::seg_readers", XS_KinoSearch_Index_IndexReader_seg_readers, file);
    newXS("KinoSearch::Index::SegReader::seg_readers", XS_KinoSearch_Index_SegReader_seg_readers, file);
    newXS("KinoSearch::Index::PolyReader::seg_readers", XS_KinoSearch_Index_PolyReader_seg_readers, file);
    newXS("KinoSearch::Index::IndexReader::obtain", XS_KinoSearch_Index_IndexReader_obtain, file);
    newXS("KinoSearch::Index::IndexReader::fetch", XS_KinoSearch_Index_IndexReader_fetch, file);
    newXS("KinoSearch::Index::IndexReader::get_components", XS_KinoSearch_Index_IndexReader_get_components, file);
    newXS("KinoSearch::Index::SegReader::register", XS_KinoSearch_Index_SegReader_register, file);
    newXS("KinoSearch::Index::SegReader::get_seg_name", XS_KinoSearch_Index_SegReader_get_seg_name, file);
    newXS("KinoSearch::Index::SegReader::get_seg_num", XS_KinoSearch_Index_SegReader_get_seg_num, file);
    newXS("KinoSearch::Index::PolyReader::get_seg_readers", XS_KinoSearch_Index_PolyReader_get_seg_readers, file);
    newXS("KinoSearch::Index::SortReader::fetch_sort_cache", XS_KinoSearch_Index_SortReader_fetch_sort_cache, file);
    newXS("KinoSearch::Index::DefaultSortReader::fetch_sort_cache", XS_KinoSearch_Index_DefaultSortReader_fetch_sort_cache, file);
    newXS("KinoSearch::Index::DeletionsReader::del_count", XS_KinoSearch_Index_DeletionsReader_del_count, file);
    newXS("KinoSearch::Index::PolyDeletionsReader::del_count", XS_KinoSearch_Index_PolyDeletionsReader_del_count, file);
    newXS("KinoSearch::Index::DefaultDeletionsReader::del_count", XS_KinoSearch_Index_DefaultDeletionsReader_del_count, file);
    newXS("KinoSearch::Index::DeletionsReader::iterator", XS_KinoSearch_Index_DeletionsReader_iterator, file);
    newXS("KinoSearch::Index::PolyDeletionsReader::iterator", XS_KinoSearch_Index_PolyDeletionsReader_iterator, file);
    newXS("KinoSearch::Index::DefaultDeletionsReader::iterator", XS_KinoSearch_Index_DefaultDeletionsReader_iterator, file);
    newXS("KinoSearch::Index::DefaultDeletionsReader::read_deletions", XS_KinoSearch_Index_DefaultDeletionsReader_read_deletions, file);
    newXS("KinoSearch::Search::Collector::collect", XS_KinoSearch_Search_Collector_collect, file);
    newXS("KinoSearch::Search::Collector::SortCollector::collect", XS_KinoSearch_Search_Collector_SortCollector_collect, file);
    newXS("KinoSearch::Search::Collector::BitCollector::collect", XS_KinoSearch_Search_Collector_BitCollector_collect, file);
    newXS("KinoSearch::Search::Collector::OffsetCollector::collect", XS_KinoSearch_Search_Collector_OffsetCollector_collect, file);
    newXS("KinoSearch::Search::Collector::set_reader", XS_KinoSearch_Search_Collector_set_reader, file);
    newXS("KinoSearch::Search::Collector::SortCollector::set_reader", XS_KinoSearch_Search_Collector_SortCollector_set_reader, file);
    newXS("KinoSearch::Search::Collector::OffsetCollector::set_reader", XS_KinoSearch_Search_Collector_OffsetCollector_set_reader, file);
    newXS("KinoSearch::Search::Collector::set_base", XS_KinoSearch_Search_Collector_set_base, file);
    newXS("KinoSearch::Search::Collector::OffsetCollector::set_base", XS_KinoSearch_Search_Collector_OffsetCollector_set_base, file);
    newXS("KinoSearch::Search::Collector::need_score", XS_KinoSearch_Search_Collector_need_score, file);
    newXS("KinoSearch::Search::Collector::SortCollector::need_score", XS_KinoSearch_Search_Collector_SortCollector_need_score, file);
    newXS("KinoSearch::Search::Collector::BitCollector::need_score", XS_KinoSearch_Search_Collector_BitCollector_need_score, file);
    newXS("KinoSearch::Search::Collector::OffsetCollector::need_score", XS_KinoSearch_Search_Collector_OffsetCollector_need_score, file);
    newXS("KinoSearch::Search::Collector::set_matcher", XS_KinoSearch_Search_Collector_set_matcher, file);
    newXS("KinoSearch::Search::Collector::OffsetCollector::set_matcher", XS_KinoSearch_Search_Collector_OffsetCollector_set_matcher, file);
    newXS("KinoSearch::Search::Collector::SortCollector::pop_match_docs", XS_KinoSearch_Search_Collector_SortCollector_pop_match_docs, file);
    newXS("KinoSearch::Search::Collector::SortCollector::get_total_hits", XS_KinoSearch_Search_Collector_SortCollector_get_total_hits, file);
    newXS("KinoSearch::Plan::Schema::architecture", XS_KinoSearch_Plan_Schema_architecture, file);
    newXS("KinoSearch::Test::TestSchema::architecture", XS_KinoSearch_Test_TestSchema_architecture, file);
    newXS("KinoSearch::Plan::Schema::spec_field", XS_KinoSearch_Plan_Schema_spec_field, file);
    newXS("KinoSearch::Plan::Schema::fetch_type", XS_KinoSearch_Plan_Schema_fetch_type, file);
    newXS("KinoSearch::Plan::Schema::fetch_analyzer", XS_KinoSearch_Plan_Schema_fetch_analyzer, file);
    newXS("KinoSearch::Plan::Schema::fetch_sim", XS_KinoSearch_Plan_Schema_fetch_sim, file);
    newXS("KinoSearch::Plan::Schema::num_fields", XS_KinoSearch_Plan_Schema_num_fields, file);
    newXS("KinoSearch::Plan::Schema::all_fields", XS_KinoSearch_Plan_Schema_all_fields, file);
    newXS("KinoSearch::Plan::Schema::get_architecture", XS_KinoSearch_Plan_Schema_get_architecture, file);
    newXS("KinoSearch::Plan::Schema::get_similarity", XS_KinoSearch_Plan_Schema_get_similarity, file);
    newXS("KinoSearch::Plan::Schema::eat", XS_KinoSearch_Plan_Schema_eat, file);
    newXS("KinoSearch::Plan::Schema::write", XS_KinoSearch_Plan_Schema_write, file);
    newXS("KinoSearch::Document::Doc::set_doc_id", XS_KinoSearch_Document_Doc_set_doc_id, file);
    newXS("KinoSearch::Document::Doc::get_doc_id", XS_KinoSearch_Document_Doc_get_doc_id, file);
    newXS("KinoSearch::Document::Doc::set_fields", XS_KinoSearch_Document_Doc_set_fields, file);
    newXS("KinoSearch::Document::HitDoc::set_score", XS_KinoSearch_Document_HitDoc_set_score, file);
    newXS("KinoSearch::Document::HitDoc::get_score", XS_KinoSearch_Document_HitDoc_get_score, file);
    newXS("KinoSearch::Util::SortExternal::flush", XS_KinoSearch_Util_SortExternal_flush, file);
    newXS("KinoSearch::Test::Util::BBSortEx::flush", XS_KinoSearch_Test_Util_BBSortEx_flush, file);
    newXS("KinoSearch::Index::PostingPool::flush", XS_KinoSearch_Index_PostingPool_flush, file);
    newXS("KinoSearch::Index::SortFieldWriter::flush", XS_KinoSearch_Index_SortFieldWriter_flush, file);
    newXS("KinoSearch::Util::SortExternal::flip", XS_KinoSearch_Util_SortExternal_flip, file);
    newXS("KinoSearch::Test::Util::BBSortEx::flip", XS_KinoSearch_Test_Util_BBSortEx_flip, file);
    newXS("KinoSearch::Index::PostingPool::flip", XS_KinoSearch_Index_PostingPool_flip, file);
    newXS("KinoSearch::Index::SortFieldWriter::flip", XS_KinoSearch_Index_SortFieldWriter_flip, file);
    newXS("KinoSearch::Util::SortExternal::add_run", XS_KinoSearch_Util_SortExternal_add_run, file);
    newXS("KinoSearch::Util::SortExternal::refill", XS_KinoSearch_Util_SortExternal_refill, file);
    newXS("KinoSearch::Test::Util::BBSortEx::refill", XS_KinoSearch_Test_Util_BBSortEx_refill, file);
    newXS("KinoSearch::Index::PostingPool::refill", XS_KinoSearch_Index_PostingPool_refill, file);
    newXS("KinoSearch::Index::SortFieldWriter::refill", XS_KinoSearch_Index_SortFieldWriter_refill, file);
    newXS("KinoSearch::Util::SortExternal::sort_cache", XS_KinoSearch_Util_SortExternal_sort_cache, file);
    newXS("KinoSearch::Util::SortExternal::clear_cache", XS_KinoSearch_Util_SortExternal_clear_cache, file);
    newXS("KinoSearch::Test::Util::BBSortEx::clear_cache", XS_KinoSearch_Test_Util_BBSortEx_clear_cache, file);
    newXS("KinoSearch::Index::SortFieldWriter::clear_cache", XS_KinoSearch_Index_SortFieldWriter_clear_cache, file);
    newXS("KinoSearch::Util::SortExternal::cache_count", XS_KinoSearch_Util_SortExternal_cache_count, file);
    newXS("KinoSearch::Util::SortExternal::set_mem_thresh", XS_KinoSearch_Util_SortExternal_set_mem_thresh, file);
    newXS("KinoSearch::Search::MatchDoc::get_doc_id", XS_KinoSearch_Search_MatchDoc_get_doc_id, file);
    newXS("KinoSearch::Search::MatchDoc::set_doc_id", XS_KinoSearch_Search_MatchDoc_set_doc_id, file);
    newXS("KinoSearch::Search::MatchDoc::get_score", XS_KinoSearch_Search_MatchDoc_get_score, file);
    newXS("KinoSearch::Search::MatchDoc::set_score", XS_KinoSearch_Search_MatchDoc_set_score, file);
    newXS("KinoSearch::Search::MatchDoc::get_values", XS_KinoSearch_Search_MatchDoc_get_values, file);
    newXS("KinoSearch::Search::MatchDoc::set_values", XS_KinoSearch_Search_MatchDoc_set_values, file);
    newXS("KinoSearch::Index::Segment::add_field", XS_KinoSearch_Index_Segment_add_field, file);
    newXS("KinoSearch::Index::Segment::_store_metadata", XS_KinoSearch_Index_Segment__store_metadata, file);
    newXS("KinoSearch::Index::Segment::fetch_metadata", XS_KinoSearch_Index_Segment_fetch_metadata, file);
    newXS("KinoSearch::Index::Segment::field_num", XS_KinoSearch_Index_Segment_field_num, file);
    newXS("KinoSearch::Index::Segment::field_name", XS_KinoSearch_Index_Segment_field_name, file);
    newXS("KinoSearch::Index::Segment::get_name", XS_KinoSearch_Index_Segment_get_name, file);
    newXS("KinoSearch::Index::Segment::get_number", XS_KinoSearch_Index_Segment_get_number, file);
    newXS("KinoSearch::Index::Segment::set_count", XS_KinoSearch_Index_Segment_set_count, file);
    newXS("KinoSearch::Index::Segment::get_count", XS_KinoSearch_Index_Segment_get_count, file);
    newXS("KinoSearch::Index::Segment::write_file", XS_KinoSearch_Index_Segment_write_file, file);
    newXS("KinoSearch::Index::Segment::read_file", XS_KinoSearch_Index_Segment_read_file, file);
    newXS("KinoSearch::Index::Lexicon::seek", XS_KinoSearch_Index_Lexicon_seek, file);
    newXS("KinoSearch::Index::SegLexicon::seek", XS_KinoSearch_Index_SegLexicon_seek, file);
    newXS("KinoSearch::Index::PolyLexicon::seek", XS_KinoSearch_Index_PolyLexicon_seek, file);
    newXS("KinoSearch::Index::LexIndex::seek", XS_KinoSearch_Index_LexIndex_seek, file);
    newXS("KinoSearch::Index::Lexicon::next", XS_KinoSearch_Index_Lexicon_next, file);
    newXS("KinoSearch::Index::SegLexicon::next", XS_KinoSearch_Index_SegLexicon_next, file);
    newXS("KinoSearch::Index::PolyLexicon::next", XS_KinoSearch_Index_PolyLexicon_next, file);
    newXS("KinoSearch::Index::RawLexicon::next", XS_KinoSearch_Index_RawLexicon_next, file);
    newXS("KinoSearch::Index::Lexicon::reset", XS_KinoSearch_Index_Lexicon_reset, file);
    newXS("KinoSearch::Index::SegLexicon::reset", XS_KinoSearch_Index_SegLexicon_reset, file);
    newXS("KinoSearch::Index::PolyLexicon::reset", XS_KinoSearch_Index_PolyLexicon_reset, file);
    newXS("KinoSearch::Index::Lexicon::get_term", XS_KinoSearch_Index_Lexicon_get_term, file);
    newXS("KinoSearch::Index::SegLexicon::get_term", XS_KinoSearch_Index_SegLexicon_get_term, file);
    newXS("KinoSearch::Index::PolyLexicon::get_term", XS_KinoSearch_Index_PolyLexicon_get_term, file);
    newXS("KinoSearch::Index::LexIndex::get_term", XS_KinoSearch_Index_LexIndex_get_term, file);
    newXS("KinoSearch::Index::RawLexicon::get_term", XS_KinoSearch_Index_RawLexicon_get_term, file);
    newXS("KinoSearch::Index::Lexicon::get_field", XS_KinoSearch_Index_Lexicon_get_field, file);
    newXS("KinoSearch::Index::SegLexicon::get_term_info", XS_KinoSearch_Index_SegLexicon_get_term_info, file);
    newXS("KinoSearch::Index::SegLexicon::get_field_num", XS_KinoSearch_Index_SegLexicon_get_field_num, file);
    newXS("KinoSearch::Index::FilePurger::purge", XS_KinoSearch_Index_FilePurger_purge, file);
    newXS("KinoSearch::Store::OutStream::tell", XS_KinoSearch_Store_OutStream_tell, file);
    newXS("KinoSearch::Store::OutStream::flush", XS_KinoSearch_Store_OutStream_flush, file);
    newXS("KinoSearch::Store::OutStream::length", XS_KinoSearch_Store_OutStream_length, file);
    newXS("KinoSearch::Store::OutStream::write_i8", XS_KinoSearch_Store_OutStream_write_i8, file);
    newXS("KinoSearch::Store::OutStream::write_u8", XS_KinoSearch_Store_OutStream_write_u8, file);
    newXS("KinoSearch::Store::OutStream::write_i32", XS_KinoSearch_Store_OutStream_write_i32, file);
    newXS("KinoSearch::Store::OutStream::write_u32", XS_KinoSearch_Store_OutStream_write_u32, file);
    newXS("KinoSearch::Store::OutStream::write_i64", XS_KinoSearch_Store_OutStream_write_i64, file);
    newXS("KinoSearch::Store::OutStream::write_u64", XS_KinoSearch_Store_OutStream_write_u64, file);
    newXS("KinoSearch::Store::OutStream::write_c32", XS_KinoSearch_Store_OutStream_write_c32, file);
    newXS("KinoSearch::Store::OutStream::write_c64", XS_KinoSearch_Store_OutStream_write_c64, file);
    newXS("KinoSearch::Store::OutStream::write_f32", XS_KinoSearch_Store_OutStream_write_f32, file);
    newXS("KinoSearch::Store::OutStream::write_f64", XS_KinoSearch_Store_OutStream_write_f64, file);
    newXS("KinoSearch::Store::OutStream::absorb", XS_KinoSearch_Store_OutStream_absorb, file);
    newXS("KinoSearch::Store::OutStream::close", XS_KinoSearch_Store_OutStream_close, file);
    newXS("KinoSearch::Object::I32Array::get", XS_KinoSearch_Object_I32Array_get, file);
    newXS("KinoSearch::Object::I32Array::get_size", XS_KinoSearch_Object_I32Array_get_size, file);
}

MODULE = KinoSearch    PACKAGE = KinoSearch::Index::SortWriter

void
set_default_mem_thresh(mem_thresh)
    size_t mem_thresh;
PPCODE:
    kino_SortWriter_set_default_mem_thresh(mem_thresh);

MODULE = KinoSearch   PACKAGE = KinoSearch::Analysis::Inversion

SV*
new(...)
CODE:
{
    kino_Token *starter_token = NULL;
    // parse params, only if there's more than one arg 
    if (items > 1) {
        SV *text_sv = NULL;
        XSBind_allot_params( &(ST(0)), 1, items, 
            "KinoSearch::Analysis::Inversion::new_PARAMS",
            &text_sv, "text", 4,
            NULL);
        if (XSBind_sv_defined(text_sv)) {
            STRLEN len;
            char *text = SvPVutf8(text_sv, len);
            starter_token = kino_Token_new(text, len, 0, len, 1.0, 1);
        }
    }
        
    RETVAL = CFISH_OBJ_TO_SV_NOINC(kino_Inversion_new(starter_token));
    KINO_DECREF(starter_token);
}
OUTPUT: RETVAL

MODULE = KinoSearch     PACKAGE = KinoSearch::Object::Obj

chy_bool_t
is_a(self, class_name)
    kino_Obj *self;
    const kino_CharBuf *class_name;
CODE:
{
    kino_VTable *target = kino_VTable_fetch_vtable(class_name);
    RETVAL = Kino_Obj_Is_A(self, target);
}
OUTPUT: RETVAL

void
STORABLE_freeze(self, ...)
    kino_Obj *self;
PPCODE:
{
    CHY_UNUSED_VAR(self);
    if (items < 2 || !SvTRUE(ST(1))) {
        SV *retval;
        kino_ByteBuf *serialized_bb;
        kino_RAMFileHandle *file_handle = kino_RAMFH_open(NULL, 
            KINO_FH_WRITE_ONLY | KINO_FH_CREATE, NULL);
        kino_OutStream *target = kino_OutStream_open((kino_Obj*)file_handle);

        Kino_Obj_Serialize(self, target);

        Kino_OutStream_Close(target);
        serialized_bb = Kino_RAMFile_Get_Contents(
            Kino_RAMFH_Get_File(file_handle));
        retval = XSBind_bb_to_sv(serialized_bb);
        KINO_DECREF(file_handle);
        KINO_DECREF(target);

        if (SvCUR(retval) == 0) { // Thwart Storable bug 
            THROW(KINO_ERR, "Calling serialize produced an empty string");
        }
        ST(0) = sv_2mortal(retval);
        XSRETURN(1);
    }
}

=begin comment

Calls deserialize(), and copies the object pointer.  Since deserialize is an
abstract method, it will confess() unless implemented.

=end comment
=cut

void
STORABLE_thaw(blank_obj, cloning, serialized_sv)
    SV *blank_obj;
    SV *cloning;
    SV *serialized_sv;
PPCODE:
{
    char *class_name = HvNAME(SvSTASH(SvRV(blank_obj)));
    kino_ZombieCharBuf *klass 
        = CFISH_ZCB_WRAP_STR(class_name, strlen(class_name));
    kino_VTable *vtable = (kino_VTable*)kino_VTable_singleton(
        (kino_CharBuf*)klass, NULL);
    STRLEN len;
    char *ptr = SvPV(serialized_sv, len);
    kino_ViewByteBuf *contents = kino_ViewBB_new(ptr, len);
    kino_RAMFile *ram_file = kino_RAMFile_new((kino_ByteBuf*)contents, true);
    kino_RAMFileHandle *file_handle 
        = kino_RAMFH_open(NULL, KINO_FH_READ_ONLY, ram_file);
    kino_InStream *instream = kino_InStream_open((kino_Obj*)file_handle);
    kino_Obj *self = Kino_VTable_Foster_Obj(vtable, blank_obj);
    kino_Obj *deserialized = Kino_Obj_Deserialize(self, instream);

    CHY_UNUSED_VAR(cloning);
    KINO_DECREF(contents);
    KINO_DECREF(ram_file);
    KINO_DECREF(file_handle);
    KINO_DECREF(instream);

    // Catch bad deserialize() override. 
    if (deserialized != self) {
        THROW(KINO_ERR, "Error when deserializing obj of class %o", klass);
    }
}

void
DESTROY(self)
    kino_Obj *self;
PPCODE:
    /*
    {
        char *perl_class = HvNAME(SvSTASH(SvRV(ST(0))));
        warn("Destroying: 0x%x %s", (unsigned)self, perl_class);
    }
    */
    Kino_Obj_Destroy(self);

MODULE = KinoSearch   PACKAGE = KinoSearch::Object::VArray

SV*
shallow_copy(self)
    kino_VArray *self;
CODE:
    RETVAL = CFISH_OBJ_TO_SV_NOINC(Kino_VA_Shallow_Copy(self));
OUTPUT: RETVAL

SV*
_deserialize(either_sv, instream)
    SV *either_sv;
    kino_InStream *instream;
CODE:
    CHY_UNUSED_VAR(either_sv);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(kino_VA_deserialize(NULL, instream));
OUTPUT: RETVAL

SV*
_clone(self)
    kino_VArray *self;
CODE:
    RETVAL = CFISH_OBJ_TO_SV_NOINC(Kino_VA_Clone(self));
OUTPUT: RETVAL

SV*
shift(self)
    kino_VArray *self;
CODE:
    RETVAL = CFISH_OBJ_TO_SV_NOINC(Kino_VA_Shift(self));
OUTPUT: RETVAL

SV*
pop(self)
    kino_VArray *self;
CODE:
    RETVAL = CFISH_OBJ_TO_SV_NOINC(Kino_VA_Pop(self));
OUTPUT: RETVAL

SV*
delete(self, tick)
    kino_VArray *self;
    uint32_t    tick;
CODE:
    RETVAL = CFISH_OBJ_TO_SV_NOINC(Kino_VA_Delete(self, tick));
OUTPUT: RETVAL

void
store(self, tick, value);
    kino_VArray *self; 
    uint32_t     tick;
    kino_Obj    *value;
PPCODE:
{
    if (value) { KINO_INCREF(value); }
    kino_VA_store(self, tick, value);
}

SV*
fetch(self, tick)
    kino_VArray *self;
    uint32_t     tick;
CODE:
    RETVAL = CFISH_OBJ_TO_SV(Kino_VA_Fetch(self, tick));
OUTPUT: RETVAL

MODULE = KinoSearch   PACKAGE = KinoSearch::Object::VTable

SV*
_get_registry()
CODE:
    if (kino_VTable_registry == NULL)
        kino_VTable_init_registry();
    RETVAL = (SV*)Kino_Obj_To_Host((kino_Obj*)kino_VTable_registry);
OUTPUT: RETVAL

MODULE = KinoSearch   PACKAGE = KinoSearch::Search::SortRule

int32_t
FIELD()
CODE:
    RETVAL = kino_SortRule_FIELD;
OUTPUT: RETVAL

int32_t
SCORE()
CODE:
    RETVAL = kino_SortRule_SCORE;
OUTPUT: RETVAL

int32_t
DOC_ID()
CODE:
    RETVAL = kino_SortRule_DOC_ID;
OUTPUT: RETVAL

MODULE = KinoSearch    PACKAGE = KinoSearch::Index::PostingListWriter

void
set_default_mem_thresh(mem_thresh)
    size_t mem_thresh;
PPCODE:
    kino_PListWriter_set_default_mem_thresh(mem_thresh);

MODULE = KinoSearch     PACKAGE = KinoSearch::Object::ByteBuf

SV*
new(either_sv, sv)
    SV *either_sv;
    SV *sv;
CODE:
{
    STRLEN size;
    char *ptr = SvPV(sv, size);
    kino_ByteBuf *self = (kino_ByteBuf*)XSBind_new_blank_obj(either_sv);
    kino_BB_init(self, size);
    Kino_BB_Mimic_Bytes(self, ptr, size);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(self);
}
OUTPUT: RETVAL

SV*
_deserialize(either_sv, instream)
    SV *either_sv;
    kino_InStream *instream;
CODE:
    CHY_UNUSED_VAR(either_sv);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(kino_BB_deserialize(NULL, instream));
OUTPUT: RETVAL

MODULE = KinoSearch   PACKAGE = KinoSearch::Index::Posting::ScorePosting

SV*
get_prox(self)
    kino_ScorePosting *self;
CODE:
{
    AV *out_av            = newAV();
    uint32_t *positions  = Kino_ScorePost_Get_Prox(self);
    uint32_t i, max;

    for (i = 0, max = Kino_ScorePost_Get_Freq(self); i < max; i++) {
        SV *pos_sv = newSVuv(positions[i]);
        av_push(out_av, pos_sv);
    }

    RETVAL = newRV_noinc((SV*)out_av);
}
OUTPUT: RETVAL

MODULE = KinoSearch     PACKAGE = KinoSearch::Object::Host

=for comment

These are all for testing purposes only.

=cut

IV
_test(...)
CODE:
    RETVAL = items;
OUTPUT: RETVAL

SV*
_test_obj(...)
CODE:
{
    kino_ByteBuf *test_obj = kino_BB_new_bytes("blah", 4);
    SV *pack_var = get_sv("KinoSearch::Object::Host::testobj", 1);
    RETVAL = (SV*)Kino_BB_To_Host(test_obj);
    SvSetSV_nosteal(pack_var, RETVAL);
    KINO_DECREF(test_obj);
    CHY_UNUSED_VAR(items);
}
OUTPUT: RETVAL

void
_callback(obj)
    kino_Obj *obj;
PPCODE:
{
    kino_ZombieCharBuf *blank = CFISH_ZCB_BLANK(); 
    kino_Host_callback(obj, "_test", 2, 
        CFISH_ARG_OBJ("nothing", (kino_CharBuf*)blank),
        CFISH_ARG_I32("foo", 3));
}

int64_t
_callback_i64(obj)
    kino_Obj *obj;
CODE:
{
    kino_ZombieCharBuf *blank = CFISH_ZCB_BLANK();
    RETVAL = kino_Host_callback_i64(obj, "_test", 2, 
        CFISH_ARG_OBJ("nothing", (kino_CharBuf*)blank), 
        CFISH_ARG_I32("foo", 3));
}
OUTPUT: RETVAL

double
_callback_f64(obj)
    kino_Obj *obj;
CODE:
{
    kino_ZombieCharBuf *blank = CFISH_ZCB_BLANK();
    RETVAL = kino_Host_callback_f64(obj, "_test", 2, 
        CFISH_ARG_OBJ("nothing", (kino_CharBuf*)blank), 
        CFISH_ARG_I32("foo", 3));
}
OUTPUT: RETVAL

SV*
_callback_obj(obj)
    kino_Obj *obj;
CODE: 
{
    kino_Obj *other = kino_Host_callback_obj(obj, "_test_obj", 0);
    RETVAL = (SV*)Kino_Obj_To_Host(other);
    KINO_DECREF(other);
}
OUTPUT: RETVAL

MODULE = KinoSearch     PACKAGE = KinoSearch::Store::FileHandle

=for comment

For testing purposes only.  Track number of FileHandle objects in existence.

=cut

uint32_t
FH_READ_ONLY()
CODE:
    RETVAL = KINO_FH_READ_ONLY;
OUTPUT: RETVAL

uint32_t
FH_WRITE_ONLY()
CODE:
    RETVAL = KINO_FH_WRITE_ONLY;
OUTPUT: RETVAL

uint32_t
FH_CREATE()
CODE:
    RETVAL = KINO_FH_CREATE;
OUTPUT: RETVAL

uint32_t
FH_EXCLUSIVE()
CODE:
    RETVAL = KINO_FH_EXCLUSIVE;
OUTPUT: RETVAL


int32_t
object_count()
CODE:
    RETVAL = kino_FH_object_count;
OUTPUT: RETVAL

=for comment

For testing purposes only.  Used to help produce buffer alignment tests.

=cut

IV
_BUF_SIZE()
CODE:
   RETVAL = KINO_IO_STREAM_BUF_SIZE;
OUTPUT: RETVAL

MODULE = KinoSearch   PACKAGE = KinoSearch::Object::Float32

SV*
new(either_sv, value)
    SV    *either_sv;
    float  value;
CODE:
{
    kino_Float32 *self = (kino_Float32*)XSBind_new_blank_obj(either_sv);
    kino_Float32_init(self, value);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(self);
}
OUTPUT: RETVAL

MODULE = KinoSearch    PACKAGE = KinoSearch

BOOT:
    kino_KinoSearch_bootstrap();

IV
_dummy_function()
CODE:
    RETVAL = 1;
OUTPUT:
    RETVAL

SV*
to_clownfish(sv)
    SV *sv;
CODE:
{
    kino_Obj *obj = XSBind_perl_to_cfish(sv);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(obj);
}
OUTPUT: RETVAL

SV*
to_perl(sv)
    SV *sv;
CODE:
{
    if (sv_isobject(sv) && sv_derived_from(sv, "KinoSearch::Object::Obj")) {
        IV tmp = SvIV(SvRV(sv));
        kino_Obj* obj = INT2PTR(kino_Obj*, tmp);
        RETVAL = XSBind_cfish_to_perl(obj);
    }
    else {
        RETVAL = newSVsv(sv);
    }
}
OUTPUT: RETVAL

MODULE = KinoSearch   PACKAGE = KinoSearch::Util::StringHelper

=for comment 

Turn an SV's UTF8 flag on.  Equivalent to Encode::_utf8_on, but we don't have
to load Encode.

=cut

void
utf8_flag_on(sv)
    SV *sv;
PPCODE:
    SvUTF8_on(sv);

=for comment

Turn an SV's UTF8 flag off.

=cut

void
utf8_flag_off(sv)
    SV *sv;
PPCODE:
    SvUTF8_off(sv);

SV*
to_base36(num)
    uint64_t num;
CODE:
{
    char base36[kino_StrHelp_MAX_BASE36_BYTES];
    size_t size = kino_StrHelp_to_base36(num, &base36);
    RETVAL = newSVpvn(base36, size);
}
OUTPUT: RETVAL

IV
from_base36(str)
    char *str;
CODE:
    RETVAL = strtol(str, NULL, 36);
OUTPUT: RETVAL

=for comment

Upgrade a SV to UTF8, converting Latin1 if necessary. Equivalent to
utf::upgrade().

=cut

void
utf8ify(sv)
    SV *sv;
PPCODE:
    sv_utf8_upgrade(sv);

chy_bool_t
utf8_valid(sv)
    SV *sv;
CODE:
{
    STRLEN len;
    char *ptr = SvPV(sv, len);
    RETVAL = kino_StrHelp_utf8_valid(ptr, len);
}
OUTPUT: RETVAL

=for comment

Concatenate one scalar onto the end of the other, ignoring UTF-8 status of the
second scalar.  This is necessary because $not_utf8 . $utf8 results in a
scalar which has been infected by the UTF-8 flag of the second argument.

=cut

void
cat_bytes(sv, catted)
    SV *sv;
    SV *catted;
PPCODE:
{
    STRLEN len;
    char *ptr = SvPV(catted, len);
    if (SvUTF8(sv)) { CFISH_THROW(KINO_ERR, "Can't cat_bytes onto a UTF-8 SV"); }
    sv_catpvn(sv, ptr, len);
}

MODULE = KinoSearch PACKAGE = KinoSearch::Object::I32Array

SV*
new(either_sv, ...) 
    SV *either_sv;
CODE:
{
    SV *ints_sv = NULL;
    AV *ints_av = NULL;
    kino_I32Array *self = NULL;

    XSBind_allot_params( &(ST(0)), 1, items, 
        "KinoSearch::Object::I32Array::new_PARAMS",
        &ints_sv, "ints", 4,
        NULL);
    if (XSBind_sv_defined(ints_sv) && SvROK(ints_sv)) {
        ints_av = (AV*)SvRV(ints_sv);
    }

    if (ints_av && SvTYPE(ints_av) == SVt_PVAV) {
        int32_t size  = av_len(ints_av) + 1;
        int32_t *ints = (int32_t*)KINO_MALLOCATE(size * sizeof(int32_t));
        int32_t i;

        for (i = 0; i < size; i++) {
            SV **const sv_ptr = av_fetch(ints_av, i, 0);
            ints[i] = (sv_ptr && XSBind_sv_defined(*sv_ptr)) 
                    ? SvIV(*sv_ptr) 
                    : 0;
        }
        self = (kino_I32Array*)XSBind_new_blank_obj(either_sv);
        kino_I32Arr_init(self, ints, size);
    }
    else {
        THROW(KINO_ERR, "Required param 'ints' isn't an arrayref");
    }
    
    RETVAL = CFISH_OBJ_TO_SV_NOINC(self);
}
OUTPUT: RETVAL

SV*
to_arrayref(self)
    kino_I32Array *self;
CODE:
{
    AV *out_av = newAV();
    uint32_t i;
    uint32_t size = Kino_I32Arr_Get_Size(self);

    av_extend(out_av, size);
    for (i = 0; i < size; i++) {
        int32_t result = Kino_I32Arr_Get(self, i);
        SV* result_sv = result == -1 ? newSV(0) : newSViv(result);
        av_push(out_av, result_sv);
    }
    RETVAL = newRV_noinc((SV*)out_av);
}
OUTPUT: RETVAL

MODULE = KinoSearch   PACKAGE = KinoSearch::Test::TestCharmonizer

void
run_tests(which)
    char *which;
PPCODE:
{
    chaz_TestBatch *batch = NULL;
    chaz_Test_init();

    if (strcmp(which, "dirmanip") == 0) {
        batch = chaz_TestDirManip_prepare();
    }
    else if (strcmp(which, "integers") == 0) {
        batch = chaz_TestIntegers_prepare();
    }
    else if (strcmp(which, "func_macro") == 0) {
        batch = chaz_TestFuncMacro_prepare();
    }
    else if (strcmp(which, "headers") == 0) {
        batch = chaz_TestHeaders_prepare();
    }
    else if (strcmp(which, "large_files") == 0) {
        batch = chaz_TestLargeFiles_prepare();
    }
    else if (strcmp(which, "unused_vars") == 0) {
        batch = chaz_TestUnusedVars_prepare();
    }
    else if (strcmp(which, "variadic_macros") == 0) {
        batch = chaz_TestVariadicMacros_prepare();
    }
    else {
        THROW(KINO_ERR, "Unknown test identifier: '%s'", which);
    }

    batch->run_test(batch);
    batch->destroy(batch);
}

MODULE = KinoSearch   PACKAGE = KinoSearch::Object::Float64

SV*
new(either_sv, value)
    SV     *either_sv;
    double  value;
CODE:
{
    kino_Float64 *self = (kino_Float64*)XSBind_new_blank_obj(either_sv);
    kino_Float64_init(self, value);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(self);
}
OUTPUT: RETVAL

MODULE = KinoSearch    PACKAGE = KinoSearch::Analysis::Stemmer

void
_copy_snowball_symbols()
PPCODE:
{
    SV **const new_sv_ptr = hv_fetch(PL_modglobal,
        "Lingua::Stem::Snowball::sb_stemmer_new", 38, 0);
    SV **const delete_sv_ptr = hv_fetch(PL_modglobal,
        "Lingua::Stem::Snowball::sb_stemmer_delete", 41, 0);
    SV **const stem_sv_ptr = hv_fetch(PL_modglobal,
        "Lingua::Stem::Snowball::sb_stemmer_stem", 39, 0);
    SV **const length_sv_ptr = hv_fetch(PL_modglobal,
        "Lingua::Stem::Snowball::sb_stemmer_length", 41, 0);
    if (!new_sv_ptr || !delete_sv_ptr || !stem_sv_ptr || !length_sv_ptr) {
        THROW(KINO_ERR, "Failed to retrieve one or more Snowball symbols");
    }
    kino_Stemmer_sb_stemmer_new 
        = (kino_Stemmer_sb_stemmer_new_t)SvIV(*new_sv_ptr);
    kino_Stemmer_sb_stemmer_delete 
        = (kino_Stemmer_sb_stemmer_delete_t)SvIV(*delete_sv_ptr);
    kino_Stemmer_sb_stemmer_stem 
        = (kino_Stemmer_sb_stemmer_stem_t)SvIV(*stem_sv_ptr);
    kino_Stemmer_sb_stemmer_length 
        = (kino_Stemmer_sb_stemmer_length_t)SvIV(*length_sv_ptr);
}

MODULE = KinoSearch  PACKAGE = KinoSearch::Index::Indexer

int32_t
CREATE(...)
CODE:
    CHY_UNUSED_VAR(items);
    RETVAL = kino_Indexer_CREATE;
OUTPUT: RETVAL

int32_t
TRUNCATE(...)
CODE:
    CHY_UNUSED_VAR(items);
    RETVAL = kino_Indexer_TRUNCATE;
OUTPUT: RETVAL

void
add_doc(self, ...)
    kino_Indexer *self;
PPCODE:
{
    kino_Doc *doc = NULL;
    SV *doc_sv = NULL;
    float boost = 1.0;

    if (items == 2) {
        doc_sv = ST(1);
    }
    else if (items > 2) {
        SV* boost_sv = NULL; 
        XSBind_allot_params( &(ST(0)), 1, items, 
            "KinoSearch::Index::Indexer::add_doc_PARAMS", &doc_sv, "doc", 3,
            &boost_sv, "boost", 5, NULL);
        if (boost_sv) {
            boost = (float)SvNV(boost_sv);
        }
    }
    else if (items == 1) {
        CFISH_THROW(KINO_ERR, "Missing required argument 'doc'");
    }

    // Either get a Doc or use the stock doc. 
    if (   sv_isobject(doc_sv) 
        && sv_derived_from(doc_sv, "KinoSearch::Document::Doc")
    ) {
        IV tmp = SvIV( SvRV(doc_sv) );
        doc = INT2PTR(kino_Doc*, tmp);
    }
    else if (XSBind_sv_defined(doc_sv) && SvROK(doc_sv)) {
        HV *maybe_fields = (HV*)SvRV(doc_sv);
        if (SvTYPE((SV*)maybe_fields) == SVt_PVHV) {
            doc = Kino_Indexer_Get_Stock_Doc(self);
            Kino_Doc_Set_Fields(doc, maybe_fields);
        }
    }
    if (!doc) {
        THROW(KINO_ERR, "Need either a hashref or a %o",
            Kino_VTable_Get_Name(KINO_DOC));
    }

    Kino_Indexer_Add_Doc(self, doc, boost);
}

MODULE = KinoSearch   PACKAGE = KinoSearch::Test::TestUtils

SV*
doc_set()
CODE:
    RETVAL = CFISH_OBJ_TO_SV_NOINC(kino_TestUtils_doc_set());
OUTPUT: RETVAL

MODULE = KinoSearch   PACKAGE = KinoSearch::Test

void
run_tests(package)
    char *package;
PPCODE:
{
    // KinoSearch::Analysis 
    if (strEQ(package, "TestAnalyzer")) {
        kino_TestAnalyzer_run_tests();
    }
    else if (strEQ(package, "TestCaseFolder")) {
        kino_TestCaseFolder_run_tests();
    }
    else if (strEQ(package, "TestPolyAnalyzer")) {
        kino_TestPolyAnalyzer_run_tests();
    }
    else if (strEQ(package, "TestStopalizer")) {
        kino_TestStopalizer_run_tests();
    }
    else if (strEQ(package, "TestStemmer")) {
        kino_TestStemmer_run_tests();
    }
    else if (strEQ(package, "TestTokenizer")) {
        kino_TestTokenizer_run_tests();
    }
    // KinoSearch::Object 
    else if (strEQ(package, "TestObj")) {
        kino_TestObj_run_tests();
    }
    else if (strEQ(package, "TestI32Array")) {
        kino_TestI32Arr_run_tests();
    }
    else if (strEQ(package, "TestByteBuf")) {
        kino_TestBB_run_tests();
    }
    else if (strEQ(package, "TestLockFreeRegistry")) {
        kino_TestLFReg_run_tests();
    }
    // KinoSearch::Plan 
    else if (strEQ(package, "TestBlobType")) {
        kino_TestBlobType_run_tests();
    }
    else if (strEQ(package, "TestFieldType")) {
        kino_TestFType_run_tests();
    }
    else if (strEQ(package, "TestFullTextType")) {
        kino_TestFullTextType_run_tests();
    }
    else if (strEQ(package, "TestNumericType")) {
        kino_TestNumericType_run_tests();
    }
    else if (strEQ(package, "TestSchema")) {
        kino_TestSchema_run_tests();
    }
    // KinoSearch::Index 
    else if (strEQ(package, "TestDocWriter")) {
        kino_TestDocWriter_run_tests();
    }
    else if (strEQ(package, "TestHighlightWriter")) {
        kino_TestHLWriter_run_tests();
    }
    else if (strEQ(package, "TestIndexManager")) {
        kino_TestIxManager_run_tests();
    }
    else if (strEQ(package, "TestPolyReader")) {
        kino_TestPolyReader_run_tests();
    }
    else if (strEQ(package, "TestPostingListWriter")) {
        kino_TestPListWriter_run_tests();
    }
    else if (strEQ(package, "TestSegment")) {
        kino_TestSeg_run_tests();
    }
    else if (strEQ(package, "TestSegWriter")) {
        kino_TestSegWriter_run_tests();
    }
    else if (strEQ(package, "TestSnapshot")) {
        kino_TestSnapshot_run_tests();
    }
    // KinoSearch::Search 
    else if (strEQ(package, "TestANDQuery")) {
        kino_TestANDQuery_run_tests();
    }
    else if (strEQ(package, "TestLeafQuery")) {
        kino_TestLeafQuery_run_tests();
    }
    else if (strEQ(package, "TestMatchAllQuery")) {
        kino_TestMatchAllQuery_run_tests();
    }
    else if (strEQ(package, "TestNoMatchQuery")) {
        kino_TestNoMatchQuery_run_tests();
    }
    else if (strEQ(package, "TestNOTQuery")) {
        kino_TestNOTQuery_run_tests();
    }
    else if (strEQ(package, "TestORQuery")) {
        kino_TestORQuery_run_tests();
    }
    else if (strEQ(package, "TestPhraseQuery")) {
        kino_TestPhraseQuery_run_tests();
    }
    else if (strEQ(package, "TestQueryParserLogic")) {
        kino_TestQPLogic_run_tests();
    }
    else if (strEQ(package, "TestSeriesMatcher")) {
        kino_TestSeriesMatcher_run_tests();
    }
    else if (strEQ(package, "TestRangeQuery")) {
        kino_TestRangeQuery_run_tests();
    }
    else if (strEQ(package, "TestReqOptQuery")) {
        kino_TestReqOptQuery_run_tests();
    }
    else if (strEQ(package, "TestTermQuery")) {
        kino_TestTermQuery_run_tests();
    }
    // KinoSearch::Store 
    else if (strEQ(package, "TestCompoundFileReader")) {
        kino_TestCFReader_run_tests();
    }
    else if (strEQ(package, "TestCompoundFileWriter")) {
        kino_TestCFWriter_run_tests();
    }
    else if (strEQ(package, "TestFileHandle")) {
        kino_TestFH_run_tests();
    }
    else if (strEQ(package, "TestFolder")) {
        kino_TestFolder_run_tests();
    }
    else if (strEQ(package, "TestFSDirHandle")) {
        kino_TestFSDH_run_tests();
    }
    else if (strEQ(package, "TestFSFolder")) {
        kino_TestFSFolder_run_tests();
    }
    else if (strEQ(package, "TestFSFileHandle")) {
        kino_TestFSFH_run_tests();
    }
    else if (strEQ(package, "TestInStream")) {
        kino_TestInStream_run_tests();
    }
    else if (strEQ(package, "TestIOChunks")) {
        kino_TestIOChunks_run_tests();
    }
    else if (strEQ(package, "TestIOPrimitives")) {
        kino_TestIOPrimitives_run_tests();
    }
    else if (strEQ(package, "TestRAMDirHandle")) {
        kino_TestRAMDH_run_tests();
    }
    else if (strEQ(package, "TestRAMFileHandle")) {
        kino_TestRAMFH_run_tests();
    }
    else if (strEQ(package, "TestRAMFolder")) {
        kino_TestRAMFolder_run_tests();
    }
    // KinoSearch::Util 
    else if (strEQ(package, "TestAtomic")) {
        kino_TestAtomic_run_tests();
    }
    else if (strEQ(package, "TestBitVector")) {
        kino_TestBitVector_run_tests();
    }
    else if (strEQ(package, "TestCharBuf")) {
        kino_TestCB_run_tests();
    }
    else if (strEQ(package, "TestHash")) {
        kino_TestHash_run_tests();
    }
    else if (strEQ(package, "TestJson")) {
        kino_TestJson_run_tests();
    }
    else if (strEQ(package, "TestMemory")) {
        kino_TestMemory_run_tests();
    }
    else if (strEQ(package, "TestIndexFileNames")) {
        kino_TestIxFileNames_run_tests();
    }
    else if (strEQ(package, "TestNumberUtils")) {
        kino_TestNumUtil_run_tests();
    }
    else if (strEQ(package, "TestNum")) {
        kino_TestNum_run_tests();
    }
    else if (strEQ(package, "TestPriorityQueue")) {
        kino_TestPriQ_run_tests();
    }
    else if (strEQ(package, "TestStringHelper")) {
        kino_TestStrHelp_run_tests();
    }
    else if (strEQ(package, "TestMemoryPool")) {
        kino_TestMemPool_run_tests();
    }
    else if (strEQ(package, "TestVArray")) {
        kino_TestVArray_run_tests();
    }
    else {
        THROW(KINO_ERR, "Unknown test id: %s", package);
    }
}

MODULE = KinoSearch   PACKAGE = KinoSearch::Test::TestQueryParserSyntax

void
run_tests(index);
    kino_Folder *index;
PPCODE:
    kino_TestQPSyntax_run_tests(index);

MODULE = KinoSearch     PACKAGE = KinoSearch::Store::OutStream

void
print(self, ...)
    kino_OutStream *self;
PPCODE:
{
    int i;
    for (i = 1; i < items; i++) {
        STRLEN len;
        char *ptr = SvPV( ST(i), len);
        Kino_OutStream_Write_Bytes(self, ptr, len);
    }
}

void 
write_string(self, aSV)
    kino_OutStream *self;
    SV *aSV;
PPCODE:
{
    STRLEN len = 0;
    char *ptr = SvPVutf8(aSV, len);
    Kino_OutStream_Write_C32(self, len);
    Kino_OutStream_Write_Bytes(self, ptr, len);
}

MODULE = KinoSearch   PACKAGE = KinoSearch::Util::Debug

#include "KinoSearch/Util/Debug.h"

void
DEBUG_PRINT(message)
    char *message;
PPCODE:
    KINO_DEBUG_PRINT("%s", message);

void
DEBUG(message)
    char *message;
PPCODE:
    KINO_DEBUG("%s", message);

chy_bool_t
DEBUG_ENABLED()
CODE:
    RETVAL = KINO_DEBUG_ENABLED;
OUTPUT: RETVAL

=for comment

Keep track of any KinoSearch objects that have been assigned to global Perl
variables.  This is useful when accounting how many objects should have been
destroyed and diagnosing memory leaks.

=cut

void
track_globals(...)
PPCODE:
{
    CHY_UNUSED_VAR(items);
    KINO_IFDEF_DEBUG(kino_Debug_num_globals++;);
}

void
set_env_cache(str)
    char *str;
PPCODE:
    kino_Debug_set_env_cache(str);

void
ASSERT(maybe)
    int maybe;
PPCODE:
    KINO_ASSERT(maybe, "XS ASSERT binding test");

IV
num_allocated()
CODE:
    RETVAL = kino_Debug_num_allocated;
OUTPUT: RETVAL

IV
num_freed()
CODE:
    RETVAL = kino_Debug_num_freed;
OUTPUT: RETVAL

IV
num_globals()
CODE:
    RETVAL = kino_Debug_num_globals;
OUTPUT: RETVAL

MODULE = KinoSearch   PACKAGE = KinoSearch::Util::IndexFileNames

uint64_t
extract_gen(name)
    const kino_CharBuf *name;
CODE:
    RETVAL = kino_IxFileNames_extract_gen(name);
OUTPUT: RETVAL

SV*
latest_snapshot(folder)
    kino_Folder *folder;
CODE:
{
    kino_CharBuf *latest = kino_IxFileNames_latest_snapshot(folder);
    RETVAL = XSBind_cb_to_sv(latest);   
    KINO_DECREF(latest);
}
OUTPUT: RETVAL

MODULE = KinoSearch    PACKAGE = KinoSearch::Analysis::Token

SV*
new(either_sv, ...)
    SV *either_sv;
CODE:
{
    SV *text_sv         = NULL;
    SV *start_offset_sv = NULL;
    SV *end_offset_sv   = NULL;
    SV *pos_inc_sv      = NULL;
    SV *boost_sv        = NULL;

    XSBind_allot_params( &(ST(0)), 1, items, 
        "KinoSearch::Analysis::Token::new_PARAMS",
        &text_sv, "text", 4,
        &start_offset_sv, "start_offset", 12, 
        &end_offset_sv, "end_offset", 10, 
        &pos_inc_sv, "pos_inc", 7, 
        &boost_sv, "boost", 5, 
        NULL);

    if (!XSBind_sv_defined(text_sv)) { 
        THROW(KINO_ERR, "Missing required param 'text'"); 
    }
    if (!XSBind_sv_defined(start_offset_sv)) { 
        THROW(KINO_ERR, "Missing required param 'start_offset'"); 
    }
    if (!XSBind_sv_defined(end_offset_sv)) { 
        THROW(KINO_ERR, "Missing required param 'end_offset'"); 
    }

    STRLEN      len;
    char       *text      = SvPVutf8(text_sv, len);
    uint32_t    start_off = SvUV(start_offset_sv);
    uint32_t    end_off   = SvUV(end_offset_sv);
    int32_t     pos_inc   = pos_inc_sv ? SvIV(pos_inc_sv) : 1;
    float       boost     = boost_sv ? (float)SvNV(boost_sv) : 1.0f;
    kino_Token *self   = (kino_Token*)XSBind_new_blank_obj(either_sv);
    kino_Token_init(self, text, len, start_off, end_off, boost, 
        pos_inc);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(self);
}
OUTPUT: RETVAL

SV*
get_text(self)
    kino_Token *self;
CODE:
    RETVAL = newSVpvn(Kino_Token_Get_Text(self), Kino_Token_Get_Len(self));
    SvUTF8_on(RETVAL);
OUTPUT: RETVAL

void
set_text(self, sv)
    kino_Token *self;
    SV *sv;
PPCODE:
{
    STRLEN len;
    char *ptr = SvPVutf8(sv, len);
    Kino_Token_Set_Text(self, ptr, len);
}

MODULE = KinoSearch    PACKAGE = KinoSearch::Index::IndexReader

void
set_race_condition_debug1(val_sv)
    SV *val_sv;
PPCODE:
    KINO_DECREF(kino_PolyReader_race_condition_debug1);
    kino_PolyReader_race_condition_debug1 = (kino_CharBuf*)
        XSBind_maybe_sv_to_cfish_obj(val_sv, KINO_CHARBUF, NULL);
    if (kino_PolyReader_race_condition_debug1)
        (void)KINO_INCREF(kino_PolyReader_race_condition_debug1);

int32_t
debug1_num_passes()
CODE: 
    RETVAL = kino_PolyReader_debug1_num_passes;
OUTPUT: RETVAL

MODULE = KinoSearch    PACKAGE = KinoSearch::Util::SortExternal

IV
_DEFAULT_MEM_THRESHOLD()
CODE:
    RETVAL = KINO_SORTEX_DEFAULT_MEM_THRESHOLD;
OUTPUT: RETVAL

MODULE = KinoSearch    PACKAGE = KinoSearch::Index::Similarity     

SV*
get_norm_decoder(self)
    kino_Similarity *self;
CODE:
    RETVAL = newSVpvn( (char*)Kino_Sim_Get_Norm_Decoder(self), 
        (256 * sizeof(float)) );
OUTPUT: RETVAL

MODULE = KinoSearch     PACKAGE = KinoSearch::Document::Doc

SV*
get_fields(self, ...)
    kino_Doc *self;
CODE:
    CHY_UNUSED_VAR(items);
    RETVAL = newRV_inc( (SV*)Kino_Doc_Get_Fields(self) );
OUTPUT: RETVAL

MODULE = KinoSearch    PACKAGE = KinoSearch::Test::Util::BBSortEx

SV*
fetch(self)
    kino_BBSortEx *self;
CODE:
{
    void *address = Kino_BBSortEx_Fetch(self);
    if (address) {
        RETVAL = XSBind_cfish_to_perl(*(kino_Obj**)address);
        KINO_DECREF(*(kino_Obj**)address);
    }
    else {
        RETVAL = newSV(0);
    }
}
OUTPUT: RETVAL

SV*
peek(self)
    kino_BBSortEx *self;
CODE:
{
    void *address = Kino_BBSortEx_Peek(self);
    if (address) {
        RETVAL = XSBind_cfish_to_perl(*(kino_Obj**)address);
    }
    else {
        RETVAL = newSV(0);
    }
}
OUTPUT: RETVAL

void
feed(self, bb)
    kino_BBSortEx *self;
    kino_ByteBuf *bb;
CODE:
    KINO_INCREF(bb);
    Kino_BBSortEx_Feed(self, &bb);


MODULE = KinoSearch   PACKAGE = KinoSearch::Index::SortCache

SV*
value(self, ...)
    kino_SortCache *self;
CODE:
{
    SV *ord_sv = NULL;
    int32_t ord = 0;

    XSBind_allot_params( &(ST(0)), 1, items, 
        "KinoSearch::Index::SortCache::value_PARAMS",
        &ord_sv, "ord", 3, 
        NULL);
    if (ord_sv) { ord = SvIV(ord_sv); }
    else { THROW(KINO_ERR, "Missing required param 'ord'"); }

    {
        kino_Obj *blank = Kino_SortCache_Make_Blank(self);
        kino_Obj *value = Kino_SortCache_Value(self, ord, blank);
        RETVAL = XSBind_cfish_to_perl(value);
        KINO_DECREF(blank);
    }
}
OUTPUT: RETVAL

MODULE =  KinoSearch    PACKAGE = KinoSearch::Object::Hash

SV*
_deserialize(either_sv, instream)
    SV *either_sv;
    kino_InStream *instream;
CODE:
    CHY_UNUSED_VAR(either_sv);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(kino_Hash_deserialize(NULL, instream));
OUTPUT: RETVAL

SV*
_fetch(self, key)
    kino_Hash *self;
    const kino_CharBuf *key;
CODE:
    RETVAL = CFISH_OBJ_TO_SV(kino_Hash_fetch(self, (kino_Obj*)key));
OUTPUT: RETVAL

void
store(self, key, value);
    kino_Hash          *self; 
    const kino_CharBuf *key;
    kino_Obj           *value;
PPCODE:
{
    if (value) { KINO_INCREF(value); }
    kino_Hash_store(self, (kino_Obj*)key, value);
}

void
next(self)
    kino_Hash *self;
PPCODE:
{
    kino_Obj *key;
    kino_Obj *val;

    if (Kino_Hash_Next(self, &key, &val)) {
        SV *key_sv = (SV*)Kino_Obj_To_Host(key);
        SV *val_sv = (SV*)Kino_Obj_To_Host(val);

        XPUSHs(sv_2mortal( key_sv ));
        XPUSHs(sv_2mortal( val_sv ));
        XSRETURN(2);
    }
    else {
        XSRETURN_EMPTY;
    }
}

MODULE = KinoSearch    PACKAGE = KinoSearch::Store::InStream

void
read(self, buffer_sv, len, ...)
    kino_InStream *self;
    SV *buffer_sv;
    size_t len;
PPCODE:
{
    UV offset = items == 4 ? SvUV(ST(3)) : 0;
    char *ptr;
    size_t total_len = offset + len;
    SvUPGRADE(buffer_sv, SVt_PV);
    if (!SvPOK(buffer_sv)) { SvCUR_set(buffer_sv, 0); }
    ptr = SvGROW(buffer_sv, total_len + 1);
    Kino_InStream_Read_Bytes(self, ptr + offset, len);
    SvPOK_on(buffer_sv);
    if (SvCUR(buffer_sv) < total_len) {
        SvCUR_set(buffer_sv, total_len);
        *(SvEND(buffer_sv)) = '\0';
    }
}

SV*
read_string(self)
    kino_InStream *self;
CODE:
{
    char *ptr;
    size_t len = Kino_InStream_Read_C32(self);
    RETVAL = newSV(len + 1);
    SvCUR_set(RETVAL, len);
    SvPOK_on(RETVAL);
    SvUTF8_on(RETVAL); // Trust source.  Reconsider if API goes public. 
    *SvEND(RETVAL) = '\0';
    ptr = SvPVX(RETVAL);
    Kino_InStream_Read_Bytes(self, ptr, len);
}
OUTPUT: RETVAL

int
read_raw_c64(self, buffer_sv)
    kino_InStream *self;
    SV *buffer_sv;
CODE:
{
    char *ptr;
    SvUPGRADE(buffer_sv, SVt_PV);
    ptr = SvGROW(buffer_sv, 10 + 1);
    RETVAL = Kino_InStream_Read_Raw_C64(self, ptr);
    SvPOK_on(buffer_sv);
    SvCUR_set(buffer_sv, RETVAL);
}
OUTPUT: RETVAL

MODULE = KinoSearch     PACKAGE = KinoSearch::Object::CharBuf

SV*
new(either_sv, sv)
    SV *either_sv;
    SV *sv;
CODE:
{
    STRLEN size;
    char *ptr = SvPVutf8(sv, size);
    kino_CharBuf *self = (kino_CharBuf*)XSBind_new_blank_obj(either_sv);
    kino_CB_init(self, size);
    Kino_CB_Cat_Trusted_Str(self, ptr, size);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(self);
}
OUTPUT: RETVAL

SV*
_clone(self)
    kino_CharBuf *self;
CODE:
    RETVAL = CFISH_OBJ_TO_SV_NOINC(kino_CB_clone(self));
OUTPUT: RETVAL

SV*
_deserialize(either_sv, instream)
    SV *either_sv;
    kino_InStream *instream;
CODE:
    CHY_UNUSED_VAR(either_sv);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(kino_CB_deserialize(NULL, instream));
OUTPUT: RETVAL

SV*
to_perl(self)
    kino_CharBuf *self;
CODE:
    RETVAL = XSBind_cb_to_sv(self);
OUTPUT: RETVAL

MODULE = KinoSearch     PACKAGE = KinoSearch::Object::ViewCharBuf

SV*
_new(unused, sv)
    SV *unused;
    SV *sv;
CODE:
{
    STRLEN size;
    char *ptr = SvPVutf8(sv, size);
    kino_ViewCharBuf *self 
        = kino_ViewCB_new_from_trusted_utf8(ptr, size);
    CHY_UNUSED_VAR(unused);
    RETVAL = CFISH_OBJ_TO_SV_NOINC(self);
}
OUTPUT: RETVAL



